#include <iostream>
#include <vector>
#include <set>
#include <map>
using namespace std;
map < string,string > m;

int main(){
    string s;
    vector<string>history;
    set<string>was;
    while(getline(cin,s)){
        int u,w;
        if(s == "\\begin{thebibliography}{99}"){
            break;
        }
        for(int i=0;i<s.size();i++){
            if(s[i] == '{'){
                u=i;
            }else if(s[i] == '}'){
                w=i;
                string ref = s.substr(u,w - u + 1);
                if(was.find(ref) == was.end()){
                    was.insert(ref);
                    history.push_back("\\bibitem" + ref);
                }
            }
        }
    }
    bool correct =true;
    int hid =0;
    while(getline(cin,s)){
        int u,w;
        if(s == "\\end{thebibliography}")
            break;
        for(int i=0;i<s.size();i++){
            if(s[i] == '\\'){
                u=i;
            }else if(s[i] == '}'){
                w=i;
                string ref = s.substr(u,w-u+1);
                m[ref] = s;
                if(ref != history[hid]){
                    correct = false;
                }else{
                    hid++;
                }
            }
        }
    }
    if(correct)
        puts("Correct");
    else {
        puts("Incorrect");
        puts("\\begin{thebibliography}{99}");
        for(int i=0;i<history.size();i++){
            cout<<m[history[i]]<<endl;
        }
        puts("\\end{thebibliography}");
    }
    return 0;
}
