#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int N = 1e5 + 5;
const ll INF = 4e18 + 5;
const ll mod = (1ll << 32ll);

int n, m, r = 1, b[N], a[N], aa[N];
bool used[N], us[N];
int u[N], v[N];
vector <int> g[N];

void dfs(int v, int d = 1, int p = 0) {
    if (used[v]) {
        return;
    }
    used[v] = 1;
    a[v] = r;
    r++;
    b[v] = d;
    for (int to : g[v]) {
        if (to == p) {
            continue;
        }
        dfs(to, d + 1, v);
    }
}

vector <pair <int, int>> vec;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin >> n >> m;
    if (n == 1) {
        cout << "NO";
        return 0;
    }
    for (int i = 1; i <= m; i++) {
        cin >> u[i] >> v[i];
        g[u[i]].push_back(v[i]);
        g[v[i]].push_back(u[i]);
    }
    for (int i = 1; i <= n; i++) {
        vec.push_back({g[i].size(), i});
    }
    sort(vec.rbegin(), vec.rend());
    for (auto i : vec) {
        if (!used[i.second])
            dfs(i.second);
    }
    for (int i = 1; i <= m; i++) {
        int u1, u2;
        if (a[u[i]] < a[v[i]])
            u1 = 1;
        else if (a[u[i]] > a[v[i]])
            u1 = 2;
        else
            u1 = 3;
        if (b[u[i]] < b[v[i]])
            u2 = 1;
        else if (b[u[i]] > b[v[i]])
            u2 = 2;
        else
            u2 = 3;
        if (u1 != u2) {
            cout << "NO";
            return 0;
        }
    }
    bool u = 0;
    for (int i = 1; i <= n; i++) {
        if (a[i] != b[i]) {
            u = 1;
            break;
        }
    }
    if (!u) {
        assert(0);
        cout << "NO";
        return 0;
    }
    for (int i = 1; i <= n; i++) {
        aa[i] = b[i];
    }
    sort(aa + 1, aa + 1 + n);
    u = 0;
    for (int i = 1; i <= n; i++) {
        if (aa[i] == aa[i - 1]) {
            u = 1;
            break;
        }
    }
    if (!u) {
        cout << "NO";
        return 0;
    }
    cout << "YES\n";
    for (int i = 1; i <= n; i++) {
        cout << a[i] << " ";
    }
    cout << "\n";
    for (int i = 1; i <= n; i++) {
        cout << b[i] << " ";
    }
}
