#include<bits/stdc++.h>
#define pb push_back

using namespace std;

int main() {
    freopen("B.in", "r", stdin);
    freopen("B.out", "w", stdout);
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    vector<string> order;                           
    string prewords = "";
    while (true) {
        string all;
        getline(cin, all);
        prewords += all;
        prewords += "\n";
        string person = "";
        for (int i = 0; i < (int) all.size(); i++) {
            if (all[i] == '{') {
                int j = i + 1;
                while (j < (int) all.size() && all[j] != '}')
                    person += all[j++];
                order.pb(person);
                person.clear();
                i = j;
            }
        }
        if (all.back() == '.')
            break;
    }
    string all;
    getline(cin, all);
    map<string, string> speech;
    vector<string> myOrder;
    while (true) {
        getline(cin, all);
        if (all.substr(0, 8) == "\\bibitem") {
            int i = 9;
            string person = "";
            string talk = "";
            while (true) {
                char c = all[i++];
                if (c == '}')
                    break;
                person += c;                                
            }
            while (i < (int) all.size())
                talk += all[i++];
            speech[person] = talk;
            myOrder.pb(person);
        } else break;
    }
    if (order == myOrder)
        cout << "Correct", exit(0);    
    cout << "Incorrect\n";
    cout << "\\begin{thebibliography}{99}\n";
    for (auto& person : order)
        cout << "\\bibitem{" << person << "}" << speech[person] << endl;
    cout << "\\end{thebibliography}";            
    return 0;
}