#include<bits/stdc++.h>

using namespace std;

using ll = long long;

const ll NO = (ll) 1e16;
const int UN = (int) 2e9 + 1e5;

ll solve(vector<int>& a) {
    int n = a.size();
    ll ans = NO;
    int pos = UN, neg = UN;  
    set<int> s;
    for (int& x : a) {
        if (x == 0) {
            ans = min(ans, 0ll);
            continue;
        }            
        if (x > 0) {        
            if (neg != UN)
                ans = min(ans, x * 1ll * neg);
            if (pos != UN && pos < x)
                ans = min(ans, x * 1ll * pos);                                                                                    
            pos = min(pos, x);
        } else {
            if (!s.empty()) {
                auto it = s.lower_bound(x);
                if (it != s.begin()) {
                    it = prev(it);
                    ans = min(ans, x * 1ll * *it);
                }
            }
            neg = min(neg, x);
            s.insert(x);
        }
    }
    return ans;
}               

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    for (int n, l, r, x, y, z, b0, b1; t--;) {
        cin >> n >> l >> r >> x >> y >> z >> b0 >> b1;
        vector<ll> b(n);
        b[0] = b0;
        b[1] = b1;
        for (int i = 2; i < n; i++) {
            ll sum = (b[i - 2] * 1ll * x + b[i - 1] * 1ll * y + z);
            b[i] = sum % (1ll << 32);
        }
        vector<int> a(n);
        bool no = true;
        for (int i = 0; i < n; i++) {
            a[i] = b[i] % (r - l + 1) + l;
            no &= (a[i - 1] >= a[i]);
        } 
        if (no)
            cout << "IMPOSSIBLE";
        else
            cout << solve(a);
        cout << '\n';
    }
    return 0;
}