//Wonder Pets!
//#define _GLIBCXX_DEBUG

//#pragma comment(linker, "/stack:200000000")
//#pragma GCC optimize("Ofast")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4);
//#pragma GCC optimize("unroll-loops")

#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;
typedef unsigned int ui;

#define forn(i, n) for (int i = 1; i <= n; i++)
#define pb push_back
#define all(x) x.begin(), x.end()
#define y1 qwer1234

const double PI = acos(-1.0);
const int DIR = 8;
const int X[] = {-2, -1, 1, 2, 2, 1, -1, -2};
const int Y[] = {1, 2, 2, 1, -1, -2, -2, -1};

const int N = 10;

using namespace std;

int d[N][N], pr[N][N];
vector < string > ans;
bool used[N][N], blocked[N][N];

bool good(int x, int y)
{
	return x >= 1 && x <= 8 && y >= 1 && y <= 8;
}

string get(int x, int y)
{
	string res;
	res += char(y - 1 + 'a');
	res += char(x + '0');
	return res;
}
void relax(int x, int y){
    while(pr[x][y] != -1)
	{
		string s;
		s += get(x, y);
		s += '-';
		int dir = pr[x][y];
		x -= X[dir];
		y -= Y[dir];
		s += get(x, y);
		if(blocked[x][y]){
			relax(x, y);
			ans.pb(s);
			break;
		}
		ans.pb(s);
	}
}
void bfs(int sx, int sy)
{
	memset(d, -1, sizeof(d));	
	memset(pr, -1, sizeof(pr));
	d[sx][sy] = 0;
	queue < pair < int, int > > q;
	q.push({sx, sy});
	int fx = -1, fy = -1;
	while(!q.empty())
	{
		int x = q.front().first, y = q.front().second;
		q.pop();
		if (used[x][y])
		{
			fx = x, fy = y;
			break;
		}
		for (int i = 0; i < DIR; i++)
		{
			int tx = x + X[i], ty = y + Y[i];
			if (good(tx, ty) && d[tx][ty] == -1)
			{
				d[tx][ty] = d[x][y] + 1;
				pr[tx][ty] = i;
				q.push({tx, ty});
			}
		}
	}
	assert(fx != -1);
	int x = fx, y = fy;
	used[x][y] = false;
	relax(x, y);
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie();
	cout.tie();

	//freopen(".in", "r", stdin);
	//freopen(".out", "w", stdout);
	
	int n;
	cin >> n;
	forn(i, n)
	{
		string s;
		cin >> s;
		int x = s[1] - '0';
		int y = s[0] - 'a' + 1;
		used[x][y] = true;
	}
	for (int x = 1; x <= 8; x++)
	{
		for (int y = 1; y <= 8; y++)
		{   
			bfs(x, y);
			blocked[x][y] = true;			
			n--;
			if (n == 0)
				break;
		}
		if (n == 0)
			break;
	}
	//~result
	cout << (int)ans.size() << endl;
	for (auto it : ans)
		cout << it << endl;

	//cerr << 1.0 * clock() / CLOCKS_PER_SEC;

	return 0;
}