//Wonder Pets!
//#define _GLIBCXX_DEBUG

//#pragma comment(linker, "/stack:200000000")
//#pragma GCC optimize("Ofast")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4);
//#pragma GCC optimize("unroll-loops")

#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;
typedef unsigned int ui;

#define forn(i, n) for (int i = 1; i <= n; i++)
#define pb push_back
#define all(x) x.begin(), x.end()
#define y1 qwer1234

const double PI = acos(-1.0);
const int DIR = 4;
const int X[] = {1, 0, -1, 0};
const int Y[] = {0, 1, 0, -1};

const int MOD = (int)1e9 + 7;
const int BASE = 1021;
const int N = (int)3e5 + 228;

using namespace std;

int T[N << 2], mn[N];
string s, t;
pair < ll, unsigned long long > f[N], h[2][N];

pair < ll, unsigned long long > get(int l, int r, int id)
{
	l++, r++;
	pair < ll, unsigned long long > res;
	res.first = (h[id][r].first - (h[id][l - 1].first * f[r - l + 1].first % MOD) + MOD) % MOD;
	res.second = (h[id][r].second - (h[id][l - 1].second * f[r - l + 1].second));
	return res;
}

void upd(int l, int r, int v, int tl, int tr, int val)
{
	if (tl > r || tr < l)
		return;
	if (tl >= l && tr <= r)
	{
		T[v] = max(T[v], val);
		return;
	}
	int mid = (tl + tr) >> 1;
	upd(l, r, v << 1, tl, mid, val);
	upd(l, r, v << 1 | 1, mid + 1, tr, val);
}

int get(int id, int v, int tl, int tr)
{
	if (tl == tr)
		return T[v];
	int mid = (tl + tr) >> 1;
	if (id <= mid)
		return max(T[v], get(id, v << 1, tl, mid));
	else
		return max(T[v], get(id, v << 1 | 1, mid + 1, tr));
}

int main()
{
	//ios_base::sync_with_stdio(false);
	//cin.tie();
	//cout.tie();

	//freopen(".in", "r", stdin);
	//freopen(".out", "w", stdout);
	cin >> s;
	cin >> t;
	f[0].first = 1, f[0].second = 1;
	int n = (int)s.size(); 
	int m = (int)t.size(); 
	forn(i, max(n, m))
	{
		f[i].first = (f[i - 1].first * BASE) % MOD;
		f[i].second = f[i - 1].second * BASE;
	}
	forn(i, n)
	{
		h[0][i].first = (h[0][i - 1].first * BASE + s[i - 1]) % MOD;
		h[0][i].second = (h[0][i - 1].second * BASE + s[i - 1]);
	}
	forn(i, m)
	{
		h[1][i].first = (h[1][i - 1].first * BASE + t[i - 1]) % MOD;
		h[1][i].second = (h[1][i - 1].second * BASE + t[i - 1]);		
	}
	for(int i = 0; i < (N << 2); i++)
		T[i] = -1;
	for(int i = 0; i < s.size(); i++){
		int ans = 0, l = 0, r = min(s.size() - i, t.size());
		while(l <= r){
			int m = (l + r) >> 1;
			if(get(i, i + m - 1, 0) == get(0, m - 1, 1))
				ans = m, l = m + 1;
			else
				r = m - 1;
		}
		if(ans > 0)
        	upd(i , i + ans - 1, 1, 0, n - 1, i);
	}
	for(int i = 0; i < s.size(); i++)
		mn[i] = get(i, 1, 0, n - 1);
	ll ans = 0;
	for(int i = 0; i < s.size(); i++){
		if(mn[i] == -1 || mn[i] == 0)
			ans += t.size();
		else
			ans += i - mn[i] + 1;
	}
	cout << ans;
	return 0;
}