#include <bits/stdc++.h>
             
#define F first
#define S second
#define mp make_pair
#define pb push_back
#define sz(x) (int)x.size()

using namespace std;

const int N = (int)1e5 + 123;
const int mod = 1e9 + 7;
const int INF = (int)1e7;
const bool SUBMIT = 1;

int dx[] = {-1, -1, 1, 1, -2, -2, 2, 2};
int dy[] = {2, -2, 2, -2, 1, -1, 1, -1};

vector<pair<pair<int, int>, pair<int, int> > > ansV;

bool need[10][10];

bool arr[10][10];

int d[10][10];

int p[10][10];

queue<pair<int, int> > q;

int n;

vector<pair<int, int> > shortest(int ax, int ay, int bx, int by) {
	for (int i = 1; i <= 8; ++i) {
		for (int j = 1; j <= 8; ++j) {
			d[i][j] = INF;
		}
	}

	d[ax][ay] = 0;
	q.push(mp(ax, ay));

	while (!q.empty()) {
		int cx = q.front().F;
		int cy = q.front().S;

		q.pop();
                                              
        for (int dir = 0; dir < 8; ++dir) {      
			int nx = cx + dx[dir];
			int ny = cy + dy[dir];

			if (nx < 1 || nx > 8 || ny < 1 || ny > 8) {
				continue;
			}

			if (d[nx][ny] == INF) {
				d[nx][ny] = d[cx][cy] + 1;
				p[nx][ny] = dir;
				q.push(mp(nx, ny));
			}		
		}
	}

	vector<pair<int, int> > ret;

	for (int x = bx, y = by; x != ax || y != ay; ) {
		int k = p[x][y];
		ret.pb(mp(x, y));
		x -= dx[k], y -= dy[k];
	}

	ret.pb(mp(ax, ay));	
	return ret;	
}

void Go(int ax, int ay, int bx, int by) {
	vector<pair<int, int> > V = shortest(ax, ay, bx, by);

	for (int i = 1; i < V.size(); ++i) {
		int cx = V[i].F, cy = V[i].S;

		if (arr[cx][cy]) {
			int j = i - 1;

			while (j >= 0 && !arr[V[j].F][V[j].S]) {
				swap(arr[V[j].F][V[j].S], arr[V[j + 1].F][V[j + 1].S]);
				ansV.pb(mp(V[j + 1], V[j]));
				--j;
			}
		}
	}
}

int main () {
    ios_base::sync_with_stdio (0);
    cin.tie (0), cout.tie (0);

    if (SUBMIT) {
    cin >> n;

    for (int i = 1; i <= n; ++i) {
    	char givenA;
    	int x, y;

    	cin >> givenA >> x;		
		y = givenA - 'a' + 1;

	  	arr[x][y] = 1;
    }
    }
    else {
    	n = 63;

    	for (int i = 1; i <= 8; ++i) {
			for (int j = 1; j <= 8; ++j) {
				arr[i][j] = 1;
			}    		
    	}

    	arr[8][1] = 0;
    }

    for (int i = 1, k = n; i <= 8; ++i) {
		for (int j = 1; j <= 8; ++j) {
			if (k > 0) {
				need[i][j] = 1;
				--k;
			}
		}    
    }

    for (int step = 0; step < 5; ++step) {         
	for (int i = 1; i <= 8; ++i) {
		for (int j = 1; j <= 8; ++j) {
			if (need[i][j] && arr[i][j] == 0) {
				bool ex = 0;

				for (int ni = 1; ni <= 8 && ex == 0; ++ni) {
					for (int nj = 1; nj <= 8 && ex == 0; ++nj) {
						if (arr[ni][nj] && need[ni][nj] == 0) {
							Go(ni, nj, i, j);
							ex = 1;			
						}
					}
				}	
			}
		}
	}
	}
	
	assert(ansV.size() <= 1500);
	cout << ansV.size() << endl;

	for (auto it : ansV) {
		auto itA = it.F;
		auto itB = it.S;

		cout << (char)(itA.S + 'a' - 1) << itA.F << '-' << (char)(itB.S + 'a' - 1) << itB.F << endl;
	}

	return 0;
}     
