#include <bits/stdc++.h>
             
#define F first
#define S second
#define mp make_pair
#define pb push_back
#define sz(x) (int)x.size()

typedef long long ll;

using namespace std;

const int MAXN = (int)2e7 + 5;
const bool SUBMIT = 1;
const ll mod = (1ll << 32);
const ll INF = (ll)5e18;
    
ll l, r, x, y, z;

vector<ll> S;

ll arr[MAXN];

int n;

void solve() {
	if (SUBMIT) {
	cin >> n >> l >> r >> x >> y >> z;
	cin >> arr[1] >> arr[2];

	for (int i = 3; i <= n; ++i) {
		arr[i] = (arr[i - 2] * x + arr[i - 1] * y + z) % mod;
	}

	for (int i = 1; i <= n; ++i) {
		arr[i] = l + arr[i] % (r - l + 1);
	}
	}
	else {
		cin >> n;

		for (int i = 1; i <= n; ++i) {
			cin >> arr[i];
		}

	}

	S.clear();

	ll ans = INF;        
    ll mn = INF;

    for (int i = 1; i <= n; ++i) {
    	if (arr[i] >= 0) {	
    		if (mn < arr[i]) {
				ans = min(ans, arr[i] * mn);    		
    		}
    	}
    	else {
    		ll cur = -arr[i];

			while (!S.empty() && S.back() > cur) {
				ans = min(ans, cur * S.back());
				S.pop_back();
			}    			

			S.push_back(cur);
    	}

    	mn = min(mn, arr[i]);
    }

    if (ans == INF) {
    	cout << "IMPOSSIBLE" << endl;
    }
    else {
    	cout << ans << endl;
    }	
}

int main () {
    ios_base::sync_with_stdio (0);
    cin.tie (0), cout.tie (0);
	
	int tt;
	cin >> tt;

	while (tt--) {
		solve();
	}
	
	return 0;
}     
