#include <iostream>
#include <map>

#define ll long long

using namespace std;

map<string, int> m;
map<int, string> texta;
map<string, int> ans;
map<int, string> kol;

int main() {
    ios::sync_with_stdio(NULL), cin.tie(NULL), cout.tie(NULL);
    string beg = "\\begin{thebibliography}{";
    string en = "\\end{thebibliography}";
    int rim = 0, hh = 1, l_max = 0;
    string g;
    while(true){
        string s;
        getline(cin, s);
        if(s.length() >= beg.length()){
            int e = 0, f = 0;
            for (int i = 0; i < beg.length(); ++i) {
                if(s[i] != beg[i]){
                    e = 1;
                    break;
                }
                f = i;
            }
            if(e == 0) {
                if(s[f + 2] == '}'){
                    l_max = (s[f + 1] - '0');
                } else {
                    l_max = (s[f + 1] - '0')*10 + (s[f + 2] - '0');
                }
                rim = 1;
                continue;
            }
        }
        if(s.length() >= en.length()){
            int e = 0;
            for (int i = 0; i < en.length(); ++i) {
                if(s[i] != en[i]){
                    e = 1;
                    break;
                }
            }
            if(e == 0)break;
        }
        if(rim == 0){
            g += s;
        } else {
            string str;
            for (int i = 9; ; ++i) {
                if(s[i] == '}'){
                    string tex;
                    for (int j = i + 1; j < s.length(); ++j) {
                        tex += s[j];
                    }
                    texta[hh] = tex;
                    break;
                }
                str += s[i];
            }
            m[str] = hh;
            hh++;
        }
    }
    hh = 1;
    int incor = 0;
    for (int i = 0; i < g.length(); ++i) {
        if(i + 6 < g.length() && g[i] == '\\' && g[i + 1] == 'c' && g[i + 2] == 'i' && g[i + 3] == 't' && g[i + 4] == 'e' && g[i + 5] == '{'){
            i += 6;
            string s;
            for (int j = i;; ++j) {
                if(g[j] == '}'){
                    i = j;
                    break;
                }
                s += g[j];
            }
            if(m[s] != hh){
                incor = 1;
            }
            ans[s] = hh;
            kol[hh] = s;
            hh++;
        }
    }
    if(hh - 1 > l_max){
        incor = 1;
    }
    if(incor == 0){
        cout << "Correct";
    } else {
        cout << "Incorrect\n";
        cout << "\\begin{thebibliography}{99}\n";
        for (int i = 1; i < hh; ++i) {
            cout << "\\bibitem{" << kol[i] << "}" << texta[m[kol[i]]] << '\n';
        }
        cout << "\\end{thebibliography}";
    }
    return 0;
}
/*
The most famous characters of Pushkin’s works are Onegin \cite{onegin},
Dubrovsky \cite{dubrovsky} and Tsar Saltan \cite{saltan}.
\begin{thebibliography}{99}
\bibitem{saltan} A.S.Pushkin. The Tale of Tsar Saltan. 1832.
\bibitem{onegin} A.S.Pushkin. Eugene Onegin. 1831.
\bibitem{dubrovsky} A.S.Pushkin. Dubrovsky. 1841.
\end{thebibliography}


 * */