#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <iomanip>
typedef unsigned int uint;
int main(int argc, char*argv[])
{
	int n; std::cin >> n;
	int m; std::cin >> m;
	std::vector<std::vector<int>> comps(n);
	for (size_t i = 0; i < m; i++)
	{
		int a, b; std::cin >> a >> b; a--; b--;
		comps[a].push_back(b);
		comps[b].push_back(a);
	}
	for (size_t i = 0; i < m; i++)
	{
		std::sort(comps[i].begin(), comps[i].end());
	}
	int ui = -1, uj = -1;
	for (size_t i = 0; i < n; i++)
	{
		for (size_t j = 0; j < m; j++)
		{
			if (i == j) continue;
			if (std::binary_search(comps[i].begin(), comps[i].end(), j))
			{
				continue;
			}
			ui = i; uj = j;
		}
	}
	if (ui == -1)
	{
		std::cout << "NO";
		return 0;
	}
	std::cout << "YES\n";
	for (size_t i = 0; i < n; i++)
	{
		std::cout << i + 1 << " ";
	}
	std::cout << '\n';
	for (size_t i = 0; i < n; i++)
	{
		if (i == ui || i == uj) std::cout << std::min(ui + 1, uj + 1) << " ";
		else std::cout << i + 1 << " ";
	}
	return 0;
}