#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <iomanip>
#include <string>
std::vector<int> zfunction(std::string s)
{
	int n = (int)s.length();
	std::vector<int> z(n);
	for (int i = 1, l = 0, r = 0; i < n; i++)
	{
		if (i <= r)
			z[i] = std::min(r - i + 1, z[i - l]);
		while (i + z[i] < n && s[z[i]] == s[i + z[i]])
			++z[i];
		if (i + z[i] - 1 > r) l = i, r = i + z[i] - 1;
	}
	return z;
}
typedef unsigned int uint;
struct creature
{
	int atk = 1;
	int hp = 1;
	int deathTime = -1;
};
int main(int argc, char*argv[])
{
	int n; std::cin >> n;
	int time = 0;
	std::vector<creature> creatures(n, { -2,-2,-2 });
	int k = 0;
	for (size_t i = 0; i < n; i++)
	{
		int type;
		time++;
		std::cin >> type;
		switch (type)
		{
		case 1:
			creatures[k++] = creature();
			break;
		case 2:
		case 3:
		{
			int to; std::cin >> to;
			to--;
			creatures[to] = { creatures[to].atk *(1 + (type == 2)), creatures[to].hp * (1 + (type == 3)), creatures[to].deathTime };
		}
		break;
		case 4:
		{
			int to; std::cin >> to;
			to--;
			creatures[k++] = { creatures[to].atk, creatures[to].hp, creatures[to].hp == -1 ? time : -1 };
		}
		break;
		case 5:
		{
			int a, b; std::cin >> a >> b; a--; b--;
			creature ca = creatures[a], cb = creatures[b];
			if (ca.hp == -1) goto exit;
			if (cb.hp == -1) goto exit;
			int nh1 = ca.hp - cb.atk;
			int nh2 = cb.hp - ca.atk;
			if (nh1 <= 0) creatures[a] = { -1,-1,time };
			else creatures[a] = { ca.atk,nh1,-1 };
			if (nh2 <= 0) creatures[b] = { -1,-1,time };
			else creatures[b] = { cb.atk,nh2,-1 };
		exit:;
		}
		break;
		}
	}
	std::cout << k << '\n';
	for (size_t i = 0; i < k; i++)
	{
		std::cout << creatures[i].deathTime << ' ';
	}
	return 0;
}