#include <bits/stdc++.h>

using namespace std;

bool has_k[8][8];
int px[8][8], py[8][8], u[8][8];
char s[3];

vector<int> hx, hy, hhx, hhy;

int dx[] = { 2,  2, -2, -2, 1,  1, -1, -1};
int dy[] = { 1, -1,  1, -1, 2, -2,  2, -2};

void print_pos(int x, int y) {
    cout << char(x + 'a') << char(y + '1');
}

bool check(int x, int y) {
    return x >= 0 && y >= 0 && x < 8 && y < 8;
}

int main() {
    int n;

    cin >> n;
    for(int i = 0; i < n; ++i) {
        cin >> s;
        has_k[s[0]-'a'][s[1]-'1'] = true;
    }

    for(int k = 0; k < n; ++k) {
        queue<int> qx; qx.push(k%8);
        queue<int> qy; qy.push(k/8);

        for(int i = 0; i < 8; ++i)
            for(int j = 0; j < 8; ++j)
                px[i][j] = py[i][j] = u[i][j] = -1;
        u[k%8][k/8] = 0;

        for(;;) {
            int x = qx.front(); qx.pop();
            int y = qy.front(); qy.pop();

            if(has_k[x][y] && x+y*8 >= k) {
                has_k[x][y] = false;
                has_k[k%8][k/8] = true;
                for(; px[x][y] != -1;) {
                    int nx = px[x][y];
                    int ny = py[x][y];

                    hx.push_back(x);
                    hy.push_back(y);
                    hhx.push_back(nx);
                    hhy.push_back(ny);

                    x = nx; y = ny;
                }
                break;
            }

            for(int j = 0; j < 8; ++j) {
                int nx = x + dx[j];
                int ny = y + dy[j];

                if(check(nx, ny) && u[nx][ny] == -1) {
                    u[nx][ny] = 0;
                    px[nx][ny] = x; qx.push(nx);
                    py[nx][ny] = y; qy.push(ny);
                }
            }
        }
    }

    cout << hx.size() << endl;
    for(int i = 0; i < hx.size(); ++i) {
        print_pos(hx[i], hy[i]);
        cout << '-';
        print_pos(hhx[i], hhy[i]);
        cout << endl;
    }
}
