#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const long long MOD = 1ll << 32, INF = 2e18;

ll find_ans(auto &q){
    ll min_value = INF;
    bool fl = false;
    ll res = INF;
    for(auto it: q){
        if(min_value < it)
            res = min(res, 1ll * it * min_value);
        if(fl && 0 < it)
            res = min(res, 0ll);
        if(it == 0)
            fl = true;
        min_value = min(min_value, 1ll * it);
    }
    return res;
}

void solve(auto &ms){
    ll ans = find_ans(ms);
    reverse(ms.begin(), ms.end());
    vector<int> tmp;
    for(auto it: ms)
        if(it <= 0)
            tmp.push_back(-it);
    ans = min(ans, find_ans(tmp));
    if(ans == INF)
        printf("IMPOSSIBLE\n");
    else
        printf("%lld\n", ans);
}

auto scan_test(){
    vector<int> q;
    int n;
    scanf("%d", &n);
    for(int i = 0; i < n; ++i){
        int x;
        scanf("%d", &x);
        q.push_back(x);
    }
    return q;
}

auto make_test(){
    ll n, l, r, x, y, z;
    scanf("%lld%lld%lld%lld%lld%lld", &n, &l, &r, &x, &y, &z);
    vector<ll> B(n, 0);
    vector<int> A(n, 0);
    scanf("%lld%lld", &B[0], &B[1]);
    for(int i = 2; i < n; ++i){
        B[i] += B[i - 2] * x % MOD;
        B[i] %= MOD;
        B[i] += B[i - 1] * y % MOD;
        B[i] %= MOD;
        B[i] += z;
        B[i] %= MOD;
    }
    for(int i = 0; i < n; ++i)
        A[i] = (B[i] % (r - l + 1)) + l;
    return A;
}

int main(){
    //freopen("input.txt", "r", stdin);
    int t;
    scanf("%d", &t);
    for(int i = 0; i < t; ++i){
        vector<int> tmp = make_test();
        solve(tmp);
    }
    return 0;
}
