#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;

const unsigned long long MOD = 1ll << 32ll;
const long long INF = (ll)4e18 + 4;

ll find_ans(auto &q){
    ll min_value = INF;
    bool fl = false;
    ll res = INF;
    for(auto it: q){
        if(min_value < it)
            res = min(res, 1ll * it * min_value);
        if(fl && 0 < it)
            res = min(res, 0ll);
        if(it == 0)
            fl = true;
        min_value = min(min_value, 1ll * it);
    }
    return res;
}

void solve(auto ms){
    ll ans = find_ans(ms);
    reverse(ms.begin(), ms.end());
    vector<ll> tmp;
    for(auto it: ms)
        if(it <= 0)
            tmp.push_back(-it);
    ans = min(ans, find_ans(tmp));
    if(ans == INF)
        cout << "IMPOSSIBLE" << endl;
    else
        cout << ans << endl;
}

auto scan_test(){
    vector<ll> q;
    int n;
    scanf("%d", &n);
    for(int i = 0; i < n; ++i){
        ll x;
        scanf("%lld", &x);
        q.push_back(x);
    }
    return q;
}

auto make_test(){
    ll n, l, r;
    ull x, y, z;
    cin >> n >> l >> r >> x >> y >> z;
    vector<ll> A(n, 0);
    vector<ull> B(n, 0);
    cin >> B[0] >> B[1];
    for(int i = 2; i < n; ++i){
        B[i] += B[i - 2] % MOD * x % MOD;
        B[i] %= MOD;
        B[i] += B[i - 1] % MOD * y % MOD;
        B[i] %= MOD;
        B[i] += z;
        B[i] %= MOD;
    }
    for(int i = 0; i < n; ++i)
        A[i] = (B[i] % (r - l + 1)) + l;
    return A;
}

auto debug_test(){
    int n = 5;
    vector<int> q;
    for(int i = 0; i < n; ++i)
        q.push_back(rand() * rand() * (rand() % 2 ? -1 : 1));
    return q;
}

ll true_solve(auto &ms){
    int n = ms.size();
    ll res = INF;
    for(int i = 0; i < n; ++i)
    for(int j = i + 1; j < n; ++j)
        if(i < j && ms[i] < ms[j])
            res = min(res, 1ll * ms[i] * ms[j]);
    return res;
}

int main(){
    //freopen("input.txt", "r", stdin);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    for(int i = 0; i < t; ++i){
        vector<ll> tmp = make_test();
        solve(tmp);
    }
    return 0;
}
