#include <bits/stdc++.h>

using namespace std;

int n;

map<pair<string, int>, vector<int> > mp;

int get_mask(string &st){
    int mask = 0;
    for(auto it: st)
        mask |= (1 << (it - 'a'));
    return mask;
}

string get_pref(string &st, int mask){
    int n = st.length();
    int pos = -1;
    for(int i = 0; i < n; ++i){
        int key = st[i] - 'a';
        if(!(mask & (1 << key)))
            pos = i;
    }
    string res;
    for(int i = 0; i <= pos; ++i)
        res += st[i];
    return res;
}

int main(){
    //freopen("input.txt", "r", stdin);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    for(int i = 0; i < n; ++i){
        string a, b;
        cin >> a >> b;
        int mask = get_mask(b);
        string st = get_pref(a, mask);
        mp[{st, mask}].push_back(i + 1);
    }
    printf("%d\n", (int)mp.size());
    for(auto &it: mp){
        auto &q = it.second;
        printf("%d ", (int)q.size());
        for(auto it: q)
            printf("%d ", it);
        printf("\n");
    }
    return 0;
}
