from pprint import pprint

n = int(input())

companies = list()


def merge_companies(comp_1, comp_2):
    new_comp = dict(max=0, count=(comp_1['count'] + comp_2['count']))
    shift = 0

    if comp_1['max'] > comp_2['max']:
        new_comp['max'] = comp_1['max']
        shift = (comp_1['max'] - comp_2['max']) * comp_2['count']

    elif comp_2['max'] > comp_1['max']:
        new_comp['max'] = comp_2['max']
        shift = (comp_2['max'] - comp_1['max']) * comp_1['count']

    else:
        new_comp['max'] = comp_1['max']

    return new_comp, shift


for _ in range(n):
    data = list(map(int, input().split()))
    del(data[0])

    companies.append({'max': max(data), 'count': len(data)})

companies.sort(key=lambda x: x['max'])
sum = 0

while len(companies) > 1:
    comp_1 = companies[0]
    comp_2 = companies[1]

    new_comp, shift = merge_companies(comp_1, comp_2)

    companies[0] = new_comp
    del(companies[1])
    sum += shift

# pprint(companies)
print(sum)

