import sys
from pprint import pprint
from copy import deepcopy


def read_text():
    references = list()
    bib_items = dict()
    # bib_items_keys = list()

    line = ''

    while True:
        line = sys.stdin.readline().strip()
        # print(line)

        if r"\begin{thebibliography}" in line:
            break

        if '\cite{' in line:
            line = line.split('\cite{')
            # print(line)

            for part in line:
                # print(part)
                if '}' in part:
                    references.append(part.split('}')[0])

    while True:
        line = sys.stdin.readline().strip()

        if r'\end{thebibliography}' in line:
            break

        key = line.split(r'\bibitem{')[1].split('}')[0]
        # tmp = {key: line}

        bib_items[key] = deepcopy(line)
        # bib_items_keys.append(key)

    return references, bib_items


references, bib_items = read_text()
# pprint(references)
# pprint(bib_items)
# pprint(bib_items.keys())

# pprint(references)
# pprint(list(bib_items.keys()))

if references == list(bib_items.keys()):
    print('Correct')
    exit(0)

else:
    print('Incorrect')
    print(r'\begin{thebibliography}{99}')
    for key in references:
        print(bib_items[key])
    print('\end{thebibliography}')
