#include <fstream>
#include <cstring>
#include <vector>
#include <map>
using namespace std;

int main()
{
    ifstream cin("in.txt");
    ofstream cout("out.txt");
    string s;

    vector<string> LinksText;
    while (cin >> s and s!="\\begin{thebibliography}{99}")
    {
        ///cout << "||||" << s.substr(0, 6) << "||||";
        if (s.substr(0, 6) == "\\cite{")
        {
            int j;
            for (j=6; j<s.length(); j++)
            {
                if (s[j] == '}')
                    break;
            }

            LinksText.push_back(s.substr(6, j-6));
        }
    }
    /**
    cout << "LinksText\n";
    for (string k : LinksText)
        cout << k << endl;
    cout << endl;
    **/
    vector<string> Links, Descriptions;
    string desc = "";
    while (cin >> s and s!="\\end{thebibliography}")
    {
        if (s.substr(0, 9) == "\\bibitem{")
        {
            int j;
            for (j=10; j<s.length(); j++)
            {
                if (s[j]=='}')
                    break;
            }
            string l = s.substr(9, j-9);
            Links.push_back(l);
            if (desc!="") Descriptions.push_back(desc);
            desc = "";
        }
        else
            desc += s + ' ';
    }
    int jend = desc.length()-1;
    while (desc[jend]==' ') jend -= 1;
    Descriptions.push_back(desc.substr(0, jend+1));
    /**
    cout << "Links -> Descriptions\n";
    for (int i=0; i<Links.size(); i++)
    {
        cout << Links[i] << " " << Descriptions[i] << endl;
    }
    **/
    bool f = true;
    for (int i=0; i<Links.size(); i++)
    {
        if (Links[i] != LinksText[i])
        {
            f = false;
            break;
        }
    }

    if (f==true)
        cout << "Correct";
    else
    {
        map<string, string> D;
        for (int i=0; i<Links.size(); i++)
        {
            D[Links[i]] = Descriptions[i];
        }

        cout << "Incorrect" << endl;
        cout << "\\begin{thebibliography}{99}" << endl;
        for (int i=0; i<Links.size(); i++)
        {
            string outt = "\\bibitem{" + LinksText[i] + "} " + D[LinksText[i]];
            int jend = outt.length()-1;
            while (outt[jend]==' ') jend -= 1;
            cout << outt.substr(0, jend+1) << "\n";
        }
        cout << "\\end{thebibliography}";
    }

}
