#include <iostream>
#include <cmath>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>

#define pb push_back
#define mp make_pair

using namespace std;

int N, M;
set<pair<int, int> > used;
vector<int> flag, a, b;
vector<pair<int, int> > p;
vector<vector<int> > cnt;

void in()
{
    cin >> N >> M;
    int v, u;
    flag.resize(N + 1, 0);
    a.resize(N + 1);
    b.resize(N + 1);
    cnt.resize(N + 1, vector<int>(1, 0));
    for (int i = 1; i <= M; i++)
    {
        cin >> v >> u;
        if (v < u)
            swap(v, u);
        if (used.find({v, u}) == used.end())
        {
            used.insert({v, u});
            p.push_back({v, u});
            if (abs(v - u) == 1)
            {
                if (v < u)
                {
                    flag[u] = 1;
                }
                else
                    flag[v] = 1;
            }
            if (v < u)
            {
                cnt[u][0]++;
                cnt[u].push_back(v);
            }
            else
            {
                cnt[v][0]++;
                cnt[v].push_back(u);
            }
        }
    }
}

void check()
{
    vector<int> mb;
    for (int i = 1; i <= N; i++)
    {
        if (cnt[i][0] != i - 1)
        {
            sort(cnt[i].begin(), cnt[i].end());
            mb.push_back(i);
            for (int j = 1; j < cnt[i][0]; j++)
            {
                if (cnt[i][j] != cnt[i][j - 1] + 1)
                {
                    swap(a[i], a[i - 1]);
                    int cur = cnt[i][j] - 1;
                    b[i - 1] = i;
                    b[i] = cur + 1;
                    //int sz = p.size();
                    int fl = 1;
                    /*for (int j = 0; j < sz; j++)
                    {
                        if (!(a[p[j].first] < a[p[j].second]
                        || a[p[j].first] > a[p[j].second]))
                        {
                            fl = 0;
                            break;
                        }
                    }*/
                    if (fl)
                    {
                        cout << "YES\n";
                        for (int i = 1; i <= N; i++)
                            cout << a[i] << " ";
                        cout << "\n";
                        for (int i = 1; i <= N; i++)
                        {
                            cout << b[i] << " ";
                        }
                        return;
                    }
                }
            }
            /*int cur = cnt[i][cnt[i][0] - 1];
            if (cur != i - 2)
            {
                swap(a[i], a[i - 1]);
                b[i - 1] = i;
                b[i] = cur + 1;
                int sz = p.size();
                int fl = 1;
                for (int j = 0; j < sz; j++)
                {
                    if (!(a[p[j].first] < a[p[j].second]
                    || a[p[j].first] > a[p[j].second]))
                    {
                        fl = 0;
                        break;
                    }
                }
                if (fl)
                {
                    cout << "YES\n";
                    for (int i = 1; i <= N; i++)
                        cout << a[i] << " ";
                    cout << "\n";
                    for (int i = 1; i <= N; i++)
                    {
                        cout << b[i] << " ";
                    }
                    return;
                }
                else
                {
                    swap(a[i], a[i - 1]);
                    b[i - 1] = b[i - 1];
                    b[i] = i;
                }
            }*/
        }
    }
    /*int h = 0, t = 1;
    vector<vector<int> > q;
    int sz = mb.size();
    set<vector<int> > u;
    u.insert(vector<int>(sz + 1, 0));
    q.push_back(vector<int>(sz + 1, 0);
    while (h < t)
    {
        int tmp = q[h];
        for (int i = 0; i < sz; i++)
        {
            tmp = q[h];
            tmp[i] = 1 - tmp[i];
            if (u.find(tmp) == u.end())
            {
                u.insert(tmp);
                t++;
                q.push_back(tmp);
            }
        }
        h++;
    }
    int szq = q.size();
    for (int i = 0; i < szq; i++)
    {
        for (int j = 0; j < sz; j++)
        {
            if (q[i][j])
            {

            }
        }
    }*/
    cout << "NO";
}

void solution()
{
    if (N == 1 && M == 1)
    {
        cout << "NO";
        return;
    }
    flag[1] = 1;
    int c = 0;
    for (int i = 1; i <= N; i++)
    {
        a[i] = i;
        b[i] = i;
        //cout << flag[i] << " ";
        if (!flag[i])
        {
            c = i;
            //break;
        }
    }
    if (!c)
    {
        check();
        return;
    }
    cout << "YES\n";
    for (int i = 1; i <= N; i++)
        cout << i << " ";
    cout << "\n";
    for (int i = 1; i <= N; i++)
    {
        if (c == i)
        {
            cout << i - 1 << " ";
        }
        else cout << i << " ";
    }
}

void out()
{

}

int main()
{
    in();
    solution();
    out();
    return 0;
}
