#include <bits/stdc++.h>

#define endl '\n'

using namespace std;

typedef long long ll;
typedef unsigned long long ull;

int main()
{
    ios_base::sync_with_stdio(0);cin.tie(0);

    const ll LINF = (ll)8e18;
    const int INF = (1LL << 31) - 1;

    int t;
    cin >> t;
    for (int tt = 0; tt < t; tt++) {
        ull n, l, r, x, y, z, b1, b2;
        cin >> n >> l >> r >> x >> y >> z >> b1 >> b2;
        vector<int> a(n);

        for (int i = 0; i < n; i++) {
            ull b = (b1 * x) % (((ull)1) << 32) + (b2 * y) % (((ull)1) << 32) + z;
            b %= ((ull)1) << 32;
            if (i == 0) b = b1;
            if (i == 1) b = b2;

            a[i] = (b % (r - l + 1)) + l;
            if (i > 1) {
                b1 = b2;
                b2 = b;
            }
        }

        ll ans = LINF;
        int min1 = INF, min2 = INF;
        for (int i = 0; i < n; i++) {
            if (a[i] >= 0) {
                if (min1 < a[i]) {
                    ans = min(ans, 1LL * a[i] * min1);
                }
                if (min2 < a[i]) {
                    ans = min(ans, 1LL * a[i] * min2);
                }
            }

            if (a[i] < min1) {
                min2 = min1;
                min1 = a[i];
            } else if (a[i] < min2 && a[i] > min1) {
                min2 = a[i];
            }
        }

        int max1 = -INF, max2 = -INF;
        for (int i = n - 1; i >= 0; i--) {
            if (a[i] < 0) {
                if (a[i] < max1) {
                    ans = min(ans, 1LL * a[i] * max1);
                }
                if (a[i] < max2) {
                    ans = min(ans, 1LL * a[i] * max2);
                }
            }

            if (a[i] > max1) {
                max2 = max1;
                max1 = a[i];
            } else if (a[i] > max2 && a[i] < max1) {
                max2 = a[i];
            }
        }

        if (ans == LINF) cout << "IMPOSSIBLE\n";
        else cout << ans << endl;
    }

    return 0;
}
