#include <bits/stdc++.h>

#define endl '\n'

using namespace std;

typedef long long ll;
typedef unsigned long long ull;

struct obj {
    int i, mask;
    string s;

    operator < (obj o) {
        return mask < o.mask;
    }
};

int main()
{
    ios_base::sync_with_stdio(0);cin.tie(0);

    int n;
    cin >> n;

    vector<obj> a;
    for (int i = 0; i < n; i++) {
        string s, t;
        cin >> s >> t;
        obj o = {i, 0, s};

        for (int x = 0; x < t.size(); x++) {
            o.mask |= 1 << (t[x] - 'a');
        }
        for (int i = o.s.size(); i >= 1; i--) {
            if (o.mask & (1 << (o.s[o.s.size() - 1] - 'a'))) {
                o.s.pop_back();
            } else {
                break;
            }
        }
        a.push_back(o);
    }
    sort(a.begin(), a.end());

    vector<vector<int>> ans;
    map<string, vector<int>> m;
    int last = -1;
    for (int i = 0; i < n; i++) {
        if (last != -1 && last != a[i].mask) {
            for (auto e : m) {
                ans.push_back(e.second);
            }
            m.clear();
        }
        m[a[i].s].push_back(a[i].i);
        last = a[i].mask;
    }
    for (auto e : m) {
        ans.push_back(e.second);
    }

    cout << ans.size() << endl;
    for (auto e : ans) {
        cout << e.size() << ' ';
        for (auto ee : e) cout << ee + 1 << ' ';
        cout << endl;
    }

    return 0;
}
/*&

1
qwertyuioplkjhgfdsazxcvbnm qwertyuioplkjhgfdsazxcvbnm




*/
