#define M_E        2.71828182845904523536   // e
#define M_LOG2E    1.44269504088896340736   // log2(e)
#define M_LOG10E   0.434294481903251827651  // log10(e)
#define M_LN2      0.693147180559945309417  // ln(2)
#define M_LN10     2.30258509299404568402   // ln(10)
#define M_PI       3.14159265358979323846   // pi
#define M_PI_2     1.57079632679489661923   // pi/2
#define M_PI_4     0.785398163397448309616  // pi/4
#define M_1_PI     0.318309886183790671538  // 1/pi
#define M_2_PI     0.636619772367581343076  // 2/pi
#define M_2_SQRTPI 1.12837916709551257390   // 2/sqrt(pi)
#define M_SQRT2    1.41421356237309504880   // sqrt(2)
#define M_SQRT1_2  0.707106781186547524401  // 1/sqrt(2)
#include <iostream>
#include <fstream>
#include <sstream>
#include <cmath>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <string>
#include <unordered_map>
#include <unordered_set>

using namespace std;

#define IN_FILE "in.txt"
#define OUT_FILE "out.txt"

#define EPS 1e-6
#define INF 1e18
#define SMALL_INF 1e9

#pragma warning (disable : 4996)

struct person
{
	long long a, h, t;
	person(long long _a, long long _h)
	{
		a = _a;
		h = _h;
		t = -1;
	}
	person()
	{
		a = h = 0;
		t = -1;
	}
};

vector<person> game;
int hod = 1;

void prisiv_sushestva()
{
	game.emplace_back(1, 1);
}

void blagoslovenie_sili()
{
	int k;
	cin >> k;
	k--;
	if (game[k].t != -1)
		return;
	game[k].a *= 2;
}

void boshestvenni_duh()
{
	int k;
	cin >> k;
	k--;
	if (game[k].t != -1)
		return;
	game[k].h *= 2;
}

void kopia_is_lavi()
{
	int k;
	cin >> k;
	k--;
	person for_copy = game[k];
	game.emplace_back(for_copy.a, for_copy.h);
	if (game[k].t != -1)
	{
		game[game.size () - 1].t = hod;
	}
}

void srazhaisya()
{
	int k, l;
	cin >> k >> l;
	k--; l--;
	if (game[k].t != -1 || game[l].t != -1)
		return;
	game[k].h -= game[l].a;
	game[l].h -= game[k].a;
	if (game[k].h <= 0)
	{
		game[k].t = hod;
	}
	if (game[l].h <= 0)
	{
		game[l].t = hod;
	}
}

int main ()
{
#ifdef  _DEBUG
	freopen (IN_FILE, "r", stdin);
	freopen (OUT_FILE, "w", stdout);
#endif
	int n;
	cin >> n;
	for (int i = 0; i < n; i++)
	{
		int k;
		cin >> k;
		switch (k)
		{
		case 1: prisiv_sushestva (); break;
		case 2: blagoslovenie_sili (); break;
		case 3: boshestvenni_duh (); break;
		case 4: kopia_is_lavi (); break;
		case 5: srazhaisya (); break;
		}
		hod++;
	}
	cout << game.size () << endl;
	for (person p : game)
	{
		cout << p.t << " ";
	}
	cout << endl;
	return 0;
}

