#include<iostream>
#include<algorithm>

using namespace std;

typedef long long LL;
typedef long double LD;
typedef pair<LL,LL> PLL;
typedef pair<int,int> PII;
#define B_E(x) x.begin(),x.end()
#define PB push_back
#define MP make_pair
#define S second
#define F first

inline void file() {
    //#ifdef _WIN32
     //   return;
    //#endif

    ios_base::sync_with_stdio(false);
    cout.tie(NULL);
    cin.tie(NULL);

}

int k = 0;

int ans[250001];

int turn = 0;

//inline void showInfo(int i)
//{
//    printf("h[%d] = %d, a[%d] = %d\n", i,h[i],i,a[i]);
//}

const int maxh = 250000;

struct Node__
{
    int l = 0, r = 0;
    int prom = -1;
    int val = 0;
};

Node__ tree[5000001];

int curnode = 0;

struct Person__
{
    int a=1, h=1;
    int root=1;
};

Person__ person[250001];

inline void push(int node, int l, int r)
{
    if(tree[node].prom == -1)
        return;
    tree[node].val = (r-l+1) * tree[node].prom;
    if(l!=r)
        tree[tree[node].l].prom = tree[tree[node].r].prom = tree[node].prom;
    tree[node].prom = -1;
}

 void setVal(int node, int l, int r, int a, int b, int val)
{
    push(node,l,r);
    if(l > b || r <a)
        return;
    tree[++curnode] = tree[tree[node].l];
    tree[node].l = curnode;
    tree[++curnode] = tree[tree[node].r];
    tree[node].r = curnode;
    if(l >= a && r <= b)
    {
        tree[node].prom = val;
        push(node,l,r);
        return;
    }
    setVal(tree[node].l,l,(l+r)/2,a,b,val);
    setVal(tree[node].r,(l+r)/2+1,r,a,b,val);

    tree[node].val = tree[tree[node].l].val + tree[tree[node].r].val;
}

 int pop(int node, int l, int r, int a, int b)
{
    if(l > b || r < a)
        return -1;
    if(l!=r){
    tree[++curnode] = tree[tree[node].l];
    tree[node].l = curnode;
    tree[++curnode] = tree[tree[node].r];
    tree[node].r = curnode;}
    push(node,l,r);

    if(!tree[node].val)
        return -1;

    if(l == r)
        return l;

    int _rget = pop(tree[node].r,(l+r)/2+1,r,a,b);
    if(_rget != -1)
        return _rget;
    else
        return pop(tree[node].l,l,(l+r)/2,a,b);
}

 void showNum(int node, int l, int r, int a, int b)
{
    if(l > b || r < a)
        return;
    if(l!=r){
    tree[++curnode] = tree[tree[node].l];
    tree[node].l = curnode;
    tree[++curnode] = tree[tree[node].r];
    tree[node].r = curnode;}
    push(node,l,r);

    if(l==r)
    {
        cout << tree[node].val;
    }
    else
    {

        showNum(tree[node].r,(l+r)/2+1,r,a,b);
        showNum(tree[node].l,l,(l+r)/2,a,b);
    }
}

inline void one()
{
    person[++k].root = ++curnode;
    setVal(person[k].root, 1,maxh, maxh, maxh,1);
}

inline void two(int i)
{
    person[i].a++;
}

inline void three(int i)
{
    person[i].h++;
}

inline void four(int i)
{
    if(ans[i] != -1)
    {
        ans[++k] = turn;
        return;
    }
    person[++k] = person[i];
    person[k].root = ++curnode;
    tree[curnode] = tree[person[i].root];
}

inline bool makePop(int a, int b)
{
  //  cout << "Pop " <<a << ' ' << b << '\n';
   // showNum(person[a].root, 1, maxh, maxh - person[a].h + 1, maxh);
  //  cout << '\n';
   // showNum(person[b].root, 1, maxh, maxh - person[b].h + 1, maxh);
   // cout << '\n';
    int _pop = person[a].h > person[b].a ? pop(person[a].root, 1,maxh,maxh - person[a].h + person[b].a,maxh) : -1;
    if(_pop==-1)
        return false;

   // cout << "Popplace = " << _pop << '\n';

    setVal(person[a].root, 1,maxh,_pop,_pop, 0);

    if(_pop != maxh - person[a].h + person[b].a)
        setVal(person[a].root, 1, maxh, maxh - person[a].h + person[b].a, _pop - 1, 1);

    if(pop(person[a].root, 1, maxh, 1, maxh) == -1)
        return false;
    return true;
}

inline void fight(int i, int j)
{
    if(ans[i] != -1 || ans[j] != -1)
        return;
    bool res1 =makePop(i,j);
    bool res2 = makePop(j,i);
    if(!res1)
        ans[i] = turn;
    if(!res2)
        ans[j] = turn;
}

int main()
{
    file();

    int n;
    cin >> n;

    for(int i = 1; i <= 250000; i++)
        ans[i] = -1;

 //   fill(ans,ans+250001,-1);

    while(n--)
    {
        turn++;
        int t;
        cin >> t;
        if(t == 1)
            one();
        if(t == 2)
        {
            int i;
            cin >> i;
            two(i);
        }
        if(t == 3)
        {
            int i;
            cin >> i;
            three(i);
        }
        if(t == 4)
        {
            int i;
            cin >> i;
            four(i);
        }
        if(t == 5)
        {
            int i,j;
            cin >> i >> j;
            fight(i,j);
        }
    }

    for(int i = 1; i <= k; i++)
        cout <<ans[i] << ' ';

    return 0;
}

/*
16
1
2 1
3 1
1
5 1 2
3 1
1
3 3
3 3
4 1
5 1 3
3 3
5 1 3
5 4 3
5 4 3
4 1
*/


