#include<iostream>
#include<set>
using namespace std;


const int N = 2e7 + 5, INF = 2e9 + 1000;



int n, a[N], c[N];
unsigned int b[N];
long long ans;
int nxt_mx1[N], nxt_mx2[N], nxt_mn1[N], nxt_mn2[N];
int prv_mx1[N], prv_mx2[N], prv_mn1[N], prv_mn2[N];

main(){
    ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);
    int test;
    cin >> test;
    while(test--){
        int n;
        unsigned int l, r, x, y, z;
        cin >> n >> l >> r >> x >> y >> z;
        cin >> b[1] >> b[2];
        a[1] = b[1] % (r - l + 1) + l;
        a[2] = b[2] % (r - l + 1) + l;
        ans = 9e18;
        if(a[2] > a[1]){
            ans = min(ans, 1LL * a[1] * a[2]);
        }
        int mn = min(a[1], a[2]);
        for(int i = 3; i <= n; i++){
            b[i] = b[i - 2] * x + b[i - 1] * y + z;
            a[i] = b[i] % (r - l + 1) + l;
            if(a[i] > a[i - 1]){
                ans = min(ans, 1LL * a[i - 1] * a[i]);
            }
            if(mn < a[i]){
                ans = min(ans, 1LL * mn * a[i]);
            }
        }
        int mx1 = -INF, mx2 = -INF, mn1 = INF, mn2 = INF;
        int mx = -INF;
        for(int i = n; i >= 1; i--){
            if(mx > a[i]){
                ans = min(ans, 1LL * mx * a[i]);
            }
            mx = max(mx, a[i]);
            if(a[i] > mx1){
                mx2 = mx1;
                mx1 = a[i];
            }
            else if(a[i] != mx1 && a[i] > mx2){
                mx2 = a[i];
            }
            if(a[i] < mn1){
                mn2 = mn1;
                mn1 = a[i];
            }
            else if(a[i] != mn1 && a[i] < mn2){
                mn2 = a[i];
            }
        }
        nxt_mx1[n + 1] = nxt_mx2[n + 1] = nxt_mn1[n + 1] = nxt_mn2[n + 1] = -INF;
        prv_mx1[0] = prv_mx2[0] = prv_mn1[0] = prv_mn2[0] = INF;
        for(int i = n; i >= 1; i--){
            nxt_mx1[i] = nxt_mx1[i + 1];
            nxt_mx2[i] = nxt_mx2[i + 1];
            nxt_mn1[i] = nxt_mn1[i + 1];
            nxt_mn2[i] = nxt_mn2[i + 1];
            if(a[i] == mx1){
                nxt_mx1[i] = i;
            }
            if(a[i] == mx2){
                nxt_mx2[i] = i;
            }
            if(a[i] == mn1){
                nxt_mn1[i] = i;
            }
            if(a[i] == mn2){
                nxt_mn2[i] = i;
            }
        }
        for(int i = 1; i <= n; i++){
            prv_mx1[i] = prv_mx1[i - 1];
            prv_mx2[i] = prv_mx2[i - 1];
            prv_mn1[i] = prv_mn1[i - 1];
            prv_mn2[i] = prv_mn2[i - 1];
            if(a[i] == mx1){
                prv_mx1[i] = i;
            }
            if(a[i] == mx2){
                prv_mx2[i] = i;
            }
            if(a[i] == mn1){
                prv_mn1[i] = i;
            }
            if(a[i] == mn2){
                prv_mn2[i] = i;
            }
            if(mx1 > a[i] && nxt_mx1[i + 1] > i){
                ans = min(ans, 1LL * a[i] * mx1);
            }
            if(mx2 > a[i] && nxt_mx2[i + 1] > i){
                ans = min(ans, 1LL * a[i] * mx2);
            }
            if(mn1 < a[i] && prv_mn1[i - 1] < i){
                ans = min(ans, 1LL * a[i] * mn1);
            }
            if(mn2 < a[i] && prv_mn2[i - 1] < i){
                ans = min(ans, 1LL * a[i] * mn2);
            }
        }
        int S = 50;
        for(int i = 1; i <= n; i += S){
            set < int > q;
            for(int j = min(n, i + S - 1); j >= i; j--){
                auto it = q.upper_bound(a[j]);
                if(it != q.end()){
                    ans = min(ans, 1LL * *it * a[j]);
                }
                q.insert(a[j]);
            }
        }
        if(ans == 9e18){
            cout << "IMPOSSIBLE\n";
        }
        else{
            cout << ans << "\n";
        }
    }
}

