#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<long long, long long> pll;

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, m;
    cin >> n >> m;
    if(m == 1ll*n*(n-1)/2) {
        cout << "NO" << endl;
        return 0;
    }
    cout << "YES\n";

    vector<pair<int, int>> edge;
    while(m--) {
        int a, b;
        cin >> a >> b;
        a--, b--;
        edge.push_back({a, b});
    }
    sort(edge.begin(), edge.end());
    int a, b;
    for(a = n-1;a >= 0 && edge.size() > 0;--a) {
        for(b = n-1;b >= 0 && edge.size() > 0;--b) {
            if(a == b)
                continue;
            if(edge.back() == make_pair(a, b))
                edge.pop_back();
        }
    }
    vector<int> ans(n);
    ans[a] = n-2;
    ans[b] = n-2;
    int cnt = 0;
    for(int i = 0;i < n;++i) {
        if(i == a || i == b)
            continue;
        ans[i] = cnt++;
    }

    ans[b] = n-1;
    for(int e: ans)
        cout << e+1 << ' ';
    cout << '\n';
    ans[b] = n-2;
    for(int e: ans)
        cout << e+1 << ' ';
    return 0;
}
