#include <bits/stdc++.h>

using namespace std;
using nagai = long long;
#ifdef ONPC
bool deb = true;
#else
bool deb = false;
#endif

mt19937 rnd(239);

vector<int> a;
void init(int n)
{
	if (!deb)
		return;
	a.resize(n);
	for (auto& x : a)
		x = rnd() % 1000000000;
}

int cntque = 0;
map<vector<int>, int> mp;
int get(int x, int y, int z)
{
	vector<int> mem = {x, y, z};
	sort(mem.begin(), mem.end());
	assert(x != y && x != z && y != z);
	if (mp.count(mem))
		return mp[mem];
	++cntque;
	if (deb)
	{
		assert(0 <= x && x < a.size() && 0 <= y && y < a.size() && 0 <= z && z < a.size());
		vector<int> arr = {a[x], a[y], a[z]};
		sort(arr.begin(), arr.end());
		return mp[mem] = arr.back() + arr.front();
	}
	cout << "? " << x + 1 << ' ' << y + 1 << ' ' << z + 1 << endl;
	int a;
	cin >> a;
	return mp[mem] = a;
}

void ans(vector<int> a)
{
	if (deb)
	{
		assert(cntque <= 4 * a.size());
		if (a == ::a)
			cout << "OK!\n";
		else
		{
			for (auto& x : a)
				cout << x << ' ';
			cout << '\n';
			cout << "GOVNO\n";
		}
		return;
	}
	cout << "! ";
	for (auto& x : a)
		cout << x << ' ';
	cout << endl;
}

vector<int> glans;

void solve(int l, int r)
{
	assert(r - l == 5);
	vector<int> mem;
	for (int i = l; i < r; ++i)
		mem.push_back(i);
	vector<vector<vector<nagai>>> ansich(5);
	for (int i = 0; i < 5; ++i)
	{
		ansich[i].resize(i);
		for (int j = 0; j < i; ++j)
		{
			ansich[i][j].resize(j);
			for (int k = 0; k < j; ++k)
			{
				ansich[i][j][k] = get(mem[i], mem[j], mem[k]);
			}
		}
	}
	vector<int> sperm(5);
	iota(sperm.begin(), sperm.end(), 0);
	do
	{
		vector<nagai> ansich1(5);
		auto get1 = [&](int a, int b, int c)
		{
			vector<int> x = {sperm[a], sperm[b], sperm[c]};
			sort(x.begin(), x.end());
			return ansich[x[2]][x[1]][x[0]];
		};
		nagai a = get1(4, 2, 0);
		nagai b = get1(4, 3, 2);
		nagai c = get1(2, 1, 0);
		nagai s = (a + b + c) / 2;
		ansich1[sperm[0]] = s - b;
		ansich1[sperm[2]] = s - a;
		ansich1[sperm[4]] = s - c;
		ansich1[sperm[1]] = get1(4, 2, 1) - ansich1[sperm[4]];
		ansich1[sperm[3]] = get1(3, 2, 0) - ansich1[sperm[0]];
		/*
		if (sperm == vector<int>{0, 2, 1, 3, 4})
		{
			for (auto& x : ansich1)
				cerr << x << ' ';
			cerr << '\n';
			cerr << a << ' ' << b << ' ' << c << ' ' << s << '\n';
		}
		*/
		bool ok = true;
		for (int i = 0; i < 5; ++i)
			for (int j = 0; j < i; ++j)
				for (int k = 0; k < j; ++k)
					if (get1(i, j, k) != ansich1[sperm[i]] + ansich1[sperm[k]])
						ok = false;
		if (ok)
		{
			for (int i = 0; i < 5; ++i)
				glans[i + l] = ansich1[i];
			return;
		}
	} while (next_permutation(sperm.begin(), sperm.end()));
}


int main()
{
	int n;
	cin >> n;
	init(n);
	glans.resize(n);
	for (int i = 0; i + 5 <= n; i += 5)
		solve(i, i + 5);
	solve(n - 5, n);
	ans(glans);
}
