#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const ll inf = LLONG_MAX;

ll solve(vector <ll> a)
{
	int n = (int) a.size();
	ll glob_min = inf;
	ll ans = inf;
	ll min_abs = inf;
	ll max_abs = inf;
	for (int i = 0; i < n; i++)
	{
		if (glob_min < a[i])
		{
			ans = min(ans, a[i] * glob_min);
		}
		if (min_abs != inf && min_abs < a[i])
		{
			ans = min(ans, a[i] * min_abs);
		}
		if (max_abs != inf && -max_abs < a[i])
		{
			ans = min(ans, a[i] * -max_abs);
		}
		glob_min = min(glob_min, a[i]);
		if (a[i] <= 0)
		{
			if (max_abs > -a[i])
			{
				max_abs = -a[i];
			}
		}
		if (a[i] >= 0)
		{
			if (min_abs > a[i])
			{
				min_abs = a[i];
			}
		}
	}
	return ans;
}

typedef unsigned int uint;

int main()
{
	//freopen("a.in", "r", stdin);
	ios::sync_with_stdio(0);
	cin.tie(0);
	ll mod = (1ll << 32);
	int t;
	cin >> t;
	while (t--)
	{
		ll n, l, r;
		uint x, y, z;
		vector <uint> b(2);
		cin >> n >> l >> r >> x >> y >> z >> b[0] >> b[1];
		while (b.size() < n) b.push_back(0);
		for (int i = 2; i < n; i++)
		{
			b[i] = b[i - 2] * x + b[i - 1] * y + z;
		}
		vector <ll> a(n);
		for (int i = 0; i < n; i++)
		{
			a[i] = (ll) (b[i]) % (r - l + 1) + l;
		}
		ll ans = solve(a);
		reverse(a.begin(), a.end());
		for (ll &x : a) x *= -1;
		ans = min(ans, solve(a));
		if (ans == inf) 
		{
			cout << "IMPOSSIBLE\n";
		}
		else
		{
			cout << ans << '\n';
		}
	}
}
