#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cmath>
#include <stack>
#include <algorithm>
#include <queue>
#include <vector>
#include <deque>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <iomanip>
#include <minmax.h>
#include <string>
#define pb push_back
#define mp make_pair

using namespace std;
typedef long long ll;
typedef long double ld;

struct S
{
	int mask;
	string s;
	int id;
};

int n;
vector <string> s;
string a;
vector <int> mask;

bool ch(char c, int m)
{
	return (m & (1 << (c - 'a')));
}

bool cmp(S& a, S& b) {
	if (a.mask < b.mask)
		return true;
	if (a.mask == b.mask)
		return a.s < b.s;
	return false;
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cin >> n;
	s.resize(n);
	mask.resize(n);
	for (int i = 0; i < n; i++)
	{
		cin >> s[i] >> a;
		for (int j = 0; j < a.length(); j++)
			mask[i] |= (1 << (a[j] - 'a'));
		while (s[i].size() > 0 && ch(s[i].back(), mask[i]))
			s[i].pop_back();
	}
	S v[100000];
	for (int i = 0; i < n; i++)
	{
		v[i].mask = mask[i];
		v[i].s = s[i];
		v[i].id = i;
	}
	sort(v, v + n, cmp);
	vector <vector < int >> gr;
	vector <int> newgr;
	newgr.pb(0);
	for (int i = 1; i < n; i++)
		if (v[i].mask == v[i - 1].mask && v[i].s == v[i - 1].s)
			newgr.pb(v[i].id);
		else
		{
			if (newgr.size() != 0)
				gr.pb(newgr);
			newgr.clear();
			newgr.pb(v[i].id);
		}
	if (newgr.size() != 0)
		gr.pb(newgr);
	cout << gr.size() << '\n';
	for (int i = 0; i < gr.size(); i++)
	{
		cout << gr[i].size() << ' ';
		for (int j = 0; j < gr[i].size(); j++)
			cout << gr[i][j] + 1 << ' ';
		cout << '\n';
	}
	return 0;
}
