#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define F first
#define S second
#define M make_pair

#define endl "\n"

typedef pair<int, int> pii;
typedef long long ll;
typedef long double ld;

const int inf = 2e9 + 27;
const int mod = 1e9 + 7;

string text;

regex refregex("[\\s]\\\\cite\\{([a-z]{1,})\\}");
regex bibregex("\\\\bibitem\\{([a-z]{1,})\\}");

map<string, string> bib;

vector<string> bibitems;
vector<string> titems;

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    string str;
    while (cin >> str) {
        if (str == "\\begin{thebibliography}{99}") {
            break;
        }
        text += str + " ";
    }
    cin.ignore();
    string ts = "";
    while (getline(cin, ts)) {
        if (ts == "\\end{thebibliography}")
            break;
        else {
            smatch tm = *sregex_iterator(ts.begin(), ts.end(), bibregex);
            bib[tm[1].str()] = ts;
            bibitems.pb(tm[1].str());
        }
    }
    auto beg = sregex_iterator(text.begin(), text.end(), refregex);
    auto ed = sregex_iterator();
    for (sregex_iterator i = beg; i != ed; i++) {
        smatch m = *i;
        titems.pb(m[1].str());
    }
    for (int i = 0; i < titems.size(); i++) {
        if (titems[i] != bibitems[i]) {
            cout << "Incorrect\n\\begin{thebibliography}{99}\n";
            for (i = 0; i < titems.size(); i++) {
                cout << bib[titems[i]] << endl;
            }
            cout << "\\end{thebibliography}";
            return 0;
        }
    }
    cout << "Correct";
    return 0;
}
