
#include <bits/stdc++.h>

#define pb push_back
#define mp make_pair
#define len(v) ((int)v.size())

using namespace std;

typedef pair<int, int> pii;
typedef long long ll;
typedef long double ld;

template<class T>
istream &operator>>(istream &is, vector<T> &v) {
    for (T &x : v) {
        is >> x;
    }
    return is;
}


template<class T>
ostream &operator<<(ostream &os, const vector<T> &v) {
    for (const T &x : v) {
        os << x << " ";
    }
    return os;
}


void run();

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    //freopen("input.txt", "r", stdin);
    run();
}

int n, m;
vector<set<int>> g;

void run() {
    cin >> n >> m;
    g.resize(n);
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        a--;b--;
        g[a].insert(b);
        g[b].insert(a);
    }
    int A = -1, B = -1;
    for (int i = 0; i < n; i++) {
        if (len(g[i]) < n - 1) {
            for (int j = 0; j < n; j++) {
                if (j == i) continue;
                if (!g[i].count(j)) {
                    A = i;
                    B = j;
                    break;
                }
            }
        }
    }
    if (A == -1) {
        cout << "NO" << endl;
    } else {
        vector<int> F(n), S(n);
        F[A] = 1;
        F[B] = 2;
        S[A] = 1;
        S[B] = 1;
        int cur = 3;
        for (int i = 0; i < n; i++) {
            if (F[i] == 0) {
                F[i] = cur;
                S[i] = cur++;
            }
        }
        cout << "YES" << endl;
        for (int x : F) {
            cout << x << " ";
        }
        cout << endl;
        for (int x : S) {
            cout << x << " ";
        }
        cout << endl;
    }
}


