#include <bits/stdc++.h>

#define pb push_back
#define mp make_pair
#define x first
#define y second

#define len(v) ((int)v.size())

using namespace std;

typedef pair<int, int> pii;
typedef long long ll;
typedef long double ld;
typedef unsigned int uint;

template<class T>
istream &operator>>(istream &is, vector<T> &v) {
    for (T &x : v) {
        is >> x;
    }
    return is;
}


template<class T>
ostream &operator<<(ostream &os, const vector<T> &v) {
    for (const T &x : v) {
        os << x << " ";
    }
    return os;
}


void run();

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    //freopen("input.txt", "r", stdin);
    run();
}

int n;
bool bad[8][8];
bool alive[8][8];
int a, b;

bool used[8][8];
pair<int, int> p[8][8];

int dx[8] = {-1, -2, -2, -1, 1, 2, 2, 1};
int dy[8] = {-2, -1, 1, 2, 2, 1, -1, -2};

vector<pair<int, int>> bfs(pair<int, int> s) {
    for (int i = 0; i < 8; ++i) {
        for (int j = 0; j < 8; ++j) {
            used[i][j] = false;
        }
    }
    queue<pair<int, int>> que;
    que.push(s);
    used[s.x][s.y] = true;
    while (true) {
        auto v = que.front();
        if (alive[v.x][v.y] && !bad[v.x][v.y]) break;
        que.pop();
        for (int d = 0; d < 8; ++d) {
            pair<int, int> cur = {v.x + dx[d], v.y + dy[d]};
            //cout << cur.x << ' ' << cur.y << endl;
            if (cur.x < 0 || cur.y < 0 || cur.x >= 8 || cur.y >= 8 || used[cur.x][cur.y])
                continue;
            p[cur.x][cur.y] = v;
            used[cur.x][cur.y] = true;
            que.push(cur);
        }
    }
    assert(que.size());
    pair<int, int> f = que.front();
    vector<pair<int, int>> rep;
    rep.pb(f);
    while (f != s) {
        f = p[f.x][f.y];
        rep.pb(f);
    }
    return rep;
}

vector<string> ans;

string f(pair<int, int> a) {
    string s;
    s += char(a.x + 'a');
    s += char(a.y + '1');
    return s;
}

void run() {
    cin >> n;
    for (int i = 0; i < n; ++i) {
        string s;
        cin >> s;
        int a = s[0] - 'a';
        int b = s[1] - '1';
        //cout << a << ' ' << b << endl;
        alive[a][b] = true;
    }
    if (n != 64) {
        for (int i = 0; i < n; ++i) {
            //cout << a << ' ' << b << endl;
            vector<pair<int, int>> res = bfs({a, b});
            while (true) {
                int lst = -1;
                for (int q = 0; q < res.size(); ++q) {
                    auto j = res[q];
                    if (alive[j.x][j.y]) {
                        lst = q;
                    }
                }
                if (lst == -1) break;
                for (int q = lst; q + 1 < res.size(); ++q) {
                    ans.pb(f(res[q]) + "-" + f(res[q + 1]));
                }
                alive[res[lst].x][res[lst].y] = false;
                alive[res.back().x][res.back().y] = true;
                res.pop_back();
            }
            bad[a][b] = true;
            ++a;
            if (a == 8) {
                a = 0;
                ++b;
            }
        }
    }
    cout << ans.size() << '\n';
    for (auto i : ans) cout << i << '\n';
}


