#include <bits/stdc++.h>
#define int long long
#define pb push_back
#define mp make_pair
#define len(v) ((int)v.size())

using namespace std;

typedef pair<int, int> pii;
typedef long long ll;
typedef long double ld;

template<class T>
istream &operator>>(istream &is, vector<T> &v) {
    for (T &x : v) {
        is >> x;
    }
    return is;
}


template<class T>
ostream &operator<<(ostream &os, const vector<T> &v) {
    for (const T &x : v) {
        os << x << " ";
    }
    return os;
}


void run();

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    //freopen("input.txt", "r", stdin);
    run();
}

int n, m;


struct Auto {
    struct Node {
        map<char, Node*> go;
        int max_len = 0;
        Node *sufflink = NULL;
    };
    Node *clone(Node *node) {
        Node *cl = new Node();
        cl->go = node->go;
        cl->max_len = node->max_len;
        cl->sufflink = node->sufflink;
        return cl;
    }
    Node *root = new Node();
    Node *cur = NULL;

    Auto() {
        cur = root;
    }

    void add(char c) {
        Node *_new = new Node();
        _new->max_len = cur->max_len + 1;
        _new->sufflink = root;
        while (cur && !cur->go.count(c)) {
            cur->go[c] = _new;
            cur = cur->sufflink;
        }
        if (cur) {
            if (cur->go[c]->max_len == cur->max_len + 1) {
                _new->sufflink = cur->go[c];
            } else {
                Node *q = cur->go[c];
                Node *p = clone(cur->go[c]);
                _new->sufflink = p;
                cur->go[c]->sufflink = p;
                p->max_len = cur->max_len + 1;

                while (cur) {
                    if (cur->go[c] == q) {
                        cur->go[c] = p;
                        cur = cur->sufflink;
                    } else {
                        break;
                    }
                }
            }
        }
        cur = _new;
    }
};

vector<int> zf(string s) {
    vector<int> z(len(s));
    int l = 0;
    int r = 0;
    z[0] = 0;
    for (int i = 1; i < len(s); i++) {
        if (i < r) {
            z[i] = min(r - i - 1, z[i - l]);
        }
        while (i + z[i] < len(s) && s[z[i]] == s[i + z[i]]) {
            z[i]++;
        }
        if (z[i] > r) {
            l = i;
            r = i + z[i];
        }
    }
    return z;
}

vector<int> pr(string s) {
    vector<int> p(len(s));
    for (int i = 1; i < len(s); i++) {

        int c = p[i - 1];
        while (c && s[c] != s[i]) {
            c = p[c - 1];
        }
        if (s[c] != s[i]) {
            p[i] = 0;
        } else {
            p[i] = c + 1;
        }
    }
    return p;
}

long long ans;
int cnt[500001];

void run() {
    string s, t;
    cin >> s >> t;
    vector<int> a = zf(t + "#" + s);
    vector<int> b = pr(s);
    for (int i = t.size() + 1; i < a.size(); ++i) {
        a[i] = min((int)a.size() - i - 1, a[i]);
        ++cnt[a[i]];
    }
    for (int i = a.size(); i--;) {
        cnt[i] += cnt[i + 1];
    }
    for (int i = 0; i < t.size(); ++i) {
        int k = cnt[i + 1 - b[i]];
        //acout << b[i] << endl;
        if (b[i] == 0) {
            ans += s.size();
        } else {
            ans += s.size() - k;
        }
    }
    cout << ans << endl;
}
