#include <bits/stdc++.h>

#define pb push_back
#define mp make_pair
#define x first
#define y second

#define len(v) ((int)v.size())

using namespace std;

typedef pair<int, int> pii;
typedef long long ll;
typedef long double ld;
typedef unsigned int uint;

template<class T>
istream &operator>>(istream &is, vector<T> &v) {
    for (T &x : v) {
        is >> x;
    }
    return is;
}


template<class T>
ostream &operator<<(ostream &os, const vector<T> &v) {
    for (const T &x : v) {
        os << x << " ";
    }
    return os;
}


void run();

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    //freopen("input.txt", "r", stdin);
    run();
}

int n;
vector<pair<pair<string, string>, int>> res;

int cnt;
vector<int> ans[200001];

void run() {
    cin >> n;
    for (int i = 0; i < n; ++i) {
        string a, b;
        cin >> a >> b;
        set<char> cool;
        for (auto j : b) cool.insert(j);
        while (a.size() && cool.count(a.back())) {
            a.pop_back();
        }
        b = "";
        for (auto j : cool) {
            b += j;
        }
        res.pb({{a, b}, i + 1});
    }
    sort(res.begin(), res.end());
    int L = 0;
    while (L < n) {
        int R = L;
        while (R < n && res[L].x == res[R].x) {
            ++R;
        }
        for (int M = L; M < R; ++M) {
            ans[cnt].pb(res[M].y);
        }
        ++cnt;
        L = R;
    }
    cout << cnt << '\n';
    for (int i = 0; i < cnt; ++i) {
        cout << ans[i].size() << ' ' << ans[i] << '\n';
    }
}


