#include <bits/stdc++.h>

#define f first
#define s second
#define pb push_back
#define mp make_pair
#define all(a) (a).begin(), (a).end()

using namespace std;

template<typename T1, typename T2> inline void chkmin(T1 & x, T2 y) {if (x > y) x = y;}
template<typename T1, typename T2> inline void chkmax(T1 & x, T2 y) {if (x < y) x = y;}

typedef long long ll;
typedef pair <int, int> pii;

const int MAXN = 1e5 + 1;
unordered_set<int> col[MAXN], ppl[MAXN];
vector<pair<int, pair<int, int>>> ans;
int n, m;

void mv(int from, int to) {
    unordered_set<int> nums_to;
    for (int i = 0; i < n; ++i)
        if (ppl[i].size() < to)
            nums_to.insert(i);

    for (int ccol = 0; ccol < m && !nums_to.empty(); ++ccol) {
        vector<int> from_mv, to_mv;
        for (int j : col[ccol])
            if (ppl[j].size() > from)
                from_mv.pb(j);

        for (int j : nums_to) {
            if (to_mv.size() == from_mv.size()) break;
            if (ppl[j].find(ccol) == ppl[j].end()) {
                to_mv.pb(j);
            }
        }
        for (int j = 0; j < min(to_mv.size(), from_mv.size()); ++j) {
            int cfrom = from_mv[j], cto = to_mv[j];
            ans.pb({ccol, {cfrom, cto}});
            //cout << ccol + 1 << ' ' << cfrom + 1 << ' ' << cto + 1 << endl;
            col[ccol].erase(cfrom);
            col[ccol].insert(cto);
            ppl[cfrom].erase(ccol);
            ppl[cto].insert(ccol);
            if (ppl[cto].size() >= to)
                nums_to.erase(cto);
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    //srand(time(0));
#ifdef DEBUG
    //freopen("in", "r", stdin);
#endif // DEBUG
    int S = 0;
    cin >> n >> m;
    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        for (int j = 0; j < k; ++j) {
            int x;
            cin >> x, --x;
            ppl[i].insert(x);
            col[x].insert(i);
        }
        S += k;
    }
    int K = S / n, A = S % n;
    mv(K + 1, K);
    int gr_k = 0, ls_k = 0;
    for (int i = 0; i < n; ++i) {
        if (ppl[i].size() > K + 1)
            gr_k = 1;
        if (ppl[i].size() < K)
            ls_k = 1;
    }
    if (ls_k || gr_k) {
        assert(ls_k ^ gr_k);
        if (ls_k) {
            mv(K, K);
        }
        else {
            mv(K + 1, K + 1);
        }
    }
    cout << ans.size() << '\n';
    for (auto i : ans)
        cout << i.s.f + 1 << ' ' << i.s.s + 1 << ' ' << i.f + 1 << '\n';
    return 0;
}
