#include <bits/stdc++.h>

#define f first
#define s second
#define pb push_back
#define mp make_pair
#define all(a) (a).begin(), (a).end()

using namespace std;

template<typename T1, typename T2> inline void chkmin(T1 & x, T2 y) {if (x > y) x = y;}
template<typename T1, typename T2> inline void chkmax(T1 & x, T2 y) {if (x < y) x = y;}

typedef long long ll;
typedef pair <int, int> pii;

const int INF = 2e9;

vector <pii> dif = {mp(1, 2), mp(1, -2), mp(-1, 2), mp(-1, -2), mp(2, 1), mp(2, -1), mp(-2, 1), mp(-2, -1)};

bool b[8][8];

vector <pair <pii, pii> > hist;

int moveCnt;
void mov(int x, int y, int x1, int y1) {
    assert(b[x][y]);
    assert(!b[x1][y1]);
    b[x][y] = false;
    b[x1][y1] = true;
    ++moveCnt;

    assert(moveCnt <= 1500);

    hist.pb(mp(mp(x, y), mp(x1, y1)));
}

string out(pii pr) {
    string res;
    res += (char)(pr.second + 'a');
    res += (char)(pr.first + '1');
    return res;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    //srand(time(0));
#ifdef DEBUG
    //freopen("in", "r", stdin);
#endif // DEBUG

    moveCnt = 0;

    int k;
    cin >> k;
    for (int i = 0; i < k; ++i) {
        string p;
        cin >> p;
        b[p[1] - '1'][p[0] - 'a'] = true;
    }

    if (k == 64) {
        cout << "0\n";
        return 0;
    }

    for (int c = 0; c < k; ++c) {
        int x0 = c / 8;
        int y0 = c % 8;

        if (!b[x0][y0]) {
            vector <int> d(64, INF);
            vector <int> p(64, -1);
            d[c] = 0;
            queue <int> q;
            q.push(c);
            while (!q.empty()) {
                int v = q.front();
                q.pop();

                int x = v / 8;
                int y = v % 8;

                for (auto _d : dif) {
                    int x1 = x + _d.first;
                    int y1 = y + _d.second;
                    int v1 = x1 * 8 + y1;

                    if (0 <= x1 && x1 < 8 &&
                        0 <= y1 && y1 < 8 &&
                    d[v1] > d[v] + 1)
                    {
                        d[v1] = d[v] + 1;
                        p[v1] = v;
                        q.push(v1);
                    }
                }
            }

            int mv = -1;
            for (int v = c + 1; v < 64; ++v) {
                if ((mv == -1 || d[v] < d[mv]) && b[v / 8][v % 8])
                    mv = v;
            }

            while (mv != c) {
                int par = p[mv];
                stack <int> st;
                while (b[par / 8][par % 8]) {
                    st.push(par);
                    par = p[par];
                }

                while (!st.empty()) {
                    mov(st.top() / 8, st.top() % 8, p[st.top()] / 8, p[st.top()] % 8);
                    st.pop();
                }

                mov(mv / 8, mv % 8, p[mv] / 8, p[mv] % 8);

                mv = par;
            }
        }
    }

    cout << hist.size() << endl;
    for (auto el : hist) {
        //cout << el.first.first << ' ' << el.first.second << ' ' << el.second.first << ' ' << el.second.second << endl;
        cout << out(el.first) << '-' << out(el.second) << '\n';
    }

    return 0;
}
