#include <bits/stdc++.h>

#define f first
#define s second
#define pb push_back
#define mp make_pair
#define all(a) (a).begin(), (a).end()
#define int long long
#define IO ios_base::sync_with_stdio(false), cin.tie(NULL), cout.tie(NULL)

using namespace std;

template<typename T1, typename T2> inline void chkmin(T1 & x, T2 y) {if (x > y) x = y;}
template<typename T1, typename T2> inline void chkmax(T1 & x, T2 y) {if (x < y) x = y;}

typedef long long ll;
typedef pair <int, int> pii;

bool isBit(int n, int i)
{
    return (n >> i) & 1;
}

int getMask(string &s)
{
    int n = s.size();
    int mask = 0;
    for (int i = 0; i < n; i++){
        int val = s[i] - 'a';
        if (!isBit(mask, val)){
            mask |= (1 << val);
        }
    }
    return mask;
}

void getPrev(string &t, int mask)
{
    while (!t.empty()){
        int val = t.back() - 'a';
        if (isBit(mask, val)){
            t.pop_back();
        }
        else{
            break;
        }
    }
    return;
}

signed main(){
    IO;
    int n;
    cin >> n;
    map <pair <int, string>, vector <int> > voc;
    for (int i = 0; i < n; i++){
        string t, s;
        cin >> t >> s;
        int mask = getMask(s);
        getPrev(t, mask);
        voc[mp(mask, t)].push_back(i);
    }
    cout << voc.size() << '\n';
    for (auto now : voc){
        cout << now.second.size() << ' ';
        for (auto id : now.second){
            cout << id + 1 << ' ';
        }
        cout << '\n';
    }
    return 0;
}
