#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <algorithm>
#include <iomanip>
#include <cmath>
#include <string>
#include <ctime>
#include <cassert>
#include <random>
#include <functional>
#include <numeric>
#include <deque>
#include <queue>
#include <cstring>
#include <complex>
#define ll long long
#define ld long double
#define null NULL
#define all(a) a.begin(), a.end()
#define x first
#define y second

using namespace std;

template<class T> int chkmax(T &a, const T &b) {
	if (b > a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class T> int chkmin(T &a, const T &b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class iterator> void output(iterator begin, iterator end, ostream &out = cerr) {
	while (begin != end) {
		out << (*begin) << " ";
		begin++;
	}
	out << endl;
}

template<class T> void output(T &x, ostream &out = cerr) {
	output(x.begin(), x.end(), out);
}

void fast_io() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

int n;
ll ans, MAX;
vector<pair<ll, ll> > vp;

int main()
{
	cin >> n;
	for (int i = 0; i < n; ++i) {
		ll cnt, cur_max = 0;
		cin >> cnt;
		for (int j = 0; j < cnt; ++j) {
			ll val;
			cin >> val;
			chkmax(cur_max, val);
		}
		vp.push_back({ cnt, cur_max });
		chkmax(MAX, cur_max);
	}

	for (int i = 0; i < n; ++i) {
		ans += (MAX - vp[i].second) * vp[i].first;
	}

	cout << ans << endl;

    return 0;
}

