#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <algorithm>
#include <iomanip>
#include <cmath>
#include <string>
#include <ctime>
#include <cassert>
#include <random>
#include <functional>
#include <numeric>
#include <deque>
#include <queue>
#include <cstring>
#include <complex>
#define ll long long
#define ld long double
#define null NULL
#define all(a) a.begin(), a.end()
#define x first
#define y second

using namespace std;

template<class T> int chkmax(T &a, const T &b) {
	if (b > a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class T> int chkmin(T &a, const T &b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class iterator> void output(iterator begin, iterator end, ostream &out = cerr) {
	while (begin != end) {
		out << (*begin) << " ";
		begin++;
	}
	out << endl;
}

template<class T> void output(T &x, ostream &out = cerr) {
	output(x.begin(), x.end(), out);
}

void fast_io() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

const int mx = 1e5 + 228;
int n, m, s, cnt[mx], aim_cnt[mx];
vector<set<int> > a;
vector<int> id;

bool cnt_cmp(int i, int j) {
	return cnt[i] < cnt[j];
}

bool diff_cmp(int i, int j) {
	return (cnt[i] - aim_cnt[i]) < (cnt[j] - aim_cnt[j]);
}

int get_diff(int i) {
	return cnt[i] - aim_cnt[i];
}

struct out_one {
	int a, b, c;
};

vector<out_one> ans;

void move(int u, int v) {
	int to_move = min(abs(cnt[u] - aim_cnt[u]), abs(cnt[v] - aim_cnt[v]));
	vector<int> erased;
	for (auto x : a[v]) {
		auto it = a[u].find(x);
		if (it != a[u].end()) {
			a[u].erase(x);
			erased.push_back(x);
		}
	}

	for (int i = 0; i < to_move; ++i) {
		ans.push_back({ u + 1, v + 1, *a[u].begin() });
		a[v].insert(*a[u].begin());
		a[u].erase(a[u].begin());
	}

	for (auto x : erased) {
		a[u].insert(x);
	}

	cnt[u] = a[u].size();
	cnt[v] = a[v].size();
}

int main()
{
	cin >> n >> m;
	a.resize(n);
	for (int i = 0; i < n; ++i) {
		cin >> cnt[i];
		s += cnt[i];
		for (int j = 0; j < cnt[i]; ++j) {
			int val;
			cin >> val;
			a[i].insert(val);
		}
	}

	id.resize(n);
	for (int i = 0; i < n; ++i) {
		id[i] = i;
	}
	sort(id.rbegin(), id.rend(), cnt_cmp);
	int val = s / n, bigger = s - val * n;

	for (int i = 0; i < bigger; ++i) {
		aim_cnt[id[i]] = val + 1;
	}
	for (int i = bigger; i < n; ++i) {
		aim_cnt[id[i]] = val;
	}

	/*cerr << "cnt" << endl;
	output(cnt, cnt + n);
	cerr << "aim_cnt" << endl;
	output(aim_cnt, aim_cnt + n);*/

	sort(id.rbegin(), id.rend(), diff_cmp);

	int ptr = 0;
	for (int i = n - 1; i >= 0; --i) {
		if (get_diff(id[i]) >= 0) {
			break;
		}
		while (get_diff(id[i]) != 0) {
			move(id[ptr], id[i]);
			if (get_diff(id[ptr]) == 0) {
				ptr++;
			}
		}
	}

	cout << ans.size() << endl;
	for (auto ppp : ans) {
		cout << ppp.a << " " << ppp.b << " " << ppp.c << "\n";
	}
	
	return 0;
}
