#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <algorithm>
#include <iomanip>
#include <cmath>
#include <string>
#include <ctime>
#include <cassert>
#include <random>
#include <functional>
#include <numeric>
#include <deque>
#include <queue>
#include <cstring>
#include <complex>
#define ll long long
#define ld long double
#define null NULL
#define all(a) a.begin(), a.end()
#define x first
#define y second

using namespace std;

template<class T> int chkmax(T &a, const T &b) {
	if (b > a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class T> int chkmin(T &a, const T &b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class iterator> void output(iterator begin, iterator end, ostream &out = cerr) {
	while (begin != end) {
		out << (*begin) << " ";
		begin++;
	}
	out << endl;
}

template<class T> void output(T &x, ostream &out = cerr) {
	output(x.begin(), x.end(), out);
}

void fast_io() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}


const int MAXN = 1e5 + 7;
string a[MAXN], b[MAXN];
int cls[MAXN];
int clsf[MAXN];
int f[MAXN], s[MAXN];
map<pair<int, int>, int> gcls;
vector<int> strs[MAXN];
int lcp(string a, string b) {
	int lim = min(a.size(), b.size());
	for (int i = 0; i < lim; ++i)
		if (a[i] != b[i])
			return i;
	return lim;
}
bool cmp(int x, int y) {
	return a[x] < a[y];
}
int main()
{
	int n;
	cin >> n;
	int ptr = 0;
	for (int i = 0; i < n; ++i) {
		cin >> a[i] >> b[i];
		for (char x : b[i])
			s[i] |= (1 << (x - 'a'));
		f[i] = -1;
		for (int j = 0; j < a[i].size(); ++j)
			if (!((s[i] >> (a[i][j] - 'a')) & 1))
				f[i] = max(f[i], j);
		f[i]++;
		pair<int, int> pr = { s[i], f[i] };
		if (gcls.find(pr) == gcls.end()) {
			clsf[ptr] = f[i];
			gcls[pr] = ptr++;
		}
		cls[i] = gcls[pr];
		strs[cls[i]].push_back(i);
	}
	vector<vector<int>> ans;
	for (int k = 0; k < ptr; ++k) {
		sort(strs[k].begin(), strs[k].end(), cmp);
		int sz = strs[k].size();
		for (int i = 0; i < sz;) {
			int cnt = 1;
			while (i + cnt < sz && lcp(a[strs[k][i]], a[strs[k][i + cnt]]) >= clsf[k])
				++cnt;
			vector<int> answ;
			for (int j = i; j < i + cnt; ++j)
				answ.push_back(strs[k][j]);
			i += cnt;
			ans.push_back(answ);
		}
	}
	cout << ans.size() << endl;
	for (vector<int> xx : ans) {
		cout << xx.size() << " ";
		for (int x : xx)
			cout << x + 1 << " ";
		cout << "\n";
	}
	return 0;
}


/*

3
kokoko tlin
koko kotlin
ko kokotlin

5
ab ab
ababab ab
a abb
x y
z w

2
a c
b c

3
a c
aa c
aaa c

*/