#include <bits/stdc++.h>
#define pb push_back
#define mp make_pair
#define x first
#define y second

using namespace std;

typedef long long ll;

bool bit(ll m, ll i)
{
    return ((m >> i) & 1LL);
}

pair<ll, ll> get_h(string a, string b)
{
    ll mask = 0;
    for (char c : b)
    {
        mask |= (1LL << (c - 'a'));
    }
    while (a.size() && bit(mask, a.back() - 'a'))
    {
        a.pop_back();
    }
    ll h1 = 19, h2 = 12;
    const ll M1 = 1E9 + 21;
    const ll M2 = 1E9 + 33;
    for (char c : a)
    {
        h1 = (h1 * 29 + (c - 'a' + 1)) % M1;
        h2 = (h2 * 31 + (c - 'a' + 1)) % M2;
    }
    return { h1 * M2 + h2, mask };
}

map<pair<ll, ll>, vector<ll>> ans;

int main()
{
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(0); cin.tie(0);

    ll n;
    cin >> n;

    string a, b;

    for (ll i = 1; i <= n; ++i)
    {
        cin >> a >> b;
        ans[get_h(a, b)].push_back(i);
    }

    cout << ans.size() << '\n';
    for (auto & e : ans)
    {
        cout << e.second.size() << ' ';
        for (auto i : e.second)
        {
            cout << i << ' ';
        }
        cout << '\n';
    }

    return 0;
}

