#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <string>
#include <unordered_map>

using ld = long long;
using namespace std;

string trans(string s) {
	sort(s.begin(), s.end());
	vector<char> s1;
	for (char l : s) {
		s1.push_back(l);
	}
	auto it = unique(s1.begin(), s1.end());
	string ans = "";
	for (auto i = s1.begin(); i < it; i++) {
		ans += *i;
	}
	return ans;
}

int main() {
	
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	/*
	int n;
	cin >> n;
	vector<pair<pair<string, string>, int>> v(n);
	for (int i = 0; i < n; i++) {
		string x, y;
		cin >> x >> y;
		v[i].first.first = trans(x + y);
		v[i].first.second = trans(y);
		v[i].second = i;
	}
	sort(v.begin(), v.end());
	vector<int> ans(n);
	auto last = v[0].first;
	int cnt = 1;
	ans[v[0].second] = 1;
	for (int i = 1; i < n; i++) {
		if (v[i].first != last) {
			cnt++;
			last = v[i].first;
		}
		ans[v[i].second] = cnt;
	}
	cout << cnt << endl;
	vector<vector<int>> g(cnt);
	for (int i = 0; i < n; i++) {
		g[ans[i] - 1].push_back(i + 1);
	}
	for (vector<int> vec : g) {
		cout << vec.size() << ' ';
		for (int i : vec) cout << i << ' ';
		cout << endl;
	}*/
	
	long long t, n, a, b, k;
	cin >> t >> n >> a >> b >> k;

	long long maxi = max(a, b);
	long long mini = min(a, b);
	long long all = ((n + 1) / 2ll) * a + (n / 2ll) * b;
	long long nn = (n / 2ll) * b;


	long long l = 0, r = t + 1;
	while (r - l > 1) {
		long long m = (l + r) / 2ll;
		if (m <= mini) {
			if (k > n) {
				r = m;
			}
			else {
				l = m;
			}
		}
		else if (m >= maxi) {
			if (k * m <= all)
				l = m;
			else {
				r = m;
			}
		}
		else {
			long long h = k;
			h -= ((n + 1) / 2ll);
			if (h <= 0) {
				l = m;
			}
			else {
				if (h * m <= nn)
					l = m;
				else {
					r = m;
				}
			}
		}
	}

	cout << l << endl;

	return 0;
}