#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <map>
#include <set>
#include <deque>
#include <fstream>
#include <iomanip>
#include <string>
using namespace std;

typedef long long ll;
typedef long double ld;

#define sz(a) int(a.size())
#define all(a) a.begin(), a.end()
#define pb push_back 
#define x first
#define y second

const int INF = int(1e9) + 111;
const int N = int(1e5) + 11;
const int M = int(1e9) + 7;

vector<int> g[100000];
bool used[100000];
int q[100000], tail, head, k = 3, ans[100000];
int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	//ifstream cin("input.txt");
	//ofstream cout("output.txt");
	int n, m, a = -1, b;
	cin >> n >> m;
	for (int i = 0; i < m; i++) {
		int x, y;
		cin >> x >> y;
		g[x - 1].pb(y - 1);
		g[y - 1].pb(x - 1);
	}
	for (int i = 0; i < n; i++)
		if (sz(g[i]) != n - 1) {
			a = i;
			used[a] = true;
			for (int j = 0; j < sz(g[i]); j++)
				used[g[i][j]] = true;
			for (int j = 0; j < n; j++)
				if (!used[j]) {
					b = j;
					break;
				}
			break;
		}
	if (a == -1) {
		cout << "NO";
		return 0;
	}
	for (int i = 0; i < n; i++)
		used[i] = false;
	q[head++] = a;
	q[head++] = b;
	used[a] = true;
	used[b] = true;
	ans[a] = 1;
	ans[b] = 1;
	while (head != tail) {
		int v = q[tail++];
		for (int i = 0; i < sz(g[v]); i++) {
			int to = g[v][i];
			if (used[to])
				continue;
			used[to] = true;
			ans[to] = k++;
			q[head++] = to;
		}
	}
	for (int i = 0; i < n; i++)
		if (!ans[i])
			ans[i] = k++;
	cout << "YES" << endl;
	for (int i = 0; i < n; i++)
		if (i == b)
			cout << "2 ";
		else
			cout << ans[i] << ' ';
	cout << endl;
	for (int i = 0; i < n; i++)
		cout << ans[i] << ' ';
	return 0;
}
