#include <bits/stdc++.h>

#define ll long long
#define ld long double
#define pii pair<int, int>
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define eb emplace_back
#define sz(a) int(a.size())

using namespace std;

void dfs(int v, vector<vector<int>>& g, vector<int>& used) {
    used[v] = 1;
    for (int u : g[v]) {
        if (!used[u]) {
            dfs(u, g, used);
        }
    }
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n, m;
    cin >> n >> m;
    if (m == 1ll * n * (n - 1) / 2) {
        cout << "NO";
        return 0;
    }
    if (n == 2) {
        cout << "YES\n1 2\n1 1";
        return 0;
    }
    vector<vector<int>> g(n);
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        --u;
        --v;
        g[u].eb(v);
        g[v].eb(u);
    }
    vector<int> used(n);
    dfs(0, g, used);
    vector<bool> cnt(n);
    int x = 0, y, z = -1;
    if (count(all(used), 0) != 0) {
        y = 1;
        z = (find(all(used), 0) - used.begin());
    }
    else {
        for (int v = 0; v < n; ++v) {
            for (int u : g[v]) {
                cnt[u] = 1;
            }
            for (int u : g[v]) {
                if (pii(sz(g[v]), v) < pii(sz(g[u]), u)) {
                    continue;
                }
                int ng = 0;
                for (int w : g[u]) {
                    if (cnt[w]) {
                        ++ng;
                    }
                }
                if (ng + 1 != sz(g[v])) {
                    for (int w : g[u]) {
                        cnt[w] = 0;
                    }
                    cnt[u] = 0;
                    for (int i = 0; i < n; ++i) {
                        if (cnt[i]) {
                            z = i;
                            x = v;
                            y = u;
                            //cout << x << y << z << endl;
                            break;
                        }
                    }
                }
            }
            if (z != -1) {
                break;
            }
            for (int u : g[v]) {
                cnt[u] = 0;
            }
        }
    }
    cout << "YES\n";
    vector<int> ans(n), ans2(n);
    ans[x] = 1;
    ans[y] = 2;
    ans[z] = 3;
    int it = 3;
    for (int& el : ans) {
        if (!el) {
            el = ++it;
        }
    }
    ans2 = ans;
    ans2[z] = 2;
    for (int el : ans) {
        cout << el << ' ';
    }
    cout << '\n';
    for (int el : ans2) {
        cout << el << ' ';
    }
    cout << '\n';
    return 0;
}
