#include <bits/stdc++.h>

#define ll long long
#define ld long double
#define pii pair<int, int>
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define eb emplace_back
#define sz(a) int(a.size())

using namespace std;

ll mod = (1ll << 32);

ll INF = 8e18;

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int q;
    cin >> q;
    while (q--) {
        int n, l, r, x, y, z, b1, b2;
        cin >> n >> l >> r >> x >> y >> z >> b1 >> b2;
        vector<ll> b(n), a(n);
        b[0] = b1;
        b[1] = b2;
        for (int i = 2; i < n; ++i) {
            b[i] = ((b[i - 2] * x + b[i - 1] * y + z) % mod + mod) % mod;
        }
        for (int i = 0; i < n; ++i) {
            a[i] = (b[i] % (r - l + 1)) + l;
            //cout << b[i] << ' ' << a[i] << endl;
        }
        ll mn1 = INF, mn2 = INF, mx1 = -INF, mx2 = -INF;
        for (int i = 0; i < n; ++i) {
            if (a[i] < mn1) {
                mn2 = mn1;
                mn1 = a[i];
            }
            else if (a[i] != mn1 && a[i] < mn2) {
                mn2 = a[i];
            }
            if (a[i] > mx1) {
                mx2 = mx1;
                mx1 = a[i];
            }
            else if (a[i] != mx1 && a[i] > mx2) {
                mx2 = a[i];
            }
        }
        vector<ll> c = {mn1, mn2, mx2, mx1};
        for (int i = 1; i < 4; ++i) {
            if (c[i] == INF || c[i] == -INF) {
                c[i] = c[i - 1];
            }
        }
        c.resize(unique(all(c)) - c.begin());
        if (sz(c) < 2) {
            cout << "IMPOSSIBLE\n";
        }
        else {
            ll res = INF;
            for (int i = 0; i < sz(c); ++i) {
                for (int j = i + 1; j < sz(c); ++j) {
                    res = min(res, c[i] * c[j]);
                }
            }
            cout << res << '\n';
        }
    }

    return 0;
}
