#include <bits/stdc++.h>
using namespace std;

#define fst first
#define snd second
#define mp make_pair
#define rep(i,a,n) for(int i=(a);i<(n);++i)
#define per(i,a,n) for(int i=(n)-1;i>=(a);--i)
#define all(x) (x).begin(),(x).end()

template<typename T1, typename T2>
inline bool umin(T1& x, const T2& y) {return x>y ? x=y,true:false;}

template<typename T1, typename T2>
inline bool umax(T1& x, const T2& y) {return x<y ? x=y,true:false;}

typedef long long ll;
typedef long double ld;

const int N    = (int)1e6+7;
const int mod  = (int)1e9+7;
const int INF  = (int)1e9+17;
const ll LLINF = (ll)1e18+17;


int n, m;
map<string,string> desc;


string parse(const string& text, int index) {
    string name;
    bool isName = false;
    for(int i = index;text[i] != '}';++i) {
        if (isName) name += text[i];
        if (text[i] == '{') isName = true;
    }
    return name;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL

    vector<string> order;
    while (true) {
        string text;
        getline(cin, text);
        if (text == "\\begin{thebibliography}{99}") {
            break;
        }
        rep(i, 0, text.size()) {
            if (text[i] == '\\') {
                order.push_back(parse(text, i));
            }
        }
    }
    vector<string> links;
    while (true) {
        string item;
        getline(cin, item);
        if (item == "\\end{thebibliography}") {
            break;
        }
        string link = parse(item, 0);
        links.push_back(link);
        desc[link] = item;
    }

    vector<string> correct;
    assert(order.size() == links.size());
    bool isIncorrect = false;
    rep(i, 0, order.size()) {
        if (!isIncorrect && order[i] != links[i]) {
            isIncorrect = true;
        }
        correct.push_back(desc[order[i]]);
    }
    if (!isIncorrect) {
        cout << "Correct" << endl;
        return 0;
    }
    cout << "Incorrect" << endl;
    cout << "\\begin{thebibliography}{99}" << endl;
    rep(i, 0, correct.size()) {
        cout << correct[i] << endl;
    }
    cout << "\\end{thebibliography}" << endl;


    return 0;
}
