#include <bits/stdc++.h>
using namespace std;

#define fst first
#define snd second
#define mp make_pair
#define rep(i,a,n) for(int i=(a);i<(n);++i)
#define per(i,a,n) for(int i=(n)-1;i>=(a);--i)
#define all(x) (x).begin(),(x).end()

template<typename T1, typename T2>
inline bool umin(T1& x, const T2& y) {return x>y ? x=y,true:false;}

template<typename T1, typename T2>
inline bool umax(T1& x, const T2& y) {return x<y ? x=y,true:false;}

typedef long long ll;
typedef long double ld;

const int N    = (int)1e5+7;
const int mod  = (int)1e9+7;
const int INF  = (int)1e9+17;
const ll LLINF = (ll)1e18+17;



int n, m;
int c[N];
ll w;
int cnt[N];
vector<int> g[N];
set<int> wait[N];
bitset<N> have;
bitset<N> cur;


void rem(int idx) {
    --c[idx];
    if (c[idx] <= w) {
        for(int x:g[idx]) {
            auto it = wait[x].find(idx);
            if (it != wait[x].end()) {
                wait[x].erase(it);
            }
            if (wait[x].empty()) {
                cur[x] = 0;
                have[x] = 0;
            }
        }
    }
}

int main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
#endif

    cin >> n >> m;
    ll total = 0;
    rep(i, 0, n) {
        cin >> c[i];
        rep(j, 0, c[i]) {
            int x;
            cin >> x;
            g[i].push_back(x);
        }
        total += c[i];
    }
    w = total / n;
    rep(i, 0, n) {
        if (c[i] <= w) continue;
        for(int x:g[i]) {
            wait[x].insert(i);
        }
    }
    rep(i, 0, m) {
        if (!wait[i].empty()) {
            have[i] = 1;
        }
    }
    vector<tuple<int,int,int>> steps;
    vector<int> ord(n);
    rep(i, 0, n) ord[i] = i;
    mt19937 rnd(chrono::system_clock::now().time_since_epoch().count());
    shuffle(all(ord), rnd);
    for(int i:ord) {
        cur.set();
        for(int x:g[i]) {
            cur[x] = 0;
        }
        cur &= have;
        int pos = -1;
        while (c[i] < w) {
//            cerr << i << ' ' << c[i] << endl;
            pos = (pos == -1 ? cur._Find_first() : cur._Find_next(pos));
//            cerr << "Add " << pos << endl;
            int index = *wait[pos].begin();
            wait[pos].erase(wait[pos].begin());
            if (wait[pos].empty()) {
                have[pos] = 0;
            }
            rem(index);
            steps.emplace_back(index, i, pos);
            ++c[i];
            cur[pos] = 0;
        }
    }
    cout << steps.size() << endl;
    for(const auto& s:steps) {
        cout << get<0>(s)+1 << ' ' << get<1>(s)+1 << ' ' << get<2>(s) << '\n';
    }


    return 0;
}
