#include <bits/stdc++.h>
using namespace std;

#define fst first
#define snd second
#define mp make_pair
#define rep(i,a,n) for(int i=(a);i<(n);++i)
#define per(i,a,n) for(int i=(n)-1;i>=(a);--i)
#define all(x) (x).begin(),(x).end()

template<typename T1, typename T2>
inline bool umin(T1& x, const T2& y) {return x>y ? x=y,true:false;}

template<typename T1, typename T2>
inline bool umax(T1& x, const T2& y) {return x<y ? x=y,true:false;}

typedef long long ll;
typedef long double ld;

const int N    = (int)1e7+7;
//const int mod  = (int)1e9+7;
const int INF  = (int)1e9+17;
const ll LLINF = (ll)1e18+17;


ll n, l, r, x, y, z;
ll b[N];
ll a[N];

const ll mod = (1ll << 32) - 1;

void solve() {
#ifndef LOCAL
    cin >> n >> l >> r >> x >> y >> z >> b[0] >> b[1];
    rep(i, 2, n) {
        b[i] = ((1ll * b[i-2] * x + 1ll * b[i-1] * y + z) & mod);
    }
    rep(i, 0, n) {
        a[i] = (b[i] % (r-l+1)) + l;
//        cerr << a[i] << ' ';
    } //cerr << endl;
#else
    cin >> n;
    rep(i, 0, n) cin >> a[i];
#endif
    bool any = false;
    ll res = numeric_limits<ll>::max();
    ll mn = a[0];
    rep(i, 1, n) {
        if (a[i] >= 0 && a[i] > mn) {
            umin(res, a[i] * mn);
            any = true;
        }
        umin(mn, a[i]);
    }
    ll mx = a[n-1];
    per(i, 0, n-1) {
        if (a[i] <= 0 && a[i] < mx) {
            umin(res, a[i] * mx);
            any = true;
        }
        umax(mx, a[i]);
    }
    if (!any) {
        cout << "IMPOSSIBLE" << '\n';
        return;
    }
    cout << res << '\n';
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL

    int T;
    cin >> T;
    while (T --> 0) {
        solve();
    }

    return 0;
}
