#pragma GCC optimize("Ofast")
#pragma GCC optimize("fast-math")
#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <cstring>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <iomanip>
#include <cstdio>
#include <stdio.h>
#include <random>

using namespace std;

#define int long long

const int MOD = (1LL << 32);

const int maxn = 10 * 1000 * 1000 + 7, INF = 2e9 + 228;

int t[maxn];

int a[maxn], b[maxn];

pair<int, int> crd[maxn];

void solve() {
	int n, l, r, x, y, z, b1, b2;
	cin >> n >> l >> r >> x >> y >> z >> b1 >> b2;
	b[1] = b1;
	b[2] = b2;
	for (int i = 3; i <= n; ++i) {
		b[i] = (b[i - 2] * x + b[i - 1] * y + z) % MOD;
	}
	for (int i = 1; i <= n; ++i) {
		a[i] = (b[i] % (r - l + 1)) + l;
	}
	int res = INF * INF;
	int mn = 1;
	for (int i = 1; i <= n; ++i) {
		if (a[mn] < a[i] && a[i] * a[mn] < res) {
			res = a[i] * a[mn];
		}
		if (a[i] < a[mn]) {
			mn = i;
		}
	}
	mn = n;
	for (int i = 1; i <= n; ++i) {
		a[i] = -a[i];
	}
	for (int i = n - 1; i > 0; --i) {
		if (a[mn] < a[i] && a[i] * a[mn] < res) {
			res = a[i] * a[mn];
		}
		if (a[i] < a[mn]) {
			mn = i;
		}
	}
	if (res == INF * INF) {
		cout << "IMPOSSIBLE\n";
	}
	else {
		cout << res << endl;
	}
}


signed main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	int tests;
	cin >> tests;
	for (int it = 0; it < tests; ++it) {
		solve();
	}
	return 0;
}
