#include <iostream>
#include <vector>
#include <map>

using namespace std;

pair<int, int> answer(string a, string b) {
    bool* counts = new bool[26];
    for (int i = 0; i < 26; i++)
        counts[i] = false;
    for (int i = 0; i < b.size(); i++)
        counts[(int)b[i] - (int)'a'] = true;
    int result = 0;
    for (int i = 0; i < 26; i++) {
        result <<= 1;
        if (counts[i]) {

            result++;
        }
    }
    int cnt = 0;
    for (int i = 0; i < a.size(); i++)
        counts[(int)a[i] - (int)'a'] = true;
    for (int i = 0; i < 26; i++) {
        cnt <<= 1;
        if (counts[i]) {

            cnt++;
        }
    }
    return make_pair(cnt, result);
}

int main(void) {
    int* counts = new int[67108864];
    int n;
    cin >> n;
    map<pair<int, int>, vector<int> > dict;
    for (int i = 0; i < n; i++) {
        string a, b;
        cin >> a >> b;
        pair<int, int> x = answer(a, b);
        if (dict.find(x) != dict.end())
            dict[x].push_back(i + 1);
        else
            //dict[x] = new vector<int>();
            dict[x].push_back(i + 1);
    }
    cout << dict.size() << endl;
    for (auto i : dict) {
        cout << i.second.size() << " ";
        for (int j = 0; j < i.second.size(); j++) {
            cout << i.second[j] << " ";
        }
        cout << endl;
    }
    return 0;
}
