#include <iostream>

using namespace std;

bool check(int len, int* houses, int n) {
    for (int i = 0; i < n - len + 1; i++) {
        bool res = true;
        for (int j = 0; j < len - 1; j++)
        if (houses[i + j] == houses[i + j + 1]) {
            res = false;
            break;
        }
        if (res)
            return true;
    }
    return false;
}

int main(void) {
    int n, k;
    cin >> n >> k;
    int* houses = new int[n];
    for (int i = 0; i < n; i++) {
        cin >> houses[i];
    }
    int left = 0, right = n + 1;
    while (right - left > 1) {
        int mid = (right + left) / 2;
        if (check(mid, houses, n))
            left = mid;
        else
            right = mid;
    }
    cout << left;
    return 0;
}
