#include <bits/stdc++.h>
using namespace std;

struct creat {
    int hp, ap, died;
    map<int, int> dmg;
};

vector <creat> creatures;
int N, n, m, k, i, j;

void add_dmg(creat &a, creat &b)
{
    int st = b.ap;

    while( a.dmg.find(st) != a.dmg.end() && a.dmg[st] == 1)
    {
        a.dmg[st] = 0;
        st++;
    }
    a.dmg[st] = 1;
}


void fight(creat &a, creat &b)
{
    add_dmg(a, b);
    add_dmg(b, a);

    /*cout << "fight a" << endl;
    cout << "hp = " << a.hp << endl;
    for(auto it = a.dmg.rbegin(); it != a.dmg.rend(); ++it)
    {
        cout << it->first << " " << it->second << endl;
    }

    cout << "fight b" << endl;
    cout << "hp = " << b.hp << endl;
    for(auto it = b.dmg.rbegin(); it != b.dmg.rend(); ++it)
    {
        cout << it->first << " " << it->second << endl;
    }*/

    if ((a.dmg.find(a.hp) != a.dmg.end()) && (a.dmg[a.hp] == 1) || (a.dmg.rbegin()->first > a.hp) && (a.dmg.rbegin()->second == 1))
    {
        a.died = N;
    }

    if ((b.dmg.find(b.hp) != b.dmg.end()) && (b.dmg[b.hp] == 1) || (b.dmg.rbegin()->first > b.hp)  && (b.dmg.rbegin()->second == 1))
    {
        b.died = N;
    }
}


int main() {
    ios_base::sync_with_stdio(0);
    cin >> n;
    int mov;
    int x, y;
    creat fake;
    creatures.push_back(fake);

    for (N = 1; N <= n; N++)
    {
        cin >> mov;
        if (mov == 1)
        {
            creat Cr;
            Cr.hp = 0, Cr.ap = 0, Cr.died = -1;
            Cr.dmg[0] = 0;
            creatures.push_back(Cr);
        } else if (mov == 2)
        {
            cin >> x;
            if (creatures[x].died < 0)
                creatures[x].ap++;
        } else if (mov == 3)
        {
            cin >> x;
            if (creatures[x].died < 0){
                map<int, int> tmp;
                for(auto it = creatures[x].dmg.rbegin(); it != creatures[x].dmg.rend(); ++it)
                {
                    tmp[it->first +1] = it->second;
                }
                creatures[x].dmg = tmp;
                creatures[x].hp++;
            }
        } else if (mov == 4)
        {
            cin >> x;
            creat Cr;
            Cr.hp = creatures[x].hp, Cr.ap = creatures[x].ap, Cr.dmg = creatures[x].dmg, Cr.died = (creatures[x].died > 0) ? N : -1;
            creatures.push_back(Cr);
        } else {
            cin >> x >> y;
            if (creatures[x].died < 0 && creatures[y].died < 0)
                fight(creatures[x], creatures[y]);
        }

        //cout << N << endl;
        /*for (i = 1; i<creatures.size(); i++)
        {
            cout << creatures[i].died << " ";
        }
        cout << endl;*/
    }

    cout << creatures.size()-1 << endl;
    for (i = 1; i<creatures.size(); i++)
    {
        cout << creatures[i].died << " ";
    }
    cout << endl;

    return 0;
}
