#pragma GCC optimaze("Ofast");
#pragma GCC optimaze("unroll-loops")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.2,popcnt,abm,mmx, tune=native")
#include<iostream>
#include<vector>
#include<string>
#include<map>
#include<set>
#include<math.h>
#include<algorithm>
#include<queue>

using namespace std;

bool fd[10][10];
bool te[10][10];
bool used[10][10];
pair<int, int> pr[10][10];

int xe[8] = { -1, -1, -2, -2, 1, 1, 2, 2 };
int ye[8] = { -2, 2, -1, 1, -2, 2, -1, 1 };

bool prov(int x)
{
	return (x >= 1) && (x <= 8);
}

vector<pair<int, int>> bfs(int x, int y)
{
	for(int i = 1; i <= 8; i++)
		for (int j = 1; j <= 8; j++)
		{
			used[i][j] = 0;
			pr[i][j] = { 0, 0 };
		}
	used[x][y] = 1;
	queue<pair<int, int>> dr;
	dr.push({ x, y });
	while (dr.size())
	{
		pair<int, int> v = dr.front();
		dr.pop();
		if (!te[v.first][v.second] && fd[v.first][v.second])
		{
			vector <pair<int, int>> g;
			while (v.first != 0)
			{
				g.push_back(v);
				v = pr[v.first][v.second];
			}
			return g;
		}
		for (int i = 0; i < 8; i++)
		{
			int nx = v.first + xe[i];
			int ny = v.second + ye[i];
			if (prov(nx) && prov(ny) && !used[nx][ny])
			{
				pr[nx][ny] = { v.first, v.second };
				used[nx][ny] = 1;
				dr.push({ nx, ny });
			}
		}
	}
}

vector<string> out;

void zp(int x, int y, int x2, int y2)
{
	fd[x2][y2] = 0;
	fd[x][y] = 1;
	swap(x, y);
	swap(x2, y2);
	string hj;
	hj.push_back(char('a' + x2 - 1));
	hj.push_back(char(y2 + '0'));
	hj.push_back('-');
	hj.push_back(char('a' + x - 1));
	hj.push_back(char(y + '0'));
	out.push_back(hj);
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	int n;
	cin >> n;
	int v = n;
	for (int i = 1; i <= n; i++)
	{
		string s;
		cin >> s;
		int x1, y1;
		x1 = s[0] - 'a' + 1;
		y1 = s[1] - '0';
		swap(x1, y1);
		fd[x1][y1] = 1;
	}
	if (n == 64)
		return 0;
	for (int i = 1; i <= 8; i++)
	{
		for (int j = 1; j <= 8; j++)
		{
			if (v != 0)
			{
				te[i][j] = 1;
				v--;
			}
		}
	}
	for (int i = 1; i <= 8; i++)
	{
		for (int j = 1; j <= 8; j++)
		{
			if (te[i][j] && !fd[i][j])
			{
				vector<pair<int, int>> mass = bfs(i, j);
				reverse(mass.begin(), mass.end());
				for (int i = 1; i < mass.size(); i++)
				{
					if (fd[mass[i].first][mass[i].second])
					{
						int h = i - 1;
						while (h >= 0 && !fd[mass[h].first][mass[h].second])
						{
							zp(mass[h].first, mass[h].second, mass[h + 1].first, mass[h + 1].second);
							h--;
						}
					}
				}
			}
		}
	}
	if (out.size() > 1500)
	{
		cout << (1 / 0);
	}
	cout << out.size() << endl;
	for (int i = 0; i < out.size(); i++)
		cout << out[i] << endl;
	//system("pause");
}

/*
63
a1
b1
c1
d1
e1
f1
g1
h1
a2
b2
c2
d2
e2
f2
g2
h2
a3
b3
c3
d3
e3
f3
g3
h3
a4
b4
c4
d4
e4
f4
g4
h4
a5
b5
c5
d5
e5
f5
g5
h5
a6
b6
c6
d6
e6
f6
g6
h6
a7
b7
c7
d7
e7
f7
g7
h7
b8
c8
d8
e8
f8
g8
h8
*/