#pragma GCC optimaze("Ofast");
#pragma GCC optimaze("unroll-loops")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.2,popcnt,abm,mmx, tune=native")
#include<iostream>
#include<vector>
#include<string>
#include<map>
#include<set>
#include<math.h>
#include<algorithm>

using namespace std;

const int maxn = 1e7 + 113;

unsigned long long mass[maxn];
long long mass2[maxn];
const unsigned long long mod = (1LL << 32);
const long long inf = (long long)(4e18) + 1;

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	int t;
	cin >> t;
	for (int test = 0; test < t; test++)
	{
		unsigned long long n, x, y, z, b1, b2;
		long long l, r;
		cin >> n >> l >> r >> x >> y >> z >> b1 >> b2;
		mass[1] = b1, mass[2] = b2;
		for (int i = 3; i <= n; i++)
			mass[i] = ((mass[i - 2] * x) % mod + (mass[i - 1] * y) % mod + z) % mod;
		for (int i = 1; i <= n; i++)
			mass2[i] = mass[i] % (r - l + 1) + l;
		long long ans = inf;
		long long last = (long long)2e9 + 1;
		int rd = 0;
		for (int i = 1; i <= n; i++)
		{
			if (mass2[i] > last)
				continue;
			last = mass2[i];
			rd = max(i + 1, rd);
			for (int j = rd; j <= n; j++)
			{
				if (mass2[j] <= mass2[i])
					break;
				ans = min(ans, mass2[i] * mass2[j]);
			}
		}
		if (ans == inf)
			cout << "IMPOSSIBLE" << endl;
		else
			cout << ans << endl;
	}
	//system("pause");
}