#include <bits/stdc++.h>

using namespace std;

template<class t1, class t2> inline void chkmin(t1 &x, const t2 &y) {if (x > y) x = y;}
template<class t1, class t2> inline void chkmax(t1 &x, const t2 &y) {if (x < y) x = y;}
#define x first
#define y second
const int MAXN = 2e5 + 7;
string to_s(pair<int, int> a)
{
    string res = "";
    res += char('a' + (a.x - 0));
    res += char('1' + (a.y - 0));
    return res;
}
pair<int, int> to_p(string s)
{
    pair<int, int> res = {0, 0};
    res.x = s[0] - 'a';
    res.y = s[1] - '1';
    return res;
}
bool on_b(pair<int, int> a)
{
    return a.x >= 0 && a.x < 8 && a.y >= 0 && a.y < 8;
}
int mat[8][8];
pair<int, int> pr[8][8];
bool used[8][8];
int k;
int dx[8] = {-1, -2, -2, -1, 1, 2, 2, 1};
int dy[8] = {-2, -1, 1, 2, 2, 1, -1, -2};
vector<pair<int, int>> K;
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> k;
    for (int i = 0; i < k; ++i)
    {
        string s;
        cin >> s;
        pair<int, int> pp = to_p(s);
        mat[pp.x][pp.y] = 1;
        K.push_back(pp);
    }
    vector<pair<pair<int, int>, pair<int, int>>> Ans;
    int sh = 0;
    for (int i1 = 0; i1 < k; ++i1)
    {
        pair<int, int> st = {i1 % 8, i1 / 8};
        if (mat[st.x][st.y] == 1)
        {
            continue;
        }
        for (int i = 0; i < 8; ++i)
        {
            for (int j = 0; j < 8; ++j)
            {
                pr[i][j] = {-1, -1};
                used[i][j] = false;
            }
        }
        used[st.x][st.y] = true;
        queue<pair<int, int>> q;
        q.push(st);
        pair<int, int> need = {-1, -1};
        while (!q.empty())
        {
            pair<int, int> cr = q.front();
            q.pop();
            if (mat[cr.x][cr.y] == 1 && cr.x + cr.y * 8 >= i1)
            {
                need = cr;
                break;
            }
            for (int i = 0; i < 8; ++i)
            {
                pair<int, int> N = {cr.x + dx[i], cr.y + dy[i]};
                if (!on_b(N) || used[N.x][N.y]) continue;
                used[N.x][N.y] = true;
                pr[N.x][N.y] = cr;
                q.push(N);
            }
        }
        //cout << need.x << " " << need.y << endl;
        vector<pair<int, int>> path;
        pair<int, int> last = need;
        while (last != st)
        {
            path.push_back(last);
            last = pr[last.x][last.y];
        }
        path.push_back(st);
        reverse(path.begin(), path.end());
        //for (auto el : path) cout << to_s(el) << " ";
        //cout << endl;
        int ind = 0;
        while (ind < path.size())
        {
            int nx = ind + 1;
            while (nx < path.size() && mat[path[nx].x][path[nx].y] != 1) nx++;
            if (nx == path.size()) break;
            int ind1 = nx;
            mat[path[nx].x][path[nx].y] = 0;
            while (nx != ind)
            {
                Ans.push_back({path[nx], path[nx - 1]});
                nx--;
            }
            mat[path[ind].x][path[ind].y] = 1;
            ind = ind1;
        }
    }
    cout << Ans.size() << endl;
    for (int i = 0; i < Ans.size(); ++i)
    {
        cout << to_s(Ans[i].x) << "-" << to_s(Ans[i].y) << endl;
    }
}
