#include <bits/stdc++.h>

using namespace std;

template<class t1, class t2> inline void chkmin(t1 &x, const t2 &y) {if (x > y) x = y;}
template<class t1, class t2> inline void chkmax(t1 &x, const t2 &y) {if (x < y) x = y;}
#define pb push_back
#define sz(c) (int)(c).size()
#define all(c) (c).begin(), (c).end()
const int MAXN = 200228;
const int M = 1000000007;
const int P = 424243;

long long h[MAXN];
long long p[MAXN];
int sup[MAXN];
int d[MAXN];
int z[MAXN];


long long gethash(int l, int r) {
    return ((h[r] - (l ? p[r - l + 1] * h[l - 1]: 0)) % M + M) % M;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
   //freopen("input.in", "r", stdin);
    string s, t;
    cin >> s >> t;
    int n = sz(s);
    int m = sz(t);
    long long ans = 1LL * n * m;
    p[0] = 1;
    for (int i = 1; i <= m; i++) {
        p[i] = (p[i - 1] * P) % M;
    }
    h[0] = t[0];
    for (int i = 1; i < m; i++) {
        h[i] = (h[i - 1] * P + t[i]) % M;
    }
    for (int i = 0; i < m; i++) {
        int pos = i;
        int len = i + 1;
        while (pos + len < m && gethash(pos + 1, pos + len) == gethash(0, i)) {
            pos += len;
        }
        int l = pos + 1;
        int r = min(pos + len, m - 1);
        while (l < r) {
            int mid = (l + r + 1) >> 1;
            if (gethash(pos + 1, mid) == gethash(0, mid - pos - 1)) {
                l = mid;
            } else {
                r = mid - 1;
            }
        }
        if (l >= pos + 1 && l < m && gethash(pos + 1, l) == gethash(0, l - pos - 1)) {
            pos = l;
        }
        sup[i] = pos + 1;
    }
    for (int i = 0; i < m; i++) {
        d[i] = sup[i];
        if (i) {
            d[i] = max(d[i], d[i - 1]);
        }
    }
    string k;
    k = t + "#" + s;
    //cout << k << endl;
    int left = 0;
    int right = 0;
    z[0] = sz(k);
    for (int i = 1; i < sz(k); i++) {
        if (i <= right) {
            z[i] = min(right - i + 1, z[i - left]);
        }
        while (i + z[i] < sz(k) && k[i + z[i]] == k[z[i]]) {
            z[i]++;
        }
        //cout << z[i] << endl;
        if (z[i] + i - 1 > right) {
            right = z[i] + i - 1;
            left = i;
        }
    }
    vector<int> ks;
    for (int i = sz(t) + 2; i < sz(k); i++) {
        ks.pb(z[i]);
       // cout << z[i] << endl;
    }
    sort(all(ks));
    int uk = 0;
    for (int i = 0; i < m; i++) {
        int r = sup[i];
        int l = max(i + 2, (i == 0 ? 0: d[i - 1]) + 1);
        int f = r - l + 1;
       // cout << f << ' ' << l << ' ' << r << endl;
        if (f <= 0) {
            continue;
        }
        while (uk < sz(ks) && ks[uk] < i + 1) {
            uk++;
        }
        int len = sz(ks) - uk;
      // cout << len << endl;
        ans -= 1LL * len * f;
    }
    cout << ans << '\n';
}
