#include <bits/stdc++.h>

using namespace std;

template<class t1, class t2> inline void chkmin(t1 &x, const t2 &y) {if (x > y) x = y;}
template<class t1, class t2> inline void chkmax(t1 &x, const t2 &y) {if (x < y) x = y;}

typedef long long ll;

ll n1, n2, a1, a2, S1, S2, k;

bool IsValid(ll k1, ll k2) {
    return 0 <= k1 && k1 <= n1 && 0 <= k2 && k2 <= n2;
}

ll CheckK(ll k1, ll k2) {
    if (!IsValid(k1, k2)) return 0;
    if (k1 == 0 && k2 == 0) return 0;
    if (k1 == 0) return S2 / k2;
    if (k2 == 0) return S1 / k1;
    return min(S1 / k1, S2 / k2);
}

bool Check1(ll m) {
    ll k1, k2, x, y;
    k1 = S1 / m;
    y = S1 % m;
    k2 = k - k1;
    return k2 * m <= S2 + y && IsValid(k1, k2);
}

bool Check2(ll m) {
//    if (m == 0)
//        cout << "KOKORIKO" << endl;
    ll k1, k2, x, y;
    k2 = S2 / m + 1;
    k1 = k - k2;
    x = S2 % m;
    y = m - x;
    return k1 * m <= S1 - y && IsValid(k1, k2);
}

bool Check(ll m) {
//    cout << m << ' ' << S1 << ' ' << S2 << endl;
    ll k1, k2;
    k1 = (S1 * k) / (S1 + S2);
    k2 = k - k1;
//    cout << "RAK" << endl;
    ll mm = max(CheckK(k1, k2), CheckK(k1 + 1, k2 - 1));
    chkmax(mm, CheckK(k1 - 1, k2 + 1));
    chkmax(mm, CheckK(k1 - 2, k2 + 2));
//    cout << k << k1 << ' ' << k2 << ' ' << mm << '\n';
    if (m <= mm) return true;
//    cout << "RAK" << endl;
    return Check1(m) || Check2(m);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
//    freopen("input.in", "r", stdin);
    ll t, n, a, b;
    cin >> t >> n >> a >> b >> k;
    n1 = (n + 1) / 2;
    n2 = n / 2;
    a1 = a;
    a2 = b;
    if (a1 > a2) {
        swap(a1, a2);
        swap(n1, n2);
    }
    S1 = n1 * a1;
    S2 = n2 * a2;
    if (k > n1) {
        ll l = 0, r = t + 1;
        while (r - l > 1) {
//                cout << l << ' ' << r << endl;
            ll m = (l + r) / 2;
            if (Check(m))
                l = m;
            else
                r = m;
        }
        cout << l << '\n';
        return 0;
    }
    cout << (S1 + S2) / k << '\n';
}
