#include <bits/stdc++.h>
using namespace std;

#define rep(i, n) for (int (i) = 0; (i) < (n); ++(i))
using ll = long long;
using ld = long double;

const int N = 8, INF = 100;
int a[N][N];
int dt[8][2] = {{1, 2}, {1, -2}, {-1, 2}, {-1, -2}, {2, 1}, {2, -1}, {-2, 1}, {-2, -1}};

int main() {
//    freopen("input", "r", stdin);
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    int n;
    cin >> n;
    string s;
    for (int i = 0; i < n; i++) {
        cin >> s;
        a[s[1] - '1'][s[0] - 'a'] = 1;
    }
    vector<string> ans;
    for (int i = 0; i < n; i++) {
        int x = i / N, y = i % N;
        if (a[x][y] == 1) {
            a[x][y] = 2;
            continue;
        }
        queue<pair<int, int>> q;
        vector<vector<int>> d(N, vector<int>(N, INF));
        vector<vector<pair<int, int>>> pr(N, vector<pair<int, int>>(N));
        d[x][y] = 0;
        int lx, ly;
        q.push({x, y});
        while (!q.empty()) {
            int cx = q.front().first, cy = q.front().second;
            q.pop();
            if (a[cx][cy] == 1) {
                lx = cx;
                ly = cy;
                break;
            }
            for (int j = 0; j < 8; j++) {
                int nx = cx + dt[j][0], ny = cy + dt[j][1];
                if (0 <= nx && nx < N && 0 <= ny && ny < N && d[nx][ny] == INF) {
                    d[nx][ny] = d[cx][cy] + 1;
                    pr[nx][ny] = {cx, cy};
                    q.push({nx, ny});
                }
            }
        }
        vector<pair<int, int>> v;
        a[lx][ly] = 0;
        while (1) {
            v.push_back({lx, ly});
            if (lx == x && ly == y)
                break;
            pair<int, int> pp = pr[lx][ly];
            lx = pp.first;
            ly = pp.second;
        }
        while (v.size() > 1) {
            int pos = v.size() - 2;
            while (pos > 0 && a[v[pos].first][v[pos].second] != 1)
                pos--;
            for (int j = pos; j + 1 < v.size(); j++) {
                string cs;
                cs += 'a' + v[j].second;
                cs += '1' + v[j].first;
                cs += '-';
                cs += 'a' + v[j + 1].second;
                cs += '1' + v[j + 1].first;
                ans.push_back(cs);
            }
            while (v.size() > pos + 1) {
                v.pop_back();
            }
        }
        a[x][y] = 2;
    }
    cout << ans.size() << '\n';
    for (auto pp : ans)
        cout << pp << '\n';
}
