#define _CRT_SECURE_NO_WARNINGS

#include<iostream>
#include  <algorithm>
#include <vector>
#include <string>
#include <map>
#include <stdio.h>
#include <queue>

#define pb push_back
#define ll long long
#define X first
#define Y second
#define pii pair<int, int>
#define mp make_pair
#define er erase
#define is insert

using namespace std;

int solve();

int main()
{
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif // _DEBUG
	solve();
	return 0;
}

vector<pair<int, int>> go = { { 1, 2 },{ 1, -2 },{ -1, 2 },{ -1, -2 },{ 2, 1 },{ 2, -1 },{ -2, 1 },{ -2, -1 } };

vector<pair<int, int>> bfs(int x, int y, int x1, int y1) {
	queue<pair<int, int>> q;
	bool used[8][8];
	for (int i = 0; i < 8; ++i) for (int j = 0; j < 8; ++j) used[i][j] = 0;
	pair<int, int> parent[8][8];
	q.emplace(x, y);
	used[x][y] = 1;
	while (!q.empty()) {
		int x_now = q.front().X;
		int y_now = q.front().Y;
		q.pop();
		for (auto &i : go) {
			int x1_now = x_now + i.X;
			int y1_now = y_now + i.Y;
			if (x1_now >= 0 && x1_now < 8 && y1_now >= 0 && y1_now < 8 && !used[x1_now][y1_now]) {
				used[x1_now][y1_now] = 1;
				parent[x1_now][y1_now] = mp(x_now, y_now);
				q.emplace(x1_now, y1_now);
			}
		}
	}
	vector<pair<int, int>> v;
	while (x1 != x || y1 != y) {
		v.emplace_back(x1, y1);
		auto p = parent[x1][y1];
		x1 = p.X;
		y1 = p.Y;
	}
	return v;
}

bool used[8][8];
vector<string> ans;

bool f(int x, int y, vector<pair<int, int>> &v) {
	if (v.empty()) return 0;
	used[x][y] = 1;
	if (!used[v.back().X][v.back().Y]) {
		string s;
		s.push_back('a' + x);
		s.push_back('1' + y);
		s.push_back('-');
		s.push_back(v.back().X + 'a');
		s.push_back(v.back().Y + '1');
		ans.emplace_back(s);
		used[x][y] = 0;
		auto p = v.back();
		v.pop_back();
		f(p.X, p.Y, v);
		return 1;
	}
	else {
		auto p = v.back();
		v.pop_back();
		if (f(p.X, p.Y, v)) {
			used[x][y] = 0;
			used[p.X][p.Y] = 1;
			string s;
			s.push_back('a' + x);
			s.push_back('1' + y);
			s.push_back('-');
			s.push_back(p.X + 'a');
			s.push_back(p.Y + '1');
			ans.emplace_back(s);
			return 1;
		}
		return 0;
	}
}

int solve()
{
	int n;
	cin >> n;
	vector<pair<int, int>> v;
	for (int i = 0; i < n; ++i) {
		string s;
		cin >> s;
		v.emplace_back(s[0] - 'a', s[1] - '1');
		used[s[0] - 'a'][s[1] - '1'] = 1;
	}
	vector<vector<pair<int, int>>> vec(n);
	for (int i = 0; i < n; ++i) {
		vec[i] = bfs(v[i].X, v[i].Y, i % 8, i / 8);
	}
	for (int i = 0; i < n; ++i) {
		f(v[i].X, v[i].Y, vec[i]);
	}
	cout << ans.size() << "\n";
	for (auto &i : ans) {
		cout << i << "\n";
	}
	return 0;
}
