#include <bits/stdc++.h>

#define y1 mozyr1
#define make_struct(args...) {args}

using namespace std;
typedef long long ll;

const long long INF = 1e18 + 10;
const int inf = 1e9 + 10;
const int N = 1e6 + 10;
typedef pair <ll, ll> pll;

int f (int a, int b)
{
    if (a > b)
        return 1;
    if (a == b)
        return 0;
    if (a < b)
        return 2;
}

void kek (vector <int> a, vector <int> b, vector <pair <int, int> > edge)
{
    for(int i = 0; i < edge.size(); i++)
    {
        int x = edge[i].first, y = edge[i].second;
        if (f (a[x], a[y]) != f (b[x], b[y]))
        {
            cout << "FAIL" << "\n";
            exit(0);
        }
    }
}


int main()
{
    cin.tie(0);
    ios::sync_with_stdio(0);

    int n, m;
    cin >> n >> m;
    srand(time(0));
    //n = 100;
    //m = 100;


    if (n == 1)
        return cout << "NO" << "\n", 0;

    vector <int> a(n), b(n);
    vector <vector <int> > g(n);
    for(int i = 0; i < n; i++)
        a[i] = i, b[i] = i;

    vector <pair <int, int> > edge(m);
    for(int i = 0; i < m; i++)
    {
        int x, y;
        //x = rand() % 100, y = rand() % 100;
        //cout << x << " " << y << endl;
        cin >> x >> y;
        x--, y--;

        g[x].push_back(y);
        g[y].push_back(x);
        edge[i] = make_pair(x, y);
    }

    int win = 0;
    for(int i = 0; i < n; i++)
    {
        int l = 0, r = n - 1;
        for(auto to : g[i])
        {
            if (f (a[i], a[to]) == 2)
                r = min(r, a[to] - 1);

            if (f (a[i], a[to]) == 1)
                l = max(l, a[i]);
        }

        if (r != i)
        {
            b[i] = r;
            win = 1;
            break;
        }

        if (l != i)
        {
            b[i] = l;
            win = 1;
            break;
        }
    }

    //kek (a, b, edge);

    if (win)
        cout << "YES" << "\n";
    else
        return cout << "NO" << "\n", 0;

    for(auto i : a)
        cout << i + 1 << " ";

    cout << "\n";

    for(auto i : b)
        cout << i + 1 << " ";
    return 0;
}
