#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
const ll INF = LLONG_MAX;

pair<int, int> moves[8] = {{-1, -2}, {-1, 2}, {1, 2}, {1, -2}, {2, -1}, {2, 1}, {-2, 1}, {-2, -1}};
int was[10][10];
vector<pair<pair<int, int>, pair<int, int> >  > res;
bool dont[10][10];

int main() {

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int k;
    cin >> k;


    for(auto &i: was)for(auto &j: i)j = 0;
    for(auto &i: dont)for(auto &j: i)j = 0;

    for(int i = 0; i < k; i++){
        string str;
        cin >> str;
        was[str[1] - '1'][str[0] - 'a'] = 1;
    }

    int p = 0;
    for(int i = 0; i <8 && p < k; i++){
        for(int j = 0; j < 8 && p < k; j++){
            if(was[i][j] == 0){
                queue<pair<int, int> > q;
                map<pair<int, int> , int> locked;
                q.push({i, j});
                int trgy, trgx;
                trgy = trgx = -1;
                while(!q.empty()){
                    int x, y;
                    tie(y, x) = q.front();
                    q.pop();
                    locked[{y, x}] = 1;
                    for(auto &j: moves){
                        int xx, yy;
                        yy = y + j.first;
                        xx = x + j.second;
                        if(yy >= 0 && yy <= 7 && xx >= 0 && xx <= 7 && !locked[{yy,xx}]  ){
                            if(was[yy][xx] == 0){
                                q.push({yy, xx});
                                locked[{yy, xx}] = 1;
                            }
                            else if(dont[yy][xx] == 0){
                                trgy = yy;
                                trgx = xx;
                                while(!q.empty())q.pop();
                                break;
                            }
                        }
                    }
                }
                if(trgx == -1)throw(1);
                vector<vector<int> > used(8, vector<int>(8, 0));

                q.push({trgy, trgx});
                while(!q.empty()){
                    int y, x;
                    tie(y, x) = q.front();
                    q.pop();
                    if(used[y][x] != 0)continue;
                    for(auto &j: moves){
                        int yy, xx;
                        yy = y + j.first;
                        xx=  x + j.second;
                        if(yy >= 0 && yy <= 7 && xx >= 0 && xx <= 7){
                            used[y][x] = max(used[y][x], used[yy][xx] + 1);
                        }
                    }
                    for(auto &j: moves){
                        int yy, xx;
                        yy = y + j.first;
                        xx=  x + j.second;
                        if(yy >= 0 && yy <= 7 && xx >= 0 && xx <= 7 && used[yy][xx] == 0 ){
                            q.push({yy, xx});
                        }
                    }
                }
                while(!q.empty())q.pop();
                q.push({i, j});
                stack<pair<pair<int, int>, pair<int, int> > > qq;
                bool po = 0;
                while(!q.empty()){
                    int y, x;
                    tie(y, x) = q.front();
                    q.pop();

                    for(auto &OO: moves){
                        int yy, xx;
                        yy = y + OO.first;
                        xx = x + OO.second;
                        if(yy >= 0 && yy <= 7 && xx >= 0 && xx <= 7){
                            if(used[yy][xx] == used[y][x] - 1){
                                q.push({yy, xx});
                                qq.push({{xx, yy}, {x, y}});
                                if(yy == i && xx == j)po = 1;
                                break;
                            }
                        }

                    }
                    if(po)break;
                }
                while(!qq.empty()) {
                    res.push_back(qq.top());
                    qq.pop();
                }
                was[trgy][trgx]  = 0;
                was[i][j] = 1;
            }
            p++;
            dont[i][j] = true;
        }
    }
    cout <<(int)res.size() << endl;
    for(auto &i: res){
        cout << char(i.first.first+'a') << char(i.first.second + '1') << "-" <<char(i.second.first+'a') << char(i.second.second + '1') << endl;
    }
    return 0;
}