//#include <bits/stdc++.h>
#include <iostream>
#include <climits>
#include <set>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
const ll INF = LLONG_MAX;

ll mod(ull a, ull b){
    return (ll)(a % b);
}

void sol(){
    ll n, l, r, x, y, z;
    ll b1, b2;
    cin >> n >> l >> r >> x >> y >> z >> b1 >> b2;
    ll minP = INF, minO = 1;
    set<ll> ost;
    ll res = INF;
    for(int i = 0; i < n; ++i) {
        ll ac = ((ll)mod(b1, (ull)(r - l + 1))) + l;

        if(minO < 1 && ac > minO)
            res = min(res, ac * minO);
        if(minP < ac && ac >= 0)
            res = min(res, ac * minP);
        if(ac <= 0) {
            auto it = ost.lower_bound(ac);
            if(it != ost.begin() && *(--it) < ac) {
                res = min(res, *(--it) * ac);
            }
        }

        if(ac >= 0) {
            minP = min(minP, ac);
        }
        if(ac <= 0) {
            ost.insert(ac);
            minO = min(minO, ac);
        }

        b1 = (ll)mod(mod((ull)b1 * x, 1ULL << 32) + mod((ull)b2 * y, 1ULL << 32) + z, 1LL << 32);
        swap(b1, b2);
    }
    if(res == INF) {
        cout << "IMPOSSIBLE\n";
    } else {
        cout << res << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t;
    cin >> t;
    while(t--)
        sol();

}