#include <iostream>
#include <iomanip>
#include <vector>
#include <string>
#include <queue>
#include <set>
#include <map>
#include <algorithm>
#include <cmath>
#include <ctime>
#include <cstring>

using namespace std;

#define int long long 
#define sz(a) (int)(a.size())
#define pb emplace_back

void fast_io() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
}

const int MAXN = 1e5 + 228;
vector<int> graph[MAXN];

int ans[MAXN];

signed main() {
	fast_io();
	int n, m;
	cin >> n >> m;
	for (int i = 0; i < m; i++) {
		int v, u;
		cin >> v >> u;
		v--;
		u--;
		graph[v].pb(u);
		graph[u].pb(v);
	}
	bool fl = false;
	for (int i = 0; i < n; i++) {
		if (sz(graph[i]) < n - 1) {
			cout << "YES\n";
			graph[i].pb(i);
			sort(graph[i].begin(), graph[i].end());
			for (int j = 0; j < n; j++) {
				if (j >= sz(graph[i]) || graph[i][j] != j) {
					ans[i] = 1;
					ans[j] = 2;
					int k = 3;
					for (int l = 0; l < n; l++) {
						if (ans[l] == 0) {
							ans[l] = k++;
						}
					}
					break;
				}
			}
			for (int i = 0; i < n; i++) {
				cout << ans[i] << ' ';
			}
			cout << '\n';
			for (int i = 0; i < n; i++) {
				if (ans[i] == 2) {
					cout << "1 ";
				}
				else {
					cout << ans[i] << ' ';
				}
			}
			return 0;
		}
	}
	cout << "NO\n";
	return 0;
}