#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

#define all(x) (x).begin(), x.end()
#define sz(x) (int)(x).size()
#define add push_back

string parse(string s) {
    if (!sz(s)) {
        return s;
    }
    while (s.back() != '}') {
        s.pop_back();
    }
    s.pop_back();
    reverse(all(s));
    while (s.back() != '{') {
        s.pop_back();
    }
    s.pop_back();
    reverse(all(s));
    return s;
}

vector <string> txt, bibl;
map <string, vector <string> > mp;

bool check() {
    for (int i = 0; i < sz(txt); i++) {
        if (txt[i] != bibl[i]) {
            return 0;
        }
    }
    return 1;
}

void $main() {
    string s, ress;
    bool f = 0;
    while (cin >> s) {
        if (s == "\\begin{thebibliography}{99}") {
            f = 1;
            continue;
        }
        if (s == "\\end{thebibliography}") {
            break;
        }
        if (!f) {
            if (sz(s) && s[0] == '\\') {
                txt.add(parse(s));
            }
        } else {
            if (!sz(s)) {
                continue;
            }
            if (s[0] == '\\') {
                bibl.add(parse(s));
                ress = parse(s);
            } else {
                mp[ress].add(s);
            }
        }
    }
    if (check()) {
        cout << "Correct";
        return;
    }
    cout << "Incorrect" << endl;
    cout << "\\begin{thebibliography}{99}" << endl;
    for (int i = 0; i < sz(txt); i++) {
        cout << "\\bibitem{" << txt[i] << "}";
        if (sz(mp[txt[i]])) {
            cout << " ";
        }
        for (int j = 0; j < sz(mp[txt[i]]) - 1; j++) {\
            cout << mp[txt[i]][j] << " ";
        }
        if (sz(mp[txt[i]])) {
            cout << mp[txt[i]].back();
        }
        cout << endl;
    }
    cout << "\\end{thebibliography}";
}

int main() {
    ios::sync_with_stdio(0);
#ifdef fff
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    $main();
}
