#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <unordered_map>
using namespace std;
char starts(string& s, string what) {
	if (s.size() < what.size())
		return 0;
	for (int i = 0; i < what.size(); i++)
		if (s[i] != what[i])
			return 0;
	return 1;
}
string getname(string& s) {
	char opened = 0;
	string ans;
	for (int i = 0; i < s.size(); i++) {
		if (s[i] == '}')
			return ans;
		if (opened)
			ans += s[i];
		if (s[i] == '{')
			opened = 1;
	}
}
int main()
{
	unordered_map<string, int>order;
	vector<string>namelist;
	unordered_map<string, string>desc;
	int inord = 0, outord = 0;
	char cor = 1;
	char need = 1;
	string s;
	string spec(1, char(92));
	while (!cin.eof()) {
		if (need)
			cin >> s;
		else
			need = 1;
		if (starts(s, spec+"cite")) {
			string name = getname(s);
			namelist.push_back(name);
			order[name] = inord++;
		}
		if (starts(s, spec+"bibitem")) {
			string name = getname(s);
			if ((outord++) != order[name])
				cor = 0;
			cin >> s;
			while (!starts(s, spec)) {
				need = 0;
				desc[name] += s;
				desc[name] += " ";
				cin >> s;
			}
		}
	}
	if (cor)
		cout << "Correct";
	else {
		cout << "Incorrect" << endl;
		cout << spec << "begin{thebibliography}{99}" << endl;
		for (int i = 0; i < namelist.size(); i++)
			cout << spec << "bibitem{" << namelist[i] << "} " << desc[namelist[i]] << endl;
		cout << spec << "end{thebibliography}";
	}
}