#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <unordered_map>
using namespace std;
char starts(string s, string what) {
	if (int(s.size()) < int(what.size()))
		return 0;
	for (int i = 0; i < int(what.size()); i++)
		if (s[i] != what[i])
			return 0;
	return 1;
}
string getname(string s) {
	char opened = 0;
	string ans;
	for (int i = 0; i < int(s.size()); i++) {
		if (s[i] == '}')
			return ans;
		if (opened)
			ans += s[i];
		if (s[i] == '{')
			opened = 1;
	}
}
int ind = 0;
string global;
void nxtstr() {
	getline(cin, global);
	ind = 0;
	while (ind < global.size() && global[ind] == ' ')
		ind++;
}
char endstr() {
	return ind == int(global.size());
}
string getstr() {
	while (endstr())
		nxtstr();
	string ans;
	while (ind < global.size() && global[ind] == ' ')
		ind++;
	while (ind < global.size() && global[ind] != ' ') {
		ans += global[ind++];
	}
	while (ind < global.size() && global[ind] == ' ')
		ind++;
	return ans;
}

int main()
{
	unordered_map<string, int>order;
	vector<string>namelist;
	unordered_map<string, vector<string> >desc;
	int inord = 0, outord = 0;
	char cor = 1;
	char need = 1;
	string s;
	string spec(1, char(92));
	string speccite = spec + "cite";
	string specbib = spec + "bibitem";
	string endbib = spec + "end{thebibliography}";
	while (s != endbib) {
		if (need)
			s = getstr();
		else
			need = 1;
		if (starts(s, speccite)) {
			string name = getname(s);
			namelist.push_back(name);
			order[name] = inord;
			inord++;
		}
		if (starts(s, specbib)) {
			string name = getname(s);
			if (outord != order[name])
				cor = 0;
			outord++;
			need = 0;
			desc[name].resize(int(desc[name].size()) + 1);
			while (endstr()) {
				nxtstr();
				desc[name].resize(int(desc[name].size()) + 1);
			}
			s = getstr();
			for (;;) {
				if (starts(s, spec)) {
					desc[name].resize(int(desc[name].size()) - 1);
					break;
				}
				desc[name].back() += s;
				desc[name].back() += " ";
				if (endstr()) {
					desc[name].back().resize(int(desc[name].back().size()) - 1);
					desc[name].resize(int(desc[name].size()) + 1);
				}
				s = getstr();
			}
		}
	}
	if (cor)
		cout << "Correct";
	else {
		cout << "Incorrect" << endl;
		cout << spec << "begin{thebibliography}{99}" << endl;
		for (int i = 0; i < int(namelist.size()); i++) {
			cout << spec << "bibitem{" << namelist[i] << "} ";
			for (int j = 0; j < desc[namelist[i]].size(); j++)
				cout << desc[namelist[i]][j] << endl;
		}
		cout << spec << "end{thebibliography}";
	}
}