#include <iostream>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;

typedef long long ll;

const ll mod = 4294967296;

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    ll T;
    cin >> T;

    while (T--)
    {
        ll n, l, r, x, y, z, b1, b2;
        cin >> n >> l >> r >> x >> y >> z >> b1 >> b2;
        vector<ll> b(n + 1, 0);
        b[1] = b1;
        b[2] = b2;
        for (int i = 3; i <= n; i++)
        {
            b[i] += b[i - 2] * x;
            b[i] %= mod;
            b[i] += b[i - 1] * y;
            b[i] %= mod;
            b[i] += z;
            b[i] %= mod;
        }
        vector<ll> A(n + 1, 0);
        set<pair<ll, ll> > S;
        for (int i = 1; i <= n; i++)
        {
            A[i] = (b[i] % (r - l + 1)) + l;
            S.insert({A[i], i});
        }

        ll ans = -123123123123;
        for (int i = 2; i <= n; i++)
        {
            if (A[i - 1] < A[i])
            {
                ans = A[i - 1] * A[i];
                break;
            }
        }
        if(ans == -123123123123)
        {
            cout << "IMPOSSIBLE\n";
            continue;
        }

        for (int i = 1; i <= n; i++)
        {
            if (A.size() == 1)
                continue;
            ll x = A[i];
            S.erase({x, i});
            if (x >= 0)
            {
                auto yk = S.lower_bound({x + 1, -1e10});
                if (yk == S.end())
                    continue;
                pair<ll, ll> to = *yk;
                ans = min(ans, x * to.first);
            }
            else
            {
                auto yk = S.end();
                yk--;
                pair<ll, ll> to = *yk;
                ans = min(ans, x * to.first);
            }
        }
        cout << ans << "\n";
    }

}
