#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

ll solve(int n, vector<ll> &v) {
    if (n < 2) {
        return 8e18;
    }
    if (*max_element(v.begin(), v.end()) < 0) {
        reverse(v.begin(), v.end());
        for (ll &i : v) {
            i *= -1;
        }
    }
    ll mn = v[0];
    ll ans = 8e18;
    for (int i = 1; i < n; ++i) {
        if (mn < v[i]) {
            ans = min(ans, mn * v[i]);
        }
        mn = min(mn, v[i]);
    }
    return ans;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    ll t;
    cin >> t;

    for (int t1 = 0; t1 < t; t1++)
    {
        ll n, l, r, x, y, z, b1, b2;
        cin >> n >> l >> r >> x >> y >> z >> b1 >> b2;

        vector<ll> b(n);
        b[0] = b1;
        b[1] = b2;
        for (int j = 2; j < n; j++)
            b[j] = (b[j - 2] * x + b[j - 1] * y + z) % (1ll << 32ll);

        vector<ll> v(n);
        for (int j = 0; j < n; j++)
            v[j] = (b[j] % (r - l + 1ll)) + l;


        vector<ll> vneg;
        for (ll i : v) {
            if (i <= 0) {
                vneg.push_back(i);
            }
        }
        ll ans = min(solve(n, v), solve(vneg.size(), vneg));
        long long inf = 8e18;
        if (ans < inf) {
            if (ans == 0) {
                cout << 0 << endl;
            }
            else {
                cout << ans << endl;
            }
        }
        else {
            cout << "IMPOSSIBLE" << endl;
        }
    }
    
    

    return 0;
}