#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
ld inf = 8e18;

ld solve(int n, vector<ld> &v) {
    if (n < 2) {
        return inf;
    }
    if (*max_element(v.begin(), v.end()) < 0) {
        reverse(v.begin(), v.end());
        for (ld &i : v) {
            i *= -1;
        }
    }
    ld mn = v[0];
    ld ans = inf;
    for (int i = 1; i < n; ++i) {
        if (mn < v[i]) {
            ans = min(ans, mn * v[i]);
        }
        mn = min(mn, v[i]);
    }
    return ans;
}

mt19937 gen(time(NULL));

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    ll t;
    cin >> t;

    for (int t1 = 0; t1 < t; t1++)
    {
        ll n, l, r, x, y, z, b1, b2;
        ll mod = 1ll << 32ll;
        cin >> n >> l >> r >> x >> y >> z >> b1 >> b2;

        vector<ll> b(n);
        b[0] = b1;
        b[1] = b2;
        for (int j = 2; j < n; j++)
            b[j] = ((b[j - 2] * x) % mod + (b[j - 1] * y) % mod + z) % mod;

        vector<ll> v1(n);
        for (int j = 0; j < n; j++)
            v1[j] = (b[j] % (r - l + 1ll)) + l;
        vector<ld> v(n);
        for (int i = 0; i < n; i++) v[i] = v1[i];
//        n = rand() % 100;
//        vector<ll> v(n);
//        for (int i = 0; i < n; i++){
//            v[i] = abs((ll)gen()) % ((ll)2e9);
//            v[i] -= 2e9;
//        }
//        ld ans1 = inf;
//        for (int i = 0; i < n; i++){
//            for (int j = i + 1; j < n; j++){
//                ld x1, y1;
//                x1 = v[i];
//                y1 = v[j];
//                if (v[i] < v[j]){
//                    ans1 = min(ans1, x1 * y1);
//                }
//            }
//        }
        vector<ld> vneg;
        for (ld i : v) {
            if (i <= 0) {
                vneg.push_back(i);
            }
        }
        ld ans = min(solve(n, v), solve(vneg.size(), vneg));
        if (ans < inf) {
            if (ans == 0) {
                cout << 0 << endl;
            }
            else {
                cout << ans << endl;
            }
        }
        else {
            cout << "IMPOSSIBLE" << endl;
        }
    }
    
    

    return 0;
}