#include <bits/stdc++.h>

using namespace std;

#ifdef DEBUG
    ifstream fin("input.txt");
    ofstream fout("output.txt");
    #define cin fin
    #define cout fout
#endif //DEBUG

void dfs (vector<vector<int>> &g, vector<int> &used, int v, int col) {
    used[v] = col;
    for (int to : g[v]) {
        if (!used[to]) {
            dfs(g, used, to, col);
        }
    }
}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    long long n, m; cin >> n >> m;
    if (m == (n * (n - 1)) / 2) {
        cout << "NO";
        return 0;
    }
    vector<pair<int, int>> vec(m);
    int u = 1, v = 2;
    for (int i = 0; i < m; i++) {
        cin >> vec[i].first >> vec[i].second;
        if (vec[i].first > vec[i].second) {
            int tmp = vec[i].first;
            vec[i].first = vec[i].second;
            vec[i].second = tmp;
        }
    }
    sort(vec.begin(), vec.end());
    for (int i = 0; i < m; i++) {
        if (u != vec[i].first || v != vec[i].second) {
//                cout << vec[i].first << ' ' <<vec[i].second << ' ' << u << ' ' << v << endl;
            break;
        }
        if (v != n) {
            v++;
        }
        else {
            u++;
            v = u + 1;
        }
        while (u == v) {
            if (v != n) {
                v++;
            }
            else {
                u++;
                v = 1;
            }
        }
    }
//    cout << u << ' ' << v << endl;
    cout << "YES\n";
    int cnt = 1;
    u--;
    v--;
    for (int j = 0; j < n; j++) {
        if (j != u && j != v) {
            cout << cnt << ' ';
            cnt++;
        }
        else {
            if (j == u) {
                cout << n - 1 << ' ';
            }
            else {
                cout << n << ' ';
            }
        }
    }
    cout << '\n';
    cnt = 1;
    for (int j = 0; j < n; j++) {
        if (j != u && j != v) {
            cout << cnt << ' ';
            cnt++;
        }
        else {
            cout << n << ' ';
        }
    }
    return 0;
}
