#include <iostream>
#include <vector>
#include <algorithm>

#define mp make_pair
#define fi(n) for (long long i = (long long)0; i < n; i++)
#define pb push_back
//#define int long long
#define endl '\n'

#pragma warning (disable : 4996)

using namespace std;

const long long MOD = ((long long)1 << 32);
const long long INF = (long long)4e18 + 50;

signed main() {
#ifdef LOCALFILE
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	int t;
	cin >> t;
	for(int tt = 0; tt < t; ++tt){
		int n;
		long long l, r, x, y, z;
		cin >> n >> l >> r >> x >> y >> z;
		vector<long long> b(n);
		cin >> b[0] >> b[1];
		for (int i = 2; i < n; ++i) {
			b[i] = (((b[i - 2] * x) % MOD + (b[i - 1] * y) % MOD) % MOD + z) % MOD;
		}
		vector<long long> a(n);
		fi(n) {
			a[i] = (b[i] % (r - l + 1)) + l;
		}

		/*int n;
		cin >> n;
		vector<int> a(n);
		fi(n) cin >> a[i];*/

		long long  ans = INF;
		vector<pair<long long, long long>> c(n);
		fi(n)
			c[i] = mp(a[i], -i);
		sort(c.begin(), c.end());
		fi(n)
			c[i].second = -c[i].second;
		vector<long long> minn(n), maxx(n);
		minn[0] = INF;
		maxx[c[0].second] = -INF;
		vector<long long> st = { c[0].second };
		for (int i = 1; i < n; ++i) {
			minn[i] = min(minn[i - 1], a[i - 1]);
			while ((int)st.size() > 0 && st.back() >= c[i].second) {
				st.pop_back();
			}
			if (st.size()) {
				maxx[c[i].second] = a[st.back()];
			}
			else {
				maxx[c[i].second] = -INF;
			}
			st.push_back(c[i].second);
		}
		fi(n) {
			if (a[i] >= (long long)0 && minn[i] < a[i] && minn[i] != INF) {
				ans = min(ans, a[i] * minn[i]);
			}
			if (a[i] <= (long long)0 && maxx[i] != -INF && maxx[i] != a[i]) {
				ans = min(ans, a[i] * maxx[i]);
			}
		}
		if (ans == INF)
			cout << "IMPOSSIBLE\n";
		else
			cout << ans << endl;
	}

	return 0;
}