#include <bits/stdc++.h>

using namespace std;

#define int long long
#define double long double

const int MAXN = 1e5 + 10;

string slc(string s, int l, int r) {
    string ans;
    if (l > s.size() - 1) {
        return "abracdarbra228";
    }
    for (int i = l; i <= min(r, (int) s.size() - 1); i++) {
        ans += s[i];
    }
    return ans;
}

bool eq(const vector<string> &a, const vector<string> &b) {
    if (a.size() != b.size()) {
        return false;
    }
    for (int i = 0; i < min(a.size(), b.size()); i++) {
        if (a[i] != b[i]) {
            return false;
        }
    }
    return true;
}


int32_t main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    cin.tie(0);
    cout.tie(0);
    cin.sync_with_stdio(0);

    vector<string> lol;
    vector<string> was;
    map<string, vector<string> > mem;
    vector<string> inp;

    string bufbeg, bufend;
    string tmp;
    while (cin >> tmp) {
        inp.push_back(tmp);
    }
    for (int i = 0; i < inp.size(); i++) {
        if (inp[i][0] == '\\') {
            string tmp = slc(inp[i], 1, 4);
            if (tmp == "cite") {
                string now;
                int l = 6;
                if (l >= inp[i].size()) {
                    return 0;
                }
                while (inp[i][l] != '}') {
                    if (l >= inp[i].size()) {
                        return 0;
                    }
                    now += inp[i][l];
                    l++;
                }
                lol.push_back(now);
                continue;
            }
            tmp = slc(inp[i], 1, 5);
            if (tmp == "begin") {
                bufbeg = inp[i];
                continue;
            }
            tmp = slc(inp[i], 1, 3);
            if (tmp == "end") {
                bufend = inp[i];
                continue;
            }
            tmp = slc(inp[i], 1, 7);
            if (tmp == "bibitem") {
                int l = 9;
                string name;
                if (l >= inp[i].size()) {
                    return 0;
                }
                while (inp[i][l] != '}') {
                    if (l >= inp[i].size()) {
                        return 0;
                    }
                    name += inp[i][l];
                    l++;
                }
                i++;
                vector<string> all;
                while (inp[i][0] != '\\') {
                    if (i >= inp.size()) {
                        return 0;
                    }
                    all.push_back(inp[i]);
                    i++;
                }
                i--;
                mem[name] = all;
                was.push_back(name);
                continue;
            }
        }
    }
    if (eq(was, lol)) {
        cout << "Correct\n";
        return 0;
    }
    cout << "Incorrect" << endl;
    cout << bufbeg << endl;
    for (int i = 0; i < lol.size(); i++) {
        cout << "\\bibitem{" << lol[i] << "} ";
        for (int j = 0; j < (int)mem[lol[i]].size() - 1; j++) {
            cout << mem[lol[i]][j] << " ";
        }
        if (mem[lol[i]].size() > 0)
            cout << mem[lol[i]].back() << endl;
        else
            cout << endl;
        //cout << endl;
    }
    cout << bufend;
    return 0;
}