import java.io.*;
import java.math.BigInteger;
import java.util.Locale;
import java.util.StringTokenizer;

public class G {
    String fileName = "kek";
    int turn = 1, cr = 0;
    Char[] f;
    int[] t;

    class Char{
        int i;
        BigInteger a,h;
        boolean dead = false;

        public Char(int i, BigInteger a, BigInteger h){
            this.a = new BigInteger(String.valueOf(a));
            this.h = new BigInteger(String.valueOf(h));
            this.i = i;
        }

        public Char(int i){
            this.a = BigInteger.ONE;
            this.h = BigInteger.ONE;
            this.i = i;
            turn++;
        }

        public boolean check(){
            if(!dead) dead = h.compareTo(BigInteger.ZERO) <= 0;
            return dead;
        }

        public void fight(int j){
            if(check() || f[j].check()){turn++; return;}
            h = h.subtract(f[j].a);
            f[j].h = f[j].h.subtract(a);
            if(check()) t[i] = turn;
            if(f[j].check()) t[j] = turn;
            turn++;
        }

        public void x2hp(){
            if(check()) {turn++; return;}
            h = h.shiftLeft(1);
            turn++;
        }

        public void x2a(){
            if(check()) {turn++; return;}
            a = a.shiftLeft(1);
            turn++;
        }

        public void copy(){
            f[cr] = new Char(cr,a,h);
            if(check()) t[cr] = turn;
            cr++;
            turn++;
        }
    }

    public void solve() throws IOException {
        int n =nextInt(), a = 0;
        f = new Char[n];
        t = new int[n];
        for(int i = 0;i<n;i++){
            t[i] = -1;
        }
        for(int i = 0;i<n;i++){
            a = nextInt();
            switch (a){
                case 1 : {f[cr] = new Char(cr++); break;}
                case 2 : {f[nextInt()-1].x2a();break;}
                case 3 : {f[nextInt()-1].x2hp();break;}
                case 4 : {f[nextInt()-1].copy();break;}
                case 5 : {f[nextInt()-1].fight(nextInt()-1);break;}
            }
        }

        out.println(cr);
      for(int i = 0;i<cr;i++){
          out.print(t[i]+" ");
      }
    }

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(new BufferedOutputStream(System.out));

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new G().run();
    }

}
