#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define f first
#define s second
#define mp(a, b) make_pair(a, b)
#define size(x) (ll)x.size()

void fast_io() {
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // LOCAL

    ios::sync_with_stdio(false);
}

int main()
{
    fast_io();

    string s;
    vector<string> text;
    vector<string> order;
    map<string, string> lib;
    bool on_text = 1;
    while (getline(cin, s)) {
        if (s == "\\begin{thebibliography}{99}") {
            on_text = 0;
            continue;
        }
        if (s == "\\end{thebibliography}") {
            break;
        }
        if (on_text) {
            text.push_back(s);
        } else {
            int pos = size(s);
            for (int i = 0; i < size(s); i++) {
                if (s[i] == '}') {
                    pos = i + 1;
                    break;
                }
            }
            string a, b;
            a = s.substr(0, pos);

            if (pos != size(s))
                b = s.substr(pos, size(s) - pos);
            else
                b = "";

            string aa = "";
            bool found = 0;
            for (auto c: a) {
                if (c == '}') found = 0;
                if (found) aa += c;
                if (c == '{') found = 1;
            }
//            cout << aa << "\n" << b << "\n";
            order.push_back(aa);
            lib[aa] = b;
        }
    }

    vector<string> new_order;
    for (int i = 0; i < size(text); i++) {
        for (int j = 0; j < size(text[i]); j++) {
            if (text[i][j] == '\\') {
                string now = "";
                while (j <= size(text[i]) && text[i][j] != '}') {
                    now += text[i][j];
                    j++;
                }
                string aa = "";
                bool found = 0;
                for (auto c: now) {
                    if (c == '}') found = 0;
                    if (found) aa += c;
                    if (c == '{') found = 1;
                }
                new_order.push_back(aa);
            }
        }
    }

    bool ok = 1;
    for (int i = 0; i < size(order); i++) {
        if (order[i] != new_order[i]) {
            ok = 0;
        }
    }

    if (ok) {
        cout << "Correct";
    } else {
        cout << "Incorrect\n";
        cout << "\\begin{thebibliography}{99}\n";
        for (int i = 0; i < size(order); i++) {
            cout << "\\bibitem{" << new_order[i] << "}" << lib[new_order[i]] << "\n";
        }
        cout << "\\end{thebibliography}";
    }
}
