#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cmath>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int,int> pi;
typedef vector<int> vi;
#define fs first
#define sc second
const int inf = 2e9;
const ll linf = 1e18;
const int maxn = 100100;


//#define LOCAL

#ifndef LOCAL
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("fast-math")
#pragma GCC target("sse,sse2,sse3,ssse3,popcnt,abm,mmx,tune=native")
#endif

int main() {
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	int n;
	cin >> n;
	vector<int> v(n);
	vector<int> ms(n);
	for (int i = 0; i < n; ++i) {
		cin >> ms[i];
		int t, mx = 0;
		for (int j = 0; j < ms[i]; ++j) {
			cin >> t;
			mx = max(mx, t);
		}
		v[i] = mx;
	}
	int mx = 0;
	for (int i = 0; i < n; ++i) {
		mx = max(mx, v[i]);
	}
	ll ans = 0;
	for (int i = 0; i < n; ++i) {
		ans += 1ll * ms[i] * (mx - v[i]);
	}
	cout << ans;

	return 0;
}