#include <iostream>
#include <vector>
#include <deque>
#include <queue>
#include <stack>
#include <set>
#include <map>
#include <iomanip>
#include <string>
#include <algorithm>
#include <cmath>
#include <bitset>


using namespace std;

/*#pragma optimize("no-stack-protector")
#pragma optimize("Ofast")
#pragma optimize("unroll-loops")
#pragma optimize("fast-math")
#pragma target("sse,sse2,sse3,ssse3,popcnt,abm,mmx,tune=native")*/

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

const ll INF = 1e18 + 7;
const int inf = 1e9 + 7;
const ld eps = 1e-9;

int main() {
#ifdef LOCAL
	freopen("input.txt", "rt", stdin);
	freopen("output.txt", "wt", stdout);
#endif
	ios_base::sync_with_stdio(false);

	int n, k;
	cin >> n >> k;

	vector<int> arr(n);
	for (int i = 0; i < n; i++)
	{
		cin >> arr[i];
	}

	int cnt = 1;
	int maxcnt = -inf;
	for (int i = 1; i < n; i++)
	{
		if (arr[i] != arr[i - 1])
			cnt++;
		else
		{
			maxcnt = max(cnt, maxcnt);
			cnt = 1;
		}
	}
	maxcnt = max(cnt, maxcnt);

	cout << maxcnt << endl;

}