#include <iostream>
#include <algorithm>
#include <cassert>

using namespace std;

long long arr[10000001];

const long long INF = 4e18+1;

int sgn(long long a) {
    if (a > 0) return 1;
    if (a < 0) return -1;
    return 0;
}

int main(){
   // cout << (1 << 32) << endl;
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int t;
    cin >> t;
    long long n, l, r, x, y, z, b1, b2, ans;
    int i, j;
    while(t--){
        cin >> n >> l >> r >> x >> y >> z >> b1 >> b2;
        arr[0] = b1;
        arr[1] = b2;
        for (int i = 2; i < n; ++i){
            arr[i] = ((arr[i - 2] * x) % ((long long)1 << 32) + (arr[i - 1] * y) % ((long long)1 << 32) + z + ((long long)1 << 32)) % ((long long)1 << 32);
        }
        for (int i = 0; i < n; ++i){
            arr[i] = (arr[i] % (r - l + 1)) + l;
        }
       // cin >> n;
        int ind = -1;
        bool ch1 = false, ch2 = false;
        int zero_ind = -1;
        bool zero_ans = false;
       /* for (int i = 0; i < n; ++i)
            cin >> arr[i];*/
        for (int i = 0; i < n; i++){
            if (abs(arr[i]) > 2e9) assert(false);
            if (arr[i] < 0 && !ch1) {
                    ind = i;
                    ch1 = true;
            }
            if (arr[i] == 0) zero_ind = i;
            if (arr[i] > 0 && zero_ind != -1) zero_ans = true;
            if (arr[i] > 0 && ch1){
               ch2 = true;
               break;
            }
        }
        if (ch2){
            i = 0;
            j = 0;
            ans = INF;
            while (j < n){
                while (arr[i] > 0) i++;
                if (i == n - 1) break;
                j = max(j, i + 1);
                if (arr[i] < arr[j]) ans = min(ans, arr[i] * arr[j]);
                if (arr[j] < arr[i]) i = j;
                else j++;
            }
            if (ans == INF) cout << "IMPOSSIBLE" << endl;
            else cout << ans << endl;
        } else {
            if(zero_ans){
                ans = 0;
            }
            else{
            i = 0;
            j = 0;
            ans = INF;
            while (j < n){
                if (i == n - 1) break;
                j = max(j, i + 1);
                if (arr[i] < arr[j]) ans = min(ans, arr[i] * arr[j]);
                if (sgn(arr[i]) == sgn(arr[j])){
                    if (sgn(arr[i]) == 1 && arr[i] > arr[j]) i = j;
                    else if (sgn(arr[i]) == -1 && arr[i] < arr[j]) i = j;
                    else j++;
                }
                else i = j;
            }
            }
            if (ans == INF) cout << "IMPOSSIBLE" << endl;
            else cout << ans << endl;
        }
    }
    return 0;
}
/*
100
10 4294967295 4294967297 4294967295 4294967295 4294967295 4294967295 4294967295
*/
