import java.io.*;
import java.util.ArrayList;
import java.util.Locale;
import java.util.StringTokenizer;

public class Main {

    public void solve() throws IOException {
        int q = 0;
        ArrayList<String> o = new ArrayList<>();
        int ind = 0;
        while (true) {
            String s = br.readLine();
            if (s.equals("\\end{thebibliography}")) {
                break;
            } else if (s.equals("\\begin{thebibliography}{99}")) {
                q = 1;
            } else {
                if (q == 0) {
                    int q2 = 0;
                    int pos = 0;
                    for (int i = 0; i < s.length(); i++) {
                        if (q2 == 0) {
                            if (s.charAt(i) == '{') {
                                q2 = 1;
                                pos = i;
                            }
                        }
                        if (q2 == 1) {
                            if (s.charAt(i) == '}') {
                                q2 = 0;
                                o.add(s.substring(pos + 1, i));
                            }
                        }
                    }
                } else {
                    if (ind >= o.size() || !s.substring(s.indexOf('{') + 1, s.indexOf('}')).equals(o.get(ind))) {
                        System.out.println("Incorrect");
                        return;
                    }
                    ind++;
                }
            }
        }
        System.out.println("Correct");
    }

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new Main().run();
    }

}
