import java.io.*;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.Locale;
import java.util.Map;
import java.util.*;

public class Main {
    public class Creature {
        int die = -1;
        BigInteger a = new BigInteger("1"), b = new BigInteger("1");
    }

    public void solve() throws IOException {
        int n = nextInt();

        Creature[] d = new Creature[n];
        int ind = 0;
        for (int i = 0; i < n; i++) {
            int q = nextInt();
            if (q == 1) {
                d[ind++] = (new Creature());
            } else if (q == 2) {
                int x = nextInt() - 1;
                if (d[x].die != -1) {
                    continue;
                }
                d[x].a = d[x].a.multiply(new BigInteger("2"));
            } else if (q == 3) {
                int x = nextInt() - 1;
                if (d[x].die != -1) {
                    continue;
                }
                d[x].b = d[x].b.multiply(new BigInteger("2"));
            } else if (q == 4) {
                int x = nextInt() - 1;
                if (d[x].die != -1) {
                    d[ind++] = new Creature();
                    d[ind - 1].die = i+1;
                } else {
                    d[ind++] = new Creature();
                    d[ind - 1].a = d[x].a.abs();
                    d[ind - 1].b = d[x].b.abs();
                }
            } else {
                int x = nextInt() - 1;
                int y = nextInt() - 1;
                if (d[x].die != -1 || d[y].die != -1) {
                    continue;
                } else {
                    d[x].b = d[x].b.subtract(d[y].a);
                    d[y].b = d[y].b.subtract(d[x].a);
                    if (d[x].b.compareTo(new BigInteger("0")) <= 0) {
                        d[x].die = i + 1;
                    }
                    if (d[y].b.compareTo(new BigInteger("0")) <= 0) {
                        d[y].die = i + 1;
                    }
                }
            }
        }
        System.out.println(ind);
        for (int i = 0; i < ind; i++) {
            System.out.print(d[i].die + " ");
        }
    }

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new Main().run();
    }

}
