import java.io.*;
import java.math.BigInteger;
import java.util.Locale;
import java.util.StringTokenizer;

public class gg {

    public void solve() throws IOException {
        BigInteger[] a = new BigInteger[251001];
        for (int i = 0; i < a.length; i++) {
            a[i] = new BigInteger(String.valueOf(i));
        }
        BigInteger[] h = new BigInteger[251001];
        for (int i = 0; i < a.length; i++) {
            h[i] = new BigInteger(String.valueOf(i));
        }
        int[] d = new int[251001];
        for (int i = 0; i < d.length; i++) {
            d[i] = -1;
        }
        int cnt = 0;
        int n = nextInt();
        for (int q = 0; q < n; q++) {
            int t = nextInt();
            if (t == 1) {
                cnt++;
                h[cnt] = new BigInteger(String.valueOf(1));
                a[cnt] = new BigInteger(String.valueOf(1));
            } else if (t == 2) {
                int i = nextInt();
                a[i] = a[i].add(a[i]);
            } else if (t == 3) {
                int i = nextInt();
                h[i] = h[i].add(h[i]);
            } else if (t == 4) {
                int i = nextInt();
                cnt++;
                h[cnt] = new BigInteger(h[i].toString());
                a[cnt] = new BigInteger(a[i].toString());
                if (d[i] != -1) {
                    d[cnt] = q + 1;
                }
            } else {
                int i = nextInt();
                int j = nextInt();
                if (d[i] == -1 && d[j] == -1) {
                    h[i] = h[i].subtract(a[j]);
                    h[j] = h[j].subtract(a[i]);
                }
                if (d[i] == -1 && h[i].signum() <= 0) {
                    d[i] = q + 1;
                }
                if (d[j] == -1 && h[j].signum() <= 0) {
                    d[j] = q + 1;
                }
            }
        }
        System.out.println(cnt);
        for (int i = 1; i < cnt + 1; i++) {
            System.out.print(d[i] + " ");
        }
    }

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            solve();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new gg().run();
    }

}