import java.io.*;
import java.util.ArrayList;
import java.util.Locale;
import java.util.StringTokenizer;

public class Template {

    public void solve() throws IOException {
        String s = nextToken();
        String t = nextToken();
        long res = 1;
        long leng = 0;
        for (int i = 1; i < t.length(); i++) {
            if (t.charAt(i) == t.charAt(i - 1)) {
                leng++;
            }
        }
        ArrayList<Long> in = new ArrayList<>();
        for (int i = 1; i < s.length(); i++) {
            if (s.charAt(i) == t.charAt(0)) {
                long start = i;
                while (i < s.length() && s.charAt(i) == t.charAt(0)) {
                    i++;
                }
                in.add(i - start);
            }
        }
        long fall = 0;
        for (int i = 0; i < in.size(); i++) {
            fall += (leng) * in.get(i);
        }
        res *= s.length();
        res *= t.length();
        System.out.println(res - fall);
    }
/*
    private int fun(Integer j, int i) {
        int a = Math.min(i, j);
        if (2 * a < i + j) {
            return (a + 1) * (a - 1) + (i + j + 1 - 2 * a) * a - (i + j);
        } else {
            a = (i + j) / 2;
            return a * (a + 2) + a * ((i + j) % 2) - (i + j);
        }
    }*/

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            solve();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new Template().run();
    }

}
