#include<iostream>
#include<vector>
#include<algorithm>
#include<cmath>
#include<map>

using namespace std;

typedef long long ll;

signed main() {
	cin.tie(0);
	ios_base::sync_with_stdio(0);

	ll n, m;
	cin >> n >> m;
	map<pair<int, int>, int> mp;
	for (int i = 0; i < m; i++) {
		int a, b;
		cin >> a >> b;
		if (a > b) {
			swap(a, b);
		}
		mp[{a, b}] = 1;
	}

	int k = -1, t = -1;
	for (int i = 1; i <= n; i++) {
		for (int j = i + 1; j <= n; j++) {
			if (mp.find({ i,j }) == mp.end()) {
				k = i;
				t = j;
				break;
			}
		}
		if (k != -1) {
			break;
		}
	}

	if (k == -1) {
		cout << "NO";
		return 0;
	}

	vector<int>ans(n + 1);
	for (int i = 1, val = t-k; i <= k; i++, val++) {
		ans[i] = val;
	}
	for (int i = k + 1, val = 1; i < t; i++,val++) {
		ans[i] = val;
	}
	for (int i = t; i <= n; i++) {
		ans[i] = i;
	}

	vector<int>ans2 = ans;
	ans2[t] = ans2[k];

	cout << "YES" << '\n';
	for (int i = 1; i <= n; i++) {
		cout << ans[i] << ' ';
	}
	cout << '\n';
	for (int i = 1; i <= n; i++) {
		cout << ans2[i] << ' ';
	}




	return 0;
}