import java.io.*;
import java.util.*;

public class Main {
	static PrintWriter out;
	static boolean[][] place = new boolean[8][8]; 
	static boolean[][] used;
	static boolean[][] usedx;
	static int anss = 0;
	static void check(int i, int j, Pair old, ArrayList<Pair> q) {
		if(i<0||i>7||j<0||j>7) return;
		if(used[i][j] || usedx[i][j]) return;
		used[i][j] = true;
		ArrayList<String> ans2 = new ArrayList<String>(old.ans);
		ans2.add((char)(i + 'a') + "" + (char)(j + '1'));
		q.add(new Pair(i, j, ans2));
	}
	static void dfs(int i, int j) {
		ArrayList<Pair> q = new ArrayList<Pair>();
		q.add(new Pair(i, j));
		q.get(0).ans.add((char)(i + 'a') + "" + (char)(j + '1'));
		while (!q.isEmpty()) {
			Pair t = q.remove(0);
			
			if(place[t.a][t.b]) {
				out.print((char)(t.a + 'a') + "" + (char)(t.b + '1'));
				for(int g =t.ans.size()-2;g>=0;g--) {
					out.println("-"+t.ans.get(g));
					out.print(t.ans.get(g));
					anss++;
				}
				out.println("-"+((char)(i + 'a') + "" + (char)(j + '1')));
				place[t.a][t.b] = false;
				return;
			}else {
				check(i+1, j+2, t, q);
				check(i+1, j-2, t, q);
				check(i-1, j+2, t, q);
				
				check(i-1, j-2, t, q);
				check(i+2, j+1, t, q);
				
				check(i+2, j-1, t, q);
				check(i-2, j+1, t, q);
				check(i-2, j-1, t, q);
			}
		}
	}
	public static void main(String[] args) {
		Scanner in = new Scanner(System.in);		
		out = new PrintWriter(System.out);
		long t = in.nextLong();
		long n = in.nextLong();
		long a = in.nextLong();
		long b = in.nextLong();
		long k = in.nextLong();
		long ans = Math.min(t, ((n+1)/2*a+n/2*b)/k);
		System.out.print(ans);
		out.close();
	}
}
class Pair{
	int a;
	int b;
	List<String> ans;
	public Pair(int a, int b) {
		ans =new ArrayList<String>();
		this.a = a;
		this.b = b;
	}
	public Pair(int a, int b, ArrayList<String> ans) {
		this.ans = ans;
		this.a = a;
		this.b = b;
	}
}