#include <iostream>
#include <vector>

#define ll long long
#define ep emplace_back
using namespace std;

const int Size = 2e7;
ll b[Size], a[Size], mod = 1;

void solve(){
    int n, i;
    ll l, r, x, y, z, b1, b2;
    cin >> n >> l >> r >> x >> y >> z >> b1 >> b2;
    b[0] = b1, b[1] = b2;
    //cout << ">>>" << mod << endl;
    for (i = 2; i < n; i++)
        b[i] = (b[i - 2] * x + b[i - 1] * y + z) % mod;
    //exit(0);
    for (i = 0; i < n; i++)
        a[i] = b[i] % (r - l + 1) + l;
    ll sn, sp;
    bool bsn, bsp;
    bsn = bsp = false;
    ll ans = 4e18 + 10;
    for (i = 0; i < n; i++){
        if (a[i] > 0){
            if (bsn)
                ans = min(sn * a[i], ans);
            if (bsp && sp < a[i])
                ans = min(sp * a[i], ans);
            if (!bsp || sp > a[i])
                sp = a[i], bsp = true;
        }
        else if (a[i] == 0){
            if (bsn)
                ans = min(ans, (ll)0);
            bsp = true, sp = 0;
        }
        else if (!bsn || sn > a[i])
            sn = a[i], bsn = true;
    }

    bool vis = false;
    for (i = n - 1; i >= 0; i--){
        if (a[i] < 0 && vis && x > a[i])
            ans = min(ans, x * a[i]);
        if (a[i] < 0 && (!vis || a[i] > x))
            x = a[i], vis = true;
    }

    if (ans == 4e18 + 10)
        cout << "IMPOSSIBLE\n";
    else
        cout << ans << '\n';
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int t, i;
    for (i = 1; i <= 32; i++)
        mod *= (ll)2;
    cin >> t;
    while (t--)
        solve();
}
