
#include<iostream>
#include "string"
#include "set"
#include "map"
#include "stack"
#include "cstdio"
#include "algorithm"
#include "math.h"
#include "vector"
#include "queue"
using namespace std;
#define ll long long
#define elif else if
#define IMP 1e18 + 7
#define mp make_pair
int field[8][8];
pair<int, int> his[8][8];
bool used[8][8];
vector<string> a;
void clearUsed()
{
	for (int i = 0; i < 8; i++)
		for (int j = 0; j < 8; j++)
			used[i][j] = false;
}
string getStr(pair<int, int> p)
{
	string s;
	char ch = ('a' + p.first);
	s += ch;
	ch = ('1' + p.second);
	s += ch;
	return s;
}
pair<int, int> bfs(int x, int y)
{
	clearUsed();
	queue<pair<int, int>> q;
	used[x][y] = true;
	q.push({ x, y });
	while (!q.empty())
	{
		auto p = q.front();
		if (field[p.first][p.second] == 1)
			return p;
		for (int i = -2; i < 3; i++)
			for (int j = -2; j < 3; j++)
				if (j != 0 && i != 0 && abs(i) != abs(j))
					if (p.first + i > -1 && p.first + i < 8 && p.second + j > -1 && p.second + j < 8)
						if (!used[p.first + i][p.second + j])
						{
							used[p.first + i][p.second + j] = true;
							q.push({ p.first + i, p.second + j });
							his[p.first + i][p.second + j] = p;
						}
		q.pop();
	}
}
int main() {
	int k;
	string s;
	cin >> k;
	for (int i = 0; i < k; i++)
	{
		cin >> s;
		field[s[0] - 'a'][s[1] - '1'] = 1;
	}
	int x, y;
	for (int i = 0; i < k; i++)
	{
		x = i % 8;
		y = i / 8;
		auto ans = bfs(x, y);
		auto perm = ans;
		vector<pair<int, int>> v;
		while (ans != mp(x, y))
		{
			v.push_back(ans);
			ans = his[ans.first][ans.second];
		}
		v.push_back(ans);
		reverse(v.begin(), v.end());
		stack<pair<int, int>> s;
		pair<int, int> tmp;
		for (int i = 0; i < v.size(); i++)
		{
			tmp = v[i];
			if (field[v[i].first][v[i].second] > 0)
			{
				while (!s.empty())
				{
					a.push_back(getStr(tmp) + "-" + getStr(s.top()));
					tmp = s.top();
					s.pop();
				}
			}
			s.push(tmp);
		}
		field[perm.first][perm.second] = 0;
		field[x][y] = 2;
	}
	cout << a.size() << endl;
	for (auto s : a)
		cout << s << endl;
	system("pause");
}