import sys
# sys.stdin = open("in")

import re


r = re.compile(r"\\cite\{[a-z]*\}")
text = sys.stdin.read()
names = [i.split('{')[1][:-1] for i in r.findall(text)]
lib = text.split('\\begin{thebibliography}{99}')[1] 
d = {}
# print(lib)
# print(lib.split('\n'))
for line in lib.split('\n'):
	if not line: 
		continue
	m = re.match(r"\\bibitem\{(?P<name>[a-z]+)\}", line)
	if m:
		# print(m.groupdict()['name'])
		d[m.groupdict()['name']] = line

for i,j in zip(names, d.items()):
	# print(i, j) 
	if i != j[0]:
		break
else:
	print('Correct')
	exit(0)

print('Incorrect\n\\begin{thebibliography}{99}')
for i in names:
	print(d[i])
print('\\end{thebibliography}')