#include<bits/stdc++.h>
using namespace std;
#define dbg(x) cerr << #x << "  = " << x << '\n';
#ifndef LOCAL
	#define cerr if(0) cerr
#endif
#define all(v) (v).begin(), (v).end()
#define pb push_back
#define mkt make_tuple
#define forn(i, n) for(int i = 0; i < (int)n; i++)
using ll = long long;
using ld = long double;
using vi = vector<int>;
using vll = vector<ll>;

const ld eps = 1e-8;
const ld Pi = acosl(-1);
const int INF = 1e9 + 10;
const int MOD = 1e9 + 7;
const ll INFL = 9e18;


void solve();
int main()
{
	cout.sync_with_stdio(0);
	cout.tie(0);
	cout.precision(9);
	cout << fixed;
	int t = 1;
	#ifdef LOCAL
		assert(freopen("in", "r", stdin));
		freopen("out", "w", stdout);
		freopen("err", "w", stderr);
		cin >> t;
	#endif
	while(t--)
		solve();
}

void cry()
{
 	cout << "NO";
 	exit(0);
}

void solve()
{
	ll n, m;
	cin >> n >> m;
	set<tuple<int, int>> st;
	forn(i, m)
	{
	 	int a, b;
	 	cin >> a >> b; a--; b--;
	 	if(a > b)
	 		swap(a, b);
	 	st.insert(mkt(a, b));
	}
	forn(i, n)
		for(int j = i + 1; j < n; j++)
			if(!st.count(mkt(i, j)))
			{
				cout << "YES\n";
				dbg(i);
				dbg(j);
				vi a(n, 0);
				a[i] = 1;
				a[j] = 2;
				int nxt = 3;
				forn(k, n)
				{
					if(!a[k])
						a[k] = nxt++;
				}
				forn(k, n)
					cout << a[k] << ' ';
				cout << '\n';
				vi b = a;
				b[j] = b[i];
				forn(k, n)
					cout << b[k] << ' ';
				for(auto bb: st)
				{
				 	int x, y;
				 	tie(x, y) = bb;
				 	if(a[x] < a[y] && !(b[x] < b[y]))
				 	{
				 	 	cout << "FAIL\n" << x << ' ' << y;
				 	}
				 	if(a[x] > a[y] && !(b[x] > b[y]))
				 	{
				 	 	cout << "FAIL\n" << x << ' ' << y;
				 	}
				 	if(a[x] == a[y] && !(b[x] == b[y]))
				 	{
				 	 	cout << "FAIL\n" << x << ' ' << y;
				 	}
				}
				exit(0);
			}
	cry();
}
