#include<bits/stdc++.h>
using namespace std;
#define dbg(x) cerr << #x << "  = " << x << '\n';
#ifndef LOCAL
	#define cerr if(0) cerr
#endif
#define all(v) (v).begin(), (v).end()
#define pb push_back
#define mkt make_tuple
#define forn(i, n) for(int i = 0; i < (int)n; i++)
using ll = long long;
using ld = long double;
using vi = vector<int>;
using vll = vector<ll>;

const ld eps = 1e-8;
const ld Pi = acosl(-1);
const int INF = 1e9 + 10;
const int MOD = 1e9 + 7;
const ll INFL = 9e18;


void solve();
int main()
{
	cout.sync_with_stdio(0);
	cout.tie(0);
	cout.precision(9);
	cout << fixed;
	int t = 1;
	#ifdef LOCAL
		assert(freopen("in", "r", stdin));
		freopen("out", "w", stdout);
		freopen("err", "w", stderr);
		cin >> t;
	#endif
	while(t--)
		solve();
}

struct Animal
{
	int id;
	ll a, h;
	Animal(int id, ll aa=1, ll hh=1) : id(id), a(aa), h(hh) {}
	Animal(int id, Animal m) : id(id), a(m.a), h(m.h) {} 
	Animal() {}
	bool operator < (Animal m) const 
	{
		return this->id < m.id; 
	}
	void debug()
	{
		cerr << "id: " << id <<  " | a: " << a << " | h:" << h << endl;
	}
};


void solve()
{
	map <int, Animal> mp;
	map <int, ll> ans;
	int n, ev, x, y, id = 1;
	cin >> n;
	for(int i = 0; i < n; i++)
	{
		//cerr << "\t !" << i + 1 << "!\n";
		cin >> ev;
		if(ev == 1) 
		{
			mp[id] = Animal(id);
			id++;	
		}
		else if(ev == 2)
		{
			cin >> x;
			mp[x].a *= 2;
		}
		else if(ev == 3)
		{
			cin >> x;
			mp[x].h *= 2;
		}
		else if(ev == 4)
		{
			cin >> x;
			mp[id] = Animal(id, mp[x]);
			id++;
			if(mp[x].h == 0)
				ans[id - 1] = i + 1;
		}
		else if(ev == 5)
		{
			cin >> x >> y;
			if(!mp[x].h || !mp[y].h) continue;
			cerr << x << " " << y << endl;
			mp[x].h -= mp[y].a;
			mp[y].h -= mp[x].a;
			//mp[x].debug();
		//	mp[y].debug();
			if(mp[x].h <= 0)
			{
				mp[x].h = 0;
				ans[x] = i + 1;
			}
			if(mp[y].h <= 0)
			{
				mp[y].h = 0;
				ans[y] = i + 1;	
			}
		}
		for(auto &j : mp)
		{
			j.second.debug();
		}
		//cerr << "=======\n";
	}
	cout << id - 1 << "\n";
	for(int i = 1; i < id; i++)
	{
		if(mp[i].h) cout << -1;
		else cout << ans[i];
		cout << " ";
	}
}
