#include<bits/stdc++.h>
using namespace std;
#define dbg(x) cerr << #x << "  = " << x << '\n';
#ifndef LOCAL
	#define cerr if(0) cerr
#endif
#define all(v) (v).begin(), (v).end()
#define pb push_back
#define mkt make_tuple
#define forn(i, n) for(int i = 0; i < (int)n; i++)
using ll = long long;
using ld = long double;
using vi = vector<int>;
using vll = vector<ll>;

const ld eps = 1e-8;
const ld Pi = acosl(-1);
const int INF = 1e9 + 10;
const ll MOD = 1ll << 32;
const ll INFL = 9e18;


void solve();
int main()
{
	cout.sync_with_stdio(0);
	cout.tie(0);
	cout.precision(9);
	cout << fixed;
	int t = 1;
	#ifdef LOCAL
		assert(freopen("in", "r", stdin));
		freopen("out", "w", stdout);
		freopen("err", "w", stderr);
	#endif
	cin >> t;
	while(t--)
		solve();
}
               
mt19937 rnd;

void solve()
{
	ll n, l, r, x, y, z, b1, b2;
	cin >> n >> l >> r >> x >> y >> z >> b1 >> b2;
	vll b(n);
	b[0] = b1;
	b[1] = b2;
	for(int i = 2; i < n; i++)
	{
	 	b[i] = (b[i - 2] * x + b[i - 1] * y + z) % MOD;
	}
	vll a(n);
	for(int i = 0; i < n; i++)
	{
	 	a[i] = (b[i] % (r - l + 1)) + l;
	}        
	forn(i, n)
		cerr << b[i] << ' ';
	cerr << '\n';
	forn(i, n)
		cerr << a[i] << ' ';
	cerr << '\n';
	set<ll> st;
	ll ans = INFL;
	forn(i, 300)
	{
	 	ll r1 = rnd() % n;
	 	ll r2 = r1 + rnd() % (n - r1);
	 	if(a[r1] > a[r2])
	 		ans = min(ans, a[r1] * a[r2]);
	}

	auto upd = [&](ll s, ll t)
	{
		if(s < t)
		 	ans = min(ans, s * t);
	};
	ll mn = INFL;
	forn(i, n)
	{
	 	auto it = st.upper_bound(a[i]);
	 	if(it != st.end())
	 		upd(*it, a[i]);
	 	dbg(a[i]);	
	 	upd(mn, a[i]);
	 	if(a[i] * a[i] <= ans)
	 		st.insert(a[i]);
	 	mn = min(a[i], mn);
	}                              
	if(ans == INFL)
		cout << "IMPOSSIBLE";
	else
		cout << ans;
	cout << '\n';
}
