#pragma GCC optimize("O3")
#include <bits/stdc++.h>
#define pb push_back
#define all(a) (a).begin(), (a).end()
#define popb pop_back
#define pf push_front
#define popf pop_front
#define sz(a) (ll)((a).size())
#define fast ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0)
#define die(cond) if(cond) for() {}
#define maxeq(a, b) if (a < b) a = b;
#define mineq(a, b) if (a > b) a = b;
#define heap priority_queue
#define hash_map unordered_map
#define hash_set unordered_set
#define endl "\n"
using namespace std;
typedef long long ll;
typedef long double ld;
typedef vector<ll> vll;
typedef pair<ll, ll> pll;
typedef set<ll> sll;
typedef map<ll, ll> mll;
const ll inf = numeric_limits<ll>::max()/2;
const ld pi = acos(-1);
const ld eps = 1e-6;

inline void read(), solve();

int main() {
    fast;
    read();
    solve();
    return 0;
}

ll n, m;
vector<vll> adj;

inline void solve() {
    ll p = -1, q = -1;
    for (ll i = 1; i <= n; i++) {
        adj[i].pb(i);
        adj[i].pb(0);
        sort(all(adj[i]));
    }
    for (ll i = 1; i <= n; i++) {
        if (sz(adj[i]) == n + 1){
            continue;
        }
        p = i;
        ll ok = 0;
        for (ll j = 1; j < sz(adj[i]); j++) {
            if (adj[i][j] != j) {
                q = j;
                ok = 1;
                break;
            }
        }
        if (ok) {
            break;
        }
        q = sz(adj[i]);
        break;
    }
    if (p == -1) {
        cout << "NO" << endl;
        return;
    }
    cout << "YES" << endl;
    vll a(n+1);
    iota(all(a), 0);
    a[1] = p;
    a[2] = q;
    a[p] = 1;
    a[q] = 2;
    for (ll i = 1; i <= n; i++) {
        cout << a[i] << " ";
    }
    cout << endl;
    a[q] = 1;
    for (ll i = 1; i <= n; i++) {
        cout << a[i] << " ";
    }
    cout << endl;
}

inline void read() {
    cin >> n >> m;
    adj.resize(n + 1);
    for (ll i = 0; i < m; i++) {
        ll v, u;
        cin >> v >> u;
        adj[v].pb(u);
        adj[u].pb(v);
    }
}
