#pragma GCC optimize("O3")
#include <bits/stdc++.h>
#define pb push_back
#define all(a) (a).begin(), (a).end()
#define popb pop_back
#define pf push_front
#define popf pop_front
#define sz(a) (ll)((a).size())
#define fast ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0)
#define die(cond) if(cond) for() {}
#define maxeq(a, b) if (a < b) a = b;
#define mineq(a, b) if (a > b) a = b;
#define heap priority_queue
#define hash_map unordered_map
#define hash_set unordered_set
#define endl "\n"
using namespace std;
typedef long long ll;
typedef long double ld;
typedef vector<ll> vll;
typedef pair<ll, ll> pll;
typedef set<ll> sll;
typedef map<ll, ll> mll;
const ll inf = 5e18;
const ld pi = acos(-1);
const ld eps = 1e-6;

inline void read(), solve();

int main() {
    fast;
    read();
    return 0;
}

const ll MAXT = 1ll << 32;
ll t;
ll n;
ll l, r, x, y, z, b1, b2;
vll a, b;
vll s1, s2, p1;

inline void solve() {
    ll ans = inf;
    p1.assign(n, inf);
    s1.assign(n+1, -inf);
    s2.assign(n+1, -inf);
    for (ll i = 0; i < n; i++) {
        if (a[i] > 0) {
            if (i == 0) {
                p1[i] = a[i];
                continue;
            }
            p1[i] = min(p1[i-1], a[i]);
        }
    }
    for (ll i = n-1; i >= 0; i--) {
        s1[i] = s1[i+1];
        s2[i] = s2[i+1];
        if (a[i] > 0) {
            maxeq(s1[i], a[i]);
        } else if (a[i] < 0) {
            maxeq(s2[i], a[i]);
        }
    }
    for (ll i = 0; i < n; i++) {
        ll p = inf;
        if (a[i] < 0) {
            if (s1[i + 1] != -inf) {
                if (s1[i + 1] > a[i]) {
                    p = a[i] * s1[i + 1];
                }
            }
        }
        mineq(ans, p);
    }
    for (ll i = 0; i < n; i++) {
        ll p = inf;
        if (a[i] < 0) {
            if (s2[i + 1] != -inf) {
                if (s2[i + 1] > a[i]) {
                    p = a[i] * s2[i + 1];
                }
            }
        }
        mineq(ans, p);
    }
    for (ll i = n-1; i > 0; i--){
        ll p = inf;
        if (a[i] > 0) {
            if (p1[i-1] != inf) {
                if (p1[i-1] < a[i]) {
                    p = a[i] * p1[i-1];
                }
            }
        }
        mineq(ans, p);
    }
    ll prv = 0;
    for (ll i = 0; i < n; i++) {
        if (a[i] < 0) {
            prv = 1;
        }
        if (a[i] != 0) {
            continue;
        }
        if (prv) {
            mineq(ans, 0ll);
        }
    }
    prv = 0;
    for (ll i = n-1; i >= 0; i--) {
        if (a[i] > 0) {
            prv = 1;
        }
        if (a[i] != 0) {
            continue;
        }
        if (prv) {
            mineq(ans, 0ll);
        }
    }
    if (ans == inf) {
        cout << "IMPOSSIBLE" << endl;
        return;
    }
    cout << ans << endl;
}

inline void read() {
    cin >> t;
    for (ll i = 0; i < t; i++) {
        cin >> n;
        cin >> l >> r >> x >> y >> z >> b1 >> b2;
        b.assign(n, 0);
        b[0] = b1;
        b[1] = b2;
        for (ll i = 2; i < n; i++) {
            b[i] = b[i-2]*x+b[i-1]*y+z;
            b[i] %= MAXT;
        }
        a.assign(n, 0);
        for (ll i = 0; i < n; i++) {
            a[i] = b[i]%(r-l+1)+l;
        }
        solve();
    }
}
