#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

typedef unsigned int uint;
#define int ll

typedef pair<int, int> pii;

#define F first
#define S second
#define all(x) (x).begin(), (x).end()
#define len(x) (int)(x).size()
#define pb push_back

template<class t1, class t2>
bool cmax(t1 &a, const t2 &b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

template<class t1, class t2>
bool cmin(t1 &a, const t2 &b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

void run();

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    run();
    return 0;
}

const int INF = 5e18;

void solve() {
    int n;
    ll l, r;
    ll x, y, z;
    int b1, b2;
    cin >> n >> l >> r >> x >> y >> z >> b1 >> b2;
    vector<int> b(n);
    b[0] = b1;
    b[1] = b2;
    for (int i = 2; i < n; ++i) {
        b[i] = uint(b[i - 2] * x + b[i - 1] * y + z);
    }
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        a[i] = (b[i] % (r - l + 1)) + l;
    }
    int ans = INF;
    vector<int> suff_max(n + 1, -INF);
    for (int i = n - 1; i >= 0; --i) {
        suff_max[i] = max(suff_max[i + 1], a[i]);
    }
    vector<int> c;
    for (int i = 0; i < n; ++i) {
        if (a[i] <= 0) {
            int val = suff_max[i + 1];
            if (val <= a[i])
                continue;
            int new_ans = val * a[i];
            cmin(ans, new_ans);
        } else {
            c.pb(a[i]);
        }
    }
    int prv = INF;
    int itr = len(c) - 1;
    vector<int> idxs;
    for (int i = 0; i < len(c); ++i) {
        if (c[i] < prv) {
            prv = c[i];
            idxs.pb(i);
        }
    }
    reverse(all(idxs));
    for (auto idx : idxs) {
        while (itr > idx) {
            int val = c[itr];
            if (c[idx] < val) {
                cmin(ans, c[idx] * val);
            }
            --itr;
        }
    }
    if (ans >= INF) {
        cout << "IMPOSSIBLE";
    }
    else
        cout << ans;
    cout << endl;
}

void run() {
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}