#include <iostream>
#include <string>
#include <vector>
#include <map>
#include <algorithm>

using namespace std;

string BEG = "\\begin{thebibliography}{99}";
string END = "\\end{thebibliography}";
typedef long long ll;
vector<string> ss;
map<string, int> mm;

struct defen{
    string s;
    vector<string> ss;
};
defen a[500];

bool comp(defen A, defen B)
{
    return mm[A.s] < mm[B.s];
}

void finish()
{
    ll t = 1;
    ll n = 0;
    for (int i = 1; a[i].s != ""; i++)
    {
        if (mm[a[i].s] != i)
            t = 0;
        n++;
    }
    if (t == 1)
    {
        cout << "Correct";
        exit(0);
    }
    sort(a + 1, a + n + 1, comp);
    cout << "Incorrect\n";
    cout << BEG << endl;
    for (int i = 1; i <= n; i++)
    {
        cout << "\\bibitem{" << a[i].s << "} ";
        for (int j = 0; j < a[i].ss.size(); j++)
        {
            cout << a[i].ss[j];
            if (j + 1 != a[i].ss.size())
                cout << " ";
        }
        cout << "\n";
    }
    cout << END << endl;
    exit(0);
}

int main()
{
    string s;
    ll id = 1;
    while(1)
    {
        cin >> s;
        if (s == BEG)
            break;
        if (s[0] == '\\')
        {
            string g = "";
            int on = 0;
            for (int i = 0; i < s.size(); i++)
            {
                if (s[i] == '{')
                {
                    on = 1;
                    continue;
                }
                if (s[i] == '}')
                {
                    on = 0;
                    continue;
                }
                if (on == 1)
                    g = g + s[i];
            }
            mm[g] = id;
            id++;
            //cout << g << endl;
        }
    }
    ll id2 = 1;
    s = "";
    cin >> s;
    f:
    while (1)
    {
        string g = "";
        int on = 0;
        for (int i = 0; i < s.size(); i++)
        {
            if (s[i] == '{')
            {
                on = 1;
                continue;
            }
            if (s[i] == '}')
            {
                on = 0;
                continue;
            }
            if (on)
                g = g + s[i];
        }
        a[id2].s = g;
        while (1)
        {
            cin >> s;
            if (s == END)
            {
                finish();
            }
            if (s[0] == '\\')
            {
                id2++;
                goto f;
            }
            a[id2].ss.push_back(s);
        }
    }
}
