#include <iostream>
#include <string>
#include <vector>
#include <map>
#include <algorithm>
#include <cassert>

/*
s is s \cite{s} \cite{go}
\begin{thebibliography}{99}
\bibitem{go} gfod.llla
\bibitem{s} tttss.
\end{thebibliography}
*/

using namespace std;
#define pb push_back

string BEG = "\\begin{thebibliography}{99}";
string END = "\\end{thebibliography}";
string BIB = "\\bibitem{";
typedef long long ll;


//struct defen{
//    string s;
//    vector<string> ss;
//};
//
//defen a[500];
const int N = 200;
string lst[N];
map < string, vector < string > > inp;
map < string, int > rev;
string nxt[N];

int main()
{
    string s;
    cin >> s;
    int cnt = 0;
    while (s != BEG) {
        //cout << s << endl;
        if (s[0] == '\\') {
            string t;
            for (int i = 6; s[i] != '}'; i++) {
                t.pb(s[i]);
            }
            lst[cnt++] = t;
        }
        cin >> s;
    }
    int p = -1;
    cin >> s;
    while (s != END) {
        if (s[0] == '\\') {
            p++;
            string t;
            for (int i = 9; s[i] != '}'; i++) {
                t.pb(s[i]);
            }
            nxt[p] = t;
        } else
            inp[nxt[p]].pb(s);
        cin >> s;
    }
    int res = 0;
    for (int i = 0; i < cnt; i++) {
        if (lst[i] == nxt[i])
            res++;
        //cout << lst[i] << ' ' << nxt[i] << endl;
    }

    if (res == cnt) {
        cout << "Correct";
        return 0;
    }
    cout << "Incorrect\n";
    cout << BEG << endl;
    for (int i = 0; i < cnt; i++) {
        cout << BIB << lst[i] << "}";
        int k = 0;
        int sz = inp[lst[i]].size();
        if (sz) {
            for (auto p : inp[lst[i]]) {
                if (k + 1 == sz)
                    break;
                cout << p << ' ';
                k++;

            }
            cout << inp[lst[i]].back() << endl;
        } else {
            cout << "\n";
        }

    }
    cout << END;
}
