#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <string>
#include <map>
#include <cassert>

using namespace std;

typedef long long ll;
typedef pair <int , int > pii;

ll k;
string let = "Aabcdefgh";
map<char, int> num;
ll table[50][50];

pair<int, int> f(int num)
{
    ll x = num / 8 + 1;
    ll y = num % 8 + 1;
    return {x, y};
}

int af(pair<int, int> r)
{
    int x = (r.first - 1) * 8 + r.second - 1;
    return x;
}

bool ok(int x, int y)
{
    if (x <= 8 && y <= 8 && 1 <= x && 1 <= y)
        return 1;
    return 0;
}

int cx[8] = {1, 1, -1, -1, 2, 2, -2, -2};
int cy[8] = {2, -2, 2, -2, 1, -1, 1, -1};

pair<int, int> pr[9][9];

struct go{
    int x1, y1, x2, y2;
};

vector<go> ans;
void go1(int x, int y, int look)
{
    if (table[x][y] == look)
        return;
    //cout << x << " " << y << endl;
    for (int i = 1; i <= 8; i++)
    {
        for (int j = 1; j <= 8; j++)
        {
            pr[i][j] = {-1, -1};
        }
    }
    vector<pair<int, int>> v;
    v.push_back({x, y});
    for (int i = 0; i < v.size(); i++)
    {
        int nx = v[i].first;
        int ny = v[i].second;
        for (int j = 0; j < 8; j++)
        {
            int xx = nx + cx[j];
            int yy = ny + cy[j];
            pii NO = {-1, -1};
            if (look == 1 && xx < x)
                continue;
            if (look == 1 && xx == x && yy < y)
                continue;
            if (look == 0 && xx > x)
                continue;
            if (look == 0 && xx == x && yy > y)
                continue;
            if (ok(xx, yy) && pr[xx][yy] == NO)
            {
                pr[xx][yy] = v[i];
                if (table[xx][yy] == look)
                {
                    table[xx][yy] = 1 - look;
                    while (xx != x || yy != y)
                    {
                        pair<int, int> f1 = pr[xx][yy];
                        if (look == 1)
                        ans.push_back({xx, yy, f1.first, f1.second});
                        else
                        ans.push_back({f1.first, f1.second, xx, yy});
                        xx = f1.first;
                        yy = f1.second;
                    }
                    table[x][y] = look;
                    return;
                }
                v.push_back({xx, yy});
            }
        }
    }
}

int main()
{
    num['a'] = 1;
    num['b'] = 2;
    num['c'] = 3;
    num['d'] = 4;
    num['e'] = 5;
    num['f'] = 6;
    num['g'] = 7;
    num['h'] = 8;
   cin >> k;
   for (int i = 63; i > 63 - k; i--)
   {
       string s;
       cin >> s;
       ll x = num[s[0]];
       ll y = s[1] - '0';
       //ll x = f(i).second;
       //ll y = f(i).first;
       table[x][y]++;
   }
   for (int i = 1; i <= 8; i++)
   {
       for (int j = 1; j <= 8; j++)
       {
           //cout << table[i][j] << " ";
           //cout << af({i, j}) << " ";
       }
       //cout << endl;
   }
   if (k <= 32)
   {
       for (int i = 0; i < k; i++)
       {
           int x = f(i).first;
           int y = f(i).second;
           //cout << let[x] << " " << y << endl;
           go1(x, y, 1);
       }
       cout << ans.size() << endl;
       for (int i = 0; i < ans.size(); i++)
       {
           cout << let[ans[i].y1] << ans[i].x1 << "-" << let[ans[i].y2] << ans[i].x2 << endl;
       }
   }
   else
   {
       for (int i = 63; i > 63 - k; i--)
       {
           int x = f(i).first;
           int y = f(i).second;
           go1(x, y, 0);
       }
       for (int i = 63; i > 63 - k; i--)
       {
           int x = f(i).first;
           int y = f(i).second;
           go1(x, y, 0);
       }
       cout << ans.size() << endl;
       for (int i = 0; i < ans.size(); i++)
       {
           cout << let[ans[i].y1] << ans[i].x1 << "-" << let[ans[i].y2] << ans[i].x2 << endl;
       }
   }
}
