#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef pair < ll, ll > pii;

const int N = 30000000;
ll b[N];
ull a[N];
int lst[N];
ll MOD = (1LL << 32);

bool check(ull a, int x, ull b, int y) {
    if (x == -1 && y == -1) {
        return a > b;
    }
    if (x == 1 && y == 1) {
        return a < b;
    }
    if (x == 1 && y == -1) {
        return false;
    }
    if (x == -1 && y == 1) {
        return true;
    }
}

void solve()
{
    ll n, l, r, x, y, z, b1, b2;
    cin >> n >> l >> r >> x >> y >> z >> b1 >> b2;
    b[1] = b1;
    b[2] = b2;
    for (int i = 3; i <= n; i++)
    {
        b[i] = (b[i - 2] * x % MOD + b[i - 1] * y % MOD + z) % MOD;
    }
    for (int i = 1; i <= n; i++)
    {
        ll p =  (b[i] % (r - l + 1)) + l;
        a[i] = abs(p);
        if (p < 0)
            lst[i] = -1;
        else
            lst[i] = 1;
    }
    /*cin >> n;
    for (int i = 1; i <= n; i++)
    {
        cin >> a[i];
    }*/
    ull inf = (1LL << 64 - 1);
    ull ans = inf;
    int as = 1;
    ull min_ = a[1];
    int s = lst[1];
    for (int i = 2; i <= n; ++i) {
        if (check(min_, s, a[i], lst[i])) {
            if (check(min_ * a[i], lst[i] * s, ans, as)) {
                ans = min_ * a[i];
                as = lst[i] * s;
            }
        } else {
            min_ = a[i];
            s = lst[i];
        }
    }
    ll max_ = a[n];
    s = lst[n];
    for (int i = n - 1; i >= 1; --i) {
        if (check(a[i], lst[i], max_, s)) {
            if (check(max_ * a[i], lst[i] * s, ans, as)) {
                ans = max_ * a[i];
                as = lst[i] * s;
            }
        } else {
            max_ = a[i];
            s = lst[i];
        }

    }
    if (ans == inf) {
        cout << "IMPOSSIBLE" << endl;
    } else {
        if (as == -1)
            cout << '-';
        cout << ans << endl;
    }
}

int main()
{
//    ull inf = ((1LL << 64 ) - 1);
//    cout << inf << endl;
   ll t;
   cin >> t;
   while (t--)
   {
       solve();
   }
}
