#include <bits/stdc++.h>

using namespace std;

#define all(s) s.begin(),s.end()
#define int long long

const int MAXN = 1e7 + 179;
const int INF = 4e18 + 179;
const int R = 1ll << 32;
int a[MAXN];

void solve() {
    int n, l, r, x, y, z, b1, b2;
    cin >> n >> l >> r >> x >> y >> z >> b1 >> b2;
    a[0] = b1; a[1] = b2;
    for (int i = 2; i < n; ++i) {
        a[i] = (a[i - 2] * x + a[i - 1] * y + z) % R;
    }
    for (int i = 0; i < n; ++i) {
        a[i] = (a[i] % (r - l + 1)) + l;
    }
    int ans = INF;
    vector<int> pref;
    for (int i = 0; i < n; ++i) {
        for (int c : pref) {
            if (c != a[i]) {
                ans = min(ans, a[i] * c);
            }
        }
        pref.push_back(a[i]);
        if (pref.size() > 3) {
            int pos = max_element(all(pref)) - pref.begin();
            swap(pref.back(), pref[pos]);
            pref.pop_back();
        }
    }
    if (ans == INF) {
        cout << "IMPOSSIBLE\n";
    } else {
        cout << ans << '\n';
    }

}
 signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}