#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

const int MAX_N = 200005;

int n;
vector<ll> a[MAX_N];
ll aMax[MAX_N];
int p[MAX_N];
ll t[4 * MAX_N];

void addOnRange(int i, int l, int r, int lx, int rx, ll val)
{
    if (l == r)
        t[i] += val;
    else
    {
        int mid = (l + r) / 2;
        if (lx <= mid)
            addOnRange(2 * i + 1, l, mid, lx, min(rx, mid), val);
        if (rx > mid)
            addOnRange(2 * i + 2, mid + 1, r, max(lx, mid + 1), rx, val);
    }
}

ll get(int i, int l, int r, int pos)
{
    if (l == r)
        return t[i];
    else
    {
        int mid = (l + r) / 2;
        if (pos <= mid)
            return t[i] + get(2 * i + 1, l, mid, pos);
        else
            return t[i] + get(2 * i + 2, mid + 1, r, pos);
    }
}

int main()
{
    ios::sync_with_stdio(false);
    cin >> n;
    for (int i = 0; i < n; i++)
    {
        int m; cin >> m;
        a[i].resize(m);
        for (int j = 0; j < m; j++)
        {
            cin >> a[i][j];
            aMax[i] = max(aMax[i], a[i][j]);
        }
    }

    for (int i = 0; i < n; i++)
        p[i] = i;
    sort(p, p + n, [](int pA, int pB)
    {
        return aMax[pA] < aMax[pB];
    });

    ll result = 0;
    for (int i = 0; i < n - 1; i++)
    {
        int curr = p[i], next = p[i + 1];
        if (aMax[curr] != aMax[next])
            addOnRange(0, 0, n - 1, 0, i, aMax[next] - aMax[curr]);
    }

    for (int i = 0; i < n; i++)
    {
        int curr = p[i];
        ll val = get(0, 0, n - 1, i);
        result += val * (ll)a[curr].size();
    }

    cout << result << endl;
}
