#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

#define pb push_back

const int MAX_N = 200005;

vector<vector<int> > g;
vector<int> a, b, used;
int col;

void dfs(int v)
{
    used[v] = true;
    a[v] = b[v] = col++;
    for(auto i : g[v])
        if(!used[i])
            dfs(i);
}

int main()
{
    int n, m;
    cin >> n >> m;
    a.resize(n);
    b.resize(n);
    g.resize(n);
    used.resize(n);
    for(int i = 0; i < m; i++)
    {
        int x, y;
        cin >> x >> y;
        x--; y--;
        g[x].pb(y);
        g[y].pb(x);
    }
    int to = 0, ms = 1000000000;
    for(int i = 0; i < n; i++)
        if(g[i].size() < ms)
        {
            ms = g[i].size();
            to = i;
        }
    if(ms == n - 1)
    {
        cout << "NO";
        return 0;
    }
    a[to] = 1;
    b[to] = 2;
    used[to] = 1;
    col = n;
    for(int i = 0; i < g[to].size(); i++)
    {
        a[g[to][i]] = b[g[to][i]] = col--;
        used[g[to][i]] = true;
    }
    col = 2;
    for(int i = 0; i < n; i++)
    {
        if(!used[i])
            dfs(i);
    }
    cout << "YES\n";
    for(auto i : a)
        cout << i << ' ';
    cout << endl;
    for(auto i : b)
        cout << i << ' ';
    return 0;
}
