#include <bits/stdc++.h>
#define m_p make_pair
#define MOD 4294967296
#define INF 2000000010
#define pb push_back

using namespace std;

typedef long long ll;
typedef long double ld;
typedef vector<int> vi;
typedef pair<ll, ll> pii;

const int MAXN = 1e7 + 10;

ll t, n, l, r, x, y, z, b1, b2;


int main() {
	ios_base::sync_with_stdio(0);
	#ifdef LOCAL
		freopen("input.txt", "r", stdin);
		freopen("output.txt", "w", stdout);
	#else
		#define cerr if(0) cerr
	#endif
	cin >> t;
	while(t--){
		cin >> n >> l >> r >> x >> y >> z >> b1 >> b2;
		vector <ll> b(n);
		b[0] = b1;
		b[1] = b2;
		for(int i = 2; i < n; i++){
			b[i] = (b[i - 2] * x + b[i - 1] * y + z) % MOD;
		}
		vi a(n);
		for(int i = 0; i < n; i++){
			a[i] = b[i] % (r - l + 1) + l;
		}
		int maxsuf = a[n - 1];
		ll ans = (ll)INF * (ll)INF;
		set <int> st;
		for(int i = n - 2; i >= 0; i--){
			if(a[i] < 0 && maxsuf > a[i]){
				ans = min(ans, (ll)a[i] * (ll)maxsuf);
			}
			else if(st.upper_bound(a[i]) != st.end()){
				ans = min(ans, (ll)a[i] * (ll)(*st.upper_bound(a[i])));
			}
			st.insert(a[i]);
			maxsuf = max(maxsuf, a[i]);
		}
		if(ans == (ll)INF * (ll)INF){
			cout << "IMPOSSIBLE\n";
		}
		else{
			cout << ans << '\n';
		}
	}
	
	
	return 0;
}