//
// Created by orspc on 09.12.2018.
//
#include <iostream>
#include <set>
#include <vector>
#include <algorithm>
using namespace std;
const int MAXN = 1e5 + 7, inf = 1e9 + 7;
using ll = long long;
typedef pair<ll, ll> pii;

int main() {
    std::ios::sync_with_stdio(0);
    std::cin.tie(0);
    int n;
    cin >> n;
    vector<pii> a(n);
    for (int i = 0; i < n; i++) {
        ll k, mx = 0; cin >> k;
        for (int j = 0; j < k; j++) {
            ll x; cin >> x;
            mx = max(x, mx);
        }
        a[i] = {mx, k};
    }
    sort(a.begin(), a.end());
    ll sum = 0;
    for (int i = 0; i + 1 < n; i++) {
        sum += (a[i + 1].first - a[i].first) * a[i].second;
        a[i + 1].second += a[i].second;
    }
    cout << sum << "\n";
    return 0;
}
