//
// Created by orspc on 09.12.2018.
//
//
// Created by orspc on 09.12.2018.
//
#include <iostream>
#include <map>
#include <vector>
#include <algorithm>
#include <memory.h>
#include <stack>

using namespace std;
using ll = long long;

const int ALPHABET = 'z' - 'a' + 1;
char used[ALPHABET];
map<pair<string, string>, stack<int>> m;

int main() {
    //freopen("input", "r", stdin);
    std::ios::sync_with_stdio(0);
    std::cin.tie(0);
    std::cout.tie(0);
    int n = 0;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        memset(used, 0, ALPHABET * sizeof(char));
        std::string s, t, t1;
        std::cin >> s >> t;
        for (auto c : t) {
            used[c - 'a'] = 1;
        }
        for (int i = 0; i < ALPHABET; ++i) {
            if (used[i]) {
                t1 += char ('a' + i);
            }
        }
        while ((!s.empty()) && used[s.back() - 'a']) {
            s.pop_back();
        }
        m[{t1, s}].push(i);
    }
    std::cout << m.size() << '\n';
    for (auto &i : m) {
        std::cout << i.second.size() << ' ';
        while (!i.second.empty()) {
            std::cout << i.second.top() + 1 << ' ';
            i.second.pop();
        }
        std::cout << '\n';
    }
    return 0;
}