#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef tuple<int, int, int> t3;
#define INF 1000000000
#define endl "\n"

#define ft first
#define sd second
#define faster ios_base::sync_with_stdio(false);cin.tie(nullptr);cout.tie(nullptr);

const ll osn = 31ll;
const ll mod = 1000000411ll;

struct el{
    ll s, t;
    int id;
};

bool comp(el &a, el &b){
    if (a.s != b.s) return a.s < b.s;
    return a.t < b.t;
}

int main()
{
//    faster;

    int n;
    cin >> n;
    string s, t;
    vector<el> a(n);
    vector<ll> st(1000007);

    st[0] = 1ll;
    for (int i = 1; i < st.size(); i++){
        st[i] = (st[i-1] * osn)%mod;
    }

    for (int i = 0; i < n; i++){
        cin >> s >> t;
        vector<int> cnt(26);
        sort(t.begin(), t.end());
        t.erase(unique(t.begin(), t.end()), t.end());

        for (int j = 0; j < t.size(); j++){
            cnt[t[j]-'a'] = 1;
        }
        for (int j = s.size()-1; j >= 0; j--){
            if (cnt[s[j]-'a'] == 0) break;
            s.pop_back();
        }

//        cout << news << " " << t << endl;

        ll hs = 0ll, ht = 0ll;
        for (int j = 0; j < s.size(); j++){
            hs = (hs + (s[j]-'a'+1ll)*st[j]) % mod;
        }

        for (int j = 0; j < t.size(); j++){
            ht = (ht + (t[j]-'a'+1ll)*st[j]) % mod;
        }

        a[i].id = i+1;
        a[i].s = hs;
        a[i].t = ht;
    }

    sort(a.begin(), a.end(), comp);

    int cnt = 1;

    for (int i = 1; i < n; i++){
        if (a[i].s != a[i-1].s || a[i].t != a[i-1].t){
            cnt++;
        }
    }

    cout << cnt << endl;
    vector<vector<int> > ans(cnt);
    int c = 0;
    ans[0].push_back(a[0].id);
    for (int i = 1; i < n; i++){
        if (a[i].s != a[i-1].s || a[i].t != a[i-1].t){
            c++;
        }
        ans[c].push_back(a[i].id);
    }

    for (int i = 0; i < cnt; i++){
        cout << ans[i].size() << " ";
        for (int j = 0; j < ans[i].size(); j++){
            cout << ans[i][j] << " ";
        }
        cout << endl;
    }

    return 0;
}
