#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef tuple<int, int, int> t3;
#define INF 1000000000
#define endl "\n"

#define ft first
#define sd second
#define faster ios_base::sync_with_stdio(false);cin.tie(nullptr);cout.tie(nullptr);

const ll osn = 31ll;
const ll mod1 = 1000000411ll;
const ll mod2 = 1000000321ll;

struct el{
    ll s1, s2, t1, t2;
    int id;
};

bool comp(el &a, el &b){
    if (a.s1 != b.s1 || a.s2 != b.s2) return a.s1 < b.s1;
    return a.t1 < b.t1;
}

int main()
{
//    faster;

    int n;
    cin >> n;
    string s, t;
    vector<el> a(n);
    vector<ll> st1(1000007);
    vector<ll> st2(1000007);

    st1[0] = 1ll;
    for (int i = 1; i < st1.size(); i++){
        st1[i] = (st1[i-1] * osn)%mod1;
    }
    st2[0] = 1ll;
    for (int i = 1; i < st2.size(); i++){
        st2[i] = (st2[i-1] * osn)%mod2;
    }

    for (int i = 0; i < n; i++){
        cin >> s >> t;
        vector<int> cnt(26);
        sort(t.begin(), t.end());
        t.erase(unique(t.begin(), t.end()), t.end());

        for (int j = 0; j < t.size(); j++){
            cnt[t[j]-'a'] = 1;
        }
        for (int j = s.size()-1; j >= 0; j--){
            if (cnt[s[j]-'a'] == 0) break;
            s.pop_back();
        }

//        cout << news << " " << t << endl;

        pll hs = {0ll, 0ll}, ht = {0ll, 0ll};
        for (int j = 0; j < s.size(); j++){
            hs.ft = (hs.ft + (s[j]-'a'+1ll)*st1[j]) % mod1;
            hs.sd = (hs.sd + (s[j]-'a'+1ll)*st2[j]) % mod2;
        }

        for (int j = 0; j < t.size(); j++){
            ht.ft = (ht.ft + (t[j]-'a'+1ll)*st1[j]) % mod1;
            ht.ft = (ht.ft + (t[j]-'a'+1ll)*st2[j]) % mod2;
        }

        a[i].id = i+1;
        a[i].s1 = hs.ft;
        a[i].s2 = hs.sd;
        a[i].t1 = ht.ft;
        a[i].t2 = ht.sd;
    }

    sort(a.begin(), a.end(), comp);

    int cnt = 1;

    for (int i = 1; i < n; i++){
        if ((a[i].s1 != a[i-1].s1 || a[i].s2 != a[i-1].s2) || a[i].t1 != a[i-1].t1 || a[i].t2 != a[i-1].t2){
            cnt++;
        }
    }

    cout << cnt << endl;
    vector<vector<int> > ans(cnt);
    int c = 0;
    ans[0].push_back(a[0].id);
    for (int i = 1; i < n; i++){
        if ((a[i].s1 != a[i-1].s1 || a[i].s2 != a[i-1].s2) || a[i].t1 != a[i-1].t1 || a[i].t2 != a[i-1].t2){
            c++;
        }
        ans[c].push_back(a[i].id);
    }

    for (int i = 0; i < cnt; i++){
        cout << ans[i].size() << " ";
        for (int j = 0; j < ans[i].size(); j++){
            cout << ans[i][j] << " ";
        }
        cout << endl;
    }

    return 0;
}
