#pragma GCC target "sse2,sse3"
#include <bits/stdc++.h>

#define INF 1234567890
#define sz(x) ((int)(x).size())

using namespace std;

typedef long long ll;

const int SZ = 1e7 + 100;
unsigned long long mod = (1LL << 32);

unsigned long long b0, b1;
ll a[SZ];
ll pref[SZ];
ll suff[SZ];

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int t;
    cin >> t;
    ll n, l, r;
    unsigned long long x, y, z;
    for (int step = 0; step < t; step++)
    {
        cin >> n >> l >> r >> x >> y >> z >> b0 >> b1;

        a[0] = b0;
        a[1] = b1;
        for (int i = 2; i < n; i++)
        {
            a[i] = ((b0 * x) % mod) + ((b1 * y) % mod) + z % mod;
            a[i] %= mod;
            b0 = b1;
            b1 = a[i];
        }
        for (int i = 0; i < n; i++)
        {
            a[i] = (a[i] % (r - l + 1)) + l;
        }

        suff[n - 1] = a[n - 1];
        for (int i = n - 2; i >= 0; i--)
        {
            suff[i] = max(suff[i + 1], a[i]);
        }

        pref[0] = a[0];
        for (int i = 1; i < n; i++)
        {
            pref[i] = min(pref[i - 1], a[i]);
        }

        bool fl = false;
        ll ans;
        ll cur;
        for (int i = 0; i < n; i++)
        {
            if (i > 0)
            {
                if (a[i] >= 0)
                {
                    if (pref[i - 1] < a[i])
                    {
                        cur = a[i] * pref[i - 1];
                        if (!fl || cur < ans)
                        {
                            ans = cur;
                            fl = true;
                        }
                    }
                }
            }
            if (i < (n - 1))
            {
                if (a[i] <= 0)
                {
                    if (suff[i + 1] > a[i])
                    {
                        cur = a[i] * suff[i + 1];
                        if (!fl || cur < ans)
                        {
                            ans = cur;
                            fl = true;
                        }
                    }
                }
            }
        }

        if (fl)
        {
            cout << ans << "\n";
        }
        else cout << "IMPOSSIBLE" << "\n";
    }


    return 0;
}
