#define _CRT_SECURE_NO_WARNINGS

#include <string>
#include <iostream>
#include <algorithm>
#include <vector> 
#include <set>
#include <queue>

#define mp make_pair

using namespace std;

typedef unsigned long long ull;
typedef long long ll;

const ll INF = ll(5e18);
const ll MOD = (1LL << 32);

template<typename T>
bool uin(T &a, T b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool uax(T &a, T b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

////////////////////////////////////////

int n, m;
vector <pair <int, vector <int>>> v;
set<pair <int, int>> st;

vector <int> ans;

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	cin >> n >> m;
	v.resize(n);
	ans.resize(n);
	if (n == 1) {
		cout << "NO";
		exit(0);
	}
	int x, y;
	for (int i = 0; i < m; i++) {
		cin >> x >> y;
		x--;
		y--;
		if (y < x) {
			swap(x, y);
		}
		if (st.find(mp(x, y)) == st.end()) {
			st.insert(mp(x, y));
		}
		else {
			continue;
		}
		v[x].second.push_back(y);
		v[y].first++;
	}
	queue <int> q;
	for (int i = 0; i < n; i++) {
		if (v[i].first == 0) {
			q.push(i);
		}
	}
	int ind = 1;
	while (!q.empty()) {
		int it = q.size();
		for (int i = 0; i < it; i++) {
			int y = q.front();
			ans[q.front()] = ind;
			q.pop();
			for (int j = 0; j < v[y].second.size(); j++) {
				v[v[y].second[j]].first--;
				if (v[v[y].second[j]].first == 0) {
					q.push(v[y].second[j]);
				}
			}
		}
		ind++;
	}
	vector <bool> w(n);
	for (int i = 0; i < n; i++) {
		if (w[ans[i] - 1]) {
			cout << "YES\n";
			for (int i = 0; i < n; i++) {
				cout << i + 1 << " ";
			}
			cout << "\n";
			for (int i = 0; i < n; i++) {
				cout << ans[i] << ' ';
			}
			exit(0);
		}
		else {
			w[ans[i] - 1] = true;
		}
	}
	cout << "NO";
}