#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <vector> 

using namespace std;

typedef long long ll;

const ll INF = ll(5e18);
const ll MOD = (1LL << 32);

template<typename T>
bool uin(T &a, T b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool uax(T &a, T b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

vector<ll> get(ll n, ll l, ll r, ll x, ll y, ll z, ll b1, ll b2) {
	vector<__int128> b(n);
	b[0] = b1;
	b[1] = b2;
	for (ll i = 2; i < n; ++i) {
		b[i] = 0;
		b[i] += b[i - 2] * x;
		b[i] %= MOD;
		b[i] += b[i - 1] * y;
		b[i] %= MOD;
		b[i] += z;
		b[i] %= MOD;
	}
	vector<ll> a(n);
	for (ll i = 0; i < n; ++i) {
		a[i] = ll(b[i]) % (r - l + 1) + l;
	}
	return a;
}

ll solve_shit(vector<ll> a) {
	ll n = ll(a.size());
	vector<pair<ll, ll>> p(n);
	for (ll i = 0; i < n; ++i) {
		p[i] = make_pair(a[i], i);
	}
	ll res = INF;
	sort(p.begin(), p.end());
	ll cur = 0;
	for (ll i = 0; i < n; ++i) {
		ll ind = p[i].second;
		if (cur > ind) {
			continue;
		}
		ll x = p[i].first;
		ll mn = INF;
		for (ll j = cur; j < ind; ++j) {
			if (a[j] == x) {
				continue;
			}
			uin(mn, a[j]);
		}
		if (mn != INF) {
			uin(res, mn * x);
		}
		cur = ind;
	}
	return res;
}

void solve(vector<ll> a) {
	ll n = ll(a.size());
	ll res = INF;
	ll mn = INF;
	for (ll i = 0; i < n; ++i) {
		if (mn < a[i]) {
			uin(res, a[i] * mn);
		}
		uin(mn, a[i]);
	}
	vector<ll> b;
	for (ll i = 0; i < n; ++i) {
		if (a[i] < 0) {
			b.push_back(-a[i]);
		}
	}
	uin(res, solve_shit(b));
	if (res == INF) {
		cout << "IMPOSSIBLE\n";
		return;
	}
	cout << res << "\n";
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ll q;
	cin >> q;
	while (q--) {
		ll n, l, r, x, y, z, b1, b2;
		cin >> n >> l >> r >> x >> y >> z >> b1 >> b2;
		vector<ll> a = get(n, l, r, x, y, z, b1, b2);
		solve(a);
	}
}