#define _CRT_SECURE_NO_WARNINGS

#include <string>
#include <iostream>
#include <algorithm>
#include <vector> 
#include <set>
#include <queue>

#define mp make_pair

using namespace std;

typedef unsigned long long ull;
typedef long long ll;

template<typename T>
bool uin(T &a, T b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool uax(T &a, T b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

const ll INF = ll(1e9 + 11);

////////////////////////////////////////

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ll t, n, a, b, k;
	cin >> t >> n >> a >> b >> k;
	ll sza = (n + 1) / 2;
	ll szb = n / 2;
	if (a > b) {
		swap(a, b);
		swap(sza, szb);
	}
	ll res = 0;
	res += (sza / k) * a;
	res += (szb / k) * b;
	sza %= k;
	szb %= k;
	if (sza + szb >= k) {
		ll cnta = a * sza;
		ll cntb = b * szb;
		if (cnta > cntb) {
			swap(cnta, cntb);
			swap(sza, szb);
		}
		ll buf = szb - (k - szb);
		if (buf <= 0) {
			res += min(cnta / (k - szb), cntb / szb);
			cout << min(t, res) << "\n";
			return 0;
		}
		ll need = (cntb - (cnta + 1)) / buf;
		uin(need, cnta / (k - szb));
		uin(need, cntb / szb);
		res += need;
		cnta -= need * (k - szb);
		cntb -= need * szb;
		ll x = -1;
		if ((k - (cntb - cnta)) % 2 == 0) {
			x = cntb - cnta;
		}
		else {
			x = cntb - (cnta + 1);
		}
		ll ost = (k - x) / 2;
		if (cnta < ost || cntb < x + ost) {
			cout << min(t, res) << "\n";
			return 0;
		}
		++res;
		cnta -= ost;
		cntb -= ost + x;
		if (k % 2 == 0) {
			res += min(cnta / (k / 2), cntb / (k / 2));
			cout << min(t, res) << "\n";
			return 0;
		}
		else {
			ll p = INF;
			ll l = -1;
			ll r = INF;
			while (l + 1 < r) {
				ll m = (l + r) / 2;
				ll cnt = (m + 1) / 2 * (k / 2);
				cnt += (m / 2) * (k / 2 + 1);
				if (cnta >= cnt) {
					l = m;
				}
				else {
					r = m;
				}
			}
			l = -1;
			r = INF;
			while (l + 1 < r) {
				ll m = (l + r) / 2;
				ll cnt = (m + 1) / 2 * (k / 2 + 1);
				cnt += (m / 2) * (k / 2);
				if (cntb >= cnt) {
					l = m;
				}
				else {
					r = m;
				}
			}
			uin(p, l);
			res += p;
			cout << min(t, res) << "\n";
			return 0;
		}
	}
	cout << min(t, res);
}