#define _CRT_SECURE_NO_WARNINGS

#include <string>
#include <iostream>
#include <algorithm>
#include <vector> 
#include <set>
#include <queue>

#define mp make_pair

using namespace std;

typedef unsigned long long ull;
typedef long long ll;

template<typename T>
bool uin(T &a, T b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool uax(T &a, T b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

const ll INF = ll(1e18 + 11);

////////////////////////////////////////

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ll t, n, a, b, k;
	cin >> t >> n >> a >> b >> k;
	ll sza = (n + 1) / 2;
	ll szb = n / 2;
	if (a > b) {
		swap(a, b);
		swap(sza, szb);
	}
	ll res = 0;
	if (sza + szb >= k) {
		ll cnta = a * sza;
		ll cntb = b * szb;
		if (cnta > cntb) {
			swap(cnta, cntb);
			swap(sza, szb);
		}
		ll buf = szb - (k - szb);
		if (buf <= 0) {
			res += min(cnta / (k - szb), cntb / szb);
			cout << min(t, res) << "\n";
			return 0;
		}
		ll need = max(0LL, (cntb - (cnta + 1))) / buf;
		uin(need, cnta / (k - szb));
		uin(need, cntb / szb);
		res += need;
		cnta -= need * (k - szb);
		cntb -= need * szb;
		ll x = -1;
		if ((k - (cntb - cnta)) % 2 == 0) {
			x = cntb - cnta;
		}
		else {
			x = max(0LL, cntb - (cnta + 1));
		}
		ll ost = (k - x) / 2;
		if (cnta < ost || cntb < x + ost) {
			cout << min(t, res) << "\n";
			return 0;
		}
		++res;
		cnta -= ost;
		cntb -= ost + x;
		if (k % 2 == 0) {
			res += min(cnta / (k / 2), cntb / (k / 2));
			cout << min(t, res) << "\n";
			return 0;
		}
		else {
			ll p = INF;
			ll l = -1;
			ll r = INF;
			while (l + 1 < r) {
				ll m = (l + r) / 2;
				__int128 cnt = (m + 1) / 2 * (k / 2);
				cnt += (m / 2) * (k / 2 + 1);
				if (cnta >= cnt) {
					l = m;
				}
				else {
					r = m;
				}
			}
			uin(p, l);
			l = -1;
			r = INF;
			while (l + 1 < r) {
				ll m = (l + r) / 2;
				__int128 cnt = (m + 1) / 2 * (k / 2 + 1);
				cnt += (m / 2) * (k / 2);
				if (cntb >= cnt) {
					l = m;
				}
				else {
					r = m;
				}
			}
			uin(p, l);
			res += p;
			cout << min(t, res) << "\n";
			return 0;
		}
	}
	cout << min(t, res);
}

/*#define _CRT_SECURE_NO_WARNINGS

#include <string>
#include <iostream>
#include <algorithm>
#include <map>
#include <vector> 

using namespace std;

typedef unsigned long long ull;
typedef long long ll;

const ll INF = ll(5e18);
const ll MOD = (1LL << 32);

template<typename T>
bool uin(T &a, T b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool uax(T &a, T b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

////////////////////////////////////////

string s;
bool f = false;
map <string, string> d;
vector <string> a, b, bp;

void add(string in) {
	s = "";
	string t;
	while (true) {
		cin >> t;
		if (t[0] == char(92)) {
			if (t[1] == 'e')
				f = true;
			break;
		}
		s += t + ' ';
	}
	if (s.size() != 0)
		s.pop_back();
	reverse(in.begin(), in.end());
	in.pop_back();
	in.pop_back();
	in.pop_back();
	in.pop_back();
	in.pop_back();
	in.pop_back();
	in.pop_back();
	in.pop_back();
	reverse(in.begin(), in.end());
	d[in] = s;
	b.push_back(in);
	bp.push_back(s);
	s = t;
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	bool fl = true;
	while (cin >> s) {
		if (s[0] == char(92)) {
			while (s.size() != 0 && s.back() != '}')
				s.pop_back();
			if (fl == false) {
				while (f == false)
					add(s);
				break;
			}
			reverse(s.begin(), s.end());
			s.pop_back();
			reverse(s.begin(), s.end());
			if (s == "begin{thebibliography}{99}") {
				fl = false;
				continue;
			}
			reverse(s.begin(), s.end());
			s.pop_back();
			s.pop_back();
			s.pop_back();
			s.pop_back();
			reverse(s.begin(), s.end());
			a.push_back(s);
		}
	}
	for (int i = 0; i < a.size(); i++) {
		if (a[i] != b[i]) {
			cout << "Incorrect\n";
			cout << char(92) << "begin{thebibliography}{99}\n";
			for (int i = 0; i < a.size(); i++) {
				cout << char(92) << "bibitem" << a[i] << ' ' << d[a[i]] << endl;
			}
			cout << char(92) << "end{thebibliography}\n";
			return 0;
		}
	}
	cout << "Correct";
}*/