#include <iostream>
#include <vector>
#include <set>

using namespace std;

int stup_main(int n, int l, int r, unsigned int x, unsigned int y, unsigned int z, unsigned int b1, unsigned int b2)
{
    vector<unsigned int> barr(n);
    vector<int> data(n);
    barr[0] = b1;
    barr[1] = b2;
    for(int i = 2; i < n; i++)
        barr[i] = barr[i - 2] * x + barr[i - 1] * y + z;
    for(int i = 0; i < n; i++)
        data[i] = ((long long)(barr[i])) % (r - l + 1) + l;
    long long ans;
    bool have_ans = false;
    for(int i = 0; i < n; i++)
        for(int j = i + 1; j < n; j++)
            if(data[j] > data[i])
            {
                if(!have_ans)
                    ans = data[i] * (long long)data[j];
                have_ans = true;
                ans = min(ans, data[i] * (long long)data[j]);
            }
    if(!have_ans)
        cout << "IMPOSSIBLE\n";
    else
        cout << ans << endl;
    return 0;/*
    for(int i = 0; i < n; i++)
            data[i] = ((int)(barr[i])) % ((long long)(r - l + 1)) + l;
        long long ans;
        for(int i = 1; i < n; i++)
            if(data[i] > data[i - 1])
            {
                ans = data[i] * (long long)data[i - 1];
                goto good;
            }
        cout << "IMPOSSIBLE\n";
        return 0;
    good:
        set<int> puk;
        for(int i = n - 1; i >= 0; i--)
        {
            if(data[i] >= 0)
            {
                auto it = puk.upper_bound(data[i]);
                if(it != puk.end())
                    ans = min(ans, data[i] * (long long)*it);
            }
            else if(!puk.empty())
            {
                int it = *puk.rbegin();
                if(it > data[i])
                    ans = min(ans, data[i] * (long long)it);
            }
            puk.insert(data[i]);
        }
        cout << ans << endl;
    return 0;*/
}

int good_main(int n, int l, int r, unsigned int x, unsigned int y, unsigned int z, unsigned int b1, unsigned int b2)
{
    vector<unsigned int> barr(n);
    vector<int> data(n);
    barr[0] = b1;
    barr[1] = b2;
    for(int i = 2; i < n; i++)
        barr[i] = barr[i - 2] * x + barr[i - 1] * y + z;
    for(int i = 0; i < n; i++)
        data[i] = ((long long)(barr[i])) % (r - l + 1) + l;
    /*long long ans;
    bool have_ans = false;
    for(int i = 0; i < n; i++)
        for(int j = i + 1; j < n; j++)
            if(data[j] > data[i])
            {
                if(!have_ans)
                    ans = data[i] * (long long)data[j];
                have_ans = true;
                ans = min(ans, data[i] * (long long)data[j]);
            }
    if(!have_ans)
        cout << "IMPOSSIBLE\n";
    else
        cout << ans << endl;
    return 0;*/
    for(int i = 0; i < n; i++)
            data[i] = ((int)(barr[i])) % ((long long)(r - l + 1)) + l;
        long long ans;
        for(int i = 1; i < n; i++)
            if(data[i] > data[i - 1])
            {
                ans = data[i] * (long long)data[i - 1];
                goto good;
            }
        cout << "IMPOSSIBLE\n";
        return 0;
    good:
        set<int> puk;
        for(int i = n - 1; i >= 0; i--)
        {
            if(data[i] >= 0)
            {
                auto it = puk.upper_bound(data[i]);
                if(it != puk.end())
                    ans = min(ans, data[i] * (long long)*it);
            }
            else if(!puk.empty())
            {
                int it = *puk.rbegin();
                if(it > data[i])
                    ans = min(ans, data[i] * (long long)it);
            }
            puk.insert(data[i]);
        }
        cout << ans << endl;
    return 0;
}

struct putin
{
    int n, l, r;
    unsigned int x, y, z, b1, b2;
};

int main()
{
    int t;
    cin >> t;
    vector<putin> jva(t);
    int nsum = 0;
    for(int i = 0; i < t; i++)
    {
        cin >> jva[i].n >> jva[i].l >> jva[i].r >> jva[i].x >> jva[i].y >> jva[i].z >> jva[i].b1 >> jva[i].b2;
        nsum += jva[i].n;
    }
    if(nsum <= 10000)
    {
        for(putin& i : jva)
            stup_main(i.n, i.l, i.r, i.x, i.y, i.z, i.b1, i.b2);
    }
    else
    {
        for(putin& i : jva)
            good_main(i.n, i.l, i.r, i.x, i.y, i.z, i.b1, i.b2);
    }
}

/*int ne_main()
{
    int t;
    cin >> t;
    for(int i = 0; i < t; i++)
        real_main();
    return 0;
}
*/
