#include<bits/stdc++.h>

using namespace std;

void FAST_IO() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
    #ifdef _offline
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // _offline
}

typedef long long ll;
typedef unsigned int uint;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const int MAXN = 1e5 + 100;
int sz[MAXN];
vector<int> g[MAXN];

signed main() {
    FAST_IO();
    int n, m;
    cin >> n >> m;
    set<pii> one, two;
    int sum = 0;
    for (int i = 0; i < n; ++i) {
        cin >> sz[i];
        two.insert({sz[i], i});
        for (int j = 0; j < sz[i]; ++j) {
            int x;
            cin >> x;
            g[x].push_back(i);
        }
        sum += sz[i];
    }
    int kek = (sum + n - 1) / n;
    vector<tuple<int, int, int>> ans;
    for (int i = m; i >= 1; --i) {
        for (auto &[a, b] : one) {
            two.insert({a, b});
        }
        one.clear();
        for (int j : g[i]) {
            one.insert({sz[j], j});
            two.erase({sz[j], j});
        }
        while (true) {
            if (one.size() == 0 || two.size() == 0) {
                break;
            }
            pii f = *prev(one.end());
            pii s = *two.begin();
            if (f.first - s.first < 2 || f.first <= kek) {
                break;
            }
            ans.push_back(make_tuple(f.second, s.second, i));
            sz[f.second]--;
            sz[s.second]++;
            one.erase(prev(one.end()));
            two.erase(two.begin());
            two.insert({f.first - 1, f.second});
            one.insert({s.first + 1, s.second});
        }
    }
    cout << ans.size() << '\n';
    for (auto &[f, s, i] : ans) {
        cout << f + 1 << ' ' << s + 1 << ' ' << i << '\n';
    }
    return 0;
}


