#include<bits/stdc++.h>

using namespace std;

void FAST_IO() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
    #ifdef _offline
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // _offline
}

typedef long long ll;
typedef unsigned int uint;
typedef pair<int, int> pii;
const ll base = 47;
const ll mod = 998244353;
const int MAXN = 1e5 + 100;
string a[MAXN], b[MAXN];
ll hsh[MAXN], mask[MAXN];
map<ll, vector<int>> mp;

signed main() {
    FAST_IO();
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> a[i] >> b[i];
        for (int j = 0; j < b[i].length(); ++j) {
            mask[i] |= (1 << (b[i][j] - 'a'));
        }
        while (a[i].size() > 0 && (mask[i] & (1 << (a[i].back() - 'a')))) {
            a[i].pop_back();
        }
        ll cur = 1;
        for (int j = 0; j < a[i].size(); ++j) {
            hsh[i] = (hsh[i] + cur * (a[i][j] - 'a' + 1)) % mod;
            cur = (cur * base) % mod;
        }
        mp[hsh[i] * 1000000000LL + mask[i]].push_back(i + 1);
    }
    cout << mp.size() << '\n';
    for (auto &[x, v] : mp) {
        cout << v.size() << ' ';
        for (int i : v) {
            cout << i << ' ';
        }
        cout << '\n';
    }
    return 0;
}

