#include<bits/stdc++.h>

using namespace std;

void FAST_IO() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
    #ifdef _offline
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // _offline
}

typedef long long ll;
typedef unsigned int uint;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
const pll base = {83, 47};
const pll mod = {998244353, 1e9 + 447};
const int MAXN = 1e5 + 100;
string a[MAXN], b[MAXN];
ll hsh[MAXN], mask[MAXN];
map<pll, vector<int>> mp;

signed main() {
    FAST_IO();
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> a[i] >> b[i];
        for (int j = 0; j < b[i].length(); ++j) {
            mask[i] |= (1 << (b[i][j] - 'a'));
        }
        while (a[i].size() > 0 && (mask[i] & (1 << (a[i].back() - 'a')))) {
            a[i].pop_back();
        }
        pll cur = {1, 1}, h = {0, 0};
        for (int j = 0; j < a[i].size(); ++j) {
            h.first = (h.first + cur.first * (a[i][j] - 'a' + 1)) % mod.first;
            h.second = (h.second + cur.second * (a[i][j] - 'a' + 1)) % mod.second;
            cur.first = (cur.first * base.first) % mod.first;
            cur.second = (cur.second * base.second) % mod.second;
        }
        hsh[i] = h.first * 1100000000LL + h.second;
        mp[{hsh[i], mask[i]}].push_back(i + 1);
    }
    cout << mp.size() << '\n';
    for (auto &[x, v] : mp) {
        cout << v.size() << ' ';
        for (int i : v) {
            cout << i << ' ';
        }
        cout << '\n';
    }
    return 0;
}

