#include <bits/stdc++.h>


using namespace std;

#define int long long

bool FmaxP, FmaxN, FminP, FminN;
const long long MX = 4e+18 + 5;

void update(long long x, long long &maxP, long long &maxN, long long &minP, long long &minN)
{
    if (x >= 0)
    {
        maxP = max(maxP, x);
        minP = min(minP, x);
        FmaxP = FminP = true;
    }
    if (x <= 0)
    {
        maxN = -max(-maxN, -x);
        minN = -min(-minN, -x);
        FmaxN = FminN = true;
    }
}

const long long MOD = (1LL << 32);

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int m;
    cin >> m;
    for(int run = 0; run < m;run++){
        long long n, l, r;
        long long x, y, z;
        cin >> n >> l >> r >> x >> y >> z;
        vector<long long> b(n);
        vector<long long> a(n);
        cin >> b[0] >> b[1];
        for(int i=2;i<n;i++){
            b[i] = ((b[i - 2] * x) % MOD + (b[i - 1] * y) % MOD + z) % MOD;
            a[i] = ((long long)b[i] %(r - l + 1)) + l;
        }
        a[0] = ((long long)b[0] %(r - l + 1)) + l;
        a[1] = ((long long)b[1] %(r - l + 1)) + l;
        int zcount = 0;
        for (auto &i : a)
            if (i == 0)
                zcount++;
        if (zcount == a.size())
        {
            cout << "IMPOSSIBLE\n";
            continue;
        }
        long long ans = MX;
        if (zcount > 0)
        {
            ans = 0;
        }
        set<long long> se;
        long long maxP = 0, minN =-(2 * 1e9 + 1), maxN = 0, minP = 2 * 1e9 + 1;
        FmaxP = FmaxN = FminP = FminN = false;
        for(int i = n - 1;i >= 0; i--){
            if (a[i] > 0)
            {
                auto it = se.upper_bound(a[i]);
                if (it != se.end())
                {
                    ans = min(ans, a[i] * (*it));
                }
            }
            else if (a[i] < 0)
            {
                if (FmaxP)
                    ans = min(ans, a[i] * maxP);
                if (FminN && a[i] < minN)
                    ans = min(ans, a[i] * minN);
            }
            update(a[i], maxP, maxN, minP, minN);



            se.insert(a[i]);
            //cout << maxP << " " << maxN << " " << minP << " " << minN << endl;
        }
        if (ans == MX){
            cout << "IMPOSSIBLE\n";
        }else{
            cout << ans << "\n";
        }
    }
    return 0;
}
