#include <bits/stdc++.h>

using namespace std;

bool FmaxP, FmaxN, FminP, FminN;

void update(long long x, long long &maxP, long long &maxN, long long &minP, long long &minN)
{
    if (x >= 0)
    {
        maxP = max(maxP, x);
        minP = min(minP, x);
        FmaxP = FminP = true;
    }
    if (x <= 0)
    {
        maxN = -max(-maxN, -x);
        minN = -min(-minN, -x);
        FmaxN = FminN = true;
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int m;
    cin >> m;
    for(int run = 0; run < m;run++){
        long long n, l, r;
        unsigned int x, y, z;
        cin >> n >> l >> r >> x >> y >> z;
        vector<unsigned int> b(n);
        vector<long long> a(n);
        cin >> b[0] >> b[1];
        for(int i=2;i<n;i++){
            b[i] = (b[i - 2] * x + b[i - 1] * y + z);
            a[i] = ((long long)b[i] %(r - l + 1)) + l;
        }
        a[0] = ((long long)b[0] %(r - l + 1)) + l;
        a[1] = ((long long)b[1] %(r - l + 1)) + l;
        long long maxP = 0, minN =-(2 * 1e9 + 1), maxN = 0, minP = 2 * 1e9 + 1, ans = 4e+18 + 5;
        FmaxP = FmaxN = FminP = FminN = false;
        for(int i = n - 1;i >= 0; i--){
            if (FmaxP && a[i] < maxP)
                ans = min(ans, a[i] * maxP);
            if (FmaxN && a[i] < maxN)
                ans = min(ans, a[i] * maxN);
            if (FminP && a[i] < minP)
                ans = min(ans, a[i] * minP);
            if (FminN && a[i] < minN)
                ans = min(ans, a[i] * minN);
            update(a[i], maxP, maxN, minP, minN);
            //cout << maxP << " " << maxN << " " << minP << " " << minN << endl;
        }
        if (ans == 4e+18 + 5){
            cout << "IMPOSSIBLE\n";
        }else{
            cout << ans << "\n";
        }
    }
    return 0;
}
