#include<iostream>
#include <utility>
#include <vector>
#include <string>
#include <map>
#include <algorithm>

using namespace std;
typedef long long ll;
typedef pair<int,int> pii;

int main(){

    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int n, m;
    cin >> n >> m;

    if(n == 1) {
        cout << "NO";
        return 0;
    }

    vector<pii> ms1;
    vector<pii> ms2;

    for(int i = 0; i < m; i++) {
        int a,b;
        cin >> a >> b;
        a--, b--;
        if(a > b)
            swap(a,b);
        ms1.push_back(pii(a,b));
        ms2.push_back(pii(b,a));
    }
    sort(ms1.begin(),ms1.end());
    sort(ms2.begin(),ms2.end());
    auto erit1 = unique(ms1.begin(), ms1.end());
    auto erit2 = unique(ms2.begin(), ms2.end());
    ms1.erase(erit1, ms1.end());
    ms2.erase(erit2, ms2.end());

    bool ex = false;
    for(int i = n-1; i >= 0; i--) {
        auto it1 = lower_bound(ms1.begin(), ms1.end(), pii(i, 0));
        auto it2 = upper_bound(ms1.begin(), ms1.end(), pii(i, 999999999));

        auto it3 = lower_bound(ms2.begin(), ms2.end(), pii(i, 0));
        auto it4 = upper_bound(ms2.begin(), ms2.end(), pii(i, 999999999));
        int num1 = 0, num2 = 0;
        if(it1 != ms1.end() && it1->first == i)
            num1 = (it2 - it1);
        if(it3 != ms1.end() && it3->first == i)
            num2 = (it4 - it3);
        if(num2 + num1 < n - 1) {
            ex = true;
            cout << "YES\n";
            //for(int j = 1; j <= n; j++)
            //    cout << j << " ";
            //cout << "\n";
            for(int j = n - 1; j >= 0; j--) {
                if(i != j) {
                    int a = i;
                    int b = j;
                    if(a > b)
                        swap(a,b);
                    auto it5 = lower_bound(ms1.begin(), ms1.end(), pii(a, b));
                    auto it6 = lower_bound(ms2.begin(), ms2.end(), pii(b, a));
                    if((it5 == ms1.end() || (*it5) != pii(a,b)) && (it6 == ms2.end() || (*it6) != pii(b,a))) {
                        for(int j = 0; j < n; j++) {
                            if(j <= a || j >= b)
                                cout << j + 1 << " ";
                            //else if(j == b)
                                //cout << a + 1 << " ";
                            else
                                cout << n + j + 1 << " ";
                        }
                        cout << "\n";
                        for(int j = 0; j < n; j++) {
                            if(j <= a || j > b)
                                cout << j + 1 << " ";
                            else if(j == b)
                                cout << a + 1 << " ";
                            else
                                cout << n + j + 1 << " ";
                        }
                        cout << "\n";
                        return 0;
                    }
                }
            }
        }
    }

    cout << "NO";

    return 0;
}
