#include <bits/stdc++.h>

using namespace std;
using ull = uint64_t;
struct Query{
    ull len, hash, hash1, mask;

    bool operator<(const Query& oth) const {
        return tie(mask, len, hash, hash1) < tie(oth.mask, oth.len, oth.hash, oth.hash1);
    }

};
const ull BASE1 = 179, BASE2 = 239;
const ull MOD1 = 150000001, MOD2 = 1500000001;
int main(){
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    map<Query, vector<int>> ans;
    for (int i = 0; i < n; i++){
        string s, t;
        cin >> s >> t;
        ull mask = 0;
        for (char c : t) mask |= (1LL << (c - 'a'));
        while (mask & (1LL << (s.back() - 'a'))){
            s.pop_back();
        }
        Query q = {0, 0, mask};
        for (char c : s){
            q.hash = ((q.hash * BASE1) % MOD1 + c) % MOD1;
            q.hash1 = ((q.hash1 * BASE2) % MOD2 + c) % MOD2;
        }
        ans[q].push_back(i + 1);
    }
    cout << ans.size() << '\n';
    for (const auto& q : ans){
        cout << q.second.size() << ' ';
        for (int i = 0; i < q.second.size(); i++) cout << q.second[i] << " \n"[i == q.second.size() - 1];
    }
}