#include <bits/stdc++.h>

using namespace std;

int mas[8][8], used[8][8], used1[8][8];
pair <int, int> pred[8][8];
vector <pair <int, int> > vec;
int xs;
int ys;

void bfs(int x, int y, int nxt)
{
    if (mas[x][y] == 1 && used1[x][y] == 0)
    {
        xs = x;
        ys = y;
        return;
    }
    if (x - 2 >= 0 && y - 1 >= 0 && used[x - 2][y - 1] == 0)
    {
        used[x - 2][y - 1] = 1;
        pred[x - 2][y - 1].first = x;
        pred[x - 2][y - 1].second = y;
        vec.push_back(pair <int, int> (x - 2, y - 1));
    }
    if (x - 1 >= 0 && y - 2 >= 0 && used[x - 1][y - 2] == 0)
    {
        used[x - 1][y - 2] = 1;
        pred[x - 1][y - 2].first = x;
        pred[x - 1][y - 2].second = y;
        vec.push_back(pair <int, int> (x - 1, y - 2));
    }
    if (x + 1 < 8 && y - 2 >= 0 && used[x + 1][y - 2] == 0)
    {
        used[x + 1][y - 2] = 1;
        pred[x + 1][y - 2].first = x;
        pred[x + 1][y - 2].second = y;
        vec.push_back(pair <int, int> (x + 1, y - 2));
    }
    if (x + 2 < 8 && y - 1 >= 0 && used[x + 2][y - 1] == 0)
    {
        used[x + 2][y - 1] = 1;
        pred[x + 2][y - 1].first = x;
        pred[x + 2][y - 1].second = y;
        vec.push_back(pair <int, int> (x + 2, y - 1));
    }
    if (x + 2 < 8 && y + 1 < 8 && used[x + 2][y + 1] == 0)
    {
        used[x + 2][y + 1] = 1;
        pred[x + 2][y + 1].first = x;
        pred[x + 2][y + 1].second = y;
        vec.push_back(pair <int, int> (x + 2, y + 1));
    }
    if (x + 1 < 8 && y + 2 < 8 && used[x + 1][y + 2] == 0)
    {
        used[x + 1][y + 2] = 1;
        pred[x + 1][y + 2].first = x;
        pred[x + 1][y + 2].second = y;
        vec.push_back(pair <int, int> (x + 1, y + 2));
    }
    if (x - 1 >= 0 && y + 2 < 8 && used[x - 1][y + 2] == 0)
    {
        used[x - 1][y + 2] = 1;
        pred[x - 1][y + 2].first = x;
        pred[x - 1][y + 2].second = y;
        vec.push_back(pair <int, int> (x - 1, y + 2));
    }
    if (x - 2 >= 0 && y + 1 < 8 && used[x - 2][y + 1] == 0)
    {
        used[x - 2][y + 1] = 1;
        pred[x - 2][y + 1].first = x;
        pred[x - 2][y + 1].second = y;
        vec.push_back(pair <int, int> (x - 2, y + 1));
    }
    if (nxt < vec.size())
        bfs(vec[nxt].first, vec[nxt].second, nxt + 1);
    return;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);

    int k;
    cin >> k;
    string st;
    for (int i = 0; i < k; i++)
    {
        cin >> st;
        int l = st[0] - 'a';
        int r = st[1] - '1';
        mas[r][l] = 1;
    }
    vector <pair <pair <int, int>, pair <int, int> > > ans;
    for (int i = 0; i < k; i++)
    {
        xs = 0;
        ys = 0;
        used[i / 8][i % 8] = 1;
        bfs(i / 8, i % 8, 0);
        int x2 = xs;
        int y2 = ys;
        int xq = x2, yq = y2;
        vector <pair <pair <int, int>, pair <int, int> > > av;
        while (x2 != i / 8 || y2 != i % 8)
        {
           // cout << x2 << " " << y2 << endl;
            if (mas[pred[x2][y2].first][pred[x2][y2].second] == 1)
                av.push_back(pair <pair <int, int>, pair <int, int> > (pair <int, int> (x2, y2), pair <int, int> (pred[x2][y2].first, pred[x2][y2].second)));
            else
            {
                ans.push_back(pair <pair <int, int>, pair <int, int> > (pair <int, int> (x2, y2), pair <int, int> (pred[x2][y2].first, pred[x2][y2].second)));
                for (int j = av.size() - 1; j >= 0; j--)
                    ans.push_back(av[j]);
                av.clear();
                mas[xq][yq] = 0;
                mas[pred[x2][y2].first][pred[x2][y2].second] = 1;
                xq = pred[x2][y2].first;
                yq = pred[x2][y2].second;
            }
            int xxx = x2;
            x2 = pred[x2][y2].first;
            y2 = pred[xxx][y2].second;
        }
        mas[xq][yq] = 0;
        mas[x2][y2] = 1;
        for (int j = av.size() - 1; j >= 0; j--)
            ans.push_back(av[j]);
        used1[i / 8][i % 8] = 1;
        for (int i = 0; i < 8; i++)
            for (int j = 0; j < 8; j++)
            {
                used[i][j] = 0;
                pred[i][j].first = 0;
                pred[i][j].second = 0;
            }
        vec.clear();
    }
    cout << ans.size() << endl;
    for (int i = 0; i < ans.size(); i++)
    {
        int xf = ans[i].first.first;
        int yf = ans[i].first.second;
        cout << (char)(yf + 'a') << (char)(xf + '1') << "-";
        xf = ans[i].second.first;
        yf = ans[i].second.second;
        cout << (char)(yf + 'a') << (char)(xf + '1') << endl;
    }
    return 0;
}
