#include <iostream>
#include <vector>
#include <cstring>

using namespace std;

int main() {

    ios_base::sync_with_stdio(false);
    int n, m;
    cin >> n >> m;
    vector < vector < int > > g(n);
    vector < int  > a(n, -1);
    vector < int  > b(n, -1);
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        a--, b--;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    bool flag = true;
    for (int i = 0; i < n; i++) {
        if(g[i].size() == n - 1) continue;
        flag = false;
        vector < bool > used(n, 0);
        used[i] = true;
        for (auto x : g[i]) {
            used[x] = true;
        }
        a[i] = b[i] = 1;
        for (int j = 0; j < n; j++) {
            if(used[j]) continue;
            a[j] = 1;
            b[j] = 2;
            break;
        }
        break;
    }
    if(flag) {
        cout << "NO";
        return 0;
    }
    int cnt = 3;
    for (int i = 0; i < n; i++) {
        if(a[i] != -1) continue;
        a[i] = b[i] = cnt;
        cnt++;
    }
    cout << "YES" << endl;
    for(int i = 0; i < n; i++) {
        cout << b[i] << " ";
    }
    cout << endl;
    for (int i = 0; i < n; i++) {
        cout << a[i] << " ";
    }
}
