#include <iostream>
#include <vector>
#define int long long

using namespace std;

const int MAX_N = 2e7 + 7, M = (1ll << 32), INF = 5e18;
int b[MAX_N];

long long my_mod(int x, int m) {
    x %= m;
    if (x < 0) x += m;
    return x;
}

signed main() {
    int t;
    cin >> t;
    for (int cc = 0; cc < t; cc++) {
        int n, l, r, x, y, z, b1, b2;
        cin >> n >> l >> r >> x >> y >> z >> b1 >> b2;
        b[1] = b1;
        b[2] = b2;
        for (int i = 3; i <= n; i++) {
            b[i] = my_mod(b[i - 2] * x + b[i - 1] * y + z, M);
        }
        for (int i = 1; i <= n; i++) b[i] = my_mod(b[i], r - l + 1) + l;
        int flag = 0;
        for (int i = 1; i <= n; i++) {
            if (flag == 0 && b[i] < 0) flag = 1;
            if (flag == 1 && b[i] > 0) flag = 2;
        }
        if (flag != 2) {
            for (int i = 1; i <= n; i++) b[i] = abs(b[i]);
        }
        int cur_mini = b[1];
        int ans = INF;
        for (int i = 2; i <= n; i++) {
            if (cur_mini < b[i]) {
                ans = min(ans, b[i] * cur_mini);
            }
            cur_mini = min(cur_mini, b[i]);
        }
        if (ans == INF) cout << "IMPOSSIBLE" << endl;
        else cout << ans << endl;
    }
    return 0;
}
