//#include <bits/stdc++.h>

#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <string>
#include <map>

using namespace std;

const int SZ = 1e5 + 10;

void fast() {
	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);
}

template<class T, class U> inline void checkmin(T &x, U y) { if (y < x) x = y; }
template<class T, class U> inline void checkmax(T &x, U y) { if (y > x) x = y; }
#define sz(a) int(a.size())
#define ll long long
#define pb push_back

string cut(string s) {
	bool flag = false;
	string news = "";
	for (auto &i : s) {
		if (i == '}') flag = false;
		if (flag) news += i;
		if (i == '{') flag = true;
	}
	return news;
}

signed main() {
	fast();
	string s;
	vector<string> right;
	while (getline(cin, s)) {
		if (s == "\\begin{thebibliography}{99}") break;
		string news;
		bool flag = false;
		for (auto i : s) {
			if (i == '}') {
				flag = false;
				right.pb(news);
				news = "";
			}
			if (flag) news += i;
			if (i == '{') flag = true;
		}
	}
	vector<string> check;
	map<string, string> st;
	while (getline(cin, s)) {
		if (s == "\\end{thebibliography}") break;
		string news = cut(s);
		check.pb(news);
		st[news] = s;
	}
	bool flag = true;
	for (int i = 0; i < sz(right); ++i)
		flag = flag && right[i] == check[i];
	if (flag) cout << "Correct";
	else {
		cout << "Incorrect\n";
		cout << "\\begin{thebibliography}{99}\n";
		for (auto i : right) cout << st[i] << '\n';
		cout << "\\end{thebibliography}\n";
	}
	return 0;
}