//#include <bits/stdc++.h>
#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
using namespace std;
#define int long long

void fast() {
	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);
}

const int N = 1e5;
vector<int> g[N];
int used1[N], used2[N], used3[N + 1];
int nxt = 1;

void dfs(int v) {
	used1[v] = nxt++;
	for (int to : g[v]) {
		if (!used1[to]) {
			dfs(to);
		}
	}
}

void dfs2(int v) {
	for (int to : g[v]) {
		if (!used2[to]) {
			used2[to] = used2[v] + 1;
			dfs2(to);
		}
	}
}

signed main() {
	int n, m;
	cin >> n >> m;
	for (int i = 0; i < m; i++) {
		int a, b;
		cin >> a >> b;
		a--; b--;
		g[a].push_back(b);
		g[b].push_back(a);
	}
	for (int i = 0; i < n; i++) {
		if (!used1[i]) {
			dfs(i);
		}
	}
	for (int i = 0; i < n; i++) {
		if (!used2[i]) {
			used2[i] = 1;
			dfs2(i);
		}
	}
	bool fl = false;

	for (int i = 0; i < n; i++) {
		if (used3[used2[i]]) fl = true;
		used3[used2[i]] = true;
	}
	if (!fl) {
		cout << "NO";
		return 0;
	}
	cout << "YES" << '\n';
	for (int i = 0; i < n; i++) {
		cout << used1[i] << ' ';
	}
	cout << '\n';
	for (int i = 0; i < n; i++) {
		cout << used2[i] << ' ';
	}
	return 0;
}
