//#include <bits/stdc++.h>
#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
using namespace std;

typedef long long ll;

const ll SZ = 1e7 + 10;
const ll MOD = 1LL << 32;
const ll INF = 5e18;

void fast() {
	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);
}

template<class T, class U> inline void checkmin(T &x, U y) { if (y < x) x = y; }
#define sz(a) int(a.size())

/*
void solve() {
	int n, l, r;
	unsigned int x, y, z, b1, b2;
	cin >> n >> l >> r >> x >> y >> z >> b1 >> b2;
	vector<unsigned int> b(n);
	b[0] = b1;
	b[1] = b2;
	for (int i = 2; i < n; ++i)
		b[i] = b[i - 2] * x + b[i - 1] * y + z;
	vector<int> a(n);
	int mx = r - l + 1;
	for (int i = 0; i < n; ++i)
		a[i] = (ll)b[i] % mx + l;
	ll ans = INF;
	set<int> st;
	for (auto i : a) {
		st.insert(i);
		if (i > 0) {
			auto it = st.begin();
			if (*it < i)
				if (sz(st) > 0)
					checkmin(ans, (ll)i * (ll)(*it));
		} else {
			if (sz(st) > 0) {
				auto it = st.find(i);
				if (it == st.begin()) continue;
				--it;
				if (*it < i)
					checkmin(ans, (ll)i * (ll)(*it));
			}
		}
	}
	if (ans == INF) cout << "IMPOSSIBLE\n";
	else cout << ans << '\n';
}
*/

int n = 0;
int q_now = 1;
vector<ll> a;
vector<ll> h;
vector<int> die;

void action1()
{
	n++;
	a.push_back(1);
	h.push_back(1);
	die.push_back(-1);
}

void action2()
{
	int x;
	cin >> x;
	a[x - 1] *= 2LL;
}

void action3()
{
	int x;
	cin >> x;
	h[x - 1] *= 2LL;
}

void action4()
{
	int x;
	cin >> x;
	n++;
	a.push_back(a[x - 1]);
	h.push_back(h[x - 1]);
	die.push_back(die[x - 1]);
	if (die.back() != -1)
		die.back() = q_now;
}

void action5()
{
	int x, y;
	cin >> x >> y;
	if (die[x - 1] != -1 || die[y - 1] != -1)
		return;
	h[x - 1] -= a[y - 1];
	h[y - 1] -= a[x - 1];
	if (h[x - 1] <= 0)
		die[x - 1] = q_now;
	if (h[y - 1] <= 0)
		die[y - 1] = q_now;
}

signed main() {
	fast();
	int q;
	cin >> q;
	while (q_now <= q) {
		int type;
		cin >> type;
		if (type == 1)
			action1();
		if (type == 2)
			action2();
		if (type == 3)
			action3();
		if (type == 4)
			action4();
		if (type == 5)
			action5();
		q_now++;
	}
	cout << n << "\n";
	for (auto x : die)
		cout << x << ' ';
	/*
	ll t;
	cin >> t;
	while (t--) solve();
	*/
	/*
	ll n, m;
	cin >> n >> m;
	vector<ll> arr(n), brr(n);
	vector<bool> used(n);
	for (int i = 0; i < m; ++i) {
		int a, b;
		cin >> a >> b;
		--a, --b;
		used[a] = used[b] = true;
	}
	int cnt = 1;
	for (int i = 0; i < n; ++i)
		if (used[i]) arr[i] = brr[i] = cnt++;
	for (int i = 0; i < n; ++i)
		if (!used[i]) arr[i] = cnt++, brr[i] = 1;
	set<int> st;
	for (auto i : brr) st.insert(i);
	if (st.size() == n || n == 1) cout << "NO";
	else {
		cout << "YES\n";
		for (auto i : arr) cout << i << ' ';
		cout << '\n';
		for (auto &i : brr) cout << i << ' ';
	}
	cout << endl;
	*/
	return 0;
}
