#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const ll SZ = 1e7 + 10;
const ll MOD = 1LL << 32;
const ll INF = 5e18;

void fast() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
}

ll n, L, R, x, y, z, b1, b2;
ll b[SZ];
ll a[SZ];

void solve()
{
    cin >> n >> L >> R >> x >> y >> z >> b[0] >> b[1];
    for (ll i = 2; i < n; i++)
        b[i] = (b[i - 2] * x + b[i - 1] * y + z) % MOD;
    for (ll i = 0; i < n; i++)
        a[i] = b[i] % (R - L + 1) + L;
    ll res = INF;
    ll min_now = a[0];
    for (ll i = 1; i < n; i++) {
        if (min_now >= a[i]) {
            min_now = a[i];
            continue;
        }
        res = min(res, min_now * a[i]);
    }
    if (res == INF)
        cout << "IMPOSSIBLE\n";
    else
        cout << res << "\n";
}

signed main() {
    fast();
    ll q;
    cin >> q;
    for (ll i = 0; i < q; i++)
        solve();
    return 0;
}
