#include <bits/stdc++.h>

#pragma GCC optimaze("-O3")

//#define int long long
//#define double long double

typedef long long ll;

using namespace std;


void flags() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cerr.tie(0);
    cout.setf(ios::fixed, ios::floatfield);
    cerr.setf(ios::fixed, ios::floatfield);
    cout.precision(16);
    cerr.precision(4);
    srand(time(0));
    return;
}

mt19937 rnd(time(0));

void solution() {
    ll t, n, l, r, x, y, z, b1, b2;
    cin >> t;
    for (int i = 0; i < t; i++) {
        cin >> n;
        cin >> l >> r >> x >> y >> z >> b1 >> b2;
        vector <ll> b(n);
        b[0] = b1;
        b[1] = b2;
        ll mod = 1LL << 32;
        for (int j = 2; j < n; j++) {
            b[j] = (b[j - 2] * x + b[j - 1] * y + z);
            b[j] %= mod;
        }
        vector <ll> a(n);
        for (int j = 0; j < n; j++) {
            a[j] = (b[j] % (r - l + 1)) + l;
        }
        vector <vector <ll> > sp(n + 1);
        for (int j = 0; j < sp.size() ; j++) {
            sp[j].resize(log(n + 1) / log(2) + 2);
        }
        for (int j = 0; j < n; j++) {
            sp[j][0] = a[j];
        }

        for (int j = 1; j < 32; j++) {
            if ((1 << j) > n)
                break;
            for (int k = 0; k < n; k++) {
                if (k + (1 << j) > n)
                    break;
                sp[k][j] = min(sp[k][j - 1], sp[k + (1 << (j - 1))][j - 1]);
            }
        }
        ll mn(9e18);
        ll ans(9e18);
        for (int j = 1; j < n; j++) {
            int k = log(j) / log(2);
            mn = min(sp[0][k], sp[j - (1 << k)][k]);
            if (mn >= a[j])
                continue;
            ans = min(ans, a[j] * mn);
        }
        if (ans == 9e18)
            cout << "IMPOSSIBLE" << endl;
        else
            cout << ans << endl;
    }
    return;
}




signed main() {
    #ifdef qwerty
        freopen("input.txt", "r", stdin);
        //freopen("output.txt", "w", stdout);
        //cin >> S1 >> S2;
        flags();
        //f();
        solution();
        //check();
    #else
        flags();
        solution();
    #endif
    return 0;
}
