#include <bits/stdc++.h>

using namespace std;

const int MAXN = 1e5 + 7;

int n, m;
vector <int> a[MAXN];

struct Node {
  	int sum;
	Node *l, *r;
	Node() {
	    sum = 0;
	    l = r = NULL;
	}	
};

int delt[MAXN];
Node *tree[MAXN];

int sum(Node *t) {
    if (!t) {
        return 0;
    }	
    else {
        return t->sum;
    }	
}	

void add(Node *t, int tl, int tr, int x) {
	if (tl == tr) {
	    t->sum++;
	    return;
	}	
	int tm = (tl + tr) >> 1;
	if (x <= tm) {
	    if (!t->l) {
	        t->l = new Node();
	    }	
	    add(t->l, tl, tm, x);
	}	
	else {
	    if (!t->r) {
            t->r = new Node();
        }	
        add(t->r, tm + 1, tr, x);
	}	
	t->sum = sum(t->l) + sum(t->r);
}

void del(Node *t, int tl, int tr, int x) {
	if (tl == tr) {
	    t->sum--;
	    return;
	}	
	int tm = (tl + tr) >> 1;
	if (x <= tm) {
	    del(t->l, tl, tm, x);
	}	
	else {
        del(t->r, tm + 1, tr, x);
	}	
	t->sum = sum(t->l) + sum(t->r);
}	

int per[MAXN];

bool comp(int i, int j) {
    return a[i].size() < a[j].size();
}	

int getl(Node *t) {
	if (!t) {
	    return 0;
	}	
	else if (!t->l) {
	    return 0;
	}	
	else {
	    return t->l->sum;
	}	
}

int getr(Node *t) {
	if (!t) {
	    return 0;
	}	
	else if (!t->r) {
	    return 0;
	}	
	else {
	    return t->r->sum;
	}	
}	

Node *sonl(Node *t) {
    if (!t) {
        return NULL;
    }	
    else {
        return t->l;
    }	
}	

Node *sonr(Node *t) {
    if (!t) {
        return NULL;
    }	
    else {
        return t->r;
    }	
}	

int get(Node *a, Node *b, int tl, int tr) {
    if (tl == tr) {
        return tl;
    }	
    int tm = (tl + tr) >> 1;
    if (getl(a) > getl(b)) {
        return get(sonl(a), sonl(b), tl, tm);
    }	
    else {
        return get(sonr(a), sonr(b), tm + 1, tr);
    }	
}	

struct Kek {
  	int i, j, x;
};

vector <Kek> ans;

int cnt = 0;
void kek(int i, int j) {
	++cnt;
	int x = get(tree[i], tree[j], 0, MAXN);
	del(tree[i], 0, MAXN, x);
	add(tree[j], 0, MAXN, x);
	ans.push_back({i, j, x});
}

signed main() {
	#ifdef HOME
		freopen("input.txt", "r", stdin);
	#endif

	//ios_base::sync_with_stdio(0);
	//cin.tie(0);
	
	cin >> n >> m;
	for (int i = 0; i < n; ++i) {
	  	int t;
	  	cin >> t;
	  	a[i].resize(t);
	  	tree[i] = new Node();
	  	for (int j = 0; j < t; ++j) {
	  	    cin >> a[i][j];
	  	    add(tree[i], 0, MAXN, a[i][j]);
	  	}	
	}	
	
	int sum = 0;
	for (int i = 0; i < n; ++i) {
	    sum += a[i].size();
	}	
	
	for (int i = 0; i < n; ++i) {
	    per[i] = i;
	}	
	sort(per, per + n, comp);

	int t = sum / n;
	for (int i = 0; i < n; ++i) {
		if (i < n - sum % n) {
		    delt[i] = t - a[i].size();
		}
		else {
			delt[i] = t + 1 - a[i].size();
		}	
	}

	vector <int> v1, v2;
	for (int i = 0; i < n; ++i) {
	    if (delt[i] < 0) {
	        v1.push_back(i);
	    }	
	    else if (delt[i] > 0) {
	     	v2.push_back(i);
	    }
	}	

	while (v1.size() && v2.size()) {
		//cout << "KEK " << v1.size() << ' ' << v2.size() << '\n';
		//cout << v1.back() << ' ' << v2.back() << '\n';	
		kek(v1.back(), v2.back());
		++delt[v1.back()];
		--delt[v2.back()];
		while (v1.size() && delt[v1.back()] == 0) {
		    v1.pop_back();
		}	
		while (v2.size() && delt[v2.back()] == 0) {
		    v2.pop_back();
		}
	}	
	
	cout << ans.size() << '\n';
	for (auto e : ans) {
		cout << e.i + 1 << ' ' << e.j + 1 << ' ' << e.x << '\n';
	}

    return 0;
}	