#include <bits/stdc++.h>

using namespace std;

const int MAXN = 1e5 + 7;

int n, m;
int a[MAXN], b[MAXN];

void print(int u, int v) {
	int x = 3;
	for (int i = 0; i < n; ++i) {
	    if (i == u) {
	    	a[i] = 1;
	    	b[i] = 1;
	    }
	    else if (i == v) {
	        a[i] = 2;
	        b[i] = 1;
	    }	
	    else {	
			a[i] = b[i] = x++;
		}
	}	
	cout << "YES\n";
	for (int i = 0; i < n; ++i) {
	    cout << a[i] << ' ';
	}	
	cout << '\n';
	for (int i = 0; i < n; ++i) {
	    cout << b[i] << ' ';
	}	
	cout << '\n';
	exit(0);
}	

signed main() {
	#ifdef HOME
		freopen("input.txt", "r", stdin);
	#endif

	ios_base::sync_with_stdio(0);
	cin.tie(0);
	
	cin >> n >> m;
	
	if (m == (n * (n - 1)) / 2) {
		cout << "NO\n";
		exit(0);
	}	

	set <pair <int, int> > ms;
	for (int i = 0; i < m; ++i) {
	    int u, v;
	    cin >> u >> v;
	    --u; --v;
	    if (v < u) {
	        swap(u, v);
	    }	
	    ms.insert({u, v});
	}	

	for (int i = 0; i < n; ++i) {
	 	for (int j = i + 1; j < n; ++j) {
	 		if (ms.find({i, j}) == ms.end()) {
	 		    print(i, j);
	 		}	
	 	}
	}

    return 0;
}	