#include <bits/stdc++.h>

using namespace std;

#define int long long

const int MAXN = 2007;

map <pair <pair <int, int>, int> , int> d;

int n;
int cnt = 0;
int get(int i, int j, int k) {
	if (j < i && j < k) {
	    swap(i, j);
	}	
	if (k < i && k < j) {
	 	swap(i, k);
	}
	if (i > j && i > k) {
	    swap(i, k);
	}	
	if (j > i && j > k) {
	 	swap(j, k);
	}

	pair <pair <int, int>, int> key = {{i, j}, k};
	if (d.find(key) == d.end()) {
		++cnt;
		if (cnt > 4 * n) {
		    exit(1);
		}	
		cout << "? " << i + 1 << ' ' << j + 1 << ' ' << k + 1 << '\n';
		fflush(stdout);
		int ans;
		cin >> ans;
		return d[key] = ans;
	}
	else {
	    return d[key];
	}	
}

pair <int, int> get4(vector <int> a) {
	vector <int> all = {get(a[3], a[1], a[2]), get(a[0], a[2], a[3]), get(a[0], a[1], a[3]), get(a[1], a[2], a[0])};
	int p1 = -1, p2 = -1;
	for (int i = 0; i < 4; ++i) {
		for (int j = i + 1; j < 4; ++j) {
		    if (all[i] == all[j]) {
		        p1 = i;
		        p2 = j;
		        break;
		    }	
		}	
	}
	vector <int> pina;
	for (int i = 0; i < 4; ++i) {
	   	if (i != p1 && i != p2) {
	   	    pina.push_back(i);
	   	}	
	}	
	if (all[pina[0]] < all[pina[1]]) {
	    return {a[pina[1]], a[pina[0]]};
	}	
	else {
	    return {a[pina[0]], a[pina[1]]};
	}	
}	

vector <int> kikos(vector <int> a, int p) {
    vector <int> ans;
    for (int i = 0; i < a.size(); ++i) {
        if (i != p) {
            ans.push_back(a[i]);
        }	
    }	
    return ans;
}	

void msort(vector <int> &a) {
	vector <pair <int, int> > t;
	for (int i = 0; i < 5; ++i) {
		t.push_back(get4(kikos(a, i)));
	}	
	
	vector <int> cntmin(5), cntmax(5);
	for (int i = 0; i < 5; ++i) {
	    for (auto e : t) {
	        cntmin[i] += (e.first == a[i]);
	        cntmax[i] += (e.second == a[i]);
	    }	
	}	

	int num1 = 0;
	for (int i = 0; i < 5; ++i) {
	    if (cntmin[i] > cntmin[num1]) {
	        num1 = i;
	    }	
	}	

	int num5 = 0;
	for (int i = 0; i < 5; ++i) {
	    if (cntmax[i] > cntmax[num5]) {
	        num5 = i;
	    }	
	}	

	int num2 = -1;
	for (int i = 0; i < 5; ++i) {
	    if (cntmin[i] && i != num1) {
	        num2 = i;
	    }	
	}	

	int num4 = -1;
	for (int i = 0; i < 5; ++i) {
		if (cntmax[i] && i != num5) {
		    num4 = i;
		}	
   	}

   	int num3 = 10 - num1 - num2 - num4 - num5;
   	a = {a[num1], a[num2], a[num3], a[num4], a[num5]};
}	

int ans[MAXN];

void get5() {
	vector <int> a = {0, 1, 2, 3, 4};
	msort(a);
	ans[a[0]] = (get(a[0], a[2], a[4]) + get(a[0], a[1], a[2]) - get(a[2], a[3], a[4])) / 2;
	ans[a[4]] = (get(a[0], a[2], a[4]) + get(a[2], a[3], a[4]) - get(a[0], a[1], a[2])) / 2;
	ans[a[2]] = get(a[0], a[1], a[2]) - ans[a[0]];
	ans[a[1]] = get(a[1], a[2], a[4]) - ans[a[4]];
	ans[a[3]] = get(a[0], a[1], a[3]) - ans[a[0]];
}

void add(int i) {
	auto para = get4({0, 1, 2, i});
	if (para.first == i) {
		ans[i] = get(0, 1, i) - max(ans[0], ans[1]);
	}	
	else if (para.second == i) {
		ans[i] = get(0, 1, i) - min(ans[0], ans[1]);
	}
	else {
		int mn = -1, mx = -1;
		if (ans[0] <= ans[1] && ans[0] <= ans[2]) {
			mn = 0;
		}	
		if (ans[1] <= ans[0] && ans[1] <= ans[2]) {
		    mn = 1;
		}	
		if (ans[2] <= ans[0] && ans[2] <= ans[1]) {
		   	mn = 2;
		}	

		if (ans[0] >= ans[1] && ans[0] >= ans[2]) {
			mx = 0;
		}	
		if (ans[1] >= ans[0] && ans[1] >= ans[2]) {
		    mx = 1;
		}	
		if (ans[2] >= ans[0] && ans[2] >= ans[1]) {
		   	mx = 2;
		}	

		int mid = -1;
		for (int i = 0; i < 3; ++i) {
			if (i != mn && i != mx) {
			    mid = i;
			    break;
			}	
		}	

		if (get(mn, mid, i) == ans[mn] + ans[mid]) {
		    ans[i] = get(i, mid, mx) - ans[mx];
		}	
		else {
		    ans[i] = get(i, mid, mn) - ans[mn];
		}	
	}	
}

signed main() {
	cin >> n;

	get5();
	for (int i = 5; i < n; ++i) {
	    add(i);
	}	

	cout << "! ";
	for (int i = 0; i < n; ++i) {
		cout << ans[i] << ' ';
	}	
	fflush(stdout);

    return 0;
}	