#include <bits/stdc++.h>

using namespace std;

#define int long long
              
const int BASE = 129;
const int MAXN = 1e6 + 7;
const int MOD = 1000 * 1000 * 1000 + 7;

int mod(int n) {
    return (n % MOD + MOD) % MOD;
}	

int n;
string a[MAXN], b[MAXN];
int mask[MAXN];
int h[MAXN];
int per[MAXN];
pair <int, int> t[MAXN];

bool check(int mask, char c) {
 	int i = c - 'a';
 	return ((mask >> i) & 1);
}

bool comp(int i, int j) {
    return t[i] < t[j];
}	

signed main() {
	#ifdef HOME
		freopen("input.txt", "r", stdin);
	#endif

	ios_base::sync_with_stdio(0);
	cin.tie(0);

	cin >> n;
	for (int i = 0; i < n; ++i) {
	    cin >> a[i] >> b[i];
	}	

	for (int i = 0; i < n; ++i) {
		for (char c : b[i]) {
			mask[i] |= 1 << (c - 'a');
        }	
        while (a[i].size() && check(mask[i], a[i].back())) {
            a[i].pop_back();
        }	
	}	
	
	for (int i = 0; i < n; ++i) {
		h[i] = 0;
		for (char c : a[i]) {
		    h[i] = mod(h[i] * BASE + c);
		}	
	}	
	
	for (int i = 0; i < n; ++i) {
	    t[i] = {h[i], mask[i]};
	}	
	
	for (int i = 0; i < n; ++i) {
	    per[i] = i;
	}	

	sort(per, per + n, comp);

	vector <vector <int> > ans;
	for (int i = 0; i < n; ++i) {
	    if (i == 0 || t[per[i - 1]] != t[per[i]]) {
	    	ans.push_back({});
	    }	
	    ans.back().push_back(per[i]);
	}	
	
	cout << ans.size() << '\n';
	for (auto e : ans) {
		cout << e.size() << ' ';
	    for (int ne : e) {
	        cout << ne + 1 << ' ';
	    }	
	    cout << '\n';
	}	

    return 0;
}	