#include <iostream>
#include <math.h>
#include <vector>
#include <set>
#include <map>
#include <stack>
#include <algorithm>
#include <string>
#include <iomanip>
#define fast_io ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0)
typedef long long ll;
using namespace std;
vector<vector<ll>> g;
vector<ll> used, cmp, ans1, ans2;
ll k = 0;
map<ll, ll> kol;
void dfs(ll v) {
	used[v] = 1;
	cmp[v] = k;
	kol[k]++;
	for (auto to : g[v]) {
		if (!used[to]) {
			dfs(to);
		}
	}
}
ll q = 0;
void dfs2(ll v) {
	used[v] = 1;
	ans1[v] = k++;
	ans2[v] = q++;
	for (auto to : g[v]) {
		if (!used[to]) {
			dfs2(to);
		}
	}
}
int main() {
	fast_io;
	ll n, m;
	cin >> n >> m;
	if (n == 1) {
		cout << "NO";
		return 0;
	}
	g.resize(n);
	cmp.resize(n);
	used.resize(n);
	ans1.resize(n);
	ans2.resize(n);
	vector<set<ll>> kekek(n);
	for (int i = 0; i < m; i++)
	{
		ll x, y;
		cin >> x >> y;
		x--;
		y--;
		g[x].push_back(y);
		g[y].push_back(x);
		kekek[x].insert(y);
		kekek[y].insert(x);
	}
	for (int i = 0; i < n; i++)
		if (!used[i]) {
			dfs(i);
			k++;
		}
	for (int i = 0; i < n; i++) {
		if (kol[cmp[i]] != g[i].size() + 1) {
			ll a = i;
			for (int j = i + 1; j < n; j++)
				if (cmp[i] == cmp[j] && kekek[i].find(j) == kekek[i].end()) {
					ll b = j;
					ans1[i] = ans2[i] = ans2[j] = 1;
					ans1[j] = 2;
					ll k = 3;
					for (int i = 0; i < n; i++)
						if (!ans1[i])
							ans1[i] = ans2[i] = k++;
					cout << "YES\n";
					for (auto i : ans1)
						cout << i << ' ';
					cout << "\n";
					for (auto i : ans2)
						cout << i << ' ';
					return 0;
				}
		}
	}
	if (k == 1) {
		cout << "NO";
		return 0;
	}
	used.assign(n, 0);
	k = 1;
	for (int i = 0; i < n; i++) {
		if (!used[i])
		{
			q = 1;
			dfs2(i);
		}
	}
	cout << "YES\n";
	for (auto i : ans1)
		cout << i << ' ';
	cout << "\n";
	for (auto i : ans2)
		cout << i << ' ';
	return 0;
}