#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <math.h>
#include <vector>
#include <set>
#include <map>
#include <stack>
#include <algorithm>
#include <string>
#include <iomanip>
#include <unordered_map>
#define fast_io ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0)


typedef long long ll;
using namespace std;


int main()
{
	fast_io;
	
	//freopen("input.txt", "r", stdin);

	ll n;
	cin >> n;

	map < pair<string, vector<ll>>, vector<ll>>mapp;

	for (int i = 0; i < n; ++i)
	{
		string s1, s2;

		cin >> s1 >> s2;

		vector<ll> dic(27);

		for(char c : s2)
			dic[c - 'a'] = 1;
		
		while (s1.size() > 0)
		{
			if (dic[s1.back() - 'a'] != 0)
			{
				s1.pop_back();
			}
			else
			{
				break;
			}
		}

		mapp[make_pair(s1, dic)].push_back(i);
	}

	cout << mapp.size() << endl;

	for (auto in : mapp)
	{
		cout << (ll)in.second.size() << " ";

		for (ll ans : in.second)
		{
			cout << ans + 1 << " ";
		}

		puts("");
	}

	return 0;
}