#include <bits/stdc++.h>

using namespace std;

using ll = long long int;
using ull = unsigned long long int;
using dd = double;
using ldd = long double;

#define ss second
#define ff first

#ifdef HOME
    #define debug(x) cout << #x << " " << x << endl;
    #define debug_v(x) cout << #x << " "; for(auto ii : x) cout << ii << " "; cout << endl;
    #define PO cout << "PO" << endl;
    #define OL cout << "OL" << endl;
#else
    #define debug(x) 0;
    #define debug_v(x) 0;
    #define PO 0;
    #define OL 0;
#endif // HOME

ll mod = 1e9 + 9;
ll p = 37;

void create(pair<ll, string>& a)
{
    for (int i = 9; a.ss[i] != '}'; ++i)
    {
        a.ff = (a.ff * p + a.ss[i] - 'a' + 1) % mod;
    }
}

ll h(string& t)
{
    ll ans = 0;
    for (int i = 0; i < t.size(); ++i)
        ans = (ans * p + t[i] - 'a' + 1) % mod;
    return ans;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cout.tie(0);
    cin.tie(0);

    string in;
    string all = "";
    vector<pair<ll, string>> ans;
    multiset<pair<int, int>> have;
    string parse;
    parse += char(92);
    parse += "begin{thebibliography}{99}";
   // cout << parse << endl;
    while (getline(cin, in))
    {
        PO;
        if (in == parse)
        {
            ans.push_back({0, parse});
            break;
        }
        all += in;
    }
    while (getline(cin, in))
    {
        if (in == "--JOPA--")
            break;
        ans.push_back({0, in});
    }
    for (int i = 1; i < ans.size() - 1; ++i)
    {
        create(ans[i]);
        have.insert({ans[i].ff, i});
    }
    vector<ll> was;
    for (int i = 0; i < all.size(); ++i)
    {
        if (all[i] != 92)
            continue;
        string t = "";
        i += 6;
        for (; all[i] != '}'; ++i)
            t += all[i];
        was.push_back(h(t));
    }
    debug_v(was);
   // for (int i = 0; i < ans.size(); ++i)
   // {
   //     cout << ans[i].ff << " " <<ans[i].ss << endl;
   // }

    bool g = 1;
    for (int i = 0; i < was.size(); ++i)
    {
        if (was[i] != ans[i + 1].ff)
        {
            g = 0;
            break;
        }
    }
    if (g)
    {
        cout << "Correct";
        return 0;
    }
    cout << "Incorrect" << '\n';
    vector<string> answer;
    cout << ans[0].ss << '\n';
    for (int i = 0; i < was.size(); ++i)
    {
        auto j = have.lower_bound({was[i], -1});
        have.erase(j);
        cout << ans[j->ss].ss << '\n';
    }
    cout << ans.back().ss;
}

