#include <bits/stdc++.h>

using namespace std;

using ll = long long int;
using ull = unsigned long long int;
using dd = double;
using ldd = long double;

#ifdef HOME
    #define debug(x) cout << #x << " " << x << endl;
    #define debug_v(x) cout << #x << " " << for(auto ii : x) cout << ii << " "; cout << endl;
    #define PO cout << "PO" << endl;
    #define OL cout << "OL" << endl;
#else
    #define debug(x) 0;
    #define debug_v(x) 0;
    #define PO 0;
    #define OL 0;
#endif // HOME

const ll N = 1e7;
const ll inf = 4e18 + 1;

ll a[N], b[N], c[N];
ll n;

ll o () {
    ll m = a[n - 1];
    ll ans = inf;
    for (int i = n - 2; i >= 0; --i)
    {
        if (a[i] < m && a[i] <= 0)
        {
            ans = min(ans, a[i] * m);
        }

        if (a[i] > m)
            m = a[i];
    }
    return ans;
}

ll p() {
    ll ans = inf;
    ll m = a[n - 1];
    for (int i = n - 2; i >= 0; --i) {
        if (a[i] < m && a[i] >= 0)
        {
            ans = min(ans, m * a[i]);
            m = a[i];
        }
    }
    return ans;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cout.tie(0);
    cin.tie(0);
    int t;
    cin >> t;
    for (int e = 0; e < t; e++) {
        ll l, r, x, y, z, b1, b2;
        cin >> n >> l >> r >> x >> y >> z >> b1 >> b2;
        b[0] = b1;
        b[1] = b2;
        a[0] = (b[0] % (r - l + 1)) + l;
        a[1] = (b[1] % (r - l + 1)) + l;
        for (int i = 2; i < n; ++i) {
            b[i] = (b[i - 2] * x + b[i - 1] * y + z) % ((ll)1 << 32);
            a[i] = (b[i] % (r - l + 1)) + l;
        }
        ll ans = min(o(), p());
        ans == inf? cout << "IMPOSSIBLE" << "\n" : cout << ans << "\n";
        //cout << min(o(), p()) << "\n";
    }
    return 0;
}


