#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

#define x first
#define y second

#define pb push_back
#define mp make_pair
#define sz(s) (int)s.size()
#define all(s) s.begin(),s.end()

int n, m, mark, cur= 1;
vector<vector<int> > A, Mark, New;
vector<pii> P;
vector<int> Cnt, Ans1, Ans2;
set<pii> S;
vector<char> Vis;

void dfs(int i, int prev){
    Vis[i]= true;
    P[i].x= P[prev].x + 1;
    P[i].y= P[i].x;
    for (int j= 0; j < A[i].size(); ++j){
        int v= A[i][j];
        if (!Vis[v]){
            dfs(v, i);

            if (P[v].y > P[i].x){
                S.insert(pii(i, v));
                S.insert(pii(v, i));
            }
            P[i].y= min(P[i].y, P[v].y);
        }else if (v != prev){
            P[i].y= min(P[i].y, P[v].x);
        }
    }
}

void Dfs(int i){
    Vis[i]= true;
    Cnt[mark]++;
    Mark[mark].push_back(i);

    for (int j= 0; j < A[i].size(); ++j){
        int v= A[i][j];
        if (!Vis[v] && S.find(pii(i, v)) == S.end()){
            Dfs(v);
        }
    }
}

void DFs(int i, int &dep){
    Vis[i]= true;
    for (int j= 0; j < A[i].size(); ++j){
        if (!Vis[A[i][j]]){
            dep++;
            if (dep > 1){
                return;
            }
            DFs(A[i][j], dep);
        }
    }
}

void DDfs(int i){
    Vis[i]= true;
    for (int j= 0; j < A[i].size(); ++j){
        if (!Vis[A[i][j]]){
            DDfs(A[i][j]);
        }
    }
}

bool Cond(){
    Vis.resize(n + 1, false);
    for (int i= 1; i <= n; ++i){
        if (!Vis[i]){
            dfs(i, 0);
        }
    }

    fill(Vis.begin(), Vis.end(), false);

    mark= 0;
    Cnt.push_back(0);
    Mark.resize(1);
    for (int i= 1; i <= n; ++i){
        if (!Vis[i]){
            mark++;
            Cnt.push_back(0);
            Mark.push_back(vector<int>(0));
            Dfs(i);
            if (Cnt[mark] > 1){
                return false;
            }
        }
    }

    fill(Vis.begin(), Vis.end(), false);
    mark= 0;
    for (int i= 1; i <= n; ++i){
        if (!Vis[i]){
            mark++;
            DDfs(i);
        }
    }

    if (mark > 1){
        return true;
    }else if (mark == 1){
        fill(Vis.begin(), Vis.end(), false);
        int dep= 0;
        DFs(1, dep);
        return dep > 1;
    }
}

void DFS(int i){
    Vis[i]= true;
    Ans1[i]= cur;
    cur++;
    for (int j= 0; j < A[i].size(); ++j){
        int v= A[i][j];
        if (!Vis[v]){
            DFS(v);
        }
    }
}

void DFS1(int i){
    Vis[i]= true;
    Ans2[i]= cur;
    cur++;
    for (int j= 0; j < A[i].size(); ++j){
        int v= A[i][j];
        if (!Vis[v]){
            DFS1(v);
        }
    }
}

signed main() {
    ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    cin >> n >> m;
    A.resize(n + 1);
    P.resize(n + 1);

    if (n == 1){
        cout << "NO";
        return 0;
    }
    if (n == 2 && m > 0){
        cout << "NO";
        return 0;
    }

    for (int i= 0; i < m; ++i){
        int x, y;
        cin >> x >> y;
        A[x].push_back(y);
        A[y].push_back(x);
    }

    if (Cond()){
        Ans1.resize(n + 1);
        Ans2.resize(n + 1);

        cout << "YES\n";

        fill (Vis.begin(), Vis.end(), false);

        cur= 1;
        for (int i= 1; i <= n; ++i){
            if (!Vis[i])
                DFS(i);
        }

        for (int i= 1; i <= n; ++i){
            cout << Ans1[i] << " ";
        }

        cout << endl;

        fill(Vis.begin(), Vis.end(), false);

        if (mark == 1){
            int v;
            for (int i= 1; i <= n; ++i){
                if (A[i].size() > 1){
                    v= i;
                    break;
                }
            }
            queue<pii> Q;
            Vis[v]= true;
            Q.push(pii(v, 1));
            while (!Q.empty()){
                pii v= Q.front();
                Q.pop();
                Ans2[v.x]= v.y;

                for (int j= 0; j < A[v.x].size(); ++j){
                    if (!Vis[A[v.x][j]]){
                        Vis[A[v.x][j]]= true;
                        Q.push(pii(A[v.x][j], v.y + 1));
                    }
                }
            }
        }else{
            for (int i= 1; i <= n; ++i){
                if (!Vis[i]){
                    cur= 1;
                    DFS1(i);
                }
            }
        }

        for (int i= 1; i <= n; ++i){
            cout << Ans2[i] << " ";
        }
    }else{
        cout << "NO";
    }
}
