#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

#define x first
#define y second

#define pb push_back
#define mp make_pair
#define sz(s) (int)s.size()
#define all(s) s.begin(),s.end()

int n, m, cnt, cur;
vector<vector<int> > A;
vector<char> Vis;
vector<int> Ans1, Ans2;

void dfs(int i){
    Vis[i]= true;
    Ans1[i]= cur;
    ++cur;
    for (int j= 0; j < A[i].size(); ++j){
        int v= A[i][j];
        if (!Vis[v]){
            dfs(v);
        }
    }
}

signed main() {
    ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    cin >> n >> m;
    if (n == 1){
        cout << "NO";
        return 0;
    }

    A.resize(n + 1);

    for (int i= 0; i < m; ++i){
        int x, y;
        cin >> x >> y;
        A[x].push_back(y);
        A[y].push_back(x);
    }

    Vis.resize(n + 1, false);

    Ans1.resize(n + 1);
    Ans2.resize(n + 1);

    cnt= 0;
    cur= 1;
    for (int i= 1; i <= n; ++i){
        if (!Vis[i]){
            cnt++;
            dfs(i);
        }
    }

    cout << "YES\n";
    fill(Vis.begin(), Vis.end(), false);

    for (int i= 1; i <= n; ++i){
        cout << Ans1[i] << " ";
    }
    cout << endl;

    if (cnt == 1){
        int v;
        for (int i= 1; i <= n; ++i){
            if (A[i].size() > 1){
                v= i;
                break;
            }
        }

        queue<pii> Q;
        Q.push(pii(v, 1));
        Vis[v]= true;

        while (!Q.empty()){
            pii v= Q.front();
            Ans2[v.x]= v.y;
            Q.pop();
            for (int j= 0; j < A[v.x].size(); ++j){
                if (!Vis[A[v.x][j]]){
                    Vis[A[v.x][j]]= true;
                    Q.push(pii(A[v.x][j], v.y + 1));
                }
            }
        }

    }else{
        for (int i= 1; i <= n; ++i){
            if (!Vis[i]){
                queue<pii> Q;
                Q.push(pii(i, 1));
                Vis[i]= true;

                while (!Q.empty()){
                    pii v= Q.front();
                    Ans2[v.x]= v.y;
                    Q.pop();
                    for (int j= 0; j < A[v.x].size(); ++j){
                        if (!Vis[A[v.x][j]]){
                            Vis[A[v.x][j]]= true;
                            Q.push(pii(A[v.x][j], v.y + 1));
                        }
                    }
                }
            }
        }
    }
    for (int i= 1; i <= n; ++i){
        cout << Ans2[i] << " ";
    }
}
