#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

#define x first
#define y second

#define pb push_back
#define mp make_pair
#define sz(s) (int)s.size()
#define all(s) s.begin(),s.end()

const ll MOD = (1LL << 32);
const ll INFLL = 1e18 + 7;
/*
ll f(ll n, ll k, ll a) {
    if (k > n)
        return 0;
    return (n * a) / k;
}

ll g(ll n, ll k, ll a) {
    return min(n * a - f(n, k, a) * k, n);
}*/

int n, m, cur;
vector<vector<int> > A;
vector<char> Vis1, Vis2;
vector<int> T, B;

bool DFS(int i, int prev){
    T[i]= 1;
    if (B[cur] == 0 && A[i].size() > 1){
        B[cur]= i;
    }
    for (int j= 0; j < A[i].size(); ++j){
        if (T[A[i][j]] == 0){
            DFS(A[i][j], i);
        }else if (prev != A[i][j] && T[A[i][j]] == 1){
            return false;
        }
    }
    T[i]= 2;
    return true;
}

bool f(){
    cur= 0;
    B.push_back(0);
    for (int i= 1; i <= n; ++i){
        if (T[i] == 0){
            cur++;
            B.push_back(0);
            if (!DFS(i, 0)){
                return false;
            }
        }
    }
    return true;
}

vector<int> Ans1, Ans2;

void dfs(int i, int &cut){
    Ans1[i]= cut;
    Vis1[i]= true;
    cut++;
    for (int j= 0; j < A[i].size(); ++j){
        if (!Vis1[A[i][j]]){
            dfs(A[i][j], cut);
        }
    }
}

signed main() {
    ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    /*ll t, n, a, b, k, a1, b1, c1;
    cin >> t >> n >> a >> b >> k;
    if (k > n) {
        cout << 0;
        return 0;
    }
    if (a < b) {
        a1 = f(n, k, a);
        b1 = f(n / 2, k, b - a);
        c1 = (g(n, k, a) + g(n / 2, k, b - a)) / k;
    } else {
        a1 = f(n, k, b);
        b1 = f((n + 1) / 2, k, a - b);
        c1 = (g(n, k, b) + g((n + 1) / 2, k, a - b)) / k;
    }
    cout << g(n, k, b) << ' ' << g((n + 1) / 2, k, a - b) << endl;
    cout << a1 << ' ' << b1 << ' ' << min(c1, 1LL) << endl;
    cout << min(a1 + b1 + min(c1, 1LL), t);*/

    cin >> n >> m;
    A.resize(n + 1);
    T.resize(n + 1);
    Vis1.resize(n + 1, false);
    Vis2.resize(n + 1, false);
    Ans1.resize(n + 1);
    Ans2.resize(n + 1);

    for (int i= 0; i < m; ++i){
        int x, y;
        cin >> x >> y;
        A[x].push_back(y);
        A[y].push_back(x);
    }

    if (n == 1 || (n == 2 && m == 1)){
        cout << "NO";
        return 0;
    }

    if (!f()){
        cout << "NO";
    }else{
        if (cur == 1){
            int i= B[1];

            int cut= 1;

            dfs(i, cut);

            queue<pii> Q;
            Q.push(pii(i, 1));
            Vis2[i]= true;

            while (!Q.empty()){
                pii v= Q.front();
                Ans2[v.x]= v.y;
                Q.pop();
                for (int i= 0; i < A[v.x].size(); ++i){
                    if (!Vis2[A[v.x][i]]){
                        Vis2[A[v.x][i]]= true;
                        Q.push(pii(A[v.x][i], v.y + 1));
                    }
                }
            }
        }else{
            int cut= 1;
            for (int i= 1; i <= n; ++i){
                if (!Vis1[i]){
                    dfs(i, cut);

                    queue<pii> Q;
                    Q.push(pii(i, 1));
                    Vis2[i]= true;

                    while (!Q.empty()){
                        pii v= Q.front();
                        Ans2[v.x]= v.y;
                        Q.pop();

                        for (int i= 0; i < A[v.x].size(); ++i){
                            if (!Vis2[A[v.x][i]]){
                                Vis2[A[v.x][i]]= true;
                                Q.push(pii(A[v.x][i], v.y + 1));
                            }
                        }
                    }
                }
            }
        }

        cout << "YES\n";
        for (int i= 1; i <= n; ++i){
            cout << Ans1[i] << " ";
        }
        cout << endl;
        for (int i= 1; i <= n; ++i){
            cout << Ans2[i] << " ";
        }
    }
}
