#include<bits/stdc++.h>

#define int long long

#define pb push_back
#define eb emplace_back

#define forn(i, n) for (int i = 0; i < n; ++i)

#define ff first
#define ss second

#define all(x) x.begin(), x.end()

#define pii pair<int, int>

using namespace std;


typedef long long ll;
typedef long double ld;
const int maxn = 3e5  + 7, inf = 1e18;
vector<int> X = {2, 2, 1, 1, -2, -2, -1, -1};
vector<int> Y = {1, -1, 2, -2, 1, -1, 2, -2};
int n;

bool check(int x, int y) {
    return x >= 0 && x < 8 && y >= 0 && y < 8;
}

int dist[8][8];
pii pr[8][8];

vector<pii> bfs(int x1, int y1, int x2, int y2) {
    for (int i = 0; i < 8; ++i) {
        for (int j = 0; j < 8; ++j) dist[i][j] = inf, pr[i][j] = {-1, -1};
    }
    dist[x1][y1] = 0;
    deque<pii> q;
    q.eb(x1, y1);
    while (q.size()) {
        pii u = q.front();
        q.pop_front();
        for (int i = 0; i < 8; ++i) {
            pii to = {u.ff + X[i], u.ss + Y[i]};
            if (to.ff > x2 || (to.ff == x2 && to.ss < y2)) continue;
            if (!check(to.ff, to.ss) || dist[to.ff][to.ss] != inf) continue;
            dist[to.ff][to.ss] = dist[u.ff][u.ss] + 1;
            pr[to.ff][to.ss] = {u.ff, u.ss};
            q.pb(to);
        }
    }
    vector<pii> path;
    while (x2 != -1 && y2 != -1) {
        path.eb(x2, y2);
        pii lst = pr[x2][y2];
        x2 = lst.ff, y2 = lst.ss;
    }
    reverse(all(path));
    return path;
}

bool used[8][8];

struct step {
    int xx1, yy1, xx2, yy2;
    step(int xx1, int yy1, int xx2, int yy2) : xx1(xx1), yy1(yy1), xx2(xx2), yy2(yy2) {}
    step() : xx1(0), yy1(0), xx2(0), yy2(0) {}
};

vector<step> ans;

void solve2(int x1, int y1, int id, vector<pii> &path) {
    if (id == (int)path.size()) return;
    pii to =  path[id];
    if (!used[to.ff][to.ss]) {
        used[x1][y1] = 0;
        used[to.ff][to.ss] = 1; 
        ans.eb(x1, y1, to.ff, to.ss);
        solve2(to.ff, to.ss, id + 1, path);
    } else {
        solve2(to.ff, to.ss, id + 1, path);
        ans.eb(x1, y1, to.ff, to.ss);
    }
}

void solve1(int x2, int y2) {
    if (used[x2][y2]) return;
    int x1 = -1, y1 = -1;
    bool fl = false;
    for (int j = y2 + 1; j < 8; ++j) {
        if (used[x2][j]) {
            x1 = x2;
            y1 = j;
            fl = true;
            break;
        }
    }
    for (int i = x2 - 1; i >= 0; --i) {
        for (int j = 0; j < 8; ++j) {
            if (fl) break;
            if (used[i][j]) {
                x1 = i;
                y1 = j;
                fl = true;
            }
        }
    }
    vector<pii> path = bfs(x1, y1, x2, y2);
    solve2(x1, y1, 1, path);
}

void solve(){
    cin >> n;
    for (int i = 0; i < n; ++i) {
        char y; int x; cin >> y >> x;
        used[8 - x][y - 'a'] = 1;
    }
    for (int i = 7; i >= 0; --i) {
        if (n == 0) break;
        for (int j = 0; j < min(8ll, n); ++j) {
            solve1(i, j);
        }
        n -= min(8ll, n);
    }
    if (ans.size() > 1500) assert(0);
    cout << ans.size() << '\n';
    for (auto v : ans) {
        char to1 = 'a' + v.yy1;
        char to2 = 'a' + v.yy2;
        cout << to1 << 8 - v.xx1 << '-' << to2 << 8 - v.xx2 << '\n';
    }
}

signed main(){
#ifdef LOCAL
    freopen("task.in", "r", stdin);
    freopen("task.out", "w", stdout);
#endif

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    solve();
}