from sys import stdin
import re

ref = re.compile(r"\\cite{([a-z]+)}")
bibitem_re = re.compile(r"\\bibitem{([a-z]+)} ([^\n]*)")

refs = []
while True:
    line = input()
    if line.startswith(r"\begin{thebibliography}{99}"):
        break
    refs += ref.findall(line)

i = 0
bibitem = []
bibitem_def = dict()
while True:
    line = input()
    if line.startswith(r"\end{thebibliography}"):
        break
    items = bibitem_re.match(line)
    bibitem.append(items[1])
    bibitem_def[items[1]] = line

if(refs != bibitem):
    print("Incorrect")
    print(r"\begin{thebibliography}{99}")
    for item in refs:
        print(bibitem_def[item])
    print(r"\end{thebibliography}")
else:
    print("Correct")
