#include <ext/pb_ds/assoc_container.hpp>
#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

#define all(a) (a).begin(), (a).end()

#define deb(x) for (auto &i: x) cout << i << " "; cout << endl;
#define sp << " " <<
#define nl << '\n'
#define sq << " "

using namespace __gnu_pbds;
using namespace std;

typedef tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
typedef gp_hash_table<int, int> heh_map;

int solve();

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie();
    cout.tie();
    return solve();
}

int solve() {
    ll n, m;
    cin >> n >> m;
    if(m>=(n*(n-1)/2)){
        cout << "NO" << endl;
        exit(0);
    }
    vector<pair<ll, ll> > a(m);
    for (ll i = 0; i < m; i++) {
        cin >> a[i].first >> a[i].second;
        a[i].first--;
        a[i].second--;
    }
    sort(all(a));
    pair<ll, ll> ass = {0, 1};
    for (ll i = 0; i < m; i++) {
        if (a[i] == ass) {
            ass.second++;
            if (ass.second == n) {
                ass.first++;
                ass.second = ass.first + 1;
            }
        } else {
            break;
        }
    }
    vector<ll> a_a(n), a_b(n);
    a_b[ass.first] = 1;
    a_b[ass.second] = 1;
    ll c = 2;
    for (ll i = 0; i < n; i++) {
        if (i != ass.first && i != ass.second)
            a_b[i] = c++;
    }
    a_a[ass.first] = 2;
    a_a[ass.second] = 1;
    c = 3;
    for (ll i = 0; i < n; i++) {
        if (i != ass.first && i != ass.second)
            a_a[i] = c++;
    }
    cout << "YES" << endl;
    for (ll i = 0; i < n; i++)
        cout << a_a[i] << " ";
    cout << endl;
    for (ll i = 0; i < n; i++)
        cout << a_b[i] << " ";
    cout << endl;
    return 0;
}