#include <ext/pb_ds/assoc_container.hpp>
#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

#define all(a) (a).begin(), (a).end()

#define deb(x) for (auto &i: x) cout << i << " "; cout << endl;
#define sp << " " <<
#define nl << '\n'
#define sq << " "

using namespace __gnu_pbds;
using namespace std;

typedef tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
typedef gp_hash_table<int, int> heh_map;

int solve();

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie();
    cout.tie();
    return solve();
}

int solve() {
    const int MAXN = 1e5 + 10;
    ll n, k, dp[MAXN], a[MAXN], maxx;
    cin >> n >> k;
    dp[0] = 0;
    for (int i = 1; i <= n; i++)
        cin >> a[i];
    dp[1] = 1;
    maxx = 1;
    for (int i = 2; i <= n; i++)
    {
        if (a[i] != a[i - 1])
            dp[i] = dp[i - 1] + 1;
        else {
            maxx = max(maxx, dp[i - 1 ]);
            dp[i] = 1;
        }
    }
    cout << maxx << "\n";
    return 0;
}