#include <bits/stdc++.h>

using namespace std;

const long long inf = 5e18;

const long long MOD = 4294967296LL;

void solve(){

	int n;
	long long l, r, x, y, z;
	cin >> n >> l >> r >> x >> y >> z;
	vector<long long> b(n);
	vector<long long> a(n);
	cin >> b[0] >> b[1];

	for(int i = 2;i < n;i++){
        b[i] = (b[i - 2] * x + b[i - 1] * y + z) % MOD;
    }
    
    for(int i = 0;i < n;i++){
        a[i] = b[i] % (r - l + 1) + l;
    }

	long long ans = inf;

	set<long long> cur;
	cur.insert(a[n - 1]);

	for(int i = n - 2;i >=0;--i){
		if(a[i] >= 0){
			auto it = cur.upper_bound(a[i]);
			if(it != cur.end()){
				ans = min(ans, a[i] * *it);
			}
		}else{
			auto it = cur.rbegin();
			if((*it) > a[i]){
				ans = min(ans, a[i] * *it);
			}
		}
		cur.insert(a[i]);
	}
	// for(int i = 0;i < n;i++)
	// 	cout << a[i] << " ";
	// cout << "\n";
	if(ans != inf)
		cout << ans << "\n";
	else
		cout << "IMPOSSIBLE\n";
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	int T;
	cin >> T;
	for(int t = 0;t < T;t++){
		solve();
	}
	
}