import java.util.*;
import java.io.*;

public class Main {

    FastScanner in;
    PrintWriter out;

    private void solve() throws IOException {
        int n = in.nextInt(), m = in.nextInt();
        TreeSet<Integer>[] am = new TreeSet[n];
        for(int i = 0; i < n; i++){
            am[i] = new TreeSet<>();
        }
        for(int i = 0; i < m; i++){
            int a = in.nextInt(), b = in.nextInt();
            am[a - 1].add(b -1);
            am[b - 1].add(a - 1);
        }
        boolean found = false;
        int[] ans1 = new int[n];
        int[] ans2 = new int[n];
        int cur = 1;
        for(int i = 0; i < n; i++){
            if(!found || ans1[i] == 0) {
                ans1[i] = cur;
                ans2[i] = cur;
                cur++;
            }
            if(am[i].size() < n - 1 && !found){
                for(int j = 0; j < n; j++){
                    if(i != j) {
                        if (!am[i].contains(j)) {
                            ans2[j] = cur - 1;
                            ans1[j] = cur;
                            found = true;
                            cur++;
                        }
                    }
                }
            }
        }
        if(n == 1){
            found = false;
        }
        if(found){
            out.println("YES");
            for(int i = 0; i < n; i++){
                out.print(ans1[i] + " ");
            }
            out.println();
            for(int i = 0; i < n; i++){
                out.print(ans2[i] + " ");
            }
        } else {
            out.println("NO");
        }

    }


    class FastScanner {
        BufferedReader br;
        StringTokenizer st;

        FastScanner(InputStream s){
            br = new BufferedReader(new InputStreamReader(s));
        }

        String next() throws IOException {
            while(st == null || !st.hasMoreTokens())
                st = new StringTokenizer(br.readLine());
            return st.nextToken();
        }

        boolean hasNext() throws IOException{
            return br.ready() || (st != null && st.hasMoreTokens());
        }

        int nextInt() throws IOException {
            return Integer.parseInt(in.next());
        }
        long nextLong() throws IOException {
            return Long.parseLong(in.next());
        }

        double nextDouble() throws IOException {
            return Double.parseDouble(in.next().replace(',', '.'));
        }

        String nextLine() throws IOException {
            return br.readLine();
        }

        boolean hasNextLine() throws IOException {
            return br.ready();
        }
    }

    private void run() throws  IOException {
        in = new FastScanner(System.in);
        out = new PrintWriter(System.out);
        solve();

        out.flush();
        out.close();
    }

    public static void main(String[] args) throws IOException {
        new Main().run();


    }

}
