#define _CRT_SECURE_NO_WARNINGS
#define forn(n, i) for(int i = 0; i < n; ++i)
#define fordown(n, i) for(int i = n -1; i >= 0; --i)
#include <iostream>
#include <stdio.h>
#include <stdlib.h>
#include <algorithm>
#include <math.h>
#include <string.h>
#include <string>
#include <vector>
#include <stack>
#include <queue>
#include <set>
#include <map>
using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef double db;
const int INF = 1000000007;
const ll LLINF = 1000000000000000007LL;
const double EPS = 1e-9;
#ifdef _DEBUG
const int sz = 100;
#endif
#ifndef _DEBUG
const int sz = 300100;
#endif

ll cnt1, cnt2;
ll n, m, x, y;
vector <int> gs[100010];
int used[100010];
int color[100010];

void DFS(int par, int col, int i) {
	//cout <<col << " " << cnt1 << " " << cnt2 << endl;
	used[i] = 1;
	if (col == 0) {
		color[i] = cnt1;
		--cnt1;
	}
	else {
		color[i] = cnt2;
		++cnt2;
	}

	forn(gs[i].size(), j) {
		if (used[gs[i][j]] == 0 && gs[i][j] != par) {
			DFS(i, (col + 1) % 2, gs[i][j]);
		}
	}
	return;
}

int main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	cin >> n >> m;
	if (n == 1) {
		cout << "NO" << endl;
		return 0;
	}
	if (m != (n * (n-1))/ 2) {
		cout << "NO" << endl;
		return 0;
	}
	cnt1 = n;
	cnt2 = 1;
	forn(m, i) {
		cin >> x >> y;
		x--;
		y--;
		gs[x].push_back(y);
		gs[y].push_back(x);
	}
	forn(n, i) {
		if (!used[i]) {
			DFS(-1, 0, i);
		}
	}
	cout << "YES" << endl;
	forn(n, i) {
		cout << color[i] << " ";
	}
	cout << endl;
	forn(n, i) {
		if (color[i] != n - 1) {
			cout << color[i] << " ";
		}
		else {
			cout << color[i] + 1 << " ";
		}
	}

}