#pragma GCC optimize("O3")
#pragma GCC targer("sse4")

#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES
#include <bits/stdc++.h>

using namespace std;

#define sp(x) setprecision(x) << fixed
#define sort(x) sort(x.begin(), x.end())
#define rsort(x) sort(x.rbegin(), x.rend())

typedef long long ll;
typedef long double ld;
typedef pair<ll, ll> pll;

ll gcd(ll a, ll b) {
	if (b == 0)
		return a;

	return gcd(b, a%b);
}
ll lcm(ll a, ll b) {
	return a / gcd(a, b)*b;
}
ll bin_pow(ll a, ll n) {
	if (n == 0)
		return 1;

	if (n % 2 == 0) {
		ll b = bin_pow(a, n / 2);
		return b * b;
	}
	else
		return bin_pow(a, n - 1)*a;
}

bool operator==(const string& s, const size_t n) {
	return s.size() == n;
}
string operator*(const string& s, const ll n) {
	string ans = "";

	for (ll i = 0; i < n; i++) {
		ans += s;
	}

	return ans;
}

string getName(string& s) {
	string ans = "";

	for (ll i = 6;; i++) {
		if (s[i] == '}')
			break;

		ans += s[i];
	}

	return ans;
}

string getNameS(string& s) {
	string ans = "";

	for (ll i = 9;; i++) {
		if (s[i] == '}')
			break;

		ans += s[i];
	}

	return ans;
}

int main() {
	ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);
	
	vector<string> order;
	map<string, string> source;
	vector<string> give;

	string s;

	bool flag = true;
	while (true) {
		if (flag) {
			cin >> s;
		}
		else {
			getline(cin, s);
		}

		if (s == "\\end{thebibliography}")
			break;

		if (!flag) {
			give.push_back(getNameS(s));
			source[give.back()] = s;
		}

		if (s == "\\begin{thebibliography}{99}") {
			flag = false;
			getline(cin, s);
		}

		if (s[0] == (char)92 && flag) {
			order.push_back(getName(s));
		}
	}

	if (order == give) {
		cout << "Correct";
		return 0;
	}
	else {
		cout << "Incorrect" << endl;
		cout << "\\begin{ thebibliography }{99}" << endl;
		for (auto c : order) {
			cout << source[c] << endl;
		}
		cout << "\\end{thebibliography}";
		return 0;
	}

	return 0;
}