﻿#pragma GCC optimize("O3")
#pragma GCC targer("sse4")

#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES

#include <bits/stdc++.h>

using namespace std;

#define sp(x) setprecision(x) << fixed
#define sort(x) sort(x.begin(), x.end())
#define rsort(x) sort(x.rbegin(), x.rend())

typedef signed long long ll;
typedef long double ld;
typedef pair<ll, ll> pll;

ll gcd(ll a, ll b) {
	if (b == 0)
		return a;

	return gcd(b, a%b);
}
ll lcm(ll a, ll b) {
	return a / gcd(a, b)*b;
}
ll bin_pow(ll a, ll n) {
	if (n == 0)
		return 1;

	if (n % 2 == 0) {
		ll b = bin_pow(a, n / 2);
		return b * b;
	}
	else
		return bin_pow(a, n - 1)*a;
}

bool operator==(const string& s, const size_t n) {
	return s.size() == n;
}
string operator*(const string& s, const ll n) {
	string ans = "";

	for (ll i = 0; i < n; i++) {
		ans += s;
	}

	return ans;
}

struct Person
{
	ld atack, health;//health is pow
	ld minus;
	ld last_minus;
	ld DTime;
	Person()
	{
		atack = 0;
		health = 0;
		minus = 0;
		last_minus = 0;
		DTime = -1;
	}
	Person(ld a, ld h)
	{
		atack = a;
		health = h;
		minus = 0;
		last_minus = 0;
		DTime = -1;
	}
};

int main() {
	ios::sync_with_stdio(false), cin.tie(0), cout.tie(0);

	ll n;
	cin >> n;
	vector<Person> a;
	for (ll i = 0; i < n; i++)
	{
		ll operation;
		cin >> operation;
		if (operation == 1)
		{
			a.push_back({ 0, 0 });
			continue;
		}
		if (operation == 2)
		{
			ll I;
			cin >> I;
			I--;
			a[I].atack++;
			continue;
		}
		if (operation == 3)
		{
			ll I;
			cin >> I;
			I--;
			a[I].health++;
			a[I].minus += a[I].last_minus * 2;
			a[I].last_minus = 0;
			continue;
		}
		if (operation == 4)
		{
			ll I;
			cin >> I;
			I--;
			if (a[I].DTime == -1)
			{
				a.push_back(a[I]);
			}
			else
			{
				a.push_back(a[I]);
				a.back().DTime = i + 1;
			}
		}
		if (operation == 5)
		{
			ll I, J;
			cin >> I >> J;
			I--; J--;
			//if (I == J)
			//  continue;
			if (a[I].DTime == -1 && a[J].DTime == -1)
			{
				//_Big_uint128 b;
				a[I].last_minus += a[J].atack + 1;
				a[J].last_minus += a[I].atack + 1;
				if (int(log2(a[I].minus + a[I].last_minus) >= a[I].health))
				{
					a[I].DTime = i + 1;
				}
				if (int(log2(a[J].minus + a[J].last_minus) >= a[J].health))
				{
					a[J].DTime = i + 1;
				}
			}
		}
	}
	cout << a.size() << '\n';
	for (auto i : a)
	{
		cout << i.DTime << ' ';
	}
	return 0;
}