import java.util.HashMap;
import java.util.HashSet;
import java.util.Scanner;
import java.util.StringTokenizer;

public class AA {
    public static void main(String[] args){
        Scanner scan  = new Scanner(System.in);
        long n = scan.nextLong();
        if (n == 1) {
            System.out.println("NO");
            return;
        }
        long m = scan.nextLong();
        if (m >= n * (n - 1) / 2) {
            System.out.println("NO");
            return;
        }
        HashMap<Integer, HashSet<Integer>> pairs = new HashMap<>();
        int counter = 0;
        for (int i = 1; i <= n && counter <= m; ++i) {
            for (int j = i + 1; j <= n && counter <= m; ++j) {
                if (pairs.containsKey(i)){
                    pairs.get(i).add(j);
                }
                else {
                    pairs.put(i, new HashSet<>());
                    pairs.get(i).add(j);
                }
                ++counter;
            }
        }
        for (int i = 0; i < m; ++i) {
            int a = scan.nextInt();
            int b = scan.nextInt();
            if(pairs.containsKey(Math.min(a,b))){
                pairs.get(Math.min(a,b)).remove(Math.max(b,a));
            }
        }
        int[] array = new int[(int) n];
        int l = 0;
        int r = 0;
        for(int k : pairs.keySet()){
            if(pairs.get(k).size() > 0){
                l = k;
                for(int j : pairs.get(l)){
                    r = j;
                    break;
                }
                break;
            }
        }
        array[l - 1] = 1;
        array[r - 1] = 2;
        int c = 3;
        System.out.println("YES");
        for (int i = 0; i < n; ++i) {
            if (array[i] == 0) {
                array[i] = c;
                ++c;
            }
            System.out.print(array[i] + " ");
        }
        System.out.println("");
        for (int i = 0; i < n; ++i) {
            if (array[i] == 1) {
                System.out.print(2 + " ");
            } else {
                System.out.print(array[i] + " ");
            }
        }
    }
}
