#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <math.h>
#include <map>
#include <string>
#include <queue>
#include <deque>
#include <cstdio>
#include <stack>
#include <time.h>
#include <cstdlib>
#include <random>
#pragma warning(disable : 4996)
#define ll long long
#define M 100
#define D 86400

using namespace std;

bool comp(const pair<ll, ll>& a, const pair<ll, ll>& b) {
	return a.second < b.second;
}

int main() {
	ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);

	//freopen("input.txt", "r", stdin);
	 //freopen("output.txt", "w", stdout);
	
	int n;
	cin >> n;

	vector < pair <ll , ll >> a(n);

	for (int i = 0; i < n; i++) {
		cin >> a[i].first;
		long long maxPay = 0;

		for (int j = 0; j < a[i].first; j++) {
			ll el;
			cin >> el;
			maxPay = max(maxPay, el);
		}
		a[i].second = maxPay;
	}

	sort(a.begin(), a.end(), comp);
	/*
	for (auto e : a)
		cout << e.first << ' ' << e.second << '\n';
	*/

	ll adj = 0;

	for (int i = 0; i < n - 1; i++) {
		adj += a[i].first * (a[i + 1].second - a[i].second);
		a[i + 1].first += a[i].first;
	}

	cout << adj;

	return 0;
}