#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <math.h>
#include <map>
#include <string>
#include <queue>
#include <deque>
#include <cstdio>
#include <stack>
#include <time.h>
#include <cstdlib>
#include <random>
#pragma warning(disable : 4996)
#define ll long long
#define M 100
#define D 86400

using namespace std;

int main() {
	ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);

	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);

	string s;

	vector <string> order;
	map <string, string> data;

	size_t pointer = 0;

	bool flag = true;

	while (cin >> s) {
		//cout << s << '\n';
		if (s.substr(0, 6) == "\\cite{") {
			string elem = "";
			size_t i = 6;
			while (i < s.size() && s[i] != '}')
				elem += s[i++];

			if (i == s.size() && s[i - 1] != '}') {
				char p = getchar();
				while (p != '}') {
					elem += p;
					p = getchar();
				}

			}

			order.push_back(elem);
		}
		else if (s.substr(0, 9) == "\\bibitem{") {
			string elem = "";
			size_t i = 9;

			while (i < s.size() && s[i] != '}')
				elem += s[i++];

			if (i == s.size() && s[i - 1] != '}') {
				char p = getchar();
				while (p != '}') {
					elem += p;
					p = getchar();
				}
			}

			string newData = "\\bibitem{" + elem + '}';

			char m = cin.peek();

			while (m != '\\') {
				newData += m;
				getchar();
				m = cin.peek();
			}

			data[elem] = newData;

			if (elem != order[pointer++])
				flag = false;
		}
	}

	if (flag)
		cout << "Correct";
	else {
		cout << "Incorrect\n";
		cout << "\\begin{thebibliography}{99}\n";
		for (auto& e : order)
			cout << data[e];
		cout << "\\end{thebibliography}";
	}


	return 0;
}