#pragma GCC optimize("Ofast")
#pragma GCC optimitze("unroll-loops")

#include <bits/stdc++.h>
#include <iostream>
#include <vector>
#include <set>
using namespace std;

typedef long long ll;

#define int long long

#define u unsigned

ll gcd(ll a, ll b) {
    while (a) {
        b %= a;
        swap(a, b);
    }

    return b;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    int N, M;
    cin >> N >> M;

    int Max = N * (N - 1) / 2;
    set<pair<int, int>> Arr;
    for (int i = 0; i < M; i++) {
        int t1, t2; cin >> t1 >> t2;

        if (t1 > t2)
            swap(t1, t2);

        Arr.insert({t1, t2});
    }

    if (Max <= M) {
        cout << "NO\n";
    } else {
        int l = 0, r = 0;

        for (int i = 1; i <= N; i++) {
            for (int j = i + 1; j <= N; j++) {
                if (Arr.find({i, j}) == Arr.end()) {
                    l = i;
                    r = j;
                    break;
                }
            }

            if (l != 0)
                break;
        }

        vector<int> Fir(N), Sec(N);

        Fir[l - 1] = N - 1;
        Fir[r - 1] = N;
        Sec[l - 1] = N;
        Sec[r - 1] = N;

        int t = 1;
        for (int i = 0; i < N; i++) {
            if (Fir[i] == 0) {
                Fir[i] = t;
                Sec[i] = t;
                t++;
            }
        }

        cout << "YES\n";
        for (int i = 0; i < N; i++) {
            cout << Fir[i] << " ";
        }
        cout << "\n";
        for (int i = 0; i < N; i++) {
            cout << Sec[i] << " ";
        }
        cout << "\n";
    }
}