#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int N = 1e5 + 5;
const ll INF = 4e18 + 5;
const ll mod = (1ll << 32ll);

int n, m, r = 1, b[N], a[N], aa[N];
bool used[N], us[N];
vector <int> g[N];

void dfs(int v, int d = 1, int p = 0) {
    if (used[v]) {
        return;
    }
    used[v] = 1;
    a[v] = r;
    r++;
    b[v] = d;
    for (int to : g[v]) {
        if (to == p) {
            continue;
        }
        dfs(to, d + 1, v);
    }
}

vector <pair <int, int>> vec;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin >> n >> m;
    for (int i = 1; i <= m; i++) {
        int u, v;
        cin >> u >> v;
        g[u].push_back(v);
        g[v].push_back(u);
        us[v] = 1;
    }
    for (int i = 1; i <= n; i++) {
        vec.push_back({g[i].size(), i});
    }
    sort(vec.rbegin(), vec.rend());
    for (auto i : vec) {
        if (!used[i.second])
            dfs(i.second);
    }
    bool u = 0;
    for (int i = 1; i <= n; i++) {
        if (a[i] != b[i]) {
            u = 1;
            break;
        }
    }
    if (!u) {
        cout << "NO";
        return 0;
    }
    for (int i = 1; i <= n; i++) {
        aa[i] = b[i];
    }
    sort(aa + 1, aa + 1 + n);
    u = 0;
    for (int i = 1; i <= n; i++) {
        if (aa[i] == aa[i - 1]) {
            u = 1;
            break;
        }
    }
    if (!u) {
        cout << "NO";
        return 0;
    }
    cout << "YES\n";
    for (int i = 1; i <= n; i++) {
        cout << a[i] << " ";
    }
    cout << "\n";
    for (int i = 1; i <= n; i++) {
        cout << b[i] << " ";
    }
}
