#include <bits/stdc++.h>
using namespace std;

#define f first
#define s second
#define pb push_back
#define mp make_pair
#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define double long double
#define pii pair<int, int> 
#define points(x) cout.precision(x)

typedef long long ll;

const int N = 1e5;
const int M = N + 7;
const int MOD = 1e9 + 7;
const ll INF = 1e16 + 17;

int n;
pii an[M];
vector<int> qn, q1, g[M];
bool us[M];

void dfs(int v, int dx, int var) {
	us[v] = 1;
	if (var) {
		an[v].s = n;
		qn.pb(v);
	} else {
		an[v].s = 1;
		q1.pb(v);
	}
	for (int i = 0; i < sz(g[v]); ++i) {
		int to = g[v][i];
		if (!us[to])
			dfs(to, n - dx + 1, var ^ 1);
		else if (an[v].s == an[to].s){
			if (var) {
				--an[v].s;
			} else {
				++an[v].s;
			}
		}
	}
}

int v[M], u[M];

int main() {
//	freopen("problem.in", "r", stdin);
//  freopen("problem.out", "w", stdout);
	int m;
	scanf("%d %d", &n, &m);
	for (int i = 1; i <= m; ++i) {
		scanf("%d %d", &v[i], &u[i]);
		g[v[i]].pb(u[i]);
		g[u[i]].pb(v[i]);
	}
	if (1LL * n * (n - 1) == 1LL * m * 2) {
		printf("NO");
		return 0;
	}
	int id = 1;
	for (int i = 1; i <= n; ++i) {
		if (us[i])
			continue;
		q1.clear();
		qn.clear();
		dfs(i, id, 0);
		for (int i = 0; i < sz(qn); ++i)
			an[qn[i]].f = n - id + 1 - i;
		for (int i = 0; i < sz(q1); ++i)
			an[q1[i]].f = id + i;
		id = id + sz(q1);
	}
	for (int i = 1; i <= m; ++i) {
		int f1 = 0, f2 = 0;
		if (an[u[i]].s > an[v[i]].s)
			f1 = 1;
		if (an[u[i]].s == an[v[i]].s)
			f1 = 2;
		if (an[u[i]].f > an[v[i]].f)
			f2 = 1;
		if (an[u[i]].f == an[v[i]].f)
			f2 = 2;
		if (f1 != f2 || an[u[i]].s == an[v[i]].s) {
			printf("NO");
			return 0;
		}
	}
	printf("YES\n");
	for (int i = 1; i <= n; ++i)
		printf("%d ", an[i].f);
	printf("\n");
	for (int i = 1; i <= n; ++i)
		printf("%d ", an[i].s);
	return 0;
}