#include <cstdio>
#include <vector>
#include <algorithm>
#include <cstdlib>

using namespace std;

void print(vector<int> a, vector<int> b, int n) {
    printf("YES\n");
    for (int i = 1; i <= n; i++) {
        printf("%d ", a[i]);
    }
    printf("\n");
    for (int i = 1; i <= n; i++) {
        printf("%d ", b[i]);
    }
    exit(0);
}

int main() {
    int n, m;
    scanf("%d %d", &n, &m);
    if (m == 0) {
        printf("NO");
        return 0;
    }
    vector<vector<int>> after(n + 1);
    vector<vector<int>> notafter(n + 1);
    for (int i = 1; i <= m; i++) {
        int ai, bi;
        scanf("%d %d", &ai, &bi);
        after[ai].push_back(bi);
        notafter[bi].push_back(ai);
    }
    vector<int> a(n + 1);
    for (int i = 1; i <= n; i++) {
        a[i] = i;
    }
    vector<int> b(n + 1);
    for (int i = 1; i <= n; i++) {
        b[i] = i;
    }
    for (int i = 2; i <= n; i++) {
        if (notafter[i].size() < i - 1) {
            //printf("%d\n", i);
            vector<bool> used(n + 1, false);
            for (int j : notafter[i]) {
               // printf("%d ", j);
                used[j] = true;
            }
            //printf("\n");
            for (int j = 1; j <= i - 1; j++) {
               // printf("1 %d ", j);
                if (!used[j]) {
                    //printf("%d\n", j);
                    b[i] = b[j];
                    print(a, b, n);
                }
            }
        }
    }
    printf("NO\n");
    return 0;
}
