#include <cstdio>
#include <vector>
#include <algorithm>
#include <cstdlib>
#include <map>
#include <set>

using namespace std;

void print(vector<int> a, vector<int> b, int n) {
    printf("YES\n");
    for (int i = 1; i <= n; i++) {
        printf("%d ", a[i]);
    }
    printf("\n");
    for (int i = 1; i <= n; i++) {
        printf("%d ", b[i]);
    }
    exit(0);
}

int main() {
    int n, m;
    scanf("%d %d", &n, &m);
    if (m == 0) {
        printf("NO");
        return 0;
    }
    vector<vector<int>> after(n + 1);
    vector<vector<int>> notafter(n + 1);
    map<int, set<int>> c;
    for (int i = 1; i <= m; i++) {
        int ai, bi;
        scanf("%d %d", &ai, &bi);
        auto it = c.find(ai);
        if (it == c.end()) {
            set<int> temp;
            temp.insert(bi);
            c.insert(pair<int, set<int>>(ai, temp));
        } else {
            it->second.insert(bi);
        }
        auto it1 = c.find(bi);
        if (it1 == c.end()) {
            set<int> temp;
            temp.insert(ai);
            c.insert(pair<int, set<int>>(bi, temp));
        } else {
            it->second.insert(ai);
        }
    }
    vector<int> a(n + 1);
    for (int i = 1; i <= n; i++) {
        a[i] = i;
    }
    vector<int> b(n + 1);
    for (int i = 1; i <= n; i++) {
        b[i] = i;
    }
    for (int i = 1; i <= n - 1; i++) {
        auto it = c.find(i);
        if (it == c.end()) {
            b[i] = b[i + 1];
            print(a, b, n);
        } else {
            set<int> temp = it->second;
            if (temp.count(b[i + 1]) != 0) {
                continue;
            } else {
                b[i] = b[i + 1];
                print(a, b, n);

            }
        }
    }
    printf("NO\n");
    return 0;
}
