#include <cstdio>
#include <vector>
#include <algorithm>
#include <cstdlib>
#include <map>
#include <set>

using namespace std;

void print(vector<int> a, vector<int> b, int n) {
    printf("YES\n");
    for (int i = 1; i <= n; i++) {
        printf("%d ", a[i]);
    }
    printf("\n");
    for (int i = 1; i <= n; i++) {
        printf("%d ", b[i]);
    }
    exit(0);
}

int main() {
    int n, m;
    scanf("%d %d", &n, &m);
    if (n == 1) {
        printf("NO");
        return 0;
    }
    vector<vector<int>> after(n + 1);
    vector<vector<int>> notafter(n + 1);
    map<int, set<int>> c;
    set<int> temp_1;
    for (int i = 1; i <= n; i++) {
        c.insert(pair<int, set<int>>(i, temp_1));
    }
    for (int i = 1; i <= m; i++) {
        int ai, bi;
        scanf("%d %d", &ai, &bi);
        auto it = c.find(ai);
        it->second.insert(bi);
        auto it1 = c.find(bi);
        it1->second.insert(ai);
    }
    int number_1 = -1;
    int number_2 = -1;
    bool isFind = false;
    for (int i = 1; i <= n; i++) {
        auto it = c.find(i);
        //printf("%d %d\n", i, it->second.size());
        if (it->second.size() != n - 1) {
            number_1 = i;
            //printf("%d %d\n", number_1, number_2);
            vector<bool> used(n + 1, false);
            set<int> temp = it->second;
            for (auto j : temp) {
                used[j] = true;
            }
            for (int j = 1; j <= n; j++) {
                if (!used[j]) {
                    number_2 = j;
                    isFind = true;
                    break;
                }
            }
            if (isFind) {
                break;
            }
        }
    }
    if (!isFind) {
        printf("NO\n");
        return 0;
    }
    //printf("%d %d\n", number_1, number_2);
    vector<int> a(n + 1, 0);
    a[number_1] = n;
    a[number_2] = n;
    int number = 1;
    for (int i =1 ;i <= n; i++) {
        if (i == number_1)
            continue;
        if (i == number_2)
            continue;
        a[i] = number;
        number++;
    }
    vector<int> b = a;
    b[number_2]--;
    print(a, b, n);
    return 0;
}
