#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;

vector<int> g[100500], t[100500];
vector<pair<int, int>> q;
int n, m;

void read()
{
    cin >> n >> m;
    for(int i = 0; i < m; i++)
    {
        int a, b;
        cin >> a >> b;
        g[a].push_back(b);
        g[b].push_back(a);
    }
}

bool solve()
{
    for(int i = 1; i <= n; i++)
    {
        if(g[i].size() != n - 1)
        {
            vector<int> a(n + 1);
            a[i] = 1;
            for(int j : g[i])
            {
                a[j] = 1;
            }
            int y;
            for(int i = 1; i <= n; i++)
            {
                if(!a[i]) y = i;
            }
            vector<int> ans1(n), ans2(n);
            ans1[i - 1] = 1;
            ans1[y - 1] = 2;
            ans2[i - 1] = ans2[y - 1] = 1;
            int c = 3;
            for(int i = 0; i < n; i++)
            {
                if(!ans2[i]) ans1[i] = ans2[i] = c++;
            }
            cout << "YES" << endl;
            for(int i : ans1) cout << i << " "; cout << endl;
            for(int j : ans2) cout << j << " "; cout << endl;
            return 0;
        }
    }
    cout << "NO" << endl;
}

bool c(vector<int> &a, vector<int> &b)
{
    for(auto i : q)
    {
        if(a[i.first - 1] < a[i.second - 1] && b[i.first - 1] >= b[i.second - 1]) return 0;
        if(a[i.first - 1] > a[i.second - 1] && b[i.first - 1] <= b[i.second - 1]) return 0;
    }
    return 1;
}

bool slow_solve()
{
    vector<int> ans(n), ans1(n);
    for(int i = 0; i < n; i++)
    {
        ans[i] = i + 1;
        ans1[i] = i + 1;
    }
    do
    {
        ans1 = ans;
        for(int i = 0; i < n; i++)
        {
            for(int j = 1; j <= n; j++)
            {
                if(j == ans[i]) continue;
                ans1[i] = j;
                if(c(ans, ans1))
                {
                    cout << "ST" << endl;
                    for(int i : ans) cout << i << " "; cout << endl;
                    for(int i : ans1) cout << i << " "; cout << endl;
                    return 1;
                }
                ans1[i] = ans[i];
            }
        }
    }
    while(next_permutation(ans.begin(), ans.end()));
    return 0;
}

void gen()
{
    n = rand() % 5 + 2;
    m = rand() % 3 + 1;
    q.clear();
    for(int i = 1; i <= n; i++)
    {
        g[i].clear();
        t[i].clear();
    }
    for(int i = 0; i < m; i++)
    {
        int a = 0, b = 0;
        while(a == b) a = rand() % n + 1, b = rand() % n + 1;
        q.push_back({a, b});
        g[a].push_back(b);
        g[b].push_back(a);
    }
}

void stress()
{
    while(true)
    {
        gen();
        if(solve() != slow_solve())
        {
            cout << "ERROR" << endl;
            q.resize(unique(q.begin(), q.end()) - q.begin());
            cout << n << " " << m << endl;
            for(auto i : q) cout << i.first << " " << i.second << endl;
            break;
        }
        cout << "YES" << endl;
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);cout.tie(0);
    cout.precision(0); cout << fixed;
    read();
    solve();
}
