#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;

int n;
int a[8][8];
int d[8][8];
int x[64], y[64];
int cnt = 0;
int dd[8][2] = {{2, 1}, {2, -1}, {-2, 1}, {-2, -1}, {1, 2}, {1, -2}, {-1, 2}, {-1, -2}};
vector<string> ans;

bool solve(int level = 0)
{
    if(level == n) return cnt <= 1500;
    for(int i = 0; i < n; i++)
    {
        vector<vector<pair<int, int>>> last(8, vector<pair<int, int>>(8, {-1, -1}));
        int ex = i % 8;
        int ey = i / 8;
        for(int i = 0; i < 8; i++)
        {
            for(int j = 0; j < 8; j++)
            {
                d[i][j] = 0;
            }
        }
        if(ex == x[level] && ey == y[level]);
        else
        {
            if(a[ex][ey]) continue;
            d[x[level]][y[level]] = 1;
            queue<pair<int, int>> q;
            q.push({x[level], y[level]});
            while(!q.empty())
            {
                auto p = q.front();
                q.pop();
                for(int i = 0; i < 8; i++)
                {
                    int ti = p.first + dd[i][0];
                    int tj = p.second + dd[i][1];
                    if(ti >= 0 && tj >= 0 && ti < 8 && tj < 8 && !d[ti][tj] && !a[ti][tj])
                    {
                        d[ti][tj] = d[p.first][p.second] + 1;
                        last[ti][tj] = p;
                        q.push({ti, tj});
                        if(ti == ex && tj == ey) break;
                    }
                }
            }
            if(!d[ex][ey]) continue;
        }
        int o = (d[ex][ey] ? d[ex][ey] - 1 : 0);
        cnt += o;
        a[x[level]][y[level]] = 0;
        a[ex][ey] = 1;
        if(solve(level + 1))
        {
            int x = ex, y = ey;
            while(true)
            {
                string s = "";
                int x1 = last[x][y].first;
                int y1 = last[x][y].second;
                if(x1 == -1 && y1 == -1) break;
                s += x1 + 'a';
                s += y1 + '1';
                s += '-';
                s += x + 'a';
                s += y + '1';
                ans.push_back(s);
                x = x1;
                y = y1;
            }
            return 1;
        }
        a[ex][ey] = 0;
        a[x[level]][y[level]] = 1;
        cnt -= o;
    }
    return 0;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);cout.tie(0);
    cout.precision(0); cout << fixed;
    cin >> n;
    for(int i = 0; i < n; i++)
    {
        string s;
        cin >> s;
        a[s[0] - 'a'][s[1] - '1'] = 1;
        x[i] = s[0] - 'a';
        y[i] = s[1] - '1';
    }
    solve();
    cout << ans.size() << endl;
    reverse(ans.begin(), ans.end());
    for(auto i : ans) cout << i << "\n";
}

/*
2
a5
f1

*/
