#include <iostream>
#include <map>
#include <vector>

#define ll long long
#define vi vector<int>
#define pb push_back

using namespace std;

vi g[100500];

int a[100500];

int used[100500];

int color = 0;

int e = -1, f = 0;

void dfs(int v){
    color++;
    a[v] = color;
    used[v] = 1;
    for(int u : g[v]){
        if(used[u] == 1 && abs(a[v] - a[u]) > 1){
            e = 0;
        }
        if(used[u] == 1) continue;
        dfs(u);
    }
}

int b[100500];

int main() {
    ios::sync_with_stdio(NULL), cin.tie(NULL), cout.tie(NULL);
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        u--, v--;
        g[u].push_back(v);
        g[v].push_back(u);
        b[u] = 1;
        b[v] = 1;
    }
    for (int i = 0; i < n; ++i) {
        if(b[i] == 1 && used[i] == 0){
            dfs(i);
        }
        if(b[i] == 0) {
            color++;
            a[i] = color;
        }
    }
    if(e == -1 || n == 1){
        cout << "NO";
    } else {
        cout << "YES\n";
        for (int i = 0; i < n; ++i) {
            if(e == i) cout << color + 1 << " ";
            else cout << a[i] << " ";
        }
        cout << '\n';
        for (int i = 0; i < n; ++i) {
            cout << a[i] << " ";
        }
    }
    return 0;
}
/*


 * */