import re

latex = ""
inp = ""
while inp != "\\begin{thebibliography}{99}":
    latex += inp + "\n"
    inp = input()
tocheck = "\\begin{thebibliography}{99}"
inp = ""
while inp != "\\end{thebibliography}":
    tocheck += inp + "\n"
    inp = input()
tocheck += "\\end{thebibliography}"

# print(latex)
# print(tocheck)


def getbytag(text, tag):
    # print(re.findall(r'\\' + tag + '{[a-z]+}', text))
    return list(map(lambda x: x[len(tag) + 2:-1], re.findall(r'\\' + tag + '{[a-z]+}', text)))


def getbib(text):
    a = list(re.findall(r'\\bibitem{(.+)}(.+)', text))
    # print(a)
    ans = {}
    for l in a:
        ans[l[0]] = l[1]
    return ans


cites = getbytag(latex, 'cite')
# print(cites)
tochecktags = getbytag(tocheck, 'bibitem')
bib = getbib(tocheck)

if cites == tochecktags:
    print('Correct')
else:
    print('Incorrect')
    print('\\begin{thebibliography}{99}')
    for cor in cites:
        print('\\bibitem{' + cor + '}' + bib[cor])
    print('\\end{thebibliography}')
