from pprint import pprint

n = int(input())
companies = list()


def merge_companies(comp_1, comp_2):
    new_comp = dict(max=max(comp_1['max'], comp_2['max']), count=(comp_1['count'] + comp_2['count']))
    shift_base = abs(comp_1['max'] - comp_2['max'])
    shift = 0

    if comp_1['max'] >= comp_2['max']:
        # new_comp['max'] = comp_1['max']
        shift = shift_base * comp_2['count']

    elif comp_2['max'] > comp_1['max']:
        # new_comp['max'] = comp_2['max']
        shift = shift_base * comp_1['count']

    return new_comp, shift


for _ in range(n):
    data = list(map(int, input().split()))
    companies.append({'max': max(data[1:]), 'count': data[0]})

companies.sort(key=lambda x: x['max'])
# pprint(companies)
sum = 0

while len(companies) > 1:
    comp_1 = companies[0]
    comp_2 = companies[1]

    companies[1], shift = merge_companies(comp_1, comp_2)
    # print(companies[1], shift)

    del(companies[0])
    sum += shift

# pprint(companies)
print(sum)

