#include <iostream>
#include <cmath>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>

#define pb push_back
#define mp make_pair

using namespace std;

vector<string> text;
vector<string> bibitem;

string st,en;

int index[100005];
bool k;

void in()
{
    string s;
    getline(cin,s);
    while(s.find("begin") == string::npos) {
        while(s.find("cite") != string::npos) {
            s = s.substr(s.find('{'),s.size());
            text.pb(s.substr(0,s.find('}')+1));
            s = s.substr(s.find('{')+1,s.size());
        }
        getline(cin,s);
    }
    st = s;
    getline(cin,s);
    while(s.find("end") == string::npos) {
        bibitem.pb(s);
        getline(cin,s);
    }
    en = s;
}

void solution()
{
    k = true;
    for(int i = 0; i < text.size(); i++)
        if(bibitem[i].find(text[i]) != string::npos) index[i] = i;
        else {
            k = false;
            for(int j = 0; j < text.size(); j++)
            if(bibitem[j].find(text[i]) != string::npos) {
                index[i] = j;
                break;
            }
        }
}

void out()
{
    if(k) cout <<"Correct\n";
    else {
        cout <<"Incorrect\n" <<st <<"\n";
        for(int i = 0; i < bibitem.size(); i++)
            cout <<bibitem[index[i]] <<"\n";
        cout <<en <<"\n";
    }
}

int main()
{
    in();
    solution();
    out();
    return 0;
}

/* The most famous characters of Pushkin's works are Onegin \cite{onegin},
Dubrovsky \cite{dubrovsky} and Tsar Saltan \cite{saltan}.

\begin{thebibliography}{99}
\bibitem{onegin} dfgdfgdfg
\bibitem{dubrovsky} dfgdfgfd
\bibitem{saltan} dfgdsfg
\end{thebibliography} */
