#include <iostream>
#include <cmath>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>

#define pb push_back
#define mp make_pair

using namespace std;

int N, M;
set<pair<int, int> > used;
vector<int> flag, a, b;
vector<pair<int, int> > p;
vector<vector<int> > cnt;

void in()
{
    cin >> N >> M;
    int v, u;
    flag.resize(N + 1, 0);
    a.resize(N + 1);
    b.resize(N + 1);
    cnt.resize(N + 1, vector<int>(1, 0));
    for (int i = 1; i <= M; i++)
    {
        cin >> v >> u;
        if (v < u)
            swap(v, u);
        if (used.find({v, u}) == used.end())
        {
            used.insert({v, u});
            p.push_back({v, u});
            if (abs(v - u) == 1)
            {
                if (v < u)
                {
                    flag[u] = 1;
                }
                else
                    flag[v] = 1;
            }
            if (v < u)
            {
                cnt[u][0]++;
                cnt[u].push_back(v);
            }
            else
            {
                cnt[v][0]++;
                cnt[v].push_back(u);
            }
        }
    }
}

void check()
{
    for (int i = 1; i <= N; i++)
    {
        if (cnt[i][0] != i - 1)
        {
            sort(cnt[i].begin(), cnt[i].end());
            int cur = cnt[i][cnt[i][0] - 1];
            if (cur != i - 2)
            {
                swap(a[i], a[i - 1]);
                b[i - 1] = i;
                b[i] = cur + 1;
                int sz = p.size();
                int fl = 1;
                for (int j = 0; j < sz; j++)
                {
                    if (!(a[p[j].first] < a[p[j].second]
                    || a[p[j].first] > a[p[j].second]))
                    {
                        fl = 0;
                        break;
                    }
                }
                if (fl)
                {cout << "YES\n";
                for (int i = 1; i <= N; i++)
                    cout << a[i] << " ";
                cout << "\n";
                for (int i = 1; i <= N; i++)
                {
                    cout << b[i] << " ";
                }
                return;}
            }
        }
    }
    cout << "NO";
}

void solution()
{
    if (N == 1 && M == 1)
    {
        cout << "NO";
        return;
    }
    flag[1] = 1;
    int c = 0;
    for (int i = 1; i <= N; i++)
    {
        a[i] = i;
        b[i] = i;
        //cout << flag[i] << " ";
        if (!flag[i])
        {
            c = i;
            //break;
        }
    }
    if (!c)
    {
        check();
        return;
    }
    cout << "YES\n";
    for (int i = 1; i <= N; i++)
        cout << i << " ";
    cout << "\n";
    for (int i = 1; i <= N; i++)
    {
        if (c == i)
        {
            cout << i - 1 << " ";
        }
        else cout << i << " ";
    }
}

void out()
{

}

int main()
{
    in();
    solution();
    out();
    return 0;
}
