#include <iostream>
#include <vector>

using namespace std;


void dfsTopo(int v, vector<vector<int>> &g, vector<int> &order, vector<bool> &used) {
	used[v] = true;

	for (int to : g[v]) {
		if (!used[to])
			dfsTopo(to, g, order, used);
	}

	order.push_back(v);
}


int main()
{
	int n, m;
	cin >> n >> m;
	vector<pair<int, int>> a(n);
	vector<vector<int>> g(n);
	vector<int> deg(n, 0);
	bool bad = false;


	for (int i = 0; i < m; i++) {
		cin >> a[i].first >> a[i].second;
		a[i].first--;
		a[i].second--;
		if (a[i].first > a[i].second)
			swap(a[i].first, a[i].second);

		deg[a[i].first]++;
		deg[a[i].second]++;

		if (deg[a[i].first] == n - 1 || deg[a[i].second] == n - 1)
			bad = true;

		g[a[i].first].push_back(a[i].second);
		g[a[i].second].push_back(a[i].first);
	}


	if (bad || !m)
		cout << "NO\n";
	else {
		cout << "YES\n";
		vector<int> res1(n), res2(n);

		res1[0] = res2[0] = 1;


		for (int i = 1; i < n - 1; i++)
			res1[i] = res2[i] = i + 2;

		res1[n - 1] = 2;
		res2[n - 1] = 1;

		for (int i : res1)
			cout << i << " ";
		cout << endl;
		for (int i : res2)
			cout << i << " ";
	}




	


	/*vector<bool> used(n, false);
	vector<int> order;
	dfsTopo(0, g, order, used);

	for (int v : order)
		cout << v + 1 << " ";*/

	/*vector<int> deg(n, 0);
	for (int i = 0; i < n; i++)
		deg[i]++;

	int count = 0, v1 = -1, v2 = -1;
	for (int i = 0; i < n; i++)
		if (deg[i] % 2) {
			count++;
			if (v1 == -1)
				v1 = i;
			else if (v2 == -1)
				v2 = i;
		}

	if (count > 2) {
		cout << "NO" << endl;
	}
	else {
		cout << "YES\n";
	}*/


    return 0;
}

