#define M_E        2.71828182845904523536   // e
#define M_LOG2E    1.44269504088896340736   // log2(e)
#define M_LOG10E   0.434294481903251827651  // log10(e)
#define M_LN2      0.693147180559945309417  // ln(2)
#define M_LN10     2.30258509299404568402   // ln(10)
#define M_PI       3.14159265358979323846   // pi
#define M_PI_2     1.57079632679489661923   // pi/2
#define M_PI_4     0.785398163397448309616  // pi/4
#define M_1_PI     0.318309886183790671538  // 1/pi
#define M_2_PI     0.636619772367581343076  // 2/pi
#define M_2_SQRTPI 1.12837916709551257390   // 2/sqrt(pi)
#define M_SQRT2    1.41421356237309504880   // sqrt(2)
#define M_SQRT1_2  0.707106781186547524401  // 1/sqrt(2)
#include <iostream>
#include <fstream>
#include <sstream>
#include <cmath>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <string>
#include <unordered_map>
#include <unordered_set>
#include <future>

using namespace std;

#define IN_FILE "in.txt"
#define OUT_FILE "out.txt"

#define EPS 1e-6
#define INF 1e18
#define SMALL_INF 1e9

#pragma warning (disable : 4996)

vector<pair<int, int>> vp;

vector<int> cnt, ansA, ansB;
vector<bool> used;

int main()
{
#ifdef  _DEBUG
	freopen(IN_FILE, "r", stdin);
	freopen(OUT_FILE, "w", stdout);
#endif
	int n, m;
	cin >> n >> m;
	vp.resize(m);
	cnt.resize(n);
	for (int i = 0; i < m; i++)
	{
		scanf("%d%d", &vp[i].first, &vp[i].second);
		vp[i].first--;
		vp[i].second--;
		cnt[vp[i].first]++;
		cnt[vp[i].second]++;
	}
	if (n == 1)
	{
		cout << "NO\n";
		return 0;
	}
	int l = -1, r = -1;
	for (int i = 0; i < n; i++)
	{
		if (cnt[i] < n - 1)
		{
			l = i;
			break;
		}
	}
	used.resize(n);
	if (l == -1)
	{
		cout << "NO\n";
		return 0;
	}
	used[l] = true;
	for (int i = 0; i < m; i++)
	{
		if (vp[i].first == l)
			used[vp[i].second] = true;
		if (vp[i].second == l)
			used[vp[i].first] = true;
	}
	ansA.resize(n);
	ansB.resize(n);
	for (int i = 0; i < n; i++)
	{
		if (!used[i])
		{
			r = i;
			break;
		}
	}
	if (r == -1)
	{
		cout << "NO\n";
		return 0;
	}
	ansA[l] = 1;
	ansB[l] = 1;
	ansA[r] = 2;
	ansB[r] = 1;
	int cur = 3;
	for (int i = 0; i < n; i++)
	{
		if (i == l || i == r)
			continue;
		ansA[i] = cur;
		ansB[i] = cur;
		cur++;
	}
	cout << "YES\n";
	for (int val : ansA)
	{
		printf("%d ", val);
	}
	printf("\n");
	for (int val : ansB)
	{
		printf("%d ", val);
	}
	printf("\n");
	return 0;
}

