#include <bits/stdc++.h>

using namespace std;

struct kek
{
	int from, to, kind;
};

const int N = 2000;

bitset <N> vis;
bitset <N> good;

int main()
{
#ifdef ONPC
	freopen("a.in", "r", stdin);
#endif
	ios::sync_with_stdio(0);
	cin.tie(0);
	int n, m;
	cin >> n >> m;
	vector <vector <int> > a(n), el(m);
	vector <pair <int, int> > ord;
	vector <set <int> > petuh(n);
	int sum = 0;
	for (int i = 0; i < n; i++)
	{
		int s;
		cin >> s;
		sum += s;
		ord.push_back({s, i});
		for (int j = 0; j < s; j++)
		{
			int x;
			cin >> x;
			x--;
			petuh[i].insert(x);
			el[x].push_back(i);
			a[i].push_back(x);
		}
	}
	sort(ord.rbegin(), ord.rend());
	vector <int> lens(n);
	vector <int> sz(n);
	for (int i = 0; i < n; i++)
	{
		sz[i] = a[i].size();
	}
	for (int i = 0; i < n; i++) lens[i] = sum / n;
	for (int i = 0; i < sum % n; i++) lens[i]++;
	vector <int> need(n);
	for (int i = 0; i < n; i++)
	{
		need[ord[i].second] = lens[i];
	}
	vector <kek> ret;
	if (n < N)
	{
		for (int i = 0; i < n; i++) vis[i] = 0;
		for (int i = 0; i < n; i++)
		{
			if (sz[i] < need[i])
			{
				good[i] = 1;
			}
		}
		vector <int> ord;
		vector <int> rem;
		for (int i = 0; i < m; i++)
		{
			ord.clear();
			for (int x : el[i]) vis[x] = true;
			for (int x : el[i])
			{
				if (sz[x] > need[x])
				{
					ord.push_back(x);
				}
			}
			while (!ord.empty() && (good & ~vis).count())
			{
				int j = (good & ~vis)._Find_first();
				ret.push_back({ord.back(), j, i});
				sz[ord.back()]--;
				sz[j]++;
				vis[j] = 1;
				rem.push_back(j);
				if (sz[j] == need[j])
				{
					good[j] = 0;
				}
				ord.pop_back();
			}
			for (int x : el[i]) vis[x] = 0;
			for (int x : rem) vis[x] = 0;
			rem.clear();
		}
	}
	else
	{
		set <pair <int, int> > q;
		for (int j = 0; j < n; j++)
		{
			q.insert({sz[j], j});
		}
		vector <bool> have(m);
		while (q.size() > 1)
		{
			if (q.begin()->first == need[q.begin()->second])
			{
				q.erase(q.begin());
				continue;
			}
			if (q.rbegin()->first == need[q.rbegin()->second])
			{
				q.erase(--q.end());
				continue;
			}
			int from = q.rbegin()->second;
			int to = q.begin()->second;
			for (int x : petuh[to])
			{
				have[x] = 1;
			}
			for (int x : petuh[from])
			{
				if (!have[x])
				{
					q.erase({sz[from], from});
					q.erase({sz[to], to});
					sz[from]--;
					sz[to]++;
					petuh[from].erase(x);
					ret.push_back({from, to, x});
					petuh[to].insert(x);
					q.insert({sz[from], from});
					q.insert({sz[to], to});
					break;
				}
			}
			for (int x : petuh[to])
			{
				have[x] = 0;
			}
		}
	}
	cout << ret.size() << '\n';
	for (auto c : ret)
	{
		cout << c.from + 1 << ' ' << c.to + 1 << ' ' << c.kind + 1 << '\n';
	}
}
