#include <bits/stdc++.h>

using namespace std;

vector <pair <int, int> > e;

bool u[8][8];

vector <pair <int, int> > path;

int dx[] = {-1, 1, -2, 2, 1, -1, 2, -2};
int dy[] = {-2, -2, -1, 1, -2, 2, -1, 1};

vector <pair <int, int> > mda[8][8];

vector <pair <int, int> > pth(int x1, int y1, int x2, int y2)
{
	e.clear();
	for (int i = 0; i < 8; i++) for (int j = 0; j < 8; j++) mda[i][j].clear();
	mda[x1][y1].push_back({x1, y1});
	queue <pair <int, int> > q;
	q.push({x1, y1});
	while (!q.empty())
	{
		int x = q.front().first, y = q.front().second;
		q.pop();
		for (int t = 0; t < 8; t++)
		{
			int gx = x + dx[t], gy = y + dy[t];
			if (0 <= gx && gx < 8 && 0 <= gy && gy < 8 && mda[gx][gy].empty())
			{
				mda[gx][gy] = mda[x][y];
				mda[gx][gy].push_back({gx, gy});
				q.push({gx, gy});
			}
		}
	}
	return mda[x2][y2];
}

bool vis[8][8];
vector <pair <pair <int, int>, pair <int, int> > > ans;

void go(int x1, int y1, int x2, int y2)
{
	auto p = pth(x1, y1, x2, y2);
	for (int i = 0; i + 1 < (int) p.size(); i++)
	{
		if (!vis[p[i + 1].first][p[i + 1].second])
		{
			vis[p[i].first][p[i].second] = 0;
			ans.push_back({p[i], p[i + 1]});
			vis[p[i + 1].first][p[i + 1].second] = 1;
		}
		else
		{
			go(p[i + 1].first, p[i + 1].second, x2, y2);
			vis[p[i].first][p[i].second] = 0;
			ans.push_back({p[i], p[i + 1]});
			vis[p[i + 1].first][p[i + 1].second] = 1;
			break;
		}
	}
}

int main()
{
	//freopen("a.in", "r", stdin);
	int k;
	cin >> k;
	vector <pair <int, int> > e;
	for (int i = 0; i < k; i++)
	{
		char a, b;
		cin >> a >> b;
		int r = a - 'a';
		int c = b - '1';
		vis[r][c] = 1;
		e.push_back({r, c});
	}
	vector <pair <int, int> > f;
	for (int j = 0; j < 8; j++)
	{
		for (int i = 0; i < 8; i++)
		{
			f.push_back({i, j});
		}
	}
	while (f.size() > k) f.pop_back();
	vector <pair <int, int> > ne, nf;
	for (auto c : e)
	{
		bool good = false;
		for (auto d : f)
		{
			if (d == c) good = true;
		}
		if (!good) ne.push_back(c);
	}
	for (auto c : f)
	{
		bool good = false;
		for (auto d : e)
		{
			if (d == c) good = true;
		}
		if (!good) nf.push_back(c);
	}
	e = ne, f = nf;
	for (int i = 0; i < (int) e.size(); i++)
	{
		go(e[i].first, e[i].second, f[i].first, f[i].second);
	}
	cout << ans.size() << '\n';
	assert(ans.size() <= 1500);
	for (auto c : ans)
	{
		cout << char(c.first.first + 'a') << c.first.second + 1 << '-';
		cout << char(c.second.first + 'a') << c.second.second + 1 << '\n';
	}
}
