#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cmath>
#include <stack>
#include <algorithm>
#include <queue>
#include <vector>
#include <deque>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <iomanip>
#include <minmax.h>
#include <string>
#define pb push_back
#define mp make_pair

using namespace std;
typedef long long ll;
typedef long double ld;

bool check(int a, int b) {
	return (a >= 0 && a < 8 && b >= 0 && b < 8);
}

vector<pair<int, int>> napr = { { 1, 2 },{ 1, -2 },{ -1, 2 },{ -1, -2 },{ 2, 1 },{ -2, 1 },{ 2, -1 },{ -1, -1 } };

int Data[8][8];

bool used[8][8];
int put[8][8];
bool us[8][8];

void clear() {
	for (int i = 0; i < 8; i++) {
		for (int j = 0; j < 8; j++) {
			put[i][j] = 0;
			used[i][j] = false;
			us[i][j] = false;
		}
	}
}

vector<string> res;

int hod = 0;

void dfs(int x, int y) {
	used[x][y] = true;
	if (Data[x][y] == 1 && x * 8 + y > hod) {
		used[x][y] = true;
		put[x][y] = 1;
		return;
	}
	for (int i = 0; i < 8; i++) {
		int nx = x + napr[i].first, ny = y + napr[i].second;
		if (!check(nx, ny)) continue;
		if (!used[nx][ny]) {
			dfs(nx, ny);
			if (put[nx][ny]) {
				put[x][y] = put[nx][ny] + 1;
				return;
			}
		}
	}
	return;
}

void add() {
	vector<pair<int, pair<int, int> > > p;
	for (int i = 0; i < 8; i++) {
		for (int j = 0; j < 8; j++) {
			if (put[i][j]) {
				p.push_back({ put[i][j],{ i, j } });
			}
		}
	}
	sort(p.rbegin(), p.rend());
	vector<string> v;
	int cnt = 0;
	for (int i = 0; i < p.size() - 1; i++) {
		string s = "";
		s.push_back(p[i + 1].second.first + 'a');
		s.push_back(p[i + 1].second.second + '1');

		s.push_back('-');

		s.push_back(p[i].second.first + 'a');
		s.push_back(p[i].second.second + '1');
		v.push_back(s);
		if (Data[p[i + 1].second.first][p[i + 1].second.second] == 1) {
			reverse(v.begin(), v.end());
			for (int j = 0; j < v.size(); j++) {
				res.push_back(v[j]);
			}
			v.clear();
		}
	}

}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "r", stdin);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	clear();
	int n;
	cin >> n;
	for (int i = 0; i < n; i++) {
		char a, b;
		cin >> a >> b;
		Data[a - 'a'][b - '1'] = 1;
	}
	for (int i = 0; i < n; i++) {
		int x = i / 8, y = i % 8;
		hod = i;
		dfs(x, y);
		add();
		clear();
	}
	cout << res.size() << endl;
	for (int i = 0; i < res.size(); i++) {
		cout << res[i] << endl;
	}
	return 0;
}