#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cmath>
#include <stack>
#include <algorithm>
#include <queue>
#include <vector>
#include <deque>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <iomanip>
#include <minmax.h>
#include <string>
#define pb push_back
#define mp make_pair

using namespace std;
typedef long long ll;
typedef long double ld;

bool check(int a, int b) {
	return (a >= 0 && a < 8 && b >= 0 && b < 8);
}

vector<pair<int, int>> napr = { { 1, 2 },{ 1, -2 },{ -1, 2 },{ -1, -2 },{ 2, 1 },{ -2, 1 },{ 2, -1 },{ -1, -1 } };

int Data[8][8];
pair <int, int> dp[8][8][8][8];
bool used[8][8];
int put[8][8];
bool us[8][8];

void bfs(int x, int y)
{
	queue <pair <int, int>> q;
	q.push(mp(x, y));
	int a = x, s = y;
	while (!q.empty())
	{
		auto p = q.front();
		q.pop();
		x = p.first, y = p.second;
		for (int qq = -2; qq <= 2; qq++)
			for (int w = -2; w <= 2; w++)
				if (abs(qq) + abs(w) == 3)
				{
					int xx = x + qq, yy = y + w;
					if (xx >= 0 && xx < 8 && yy >= 0 && yy < 8 && dp[a][s][xx][yy].first == 100000)
					{
						dp[a][s][xx][yy] = mp(x, y);
						q.push(mp(xx, yy));
					}
				}
	}
}

void clear() {
	for (int i = 0; i < 8; i++) {
		for (int j = 0; j < 8; j++) {
			put[i][j] = 0;
			used[i][j] = false;
			us[i][j] = false;
		}
	}
}

vector<string> res;

int hod = 0;

void dfs(int x, int y) {
	used[x][y] = true;
	if (Data[x][y] == 1 && x * 8 + y > hod) {
		used[x][y] = true;
		put[x][y] = 1;
		return;
	}
	for (int i = 0; i < 8; i++) {
		int nx = x + napr[i].first, ny = y + napr[i].second;
		if (!check(nx, ny)) continue;
		if (!used[nx][ny]) {
			dfs(nx, ny);
			if (put[nx][ny]) {
				put[x][y] = put[nx][ny] + 1;
				return;
			}
		}
	}
	return;
}

void add() {
	vector<pair<int, pair<int, int> > > p;
	for (int i = 0; i < 8; i++) {
		for (int j = 0; j < 8; j++) {
			if (put[i][j]) {
				p.push_back({ put[i][j],{ i, j } });
			}
		}
	}
	sort(p.rbegin(), p.rend());
	vector<string> v;
	pair<int, int> ss = p[0].second;
	for (int i = 0; i < p.size() - 1; i++) {
		string s = "";
		s.push_back(p[i + 1].second.first + 'a');
		s.push_back(p[i + 1].second.second + '1');

		s.push_back('-');

		s.push_back(p[i].second.first + 'a');
		s.push_back(p[i].second.second + '1');
		v.push_back(s);
		if (Data[p[i + 1].second.first][p[i + 1].second.second] == 1) {
			reverse(v.begin(), v.end());
			for (int j = 0; j < v.size(); j++) {
				res.push_back(v[j]);
			}
			v.clear();
			Data[p[i + 1].second.first][p[i + 1].second.second] = 0;
			Data[ss.first][ss.second] = 1;
			ss = p[i + 1].second;
		}
	}

}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	for (int a = 0; a < 8; a++)
		for (int b = 0; b < 8; b++)
			for (int c = 0; c < 8; c++)
				for (int d = 0; d < 8; d++)
					dp[a][b][c][d] = mp(100000, 100000);
	for (int x = 0; x < 8; x++)
		for (int y = 0; y < 8; y++)
			bfs(x, y);
	clear();
	int n;
	cin >> n;
	for (int i = 0; i < n; i++) {
		char a, b;
		cin >> a >> b;
		Data[a - 'a'][b - '1'] = 1;
	}
	for (int i = 0; i < n; i++) {
		int a = i / 8, b = i % 8;
		if (Data[a][b] == 1) continue;
		int c, d;
		bool f = false;
		for (int q = 0; q < 8; q++) {
			for (int w = 0; w < 8; w++) {
				if (q * 8 + w > i) {
					if (Data[q][w] == 1) {
						c = q;
						d = w;
						f = true;
						break;
					}
				}
			}
			if (f) {
				break;
			}
		}
		vector<pair<int, int> > pp;
		int cc = c, dd = d;
		while (a != c || b != d) {
			pp.push_back({ c, d });
			int x = dp[a][b][c][d].first, y = dp[a][b][c][d].second;
			c = x;
			d = y;
		}
		pp.push_back({ a, b });
		reverse(pp.begin(), pp.end());
		vector<string> v;
		for (int j = 0; j < pp.size() - 1; j++) {
			string s = "";
			s.push_back(pp[j + 1].first + 'a');
			s.push_back(pp[j + 1].second + '1');
			s.push_back('-');
			s.push_back(pp[j].first + 'a');
			s.push_back(pp[j].second + '1');
			v.push_back(s);
			if (Data[pp[j + 1].first][pp[j + 1].second] == 1) {
				for (int k = v.size() - 1; k >= 0; k--) {
					res.push_back(v[k]);
				}
				v.clear();
			}
		}
		Data[cc][dd] = 0;
		Data[a][b] = 1;
	}
	cout << res.size() << endl;
	for (int i = 0; i < res.size(); i++) {
		cout << res[i] << endl;
	}
	return 0;
}