#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define F first
#define S second
#define M make_pair

#define endl "\n"

typedef pair<int, int> pii;
typedef long long ll;
typedef long double ld;

const int inf = 2e9 + 27;
const int mod = 1e9 + 7;

int n, m, a[1000005], b[1000005];
set <pii> s;

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	
	cin >> n >> m;
	
	for (int i = 0; i < m; i++) {
		int u, v;
		cin >> u >> v;
		
		if (u > v)
			swap(u, v);
		
		s.insert({u, v});
	}
	
	pii g = {-1, -1};
	
	for (int i = 1; i <= n; i++) {
		for (int j = i + 1; j <= n; j++) {
			if (!s.count({i, j})) {
				g = {i, j};
				break;
			}
		}
	}
	
	if (g.first == -1) {
		cout << "NO";
		return 0;
	}
	
	a[g.first] = 1;
	a[g.second] = 2;
	int k = 3;
	
	for (int i = 1; i <= n; i++) {
		if (!a[i]) {
			a[i] = k++;
		}
		
		b[i] = a[i];
		
		if (b[i] == 2)
			b[i] = 1;
	}
	
	for (auto it : s) {
		if ((a[it.first] > a[it.second]) && (b[it.first] <= b[it.second])) {
			cout << "NO";
			return 0;
		}
		
		if ((a[it.first] < a[it.second]) && (b[it.first] >= b[it.second])) {
			cout << "NO";
			return 0;
		}
	}

	cout << "YES" << endl;
	for (int i = 1; i <= n; i++)
		cout << a[i] << " ";
	cout << endl;
	for (int i = 1; i <= n; i++)
		cout << b[i] << " ";
	cout << endl;
	
	return 0;
}
