
#include <bits/stdc++.h>

#define pb push_back
#define mp make_pair
#define len(v) ((int)v.size())

using namespace std;

typedef pair<int, int> pii;
typedef long long ll;
typedef long double ld;

template<class T>
istream &operator>>(istream &is, vector<T> &v) {
    for (T &x : v) {
        is >> x;
    }
    return is;
}


template<class T>
ostream &operator<<(ostream &os, const vector<T> &v) {
    for (const T &x : v) {
        os << x << " ";
    }
    return os;
}


void run();

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    //freopen("input.txt", "r", stdin);
    run();
}

int n, m;
vector<set<int>> v;
vector<set<int>> type_big;
vector<set<int>> type_small;
vector<bool> feed;
vector<int> mem;
int L;
int get_up(int i) {
    if (i == n) return i;
    if (!feed[i] && len(v[i]) < L) {
        return mem[i] = i;
    }
    int next;
    if (mem[i] == -1 || mem[i] == i) {
        next = i + 1;
    } else {
        next = mem[i];
    }
    return mem[i] = get_up(next);
}

void run() {
    cin >> n >> m;
    feed.resize(n, false);
    v.resize(n);
    mem.resize(n, -1);
    int S = 0;
    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;

        for (int j = 0; j < k; j++) {
            int x;
            cin >> x;
            v[i].insert(x);
        }

        S += k;
    }

    L = S / n;
    int big = S - L * n;

    type_big.resize(m + 1);
    type_small.resize(m + 1);
    for (int i = 0; i < len(v); i++) {
        if (len(v[i]) > L) {
            if (big) {
                if (len(v[i]) == L + 1) {
                    big--;
                } else {
                    for (int x : v[i]) {
                        type_big[x].insert(i);
                    }
                }
            } else {
                for (int x : v[i]) {
                    type_big[x].insert(i);
                }
            }
        }

        if (len(v[i]) < L) {
            for (int x : v[i]) {
                type_small[x].insert(i);
            }
        }
    }
    vector<vector<int>> rez;
    for (int t = 1; t <= m; t++) {
        vector<int> free;
        set<int> _s(type_small[t].begin(), type_small[t].end());
        for (int j = get_up(0); j < n && len(free) <= len(type_big[t]); j = get_up(j + 1)) {
            if (!_s.count(j)) {
                free.pb(j);
            }
        }
        vector<int> _big(type_big[t].begin(), type_big[t].end());
        for (int i = 0; i < min(len(free), len(_big)); i++) {
            int from = _big[i];
            int to = free[i];
            rez.pb(vector<int>{from, to, t});
            v[from].erase(t);
            if (big) {
                if (len(v[from]) == L + 1) {
                    big--;
                    for (int x : v[from]) {
                        type_big[x].erase(from);
                    }
                }
            } else {
                if (len(v[from]) == L) {
                    for (int x : v[from]) {
                        type_big[x].erase(from);
                    }
                }
            }

            v[to].insert(t);
            if (len(v[to]) == L) {
             //   cout << "DELETE " << to << " " << t << endl;
                feed[to] = true;
            }
        }
    }
    cout << len(rez) << endl;
    for (vector<int> x : rez) {
        cout << x[0] + 1 << " " << x[1] + 1 << " " << x[2] << endl;
    }
}
