#include <bits/stdc++.h>

#define pb push_back
#define mp make_pair
#define x first
#define y second

#define len(v) ((int)v.size())

using namespace std;

typedef pair<int, int> pii;
typedef long long ll;
typedef long double ld;
typedef unsigned int uint;

template<class T>
istream &operator>>(istream &is, vector<T> &v) {
    for (T &x : v) {
        is >> x;
    }
    return is;
}


template<class T>
ostream &operator<<(ostream &os, const vector<T> &v) {
    for (const T &x : v) {
        os << x << " ";
    }
    return os;
}


void run();

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    //freopen("input.txt", "r", stdin);
    run();
}

int n;
int a[1001];
map<vector<int>, int> ans;

int f(vector<int> a) {
    sort(a.begin(), a.end());
    if (ans.count(a)) {
        return ans[a];
    }
    cout << "? " << a << endl;
    cin >> ans[a];
   return ans[a];
}

int ansx[1001];


void solve(int L, int R) {
    vector<vector<int>> res;
    vector<int> rep;
    for (int i = L; i <= R; ++i) {
        for (int j = i + 1; j <= R; ++j) {
            for (int k = j + 1; k <= R; ++k) {
                res.pb({i, j, k});
                rep.pb(f({i, j, k}));
            }
        }
    }
    vector<int> a;
    //cout << rep << endl;
    for (int M = L; M <= R; ++M) {
        a.pb(M - L);
    }
    //cout << L << endl;
    do {
        int resp[5][5];
        for (int i = 0; i < 5; ++i) {
            for (int j = 0; j < 5; ++j) {
                resp[i][j] = -1e9;
            }
        }
        bool OK = true;
        for (int i = 0; i < res.size(); ++i) {
            vector<pair<int, int>> cur;
            for (int j = 0; j < 3; ++j) {
                cur.pb({a[res[i][j] - L], res[i][j]});
            }
            sort(cur.begin(), cur.end());
            //cout << cur[0].x << ' ' << cur[1].x << endl;
            if (resp[cur[0].x][cur[2].x] == -1e9) {
                resp[cur[0].x][cur[2].x] = rep[i];
            } else if (resp[cur[0].x][cur[2].x] != rep[i]) {
                OK = false;
                break;
            }
        }
        //cout << endl;
        long long sum = resp[0][2] + resp[1][3] + resp[2][4] + resp[0][4] + resp[1][3];
        //cout << sum << endl;
        if (sum % 2) continue;
        sum >>= 1;
        vector<long long> cool(5);
        cool[2] = resp[0][2] + resp[1][3] + resp[2][4] - sum;
        cool[0] = resp[0][2] - cool[2];
        cool[3] = resp[0][3] - cool[0];
        cool[4] = resp[0][4] - cool[0];
        cool[1] = resp[1][4] - cool[4];
        for (int i = 0; i < 5; ++i) {
            for (int j = i + 2; j < 5; ++j) {
                //cout << i << " " << j << ' ' << resp[i][j] << endl;
                if (resp[i][j] != cool[i] + cool[j]) {
                    OK = false;
                    break;
                }
            }
        }
        for (int i = 0; i < 4; ++i) {
            if (cool[i] > cool[i + 1]) {
                OK = false;
            }
        }
        //
        //cout << cool << endl;
        if (OK) {
            for (int M = L; M <= R; ++M) {
                ansx[M] = cool[a[M - L]];
            }
            return;
        }
    } while (next_permutation(a.begin(), a.end()));
}

void run() {
    cin >> n;
    for (int i = 1; i <= n; i += 5) {
        int L = i, R = i + 5 - 1;
        if (R > n) R = n, L = n - 4;
        solve(L, R);
    }
    cout << "! ";
    for (int i = 0; i < n; ++i) {
        cout << ansx[i + 1] << ' ';
    }
    cout << '\n';
}



