#include <bits/stdc++.h>

#define pb push_back
#define mp make_pair
#define x first
#define y second

#define len(v) ((int)v.size())

using namespace std;

typedef pair<int, int> pii;
typedef long long ll;
typedef long double ld;
typedef unsigned int uint;

template<class T>
istream &operator>>(istream &is, vector<T> &v) {
    for (T &x : v) {
        is >> x;
    }
    return is;
}


template<class T>
ostream &operator<<(ostream &os, const vector<T> &v) {
    for (const T &x : v) {
        os << x << " ";
    }
    return os;
}


void run();

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    //freopen("input.txt", "r", stdin);
    run();
}


int t;
unsigned int

long long ans;
int n;

int a[20000001];
uint b[20000001];

void read() {
    ll l, r;
    uint x, y, z;
    cin >> n >> l >> r >> x >> y >> z >> b[0] >> b[1];
    for (int i = 2; i < n; i++) {
        b[i] = (b[i - 2] * x + b[i - 1] * y + z);
    }
    for (int i = 0; i < n; i++) {
        ll P = (ll)((ll)b[i] % ((ll)r - (ll)l + 1LL)) + (ll)l;
        a[i] = P;
    }
}

long long solve() {
    read();
    long long ans = 4e18;
    long long L1 = 1e9, R1 = -1e9, L2 = 1e9, R2 = -1e9;
    int last_plus = -1, first_minus = n;
    for (int i = 0; i < n; ++i) {
        if (a[i] < 0) {
            if (first_minus == n) first_minus = i;
            L1 = min(L1, 1LL * a[i]);
        } else {
            if (first_minus != n) {
                ans = min(ans, L1 * a[i]);
            }
            if (last_plus != -1) {
                if (L2 < a[i]) {
                    ans = min(ans, L2 * a[i]);
                }
            }
            L2 = min(L2, 1LL * a[i]);
            last_plus = i;
        }
    }
    if (last_plus + 1 == first_minus) {
        //cout << "HI" << endl;
        long long L = 1e9;
        for (int i = n; i--;) {
            if (a[i] >= 0) break;
            if (i != n) {
                ans = min(ans, a[i] * L);
            }
            L = min(-1LL * a[i], L);
        }
    }
    return ans;
}

void run() {
    int t;
    cin >> t;
    while (t--) {
        long long ans = solve();
        if (ans == 4e18) {
            cout << "IMPOSSIBLE\n";
        } else {
            cout << ans << '\n';
        }
    }
}


