#include <bits/stdc++.h>

#define pb push_back
#define mp make_pair
#define x first
#define y second

#define len(v) ((int)v.size())

using namespace std;

typedef pair<int, int> pii;
typedef long long ll;
typedef long double ld;
typedef unsigned int uint;

template<class T>
istream &operator>>(istream &is, vector<T> &v) {
    for (T &x : v) {
        is >> x;
    }
    return is;
}


template<class T>
ostream &operator<<(ostream &os, const vector<T> &v) {
    for (const T &x : v) {
        os << x << " ";
    }
    return os;
}


void run();

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    freopen("input.txt", "r", stdin);
    run();
}

long long t, n, a, b, k;

long long solve(long long cnta, long long cntb, long long v1, long long v2 = -2) {
    if (v2 == -2) v2 = v1 - 1;
    return (cnta * v1 + cntb * v2) / k;
}

long long cnta, cntb;

bool check(long long M) {
    if (b < M || a * cnta - M * (k - cntb) < 0) return false;
    long long cur = (a * cnta - M * (k - cntb));
    long long cb = cur % cnta;
    long long ca = cnta - cb;
    long long v1 = cur / cnta + 1;
    long long v2 = b - M;
    return v2 > v1;
}

bool check2(long long M) {
    if (b < M || a * cnta - M * (k - cntb) < 0) return false;
    long long cur = (a * cnta - M * (k - cntb));
    long long cb = cur % cnta;
    long long ca = cnta - cb;
    long long v1 = cur / cnta + 1;
    long long v2 = b - M;
    return true;
}

void run() {
    cin >> t >> n >> a >> b >> k;
    cntb = n >> 1;
    cnta = n - cntb;
    if (a > b) {
        swap(a, b);
        swap(cnta, cntb);
    }
    if (k > n) {
        cout << 0 << endl;
        return;
    }
    if (cntb < k) {
        long long L = -1, R = t + 1;
        while (R - L > 1) {
            long long M = (L + R) >> 1;
            if (check(M)) {
                L = M;
            } else {
                R = M;
            }
        }
        if (check2(L)) ++L;
        long long cur = (a * cnta - L * (k - cntb));
        long long cb = cur % cnta;
        long long ca = cnta - cb;
        long long v1 = cur / cnta + 1;
        long long v2 = b - R;
        //cout << L << ':' << v2 << ' ' << cntb << ' ' << v1 << ' ' << cb << ' ' << v1 - 1 << ' ' << ca << endl;
        if (v2 == v1) {
            L += solve(cb + cntb, ca, v1);
        } else {
            if (v2 + 1 == v1) {
                L += solve(cb, ca + cntb, v1);
            }
        }
        t = min(L, t);
    } else {
        long long cur = (b - a) * cntb / k;
        cntb = (b - a) * cntb % k;
        cnta = n - cntb;
        b = a + 1;
        cur += solve(cntb, cnta, b);
        t = min(cur, t);
    }
    cout << t << endl;
}


