#include <bits/stdc++.h>

#define f first
#define s second
#define pb push_back
#define mp make_pair
#define all(a) (a).begin(), (a).end()
#define int long long
using namespace std;

template<typename T1, typename T2> inline void chkmin(T1 & x, T2 y) {if (x > y) x = y;}
template<typename T1, typename T2> inline void chkmax(T1 & x, T2 y) {if (x < y) x = y;}

typedef long long ll;

const int MAXN = 1e7 + 1;
const int MOD = 1LL << 32;
ll a[MAXN], b[MAXN], go[MAXN];
const ll INF = 4e18 + 1;
ll suf[MAXN];

ll solve1(int l, int r) {
    if (l == r) return INF;
    int p = l;
    for (int i = l + 1; i <= r; ++i) {
        if (a[i] <= a[p]) {
            go[p] = i;
            p = i;
        }
    }
    go[p] = r + 1;
    int cur = l;
    ll ans = INF;
    while (cur != r + 1) {
        ll cur_min = INF;
        for (int j = cur + 1; j < go[cur]; ++j) {
            chkmin(cur_min, a[j]);
        }
        if (cur_min == INF) {
            cur = go[cur];
        continue;
        }
        chkmin(ans, cur_min * a[cur]);

        cur = go[cur];
    }
    return ans;
}

ll solve2(int l, int r) {
    suf[r] = a[r];
    for (int i = r - 1; i >= l; i--){
        suf[i] = max(suf[i + 1], a[i]);
    }
    ll ans = INF;
    for (int i = l; i < r; i++){
        if (a[i] >= 0) continue;
        if (suf[i + 1] > a[i]){
            chkmin(ans, a[i] * suf[i + 1]);
        }
    }
    return ans;
}

bool check(int l, int r) {
    for (int i = l; i < r; ++i)
        if (a[i] < a[i + 1]) return true;
    return false;
}


ll solve(int n)
{
    bool pos = false, neg = false;
    for (int i = 0; i < n; ++i) {
        if (a[i] < 0) neg = true;
        else pos = true;
    }


    if (!check(0, n - 1)) {
        return INF;
        cout << "Impossible\n";
        //continue;
    }
    if (pos && !neg) {
        return solve1(0, n - 1);
        cout << solve1(0, n - 1) << '\n';
        //continue;
    }
    int idNeg = -1;
    bool fl = true;
    for (int i = 0; i < n; i++){
        if (idNeg == -1 && a[i] < 0){
            idNeg = i;
        }
        if (idNeg != -1 && a[i] >= 0){
            fl = false;
        }
    }
    if (fl && idNeg != 0){
        ll ans = min(solve1(0, idNeg - 1), solve2(idNeg, n - 1));
        return ans;
        cout << ans << '\n';
        //continue;
    }
    return solve2(0, n - 1);
    cout << solve2(0, n - 1) << '\n';
}

ll solve3(int n)
{
    if (!check(0, n - 1)){
        return INF;
    }
    ll ans = INF;
    for (int i = 0; i < n; i++){
        for (int j = i + 1; j < n; j++){
            if (a[i] < a[j]){
                chkmin(ans, a[i] * a[j]);
            }
        }
    }
    return ans;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
#ifdef DEBUG
    //freopen("in", "r", stdin);
#endif // DEBUG
    int t;
    cin >> t;
    while (t--) {
        int n, l, r, x, y, z;
        cin >> n >> l >> r >> x >> y >> z >> b[0] >> b[1];
        bool pos = false, neg = false;
        for (int i = 2; i < n; ++i) {
            b[i] = (b[i - 2] * x + b[i - 1] * y + z) % MOD;
            a[i] = (b[i] % (r - l + 1)) + l;
            if (a[i] < 0) neg = true;
            else pos = true;
        }
        for (int i = 0; i < 2; ++i) {
            a[i] = (b[i] % (r - l + 1)) + l;
            if (a[i] < 0) neg = true;
            else pos = true;
        }
        ll tmp = solve(n);
        if (tmp == INF)
            cout << "IMPOSSIBLE\n";
        else
            cout << tmp << '\n';
        //cout << solve(n) << '\n';
        /*int n = rand() % 10 + 1000;
        for (int i = 0; i < n; i++){
            a[i] = rand() % (int)2e9;
            if (rand() % 2){
                a[i] = -a[i];
            }
        }
        if (solve(n) != solve3(n)){
            cout << "WRONG" << endl;
            for (int i = 0; i < n; i++){
                cout << a[i] << ' ';
            }
            return 0;
        }
        cout << "OK" << endl;
        *//*
        int n;
        cin >> n;
        for (int i = 0; i < n; ++i) {
            cin >> a[i];
        }
        cout << solve(n) << '\n';
        */
    }
    cout << endl;
    return 0;
}
