#include <bits/stdc++.h>

#define f first
#define s second
#define pb push_back
#define mp make_pair
#define all(a) (a).begin(), (a).end()
#define int long long
using namespace std;

template<typename T1, typename T2> inline void chkmin(T1 & x, T2 y) {if (x > y) x = y;}
template<typename T1, typename T2> inline void chkmax(T1 & x, T2 y) {if (x < y) x = y;}

typedef long long ll;

const int MAXN = 1e7 + 1;
const int MOD = 1LL << 32;
ll a[MAXN], mn_pref[MAXN], mx_suf[MAXN];
unsigned int b[MAXN];
const ll INF = 4000000000000000001LL;

bool check(int l, int r) {
    for (int i = l; i < r; ++i)
        if (a[i] < a[i + 1]) return true;
    return false;
}

void solve(int n)
{
    assert(n <= 10000000);
    if (!check(0, n - 1)) {
        cout << "IMPOSSIBLE\n";
        return;
    }
    mn_pref[0] = a[0];
    for (int i = 1; i < n; ++i)
        mn_pref[i] = min(mn_pref[i - 1], a[i]);
    mx_suf[n - 1] = a[n - 1];
    for (int i = n - 2; i >= 0; --i)
        mx_suf[i] = max(mx_suf[i + 1], a[i]);
    ll ans = INF;
    for (int i = 0; i < n; ++i) {
        if (a[i] >= 0 && i - 1 >= 0) {
            ll val = mn_pref[i - 1];
            if (val < a[i])
                chkmin(ans, val * a[i]);
        }
        if (a[i] <= 0 && i + 1 < n) {
            ll val = mx_suf[i + 1];
            if (a[i] < val)
                chkmin(ans, val * a[i]);
        }
    }
    cout << ans << '\n';
    return;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    //srand(time(0));
#ifdef DEBUG
    //freopen("in", "r", stdin);
#endif // DEBUG
    //cout << INF << endl;
    int t;
    cin >> t;
    while (t--) {

        int n, l, r;
        unsigned int x, y, z;
        cin >> n >> l >> r >> x >> y >> z >> b[0] >> b[1];
        for (int i = 2; i < n; ++i) {
            b[i] = (b[i - 2] * x + b[i - 1] * y + z) % MOD;
            //cout << b[i] << ' ';
            //cout << endl;
            a[i] = (b[i] % (r - l + 1)) + l;
        }
        for (int i = 0; i < 2; ++i) {
            a[i] = (b[i] % (r - l + 1)) + l;
        }
        solve(n);
        /**/
        //cout << solve(n) << '\n';
        /*int n = rand() % 100 + 2;
        for (int i = 0; i < n; i++){
            a[i] = 2e9;
            a[i] = a[i];
            if (rand() % 2) a[i] = -a[i];
        }
        if (solve(n) != solve3(n)){
            cout << "WRONG" << endl;
            for (int i = 0; i < n; i++){
                cout << a[i] << ' ';
            }
            return 0;
        }
        cout << "OK" << endl;
        /*
        int n;
        cin >> n;
        for (int i = 0; i < n; ++i) {
            cin >> a[i];
        }
        cout << solve(n) << '\n';
        */
    }
    cout << endl;
    return 0;
}
