#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <algorithm>
#include <iomanip>
#include <cmath>
#include <string>
#include <ctime>
#include <cassert>
#include <random>
#include <functional>
#include <numeric>
#include <deque>
#include <queue>
#include <cstring>
#include <complex>
#define ll long long
#define ld long double
#define null NULL
#define all(a) a.begin(), a.end()
#define x first
#define y second

using namespace std;

template<class T> int chkmax(T &a, const T &b) {
	if (b > a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class T> int chkmin(T &a, const T &b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class iterator> void output(iterator begin, iterator end, ostream &out = cerr) {
	while (begin != end) {
		out << (*begin) << " ";
		begin++;
	}
	out << endl;
}

template<class T> void output(T &x, ostream &out = cerr) {
	output(x.begin(), x.end(), out);
}

void fast_io() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}
const int NIL = 2e9 + 7;

int main()
{
	string all;
	string s;
	while (getline(cin, s)) {
		all += s;
		all += '\n';
	}
	int n = (int)all.size();
	vector<string> ord;
	for (int i = 0; i < n; i++) {
		if (all.substr(i, 5) == "\\cite") {
			int r = -1;
			for (int j = i; j < n; j++) {
				if (all[j] == '}') {
					r = j;
					break;
				}
			}
			ord.push_back(all.substr(i + 6, r - i - 6));
		}
	}
	map<string, string> d;
	vector<string> prd1;
	string start, fin;
	for (int i = 0; i < n; i++) {
		if (all.substr(i, 6) == "\\begin") {
			int r = i;
			for (int j = i + 1; j < n; j++) {
				if (all[j] == '\\') {
					r = j;
					break;
				}
			}
			start = all.substr(i, r - i);
		}
		else if (all.substr(i, 8) == "\\bibitem") {
			int r = i;
			int r1 = i;
			for (int j = i + 1; j < n; j++) {
				if (all[j] == '}') {
					r1 = j;
				}
				if (all[j] == '\\') {
					r = j;
					break;
				}
			}
			d[all.substr(i + 9, r1 - i - 9)] = all.substr(i, r - i);
			prd1.push_back(all.substr(i + 9, r1 - i - 9));
		}
		else if (all.substr(i, 4) == "\\end") {
			fin = all.substr(i);
		}
	}
	if (prd1 == ord) {
		cout << "Correct" << endl;
		return 0;
	}
	cout << "Incorrect" << endl;
	cout << start;
	for (auto elem : ord) {
		cout << d[elem];
	}
	cout << fin;
	return 0;
}
/*
8 3
1 2 3 3 2 1 2 2
*/