#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <algorithm>
#include <iomanip>
#include <cmath>
#include <string>
#include <ctime>
#include <cassert>
#include <random>
#include <functional>
#include <numeric>
#include <deque>
#include <queue>
#include <cstring>
#include <complex>
#define ll long long
#define ld long double
#define null NULL
#define all(a) a.begin(), a.end()
#define x first
#define y second

using namespace std;

template<class T> int chkmax(T &a, const T &b) {
	if (b > a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class T> int chkmin(T &a, const T &b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class iterator> void output(iterator begin, iterator end, ostream &out = cerr) {
	while (begin != end) {
		out << (*begin) << " ";
		begin++;
	}
	out << endl;
}

template<class T> void output(T &x, ostream &out = cerr) {
	output(x.begin(), x.end(), out);
}

void fast_io() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

const int MAXN = 1e5;
int a[MAXN], len[MAXN], b[MAXN];
int main()
{
	int n, m;
	cin >> n >> m;
	set<pair<int, int> > s;
	for (int i = 0; i < m; i++) {
		int u, v;
		cin >> u >> v;
		s.insert({ u, v });
	}
	int u = -1, v = -1;
	for (int i = 1; i <= n; i++) {
		for (int j = i + 1; j <= n; j++) {
			if (s.find({ i, j }) == s.end() && s.find({ j, i }) == s.end()) {
				u = i, v = j;
				break;
			}
		}
		if (u != -1 && v != -1) break;
	}
	//cout << u << ' ' << v << endl;
	if (u == -1 && v == -1) {
		cout << "NO" << endl;
		return 0;
	}
	cout << "YES" << endl;
	int it = 2;
	for (int i = 0; i < n; i++) {
		if (i != u - 1 && i != v - 1) {
			cout << ++it << ' ';
		}
		else if (i == u - 1) {
			cout << 1 << ' ';
		}
		else cout << 2 << ' ';
	}
	cout << endl;
	it = 2;
	for (int i = 0; i < n; i++) {
		if (i != u - 1 && i != v - 1) {
			cout << ++it << ' ';
		}
		else if (i == u - 1) {
			cout << 1 << ' ';
		}
		else cout << 1 << ' ';
	}
	cout << endl;
	return 0;
}
/*
8 3
1 2 3 3 2 1 2 2
*/