#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <algorithm>
#include <iomanip>
#include <cmath>
#include <string>
#include <ctime>
#include <cassert>
#include <random>
#include <functional>
#include <numeric>
#include <deque>
#include <queue>
#include <cstring>
#include <complex>
#define ll long long
#define ld long double
#define null NULL
#define all(a) a.begin(), a.end()
#define x first
#define y second

using namespace std;

template<class T> int chkmax(T &a, const T &b) {
	if (b > a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class T> int chkmin(T &a, const T &b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class iterator> void output(iterator begin, iterator end, ostream &out = cerr) {
	while (begin != end) {
		out << (*begin) << " ";
		begin++;
	}
	out << endl;
}

template<class T> void output(T &x, ostream &out = cerr) {
	output(x.begin(), x.end(), out);
}

void fast_io() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

int n;
map<pair<pair<int, int>, int>, ll> mp;

const int mx = 1010;
ll a0[mx];

ll get(int i, int j, int k) {
	vector<int> v = { i, j, k };
	sort(all(v));
	i = v[0];
	j = v[1];
	k = v[2];
	if (mp.find({ {i, j}, k }) != mp.end()) {
		return mp[{ {i, j}, k}];
	}
	else {
		cout << "? " << i + 1 << " " << j + 1 << " " << k + 1 << endl;
		int res;
		cin >> res;
		return mp[{ {i, j}, k }] = res;
		//return mp[{ {i, j}, k}] = min(a0[i], min(a0[j], a0[k])) + max(a0[i], max(a0[j], a0[k]));
	}
}

ll arr[mx];

void solve_segment(int l, int r) {
	vector<pair<ll, int> > vp;
	for (int i = l; i <= r; ++i) {
		ll f = 0;
		for (int j1 = l; j1 <= r; ++j1) {
			for (int j2 = j1 + 1; j2 <= r; ++j2) {
				if (i != j1 && i != j2) {
					f += get(i, j1, j2);
				}
			}
		}
		vp.push_back({ f, i });
	}

	/*cerr << "solve_segment " << l << " " << r << endl;
	cerr << "vp" << endl;
	for (auto pp : vp) {
		cerr << pp.first << " " << pp.second << endl;
	}
	cerr << "mp" << endl;
	for (auto pp : mp) {
		cerr << pp.first.first.first << " " << pp.first.first.second << " " << pp.first.second << " " << pp.second << endl;
	}*/

	sort(all(vp));
	vector<int> id(r - l + 1);
	for (int i = l; i <= r; ++i) {
		id[i - l] = vp[i - l].second;
	}

	ll a = get(id[0], id[1], id[2]);
	ll b = get(id[2], id[3], id[4]);
	ll c = get(id[0], id[2], id[4]);

	arr[id[0]] = (a + b + c) / 2 - b;
	arr[id[2]] = (a + b + c) / 2 - c;
	arr[id[4]] = (a + b + c) / 2 - a;

	arr[id[1]] = get(id[1], id[2], id[4]) - arr[id[4]];
	arr[id[3]] = get(id[0], id[1], id[3]) - arr[id[0]];
}

int main()
{
	cin >> n;
	/*for (int i = 0; i < n; ++i) {
		cin >> a0[i];
	}*/
	for (int i = 0; i < n; i += 5) {
		solve_segment(i, i + 4);
	}
	if (n % 5 != 0) {
		solve_segment(n - 5, n - 1);
	}
	cout << "! ";
	for (int i = 0; i < n; ++i) {
		cout << arr[i] << " ";
	}
	cout << endl;
	return 0;
}
