#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <algorithm>
#include <iomanip>
#include <cmath>
#include <string>
#include <ctime>
#include <cassert>
#include <random>
#include <functional>
#include <numeric>
#include <deque>
#include <queue>
#include <cstring>
#include <complex>
#define ll long long
#define ld long double
#define null NULL
#define all(a) a.begin(), a.end()
#define x first
#define y second

using namespace std;

template<class T> int chkmax(T &a, const T &b) {
	if (b > a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class T> int chkmin(T &a, const T &b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class iterator> void output(iterator begin, iterator end, ostream &out = cerr) {
	while (begin != end) {
		out << (*begin) << " ";
		begin++;
	}
	out << endl;
}

template<class T> void output(T &x, ostream &out = cerr) {
	output(x.begin(), x.end(), out);
}

void fast_io() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}
const int MAXN = 2e5 + 7;
int src[MAXN * 2];
int a[MAXN * 2];
int dp[20][MAXN];
int main()
{
	int n;
	cin >> n;
	for (int i = 0; i < n; ++i) {
		char x;
		cin >> x;
		src[i] = x - '0';
	}
	for (int i = 1; i < n; ++i)
		a[i - 1] = src[i] ^ src[i - 1];
	a[n - 1] = src[n - 1];
	int q;
	cin >> q;
	for (int i = 0; i < q; ++i) {
		int l, r;
		cin >> l >> r;
		vector<int> x(a + l, a + r + 1);
		//output(x);
		if (l)
			x[0] ^= src[l - 1];
		x[r - l] ^= src[r + 1];
		vector<int> cnt(32);
		int len = r - l + 1;
		for (int p = 0; p < 32; p++) {
			int step = 1 << p;
			for (int i = step - 1; i < len; i += step)
				cnt[p] += x[i];
			//cout << cnt[p] << " ";
		}
		//cout << endl;
		int ans = 0;
		int sz = len;
		for (int p = 0; p < 31 && sz; ++p) {
			int lenod = sz - sz / 2;
			int delt = cnt[p] - cnt[p + 1];
			//cout << delt << " " << lenod << endl;
			ans += min(delt, lenod - delt);
			sz >>= 1;
		}
		if (!ans)
			cout << "0\n";
		else
			cout << (ans - 1) / 2 + 1 << endl;
	}
	return 0;
}
/*

8 
00000101
3
0 7
2 5
0 3

*/