#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <algorithm>
#include <iomanip>
#include <cmath>
#include <string>
#include <ctime>
#include <cassert>
#include <random>
#include <functional>
#include <numeric>
#include <deque>
#include <queue>
#include <cstring>
#include <complex>
#define ll long long
#define ld long double
#define null NULL
#define all(a) a.begin(), a.end()
#define x first
#define y second

using namespace std;

template<class T> int chkmax(T &a, const T &b) {
	if (b > a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class T> int chkmin(T &a, const T &b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class iterator> void output(iterator begin, iterator end, ostream &out = cerr) {
	while (begin != end) {
		out << (*begin) << " ";
		begin++;
	}
	out << endl;
}

template<class T> void output(T &x, ostream &out = cerr) {
	output(x.begin(), x.end(), out);
}

void fast_io() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}
#define int long long
const int MAXN = 1e7;
int a[MAXN], b[MAXN];
const int md = (1ll << 32ll) - 1;
void solve() {
	int n, l, r, x, y, b1, b2, z;
	cin >> n >> l >> r >> x >> y >> z >> b1 >> b2;
	b[0] = b1;
	b[1] = b2;
	int mod = r - l + 1;
	a[0] = b[0] % mod + l;
	a[1] = b[1] % mod + l;
	for (int i = 2; i < n; ++i) {
		b[i] = (b[i - 1] * y + b[i - 2] * x + z) & md;
		a[i] = b[i] % mod + l;
	}
	int mn = a[0];
	int answ = 5e18;
	for (int i = 1; i < n; ++i) {
		if (mn < a[i])
			answ = min(answ, mn * a[i]);
		else
			mn = a[i];
	}
	int mx = a[n - 1];
	for (int i = n - 2; i >= 0; --i)
		if (mx > a[i])
			answ = min(answ, mx * a[i]);
		else
			mx = a[i];
	if (answ == (int)5e18)
		cout << "IMPOSSIBLE\n";
	else
		cout << answ << "\n";
}
signed main() {
	int t;
	cin >> t;
	for (int i = 0; i < t; ++i)
		solve();
    return 0;
}
/*
2
4 -5 5 11 13 17 0 3
5 0 100 0 1 0 42 42
*/

