#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <algorithm>
#include <iomanip>
#include <cmath>
#include <string>
#include <ctime>
#include <cassert>
#include <random>
#include <functional>
#include <numeric>
#include <deque>
#include <queue>
#include <cstring>
#include <complex>
#define ll long long
#define ld long double
#define null NULL
#define all(a) a.begin(), a.end()
#define x first
#define y second

using namespace std;

template<class T> int chkmax(T &a, const T &b) {
	if (b > a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class T> int chkmin(T &a, const T &b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class iterator> void output(iterator begin, iterator end, ostream &out = cerr) {
	while (begin != end) {
		out << (*begin) << " ";
		begin++;
	}
	out << endl;
}

template<class T> void output(T &x, ostream &out = cerr) {
	output(x.begin(), x.end(), out);
}

void fast_io() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

ll t, n, a, b, k;
ll cnt_a, cnt_b, all_a, all_b;

int main()
{
	cin >> t >> n >> a >> b >> k;
	if (n % 2 == 0) {
		cnt_a = n / 2;
		cnt_b = n / 2;
	}
	else {
		cnt_a = n / 2 + 1;
		cnt_b = n / 2;
	}

	all_a = cnt_a * a;
	all_b = cnt_b * b;

	if (k > n) {
		cout << 0 << endl;
		return 0;
	}
	ll need_a = max(k - cnt_b, 0LL), need_b = max(k - cnt_a, 0LL);
	
	if (need_a) {
		chkmin(t, all_a / need_a);
	}
	if (need_b) {
		chkmin(t, all_b / need_b);
	}

	chkmin(t, (all_a + all_b) / k);

	cout << t << endl;
    return 0;
}

