#include <bits/stdc++.h>
#define pb push_back
#define mp make_pair
#define x first
#define y second

using namespace std;

typedef long long ll;

const ll INF = 1E9;

map<string, ll> id;

struct S
{
    string str;
    ll num;
};

bool operator<(const S & a, const S & b)
{
    return a.num < b.num;
}

vector<S> srt;

int main()
{
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(0); cin.tie(0);

    string s;

    ll cur_id = 0;

    while (cin >> s)
    {
        if (s[0] != '\\')
        {
            continue;
        }
        if (s[1] == 'b')
        {
            break;
        }
        s = s.substr(5, INF);
        while (s.size() && s.back() != '}')
        {
            s.pop_back();
        }
        id[s] = cur_id;
        ++cur_id;
    }

    getline(cin, s);
    getline(cin, s);

    string x;

    while (!(s.size() >= 2 && s[1] == 'e'))
    {
        x = s.substr(8, INF);
        while (x.size() && x.back() != '}')
        {
            x.pop_back();
        }
        srt.push_back(S{s, id[x]});
        getline(cin, s);
    }

    if (is_sorted(srt.begin(), srt.end()))
    {
        cout << "Correct" << '\n';
    }
    else
    {
        cout << "Incorrect" << '\n';
        sort(srt.begin(), srt.end());
        cout << "\\begin{thebibliography}{99}" << '\n';
        for (auto & t : srt)
        {
            cout << t.str << '\n';
        }
        cout << "\\end{thebibliography}" << '\n';
    }
    return 0;
}

