#include <bits/stdc++.h>
#define pb push_back
#define mp make_pair
#define x first
#define y second

using namespace std;

typedef long long ll;

int dx[8] = {1, 2, 2, 1, -1, -2, -2, -1}, dy[8] = {2, 1, -1, -2, -2, -1, 1, 2};

string saved =
"1 1 \
2 3 \
3 5 \
4 7 \
6 8 \
8 7 \
7 5 \
8 3 \
7 1 \
5 2 \
6 4 \
7 6 \
8 8 \
6 7 \
8 6 \
7 4 \
8 2 \
6 1 \
7 3 \
8 5 \
6 6 \
7 8 \
5 7 \
6 5 \
7 7 \
5 6 \
4 4 \
6 3 \
8 4 \
7 2 \
5 1 \
3 2 \
5 3 \
4 1 \
2 2 \
1 4 \
3 3 \
1 2 \
3 1 \
4 3 \
5 5 \
3 4 \
1 5 \
2 7 \
4 8 \
3 6 \
2 8 \
1 6 \
2 4 \
4 5 \
2 6 \
1 8 \
3 7 \
5 8 \
4 6 \
3 8 \
1 7 \
2 5 \
1 3 \
2 1 \
4 2 \
5 4 \
6 2 \
8 1";

bool used[10][10];
vector<pair <int, int>> path;
/*
void finds(int x, int y, int kol)
{
    used[x][y] = true;
    path.pb(mp(x, y));
    if (kol == 64)
    {
        cout << "URA\n";
        for (int i = 0; i < (int) path.size(); i++)
            cout << path[i].x << ' ' << path[i].y << '\n';
        exit(0);
    }
    for (int k = 0; k < 8; k++)
    {
        int nx = dx[k] + x, ny = dy[k] + y;
        if (nx > 0 && nx <= 8 && ny > 0 && ny <= 8 && !used[nx][ny]) finds(nx, ny, kol + 1);
    }
    used[x][y] = false;
    path.pop_back();
    return;
}*/

bool home[10][10];
bool horse[10][10];

ll ord[10][10];

vector<ll> home_ord, horse_ord;

vector<string> answer;

void move_horse(ll i, ll x, ll y, ll a, ll b)
{
    assert(horse[x][y] && !horse[a][b]);
    string add;
    add += char(x + 'a');
    add += char(y + '1');
    add += '-';
    add += char(a + 'a');
    add += char(b + '1');
    answer.push_back(add);

    horse[x][y] = 0;
    horse[a][b] = 1;
    horse_ord[i] = ord[a][b];
}

int main()
{
    //freopen("input.txt", "r", stdin);
    //freopen("out.txt", "w", stdout);
    ios_base::sync_with_stdio(0); cin.tie(0);
    //finds(1, 1, 1);

    stringstream from(saved);
    for (ll i = 0; i < 64; ++i)
    {
        ll a, b;
        from >> a >> b;
        --a; --b;
        path.emplace_back(a, b);
        ord[a][b] = i;
    }

    ll k;
    cin >> k;

    for (ll i = 0; i < k; ++i)
    {
        string h;
        cin >> h;
        ll x = h[0] - 'a';
        ll y = h[1] - '1';
        horse[x][y] = 1;
    }

    ll least = 0;

    for (ll i = 0; i < 8; ++i)
    {
        for (ll j = 0; j < 8; ++j)
        {
            if (least < k)
            {
                home[i][j] = 1;
                ++least;
            }
        }
    }

    for (ll i = 0; i < 64; ++i)
    {
        ll x = path[i].first;
        ll y = path[i].second;
        if (home[x][y])
        {
            home_ord.push_back(i);
        }
        if (horse[x][y])
        {
            horse_ord.push_back(i);
        }
    }

    for (ll run = 1; run; )
    {
        run = 0;
        for (ll i = 0; i < k; ++i)
        {
            ll cx = path[horse_ord[i]].first;
            ll cy = path[horse_ord[i]].second;

            if (home_ord[i] < horse_ord[i])
            {
                ll nx = path[horse_ord[i] - 1].first;
                ll ny = path[horse_ord[i] - 1].second;
                if (horse[nx][ny] == 0)
                {
                    move_horse(i, cx, cy, nx, ny);
                }
                run = 1;
            }

            if (home_ord[i] > horse_ord[i])
            {
                ll nx = path[horse_ord[i] + 1].first;
                ll ny = path[horse_ord[i] + 1].second;
                if (horse[nx][ny] == 0)
                {
                    move_horse(i, cx, cy, nx, ny);
                }
                run = 1;
            }
        }
    }

    cout << answer.size() << '\n';
    for (string & ss : answer)
    {
        cout << ss << '\n';
    }


    return 0;
}

