#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>

using ld = long long;
using namespace std;
const ld INF = 1e10;

int main() {

	/*ld t, n, l, r, x, y, z, b1, b2;
	cin >> t;

	for (int j = 0; j < t; ++j) {
		cin >> n >> l >> r >> x >> y >> z >> b1 >> b2;
		ld m = INF, a = -INF, b = -INF, ans = (1 << 62);
		for (int i = 0; i < n - 2; ++i) {
			if(b1 > m)
				ans = min(ans, m * b1);
			m = min(m, b1);
			if (b1 < 0 && b1 > a) {
					b = a;
					a = b1;
				}
			tie(b1, b2) = make_pair(b2, (b1 * x + b2 * y + z) % (1 << 32) % (r - l + 1) + l);
		}
		if (b != -INF)
			ans = min(ans, a * b);
		if (ans == (1 << 62))
			cout << "IMPOSIBLE\n";
		else
			cout << ans;


	}*/

	long long n, m;
	cin >> n >> m;

	if ((n * (n - 1)) / 2 == m) {
		cout << "NO" << endl;
		return 0;
	}

	vector<vector<int>> a(n);
	for (int i = 0; i < m; i++) {
		int u, v;
		cin >> u >> v;
		u--;
		v--;
		a[u].push_back(v);
		a[v].push_back(u);
	}

	int x, y;
	bool f = false;
	for (int i = 0; i < n; i++) {
		if (a[i].size() < n - 1) {
			x = i;
			vector<bool> used(n);
			used[i] = true;
			for (int j = 0; j < a[i].size(); j++){
				used[a[i][j]] = true;
			}
			for (int j = 0; j < n; j++) {
				if (!used[j]) {
					y = j;
					f = true;
					break;
				}
			}
		}
		if (f) {
			break;
		}
	}

	cout << "YES" << endl;
	int t = 1;
	if (x > y)
		swap(x, y);
	for (int i = 0; i < n; i++) {
		if (i != x && i != y) {
			cout << t << ' ';
			t++;
		}
		else if (i == x) {
			cout << n - 1 << ' ';
		}
		else {
			cout << n << ' ';
		}
	}
	cout << endl;
	t = 1;
	for (int i = 0; i < n; i++) {
		if (i != x && i != y) {
			cout << t << ' ';
			t++;
		}
		else if (i == x) {
			cout << n << ' ';
		}
		else {
			cout << n << ' ';
		}
	}

	return 0;
}