#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <map>
#include <set>
#include <deque>
#include <fstream>
#include <iomanip>
#include <string>
using namespace std;

typedef long long ll;
typedef long double ld;

#define sz(a) int(a.size())
#define all(a) a.begin(), a.end()
#define pb push_back 
#define x first
#define y second

const int INF = int(1e9) + 111;
const int N = int(1e5) + 11;
const int M = int(1e9) + 7;

ll t, n, a, b, k;
bool check(ll m) {
	ll a1 = min(m, a), b1 = min(m, b), ans = 0;
	ans += a1 * ((n / 2) + n % 2);
	ans += b1 * (n / 2);
	return ans >= m * k;
}
int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	//ifstream cin("input.txt");
	//ofstream cout("output.txt");
	cin >> t >> n >> a >> b >> k;
	ll l = 0, r = t + 1;
	while (r - l > 1) {
		ll m = (l + r) / 2;
		if (check(m))
			l = m;
		else
			r = m;
	}
	cout << l;
	return 0;
}
