#include <bits/stdc++.h>
using namespace std;

#define fst first
#define snd second
#define mp make_pair
#define rep(i,a,n) for(int i=(a);i<(n);++i)
#define per(i,a,n) for(int i=(n)-1;i>=(a);--i)
#define all(x) (x).begin(),(x).end()

template<typename T1, typename T2>
inline bool umin(T1& x, const T2& y) {return x>y ? x=y,true:false;}

template<typename T1, typename T2>
inline bool umax(T1& x, const T2& y) {return x<y ? x=y,true:false;}

typedef long long ll;
typedef long double ld;

const int N    = (int)1e6+7;
const int mod  = (int)1e9+7;
const int INF  = (int)1e9+17;
const ll LLINF = (ll)1e18+17;


int n, m;
vector<int> g[N];
int ans[N];

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL

    cin >> n >> m;
    if (n == 1) {
        cout << "NO" << endl;
        return 0;
    }
    if (m == 1ll * n * (n-1) / 2) {
        cout << "NO" << endl;
        return 0;
    }
    rep(i, 0, m) {
        int x, y;
        cin >> x >> y;
        --x, --y;
        g[x].push_back(y);
        g[y].push_back(x);
    }
    int x, y;
    bool found = false;
    rep(i, 0, n) {
        if (found) break;
        if (g[i].size() != n-1) {
            set<int> cur(all(g[i]));
            rep(j, 0, n) {
                if (i == j) continue;
                if (cur.count(j)) continue;
                x = i, y = j;
                found = true;
                break;
            }
        }
    }
    assert(found);
    fill(ans, ans+n, -1);
    ans[x] = 1;
    ans[y] = 2;
    int timer = 2;
    rep(i, 0, n) {
        if (ans[i] == -1) {
            ans[i] = ++timer;
        }
    }
    cout << "YES" << endl;
    rep(i, 0, n) cout << ans[i] << ' ';
    cout << endl;
    ans[y] = 1;
    rep(i, 0, n) cout << ans[i] << ' ';
    cout << endl;

    return 0;
}
