#include <bits/stdc++.h>
using namespace std;

#define fst first
#define snd second
#define mp make_pair
#define rep(i,a,n) for(int i=(a);i<(n);++i)
#define per(i,a,n) for(int i=(n)-1;i>=(a);--i)
#define all(x) (x).begin(),(x).end()

template<typename T1, typename T2>
inline bool umin(T1& x, const T2& y) {return x>y ? x=y,true:false;}

template<typename T1, typename T2>
inline bool umax(T1& x, const T2& y) {return x<y ? x=y,true:false;}

typedef long long ll;
typedef long double ld;

const int N    = (int)1e6+7;
const int mod  = (int)1e9+7;
const int INF  = (int)1e9+17;
const ll LLINF = (ll)1e18+17;


int n;
bool cnt[29];
map<pair<pair<ll,ll>,pair<ll,ll>>,vector<int>> st;


string parse(string s, const string& t) {
    fill(cnt, cnt+27, false);
    for(char ch:t) cnt[ch-'a'] = true;
    while (!s.empty()) {
        if (!cnt[s.back()-'a']) break;
        s.pop_back();
    }
    return s;
}

const ll p = 37;
const ll p2 = 449;
const ll q = 999988901;
const ll q2 = 888888901;


pair<ll,ll> gethash(const string& s) {
    pair<ll,ll> H = mp(0, 0);
    pair<ll,ll> pw = mp(1, 1);
    for(char ch:s) {
        H.fst = (H.fst + (ch-'a'+1) * pw.fst) % q;
        H.snd = (H.snd + (ch-'a'+1) * pw.snd) % q2;
        pw.fst = pw.fst * p % q;
        pw.snd = pw.snd * p2 % q2;
    }
    return H;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL

    cin >> n;
    rep(i, 0, n) {
        string s, t;
        cin >> s >> t;
        sort(all(t));
        t.erase(unique(all(t)), t.end());
        s = parse(s, t);
        st[mp(gethash(s), gethash(t))].push_back(i);
    }
    cout << st.size() << endl;
    for(const auto& cur:st) {
        cout << cur.snd.size(); for(int x:cur.snd) cout << ' ' << x+1;
        cout << '\n';
    }


    return 0;
}
