#pragma GCC optimize("Ofast")
#pragma GCC optimize("fast-math")
#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <cstring>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <iomanip>
#include <cstdio>
#include <stdio.h>
#include <random>

using namespace std;

#define int long long

const int MOD = (1LL << 32);

const int maxn = 10 * 1000 * 1000 + 7, INF = 2e9 + 228;

int t[maxn];

int a[maxn], b[maxn];

pair<int, int> crd[maxn];

void solve() {
	int n, l, r, x, y, z, b1, b2;
	cin >> n >> l >> r >> x >> y >> z >> b1 >> b2;
	b[1] = b1;
	b[2] = b2;
	for (int i = 3; i <= n; ++i) {
		b[i] = (b[i - 2] * x + b[i - 1] * y + z) % MOD;
	}
	for (int i = 1; i <= n; ++i) {
		crd[i - 1].first = a[i] = (b[i] % (r - l + 1)) + l;
		crd[i - 1].second = i - 1;
	}
	sort(crd, crd + n);
	for (int i = 1; i <= n; ++i) {
		a[i] = lower_bound(crd, crd + n, make_pair(a[i], 0LL)) - crd;
	}
	bool OK = 1;
	for (int i = 1; i < n; ++i) {
		if (a[i] < a[i + 1]) {
			OK = 0;
			break;
		}
	}
	if (OK) {
		cout << "IMPOSSIBLE\n";
		return;
	}
	for (int i = 0; i < n; ++i) {
		t[i] = -INF;
	}
	int pos1 = 0, pos2 = 0, res = INF * INF;
	int mn = 0;
	for (int i = 1; i < n; ++i) {
		if (crd[mn].first < crd[i].first) {
			if (crd[mn].first * crd[i].first < res) {
				res = crd[mn].first * crd[i].first;
			}
		}
		if (crd[i].first < crd[mn].first) {
			mn = i;
		}
	}
	bool relaxed = 0;
	int pos = 0;
	r = 0;
	for (int it = 0; it < n; ++it) {
		if (crd[it].first > 0) continue;
		pos = crd[it].second;
		for (r = pos; r < n; r |= (r + 1)) {
			t[r] = max(t[r], crd[it].first);
		}
		r = crd[it].second - 1;
		int mx = -INF;
		for (; r >= 0; r = (r & (r + 1)) - 1) {
			mx = max(mx, t[r]);
		}
		if (mx == -INF) continue;
		if (mx * crd[it].first < res) {
			res = mx * crd[it].first;
		}
	}
	cout << res << endl;
}


signed main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	int tests;
	cin >> tests;
	for (int it = 0; it < tests; ++it) {
		solve();
	}
	return 0;
}
