#include <iostream>
#include <vector>
#include <map>

using namespace std;

int answer(string str) {
    bool* counts = new bool[26];
    for (int i = 0; i < 26; i++)
        counts[i] = false;
    for (int i = 0; i < str.size(); i++)
        counts[(int)str[i] - (int)'a'] = true;
    int result = 0;
    for (int i = 0; i < 26; i++) {
        result <<= 1;
        if (counts[i]) {

            result++;
        }
    }
    return result;
}

int main(void) {
    int* counts = new int[67108864];
    int n;
    cin >> n;
    map<int, vector<int> > dict;
    for (int i = 0; i < n; i++) {
        string str;
        cin >> str >> str;
        int x = answer(str);
        if (dict.find(x) != dict.end())
            dict[x].push_back(i + 1);
        else
            //dict[x] = new vector<int>();
            dict[x].push_back(i + 1);
    }
    cout << dict.size() << endl;
    for (auto i : dict) {
        cout << i.second.size() << " ";
        for (int j = 0; j < i.second.size(); j++) {
            cout << i.second[j] << " ";
        }
        cout << endl;
    }
    return 0;
}
