#include <iostream>

using namespace std;

bool check(int len, int* houses, int n) {
    int cnt = 1;
    for (int i = 0; i < n - 1; i++) {
        if (houses[i] != houses[i + 1])
            cnt++;
        else
            cnt = 1;
        if (cnt >= len)
            return true;
    }
    if (cnt >= len)
        return true;
    return false;
}

int main(void) {
    int n, k;
    cin >> n >> k;
    int* houses = new int[n];
    for (int i = 0; i < n; i++) {

        cin >> houses[i];
    }
    int left = 0, right = n + 1;
    while (right - left > 1) {
        int mid = (right + left) / 2;
        if (check(mid, houses, n))
            left = mid;
        else
            right = mid;
    }
    cout << left;
    return 0;
}
