#pragma GCC optimaze("Ofast");
#pragma GCC optimaze("unroll-loops")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.2,popcnt,abm,mmx, tune=native")
#include<iostream>
#include<vector>
#include<string>
#include<map>
#include<set>
#include<math.h>
#include<algorithm>

using namespace std;

const int maxn = 1e7 + 113;

unsigned long long mass[maxn];
long long mass2[maxn];
const unsigned long long mod = (1LL << 32);
const long long inf = (long long)(4e18) + 1;

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	int t;
	cin >> t;
	for (int test = 0; test < t; test++)
	{
		long long n;
		unsigned long long x, y, z, b1, b2;
		long long l, r;
		cin >> n >> l >> r >> x >> y >> z >> b1 >> b2;
		mass[1] = b1, mass[2] = b2;
		for (int i = 3; i <= n; i++)
			mass[i] = ((mass[i - 2] * x) % mod + (mass[i - 1] * y) % mod + z) % mod;
		bool tr = false;
		for (int i = 1; i <= n; i++)
		{
			mass2[i] = (long long)mass[i] % (r - l + 1) + l;
			if (mass2[i] > 0)
				tr = true;
		}
		long long ans = inf;
		long long last = (long long)2e9 + 1;
		int rd = 0;
		for (int i = 1; i <= n; i++)
		{
			if (mass2[i] > last)
				continue;
			last = mass2[i];
			rd = max(i + 1, rd);
			for (int j = rd; j <= n; j++)
			{
				if (mass2[j] <= mass2[i])
					break;
				ans = min(ans, mass2[i] * mass2[j]);
			}
		}
		for (int i = 1; i <= n; i++)
			mass2[n + 1 - i] = -((long long)mass[i] % (r - l + 1) + l);
		long long ans2 = inf;
		long long last2 = (long long)2e9 + 1;
		int rd2 = 0;
		for (int i = 1; i <= n; i++)
		{
			if (mass2[i] > last2)
				continue;
			last2 = mass2[i];
			rd2 = max(i + 1, rd2);
			for (int j = rd2; j <= n; j++)
			{
				if (mass2[j] <= mass2[i])
					break;
				ans2 = min(ans2, mass2[i] * mass2[j]);
			}
		}
		if (min(ans, ans2) == inf)
			cout << "IMPOSSIBLE";
		else
			cout << min(ans, ans2) << endl;
	}
	//system("pause");
}

/*
1
3 -6 1 1 2 3 4 5
*/