#pragma GCC optimaze("Ofast");
#pragma GCC optimaze("unroll-loops")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.2,popcnt,abm,mmx, tune=native")
#include<iostream>
#include<vector>
#include<string>
#include<map>
#include<set>
#include<math.h>
#include<algorithm>

using namespace std;

bool used[300];

const long long ps = 47;
const long long mod1 = 1e9 + 7;
const long long mod2 = 1e9 + 9;

long long hasf(string &s, int t)
{
	if (t == 0)
	{
		long long su = 0;
		long long pd = 1;
		for (int i = 0; i < s.size(); i++)
		{
			su = ((pd * s[i]) + su) % mod1;
			pd = (pd * ps) % mod1;
		}
		return su;
	}
	else
	{
		long long su = 0;
		long long pd = 1;
		for (int i = 0; i < s.size(); i++)
		{
			su = ((pd * s[i]) + su) % mod2;
			pd = (pd * ps) % mod2;
		}
		return su;
	}
}

map<pair<pair<int, int>, pair<int, int>>, vector<int>> mv;

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	int n;
	cin >> n;
	for (int i = 0; i < n; i++)
	{
		string s, t;
		cin >> s >> t;
		string nt;
		for (int j = 0; j < t.size(); j++)
			used[t[j]] = 1;
		for (char j = 'a'; j <= 'z'; j++)
			if (used[j])
				nt.push_back(j);
		while (s.size() && used[s.back()])
			s.pop_back();
		pair<pair<int, int>, pair<int, int>> fd = { {hasf(s, 0), hasf(s, 1)}, {hasf(nt, 0), hasf(nt, 1)} };
		mv[fd].push_back(i);
		for (char j = 'a'; j <= 'z'; j++)
			used[j] = 0;
	}
	cout << mv.size() << endl;
	for (auto it : mv)
	{
		cout << it.second.size() << " ";
		for (int i = 0; i < it.second.size(); i++)
			cout << it.second[i] + 1 << " ";
		cout << endl;
	}
	//system("pause");
}

/*
1
30 -7 1 1 2 3 4 5

2
aaaa a
bb aa
*/