#include<bits/stdc++.h>

#define pb push_back
#define ll __int128_t
#define pii pair<ll, ll>
#define mp make_pair

using namespace std;

const ll MOD = (1ll << 32ll);
const ll INF = (ll)1e19 + 10ll;

int solve();

int t;

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    #ifdef _DEBUG
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // _DEBUG
    cin >> t;
    for (int i = 0; i < t; ++i)
    {
        solve();
    }
    return 0;
}

int n;

long long l, r, x, y, z, b0, b1;

vector<ll> b;
vector<ll> a;

int solve()
{
    //cerr << INF << endl;
    a.clear();
    b.clear();
    cin >> n >> l >> r >> x >> y >> z >> b0 >> b1;
    b.pb(b0);
    b.pb(b1);
    for (int i = 2; i < n; ++i)
    {
        ll cur = (((b[i - 2] * (ll)x) % MOD + (b[i - 1] * (ll)y) % MOD) % MOD + (ll)z) % MOD;
        b.pb(cur);
    }
    //cerr << "HERE" << endl;
    for (int i = 0; i < n; ++i)
    {
        ll cur = (b[i] % (ll)(r - l + 1ll)) + (ll)l;
        a.pb(cur);
        //cerr << a[i] << ' ';
    }
    /*cin >> n;
    for (int i = 0; i < n; ++i)
    {
        ll x;
        cin >> x;
        a.pb(x);
    }*/
    bool fl = false;
    ll maxV = -INF;
    ll minV = INF;
    ll ans = INF;
    //cerr << maxV << ' ' << minV << ' ' << ans << endl;
    for (int i = 0; i < n; ++i)
    {
        if (minV != INF && minV < a[i])
        {
            fl = true;
            ans = min(ans, a[i] * minV);
        }
        if (maxV != -INF && maxV < a[i])
        {
            fl = true;
            ans = min(ans, a[i] * maxV);
        }
        minV = min(minV, a[i]);
        maxV = max(maxV, a[i]);
    }
    maxV = -INF;
    minV = INF;
    for (int i = n - 1; i >= 0; --i)
    {
        if (minV != INF && a[i] < minV)
        {
            fl = true;
            ans = min(ans, a[i] * minV);
        }
        if (maxV != -INF && a[i] < maxV)
        {
            fl = true;
            ans = min(ans, a[i] * maxV);
        }
        minV = min(minV, a[i]);
        maxV = max(maxV, a[i]);
    }
    if (!fl)
    {
        cout << "IMPOSSIBLE" << '\n';
    }
    else
    {
        cout << (long long)ans << '\n';
    }
    return 0;
}
