#include<bits/stdc++.h>

#define pb push_back
#define ll __int128_t
#define pii pair<ll, ll>
#define mp make_pair
#define X first
#define Y second

using namespace std;

const ll MOD = (1ll << 32);
const ll INF = (ll)8e18 + 10;

int solve();

int t;

int main()
{
    #ifdef _DEBUG
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // _DEBUG
    cin >> t;
    while (t--)
    {
        solve();
    }
    return 0;
}

int n;

long long l, r, x, y, z, b0, b1;

vector<ll> b;
vector<ll> a;

pii maxV;
pii minV;

void updateMax(ll val)
{
    if (maxV.Y < val)
    {
        maxV.X = maxV.Y;
        maxV.Y = val;
    }
    else if (maxV.X < val && val != maxV.Y)
    {
        maxV.X = val;
    }
}

void updateMin(ll val)
{
    if (val < minV.X)
    {
        minV.Y = minV.X;
        minV.X = val;
    }
    else if (val < minV.Y && val != minV.X)
    {
        minV.Y = val;
    }
}

int solve()
{
    //cerr << INF << endl;
    a.clear();
    b.clear();
    cin >> n >> l >> r >> x >> y >> z >> b0 >> b1;
    b.pb(b0);
    b.pb(b1);
    for (int i = 2; i < n; ++i)
    {
        ll cur = b[i - 2] * (ll)x + b[i - 1] * (ll)y + (ll)z;
        cur %= MOD;
        b.pb(cur);
    }
    //cerr << "HERE" << endl;
    for (int i = 0; i < n; ++i)
    {
        ll cur = (b[i] % (ll)(r - l + 1ll)) + (ll)l;
        a.pb(cur);
        //cerr << a[i] << ' ';
    }
    /*cin >> n;
    for (int i = 0; i < n; ++i)
    {
        ll x;
        cin >> x;
        a.pb(x);
    }*/
    bool fl = false;
    maxV = mp(-INF, -INF);
    minV = mp(INF, INF);
    long long ans = INF;
    //cerr << maxV << ' ' << minV << ' ' << ans << endl;
    for (int i = 0; i < n; ++i)
    {
        if (minV.X != INF && minV.X < a[i])
        {
            fl = true;
            ans = min(ans, (long long)(a[i] * minV.X));
        }
        if (minV.Y != INF && minV.Y < a[i])
        {
            fl = true;
            ans = min(ans, (long long)(a[i] * minV.Y));
        }
        if (maxV.X != -INF && maxV.X < a[i])
        {
            fl = true;
            ans = min(ans, (long long)(a[i] * maxV.X));
        }
        if (maxV.Y != -INF && maxV.Y < a[i])
        {
            fl = true;
            ans = min(ans, (long long)(a[i] * maxV.Y));
        }
        updateMin(a[i]);
        updateMax(a[i]);
    }
    if (!fl)
    {
        cout << "IMPOSSIBLE" << endl;
    }
    else
    {
        cout << ans << endl;
    }
    return 0;
}

