#include <iostream>
#include <algorithm>
#include<string>
#include <vector>
#include<map>
#include <deque>
#include<set>
#define int long long
#define FOR(i, n) for (int i = 0; i < n; ++i)

using namespace std;

const int INF = 1e18;
signed main() {
	string s;
	vector<string>v;
	while (1)
	{
		getline(cin, s);
		if (s == "\\begin{thebibliography}{99}")
		{
			break;
		}
		for (int i = 0; i < s.size(); ++i)
		{
			if (s[i] == '\\')
			{
				string ref;
				i += 6;
				for (; i < s.size(); ++i)
				{
					if (s[i] == '}')
						break;
					ref.push_back(s[i]);
				}
				v.push_back(ref);
			}
		}
		
	}
	vector<string>v2;
	map<string, string>desc;
	while(1)
	{
		getline(cin, s);
		if (s == "\\end{thebibliography}")
		{
			break;
		}
		string ref;
		for (int i = 9; i < s.size(); ++i)
		{
			if (s[i] == '}')
			{
				v2.push_back(ref);
				string d = s.substr(i + 1, s.size());
				desc[ref] = d;
				break;
			}
			ref.push_back(s[i]);
		}
	}
	if (v == v2)
	{
		cout << "Correct";
		return 0;
	}
	cout << "Incorrect\n";
	cout << "\\begin{thebibliography}{99}\n";
	for (int i = 0; i < v.size(); ++i)
	{
		cout << "\\bibitem{" << v[i] << '}' << desc[v[i]] << '\n';
	}
	cout << "\\end{thebibliography}";
	return 0;
}