#include <bits/stdc++.h>

using namespace std;

const int N = 2e5 + 5, M = 2e7, MAX = 6e5;
int a[N], f[N], lc[M], rc[M], rt[N], g[N];
int z = 1;

int get(int v, int x, int L = 0, int R = MAX) {
    if (v == 0)
        return 0;
    if (L == R)
        return 1;

    int m = (L + R) >> 1;
    if (x <= m)
        return get(lc[v], x, L, m);
    return get(rc[v], x, m + 1, R);
}

int add(int v, int x, int L = 0, int R = MAX) {
    lc[z] = lc[v];
    rc[z] = rc[v];

    v = z;

    z++;

    if (L != R) {
        int m = (L + R) >> 1;
        if (x <= m)
            lc[v] = add(lc[v], x, L, m);
        else
            rc[v] = add(rc[v], x, m + 1, R);
    }

    return v;
}

int del(int v, int x, int L = 0, int R = MAX) {
    if (L == R)
        return 0;

    lc[z] = lc[v];
    rc[z] = rc[v];

    v = z;

    z++;

    int m = (L + R) >> 1;
    if (x <= m)
        lc[v] = del(lc[v], x, L, m);
    else
        rc[v] = del(rc[v], x, m + 1, R);

    if (lc[v] == 0 && rc[v] == 0)
        return 0;

    return v;
}

bool magic(int x, int y) {
    int p = y + f[x];

    while (get(rt[x], p)) {
        p++;
        rt[x] = del(rt[x], p - 1);
    }

    rt[x] = add(rt[x], p);
    if (p >= N)
        return true;
    return false;
}

int main()
{
#ifdef HOME
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n;
    scanf("%d", &n);

    int k = 1;
    for (int i = 1; i <= n; i++) {
        int t, x, y;
        scanf("%d", &t);

        if (t == 1) {
            f[k] = N;
            rt[k] = z++;
            g[k] = -1;
            k++;
        }
        else if (t == 2) {
            scanf("%d", &x);
            a[x]++;
        }
        else if (t == 3) {
            scanf("%d", &x);
            f[x]--;
        }
        else if (t == 4) {
            scanf("%d", &x);
            f[k] = f[x];
            rt[k] = rt[x];
            a[k] = a[x];
            g[k] = g[x];
            if (g[k] != -1)
                g[k] = i;
            k++;
        }
        else {
            scanf("%d%d", &x, &y);
            if (g[x] == -1 && g[y] == -1) {
                if (magic(x, a[y]))
                    g[x] = i;
                if (magic(y, a[x]))
                    g[y] = i;
            }
        }

    }

    printf("%d\n", k - 1);

    for (int i = 1; i < k; i++)
        printf("%d ", g[i]);


    return 0;
}
