#include <bits/stdc++.h>

#define y1 mozyr1
#define make_struct(args...) {args}

using namespace std;
typedef long long ll;

const long long INF = 1e18 + 10;
const int inf = 1e9 + 10;
const int N = 1e6 + 10;
typedef pair <ll, ll> pll;

int f (int a, int b)
{
    if (a > b)
        return 1;
    if (a == b)
        return 0;
    if (a < b)
        return 2;
}

set <ll> G[N];

void kek (vector <int> a, vector <int> b, vector <pair <int, int> > edge)
{
    for(int i = 0; i < edge.size(); i++)
    {
        int x = edge[i].first, y = edge[i].second;
        if (f (a[x], a[y]) != f (b[x], b[y]))
        {
            cout << "FAIL" << "\n";
            exit(0);
        }
    }


}

vector <int> way, ans;
bool brut (vector <pair <int, int> > edge, int n, vector <int> a)
{
    if (way.size() == n)
    {
        for(int i = 0; i < edge.size(); i++)
        {
            int x = edge[i].first, y = edge[i].second;
            if (f(way[x], way[y]) != f (a[x], a[y]))
                return false;
        }

        for(int i = 0; i < n; i++)
            for(int j = i + 1; j < n; j++)
                if (way[i] == way[j])
                {
                    ans = way;
                    return true;
                }

        return false;
    }

    bool fl = 0;
    for(int i = 0; i < n; i++)
    {
        way.push_back(i);
        fl |= brut (edge, n, a);
        way.pop_back();

    }


    return fl;
}


int main()
{
    cin.tie(0);
    ios::sync_with_stdio(0);

    int n, m;
    cin >> n >> m;
    srand(time(0));
    //n = 5;
    //m = 10;

    if (n == 1)
        return cout << "NO" << "\n", 0;

    vector <int> a(n), b(n);
    vector <vector <int> > g(n);
    for(int i = 0; i < n; i++)
        b[i] = i;



    //cout << n << " " << m << endl;

    vector <pair <int, int> > edge(m);
    for(int i = 0; i < m; i++)
    {
        int x, y;
        //x = rand() % n + 1, y = rand() % n + 1;
        //cout << x << " " << y << endl;
        cin >> x >> y;
        x--, y--;

        g[x].push_back(y);
        g[y].push_back(x);

        G[x].insert(y);
        G[y].insert(x);

        edge[i] = make_pair(x, y);
    }
    multiset <pair<ll, ll> > st;
    for(ll i = 0; i < n; ++ i)
        st.insert({G[i].size(), i});

    ll pos = 0;
    while(st.size() > 0){
        auto it = st.end();
        --it;
        ll x = (*it).second;
        for(auto it1 : G[x])
            G[it1].erase(x);

        G[x].clear();

        st.erase(it);
        a[pos ++] = x;
    }


    for(int i = 0; i < n; i++)
        b[i] = a[i];

    int win = 0;
    for(int i = 0; i < n; i++)
    {
        int l = 0, r = n - 1;
        for(auto to : g[i])
        {
            if (f (a[i], a[to]) == 2)
                r = min(r, a[to] - 1);

            if (f (a[i], a[to]) == 1)
                l = max(l, a[to] + 1);
        }

        if (l > r)
            continue;

        if (r != i)
        {
            b[i] = r;
            win = 1;
            break;
        }

        if (l != i)
        {
            b[i] = l;
            win = 1;
            break;
        }
    }


    //int flyg = 0;
    //vector <int> aa(n);
    //for(int i = 0; i < n; i++)
    //    aa[i] = i;

    //do
    //{
//        flyg |= brut(edge, n, aa);
//        cout << flyg << endl;
//        if (flyg == 1)
//        {
//            for(int i = 0; i < n; i++)
//                cout << aa[i] + 1 << " ";
//
//            cout << "\n";
//
//            for(int i = 0; i < n; i++)
//                cout << ans[i] + 1 << " ";
//
//            cout << "\n";
//            break;
//        }
//    }
//    while(next_permutation(aa.begin(), aa.end()));

   // cout << "Win : " << win << endl;
   // if (!win and flyg)
   // {
   //     return cout << "FAIL NO" << endl, 0;
   // }

    if (win)
        cout << "YES" << "\n";
    else
        return cout << "NO" << "\n", 0;

    //kek (a, b, edge);

    for(auto i : a)
        cout << i + 1 << " ";

    cout << "\n";

    for(auto i : b)
        cout << i + 1 << " ";
    return 0;
}
/*
5 6
1 3
1 2
3 4
2 3
1 5
4 5
*/

