#include <bits/stdc++.h>

using namespace std;
#define int long long
#define sz(a) (int) (a).size()
#define fs first
#define sc second
const int mod = 1e9 + 7;
const int base = 29;
const int N = 1e5 + 1;
int powOfBase[N];
int weight[N];
struct segTree {
    segTree *left = nullptr, *right = nullptr;
    int val = 0;
};
int v(segTree* cur) { return (cur == nullptr) ? 0 : cur -> val;}
segTree* righ(segTree* cur) { return (cur == nullptr) ? nullptr : cur -> right;}
segTree* lef(segTree* cur) { return (cur == nullptr) ? nullptr : cur -> left;}
int m;

void update(int p, int val, segTree* cur, int ll = 1, int rr = m) {
    if (ll == rr) {
        cur -> val = val * powOfBase[p];
        return;
    }
    int mid = (ll + rr) / 2;
    if (p <= mid) {
        if (cur -> left == nullptr)
            cur -> left = new segTree();
        update(p, val, cur -> left, ll, mid);
    } else {
        if (cur -> right == nullptr)
            cur -> right = new segTree();
        update(p, val, cur -> right, mid + 1, rr);
    }
    cur -> val = (v(cur -> left) + v(cur -> right)) % mod;
}

signed main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    srand(time(0));
    int n;
    cin >> n >> m;
    segTree* s[n];
    for (int i = 0; i < n; i++)
        s[i] = new segTree();
    powOfBase[0] = 1;
    for (int i = 1; i <= m; i++) {
        powOfBase[i] = (powOfBase[i - 1] * base) % mod;
        weight[i] = (rand() << 16) + rand();
    }

    int sum = 0;
    priority_queue<pair<int, int>> mx, mn;
    for (int i = 0; i < n; i++) {
        int q;
        cin >> q;
        sum += q;
        mx.push({q, i});
        mn.push({-q, i});
        for (int j = 0; j < q; j++) {
            int k;
            cin >> k;
            update(k, 1, s[i]);
        }
    }
    int lim = sum % n != 0;
    vector<vector<int>> ans;
    while (mx.top().fs + mn.top().fs > lim) {
        int sf = mx.top().fs, ss = -mn.top().fs;
        int f = mx.top().sc, u = mn.top().sc;
        //cout << sf << " " << f << " " << ss << " " << u << endl;
        mx.pop();
        mn.pop();

        int l = 1, r = m;
        segTree* c1 = s[f], *c2 = s[u];
        while (l != r) {
            int mid = (l + r) / 2;
            if ((v(lef(c1)) & v(lef(c2))) == v(lef(c2))) {
                c1 = righ(c1);
                c2 = righ(c2);
                l = mid + 1;
            } else {
                c1 = lef(c1);
                c2 = lef(c2);
                r = mid;
            }
        }

        ans.push_back({f, u, l});
        update(l, 0, s[f]);
        update(l, 1, s[u]);

        mx.push({sf - 1, f});
        mn.push({-(sf - 1), f});
        mx.push({ss + 1, u});
        mn.push({-(ss + 1), u});
    }
    cout << ans.size() << endl;
    for (vector<int> i : ans)
        cout << i[0] + 1 << " " << i[1] + 1 << " " << i[2] << endl;
}
