#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <map>
#include <stack>

using namespace std;

const long long INF = 5e+18;

const int N = 1e+7;
int b[N], a[N];

signed main()
{
	//freopen("input.txt", "r", stdin);
	
	int q;
	cin >> q;

	while (q--) {
		unsigned n, l, r, x, y, z, b1, b2;
		cin >> n >> l >> r >> x >> y >> z >> b1 >> b2;
		b[0] = b1;
		b[1] = b2;

		for (int i = 2; i < n; i++)
			b[i] = b[i - 2] * x + b[i - 1] * y + z;

		for (int i = 0; i < n; i++)
			a[i] = b[i] % (r - l + 1) + l;

		stack<int> s;

		long long ans = INF;
		long long curmin = 3e+9;
		for (int i = 0; i < n; i++) {
			long long x = a[i];
			while (s.size() && s.top() >= x)
				s.pop();

			if (x < 0) {
				if (s.size())
					ans = min(ans, x * 1LL * s.top());
			}
			else if (curmin < x)
				ans = min(ans, curmin * 1LL * x);

			curmin = min(curmin, x);
			s.push(a[i]);
		}

		if (ans == INF)
			cout << "IMPOSSIBLE\n";
		else
			cout << ans << '\n';
	}
}
