#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
const ll INF = LLONG_MAX;

int const mxn = 100005;

vector<string> Q;
int ind = 0;
map<string, string> W;

bool beginsWith(string a, string b) {
    for (int i = 0; i < b.size(); ++i) {
        if (a[i] != b[i]) {
            return 0;
        }
    }
    return 1;
}

string substr(string str, int a, int b) {
    string res = "";
    for (int i = a; i <= b; ++i) {
        res += str[i];
    }
    return res;
}

int getInd(string str) {
    int act = str.size() - 1;
    while (str[act] == ',' || str[act] == '.' || str[act] == 39) {
        act--;
    }
    return act;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    string str;
    while (true) {
        cin >> str;
        if (beginsWith(str, "\\begin{")) {
            continue;
        }
        if (beginsWith(str, "\\end{")) {
            break;
        }
        if (beginsWith(str, "\\cite{")) {
            Q.push_back(substr(str, 6, getInd(str)));
        }
        if (beginsWith(str, "\\bibitem{")) {
            if (Q[ind] == substr(str, 9, getInd(str))) {
                ind++;
            }
            string LoL;
            getline(cin, LoL);
            W[substr(str, 9, getInd(str))] = LoL;
        }
    }
    if (ind == Q.size()) {
        cout << "Correct";
    }
    else {
        cout << "Incorrect\n\\begin{thebibliography}{99}\n";
        for (auto j : Q) {
            cout << "\\bibitem{" << j << "}" << W[j] << "\n";
        }
        cout << "\\end{thebibliography}";
    }

    return 0;
}