#include <bits/stdc++.h>
#include <iostream>
#include <climits>
#include <set>
#include <algorithm>

using namespace std;
#define FAST_ALL 2e8

int allpos = 0;
char allmem[(int)FAST_ALL];

inline void* operator new(size_t n){
    char *res = allmem + allpos;
    allpos += n;
    assert(allpos <= (int)FAST_ALL);
    return (void *) res;
}
inline  void operator delete(void *){};


typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
const ll INF = LLONG_MAX;

const ll N = 1e7 + 7;
int arr[N];

inline ll mod(ull a, ull b){
    return (ll)(a % b);
}

void sol(){
    ll n, l, r, x, y, z;
    ll b1, b2;
    cin >> n >> l >> r >> x >> y >> z >> b1 >> b2;
    ll minP = INF, minO = 1;
    allpos = 0;
    set<ll> ost;
    ll res = INF;
    for(int i = 0; i < n; ++i) {
        ll ac = ((ll)mod((ull)b1, (ull)(r - l + 1))) + l;
        arr[i] = ac;

        b1 = (ll)((((ull)b1 * x & ((1ULL << 32) - 1)) + ((ull)b2 * y & ((1ULL << 32) - 1) + z)) & ((1LL << 32) - 1));
        swap(b1, b2);
    }
    int eminn = INT_MAX;
    for (int i = 0; i < n; ++i) {
        if (eminn < arr[i]) {
            res = min(res, (ll)eminn * arr[i]);
        }
        eminn = min(eminn, arr[i]);
    }
    int emaxx = INT_MIN;
    for (int i = n - 1; i >= 0; --i) {
        if (emaxx > arr[i]) {
            res = min(res, (ll)emaxx * arr[i]);
        }
        emaxx = max(emaxx, arr[i]);
    }
    if(res == INF) {
        cout << "IMPOSSIBLE\n";
    } else {
        cout << res << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t;
    cin >> t;
    while(t--)
        sol();

}