#include <iostream>
#include <iomanip>
#include <vector>
#include <string>
#include <queue>
#include <set>
#include <map>
#include <algorithm>
#include <cmath>
#include <ctime>
#include <cstring>

using namespace std;

#define int long long 
#define sz(a) (int)(a.size())
#define pb emplace_back

void fast_io() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
}


const int MAXN = 228;
string addr[MAXN];
string list[MAXN];
map<string, string> ans;

string get_ref(string &s) {
	string ref;
	bool fl = false;
	for (auto el : s) {
		if (el == '}') {
			fl = false;
		}
		if (fl) {
			ref += el;
		}
		if (el == '{') {
			fl = true;
		}
	}
	return ref;
}

signed main() {
	fast_io();
	string s, add;
	int ind = 0, ind_list = 0;
	bool listmode = false;
	while (true) {
		getline(cin, s);
		if (s.substr(0, 4) == "\\end") {
			break;
		}
		string cur_s;
		if (listmode || s.substr(0, 6) == "\\begin") {
			listmode = true;
			if (s.substr(0, 3) == "\\bi") {
				list[ind_list++] = s;
			}
			ans[get_ref(s)] = s;
		}
		for (auto ch : s) {
			if (ch != ' ') {
				cur_s += ch;
			}
			else {
				if (cur_s.substr(0, 5) == "\\cite") {
					addr[ind++] = get_ref(cur_s);
				}
				cur_s = "";
			}
		}
		if (cur_s.substr(0, 5) == "\\cite") {
			addr[ind++] = get_ref(cur_s);
		}
		cur_s = "";
	}
	bool correct = true;
	for (int i = 0; i < ind_list; i++) {
		if (get_ref(list[i]) != addr[i]) {
			correct = false;
		}
	}
	if (correct) {
		cout << "Correct";
		return 0;
	}
	cout << "Incorrect\n";
	cout << char(92) << "begin{thebibliography}{99}\n";
	for (int i = 0; i < ind; i++) {
		cout << ans[addr[i]] << '\n';
	}
	cout << char(92) << "end{thebibliography}";
	return 0;
}