#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

#define int long long

int turn = 1;

struct entity {
	int a;
	int h;
	bool dead;
	int deathTurn;
	entity(entity &e) : a(e.a), h(e.h), dead(e.dead) {
		if (dead) {
			deathTurn = turn;
		}
		else {
			deathTurn = -1;
		}
	}
	entity() : a(1), h(1), dead(false), deathTurn(-1) {}
	void bless() {
		a *= 2;
	}
	void spirit() {
		h *= 2;
	}
};

void attack(entity &a, entity &b) {
	a.h -= b.a;
	b.h -= a.a;
	if (a.h <= 0) {
		a.dead = true;
		a.deathTurn = turn;
	}
	if (b.h <= 0) {
		b.dead = true;
		b.deathTurn = turn;
	}
}

entity a[250000];
signed main() {
	int n, t, x, y, k = 0;
	cin >> n;
	for (int i = 0; i < n; i++, turn++) {
		cin >> t;
		if (t == 1) {
			a[k++] = entity();
		}
		if (t == 2) {
			cin >> x;
			x--;
			if (!a[x].dead)
				a[x].bless();
		}
		if (t == 3) {
			cin >> x;
			x--;
			if (!a[x].dead)
				a[x].spirit();
		}
		if (t == 4) {
			cin >> x;
			x--;
			a[k++] = entity(a[x]);
		}
		if (t == 5) {
			cin >> x >> y;
			x--; y--;
			if (!a[x].dead && !a[y].dead)
				attack(a[x], a[y]);
		}
	}

	for (int i = 0; i < k; i++) {
		cout << a[i].deathTurn << ' ';
	}

	return 0;
}