#include <iostream>
#include <iomanip>
#include <vector>
#include <string>
#include <queue>
#include <set>
#include <map>
#include <algorithm>
#include <cmath>
#include <ctime>
#include <cstring>

using namespace std;

#define int long long 
#define sz(a) (int)(a.size())
#define pb emplace_back

void fast_io() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
}

const int MAXN = 1e7 + 228;
int a[MAXN];
int b[MAXN];
const int MOD = 4294967296;
const int INF = (int)5e18;

signed main() {
	fast_io();
	int t;
	cin >> t;
	for (int i = 0; i < t; i++) {
		int ans = INF;
		int n, l, r, x, y, z, b1, b2;
		cin >> n >> l >> r >> x >> y >> z >> b1 >> b2;
		b[1] = b1;
		b[2] = b2;
		for (int i = 3; i <= n; i++) {
			b[i] = (b[i - 2] * x + b[i - 1] * y + z) % MOD;
		}
		for (int i = 1; i <= n; i++) {
			a[i] = (b[i] % (r - l + 1)) + l;
		}
		set<int> suf;
		for (int i = n; i > 0; i--) {
			auto it = suf.upper_bound(a[i]);
			if (it != suf.end()) {
				ans = min(ans, min(a[i] * (*suf.rbegin()), a[i] * (*it)));
			}
			suf.insert(a[i]);
		}
		if (ans == INF) {
			cout << "IMPOSSIBLE\n";
		}
		else {
			cout << ans << '\n';
		}
	}
	return 0;
}