#include <iostream>
#include <iomanip>
#include <vector>
#include <string>
#include <queue>
#include <set>
#include <map>
#include <algorithm>
#include <cmath>
#include <ctime>
#include <cstring>

using namespace std;

#define int long long 
#define sz(a) (int)(a.size())
#define pb emplace_back

void fast_io() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
}

int t, n, a, b, k;

int v1() {
	int l1 = n;
	int l2 = n / 2;
	if (a > b) swap(a, b);
	int h1 = a;
	int h2 = b - a;
	int ans = 0;
	while (l1 >= k) {
		ans += h2 * (l2 / k);
		ans += h1 * (l1 / k);
		int nl1, nl2, nh1, nh2;
		int na = a, nb = b - a;
		if (na > nb) {
			nl2 = l1 % k;
			swap(na, nb);
		}
		else {
			nl2 = l2 % k;
		}
		nl1 = (l1 % k) + l2 % k;
		nh1 = na;
		nh2 = nb - na;
		swap(l1, nl1);
		swap(l2, nl2);
		swap(h1, nh1);
		swap(h2, nh2);
	}
	return min(ans, t);
}

int v2() {
	int l1 = n;
	int l2 = n / 2;
	if (a > b) {
		swap(a, b);
		l2 = (n + 1) / 2;
	}
	int h1 = a;
	int h2 = b - a;
	int ans = 0, o1 = 0, o2 = 0;
	if (l1 < k) {
		return 0;
	}
	else {
		int S1 = l1 * h1;
		ans += S1 / k;
		o1 = S1 % k;
	}
	if (l2 < k) {
		o2 = k - l2;
		ans += min(h2, o1 / o2);
	}
	else {
		int S2 = l2 * h2;
		ans += S2 / k;
		o2 = S2 % k;
		ans += (o1 + o2) % k;
	}
	return min(ans, t);
}

signed main() {
	fast_io();
	cin >> t >> n >> a >> b >> k;
	cout << max(v1(), v2());
	return 0;
}