#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

#define all(x) (x).begin(), x.end()
#define sz(x) (int)(x).size()
#define add push_back

string parse(string s) {
    assert(sz(s));
    while (s.back() != '}') {
        s.pop_back();
    }
    s.pop_back();
    reverse(all(s));
    while (s.back() != '{') {
        s.pop_back();
    }
    s.pop_back();
    reverse(all(s));
    return s;
}

vector <string> txt, bibl;
map <string, string> mp;

void megaParse(string s) {
    string cur;
    bool f = 0;
    for (int i = 0; i < sz(s); i++) {
        if (s[i] == '{') {
            f = 1;
            cur = "";
            continue;
        }
        if (s[i] == '}') {
            f = 0;
            txt.add(cur);
            continue;
        }
        if (f) {
            cur += s[i];
        }
    }
}

bool check() {
    for (int i = 0; i < sz(txt); i++) {
        if (txt[i] != bibl[i]) {
            return 0;
        }
    }
    return 1;
}

void $main() {
    string s;
    bool f = 0;
    while (1) {
        getline(cin, s);
        if (!sz(s)) {
            continue;
        }
        if (s == "\\begin{thebibliography}{99}") {
            f = 1;
            continue;
        }
        if (s == "\\end{thebibliography}") {
            break;
        }
        if (!f) {
            megaParse(s);
        } else {
            string res = parse(s);
            bibl.add(res);
            mp[res] = s;
        }
    }
    if (check()) {
        cout << "Correct";
        return;
    }
    cout << "Incorrect" << endl;
    cout << "\\begin{thebibliography}{99}" << endl;
    for (int i = 0; i < sz(txt); i++) {
        cout << mp[txt[i]] << endl;
    }
    cout << "\\end{thebibliography}";
}

int main() {
    ios::sync_with_stdio(0);
#ifdef fff
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    $main();
}
