#include <bits/stdc++.h>

using namespace std;

#define F first
#define S second

const int INF = 1e9 + 10;

int main() {
#ifdef PC
    freopen("input.txt", "r", stdin);
#endif
    int n;
    cin >> n;
    vector<pair<int, int> > arr(n + 10);
    vector<int> dead(n + 10, INF);
    int cnt = 0;
    for (int i = 0; i < n; i++) {
        int type;
        cin >> type;
        if (type == 1) {
            cnt++;
            arr[cnt] = {1, 1};
        }
        if (type == 2) {
            int x;
            cin >> x;
            if (arr[x].S > 0) {
                arr[x].F *= 2;
            }
        }
        if (type == 3) {
            int x;
            cin >> x;
            if (arr[x].S > 0) {
                arr[x].S *= 2;
            }
        }
        if (type == 4) {
            int x;
            cin >> x;
            cnt++;
            arr[cnt] = arr[x];
            if (arr[cnt].S <= 0) {
                dead[cnt] = i;
            }
        }
        if (type == 5) {
            int x, y;
            cin >> x >> y;
            if (arr[x].S <= 0 || arr[y].S <= 0) {
                continue;
            }
            pair<int, int> A = {arr[x].F, arr[x].S - arr[y].F}, B = {arr[y].F, arr[y].S - arr[x].F};
            arr[x] = A;
            arr[y] = B;
            if (arr[x].S <= 0) {
                dead[x] = i;
            }
            if (arr[y].S <= 0) {
                dead[y] = i;
            }
        }
    }
    cout << cnt << '\n';
    for (int i = 1; i <= cnt; i++) {
        if (dead[i] < INF) {
            cout << dead[i] + 1 << ' ';
        }
        else {
            cout << -1 << ' ';
        }
    }
    return 0;
}
