#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <unordered_map>
using namespace std;
char starts(string s, string what) {
	if ( int(s.size()) < int(what.size()) )
		return 0;
	for (int i = 0; i < int(what.size()); i++)
		if (s[i] != what[i])
			return 0;
	return 1;
}
string getname(string s) {
	char opened = 0;
	string ans;
	for (int i = 0; i < int(s.size()); i++) {
		if (s[i] == '}')
			return ans;
		if (opened)
			ans += s[i];
		if (s[i] == '{')
			opened = 1;
	}
}
int main()
{
	unordered_map<string, int>order;
	vector<string>namelist;
	unordered_map<string, vector<string> >desc;
	int inord = 0, outord = 0;
	char cor = 1;
	char need = 1;
	string s;
	string spec(1, char(92));

	string speccite = spec + "cite";
	string specbib = spec + "bibitem";
	string endbib = spec + "end{thebibliography}";

	while (s!=endbib) {
		if (need)
			cin >> s;
		else
			need = 1;
		if (starts(s, speccite)) {
			string name = getname(s);
			namelist.push_back(name);
			order[name] = inord;
			inord++;
		}
		if (starts(s, specbib)) {
			string name = getname(s);
			if (outord != order[name])
				cor = 0;
			outord++;
			
			need = 0;
			char exit = 0;
			
			while (!exit) {
				
			
				cin >> s;
				if (starts(s, spec))
					break;
				desc[name].resize(int(desc[name].size()) + 1);
				string nows = s;
				getline(cin, s);

				for (int i = 0; i < int(s.size()) && !exit; i++) 
					if (s[i] == ' ') {
						if (starts(nows, spec)) {
							exit = 1;
							s = nows;
						}
						else if (nows.size() > 0) {
							desc[name].back() += nows;
							desc[name].back() += " ";
						}
						nows = "";
					}
					else
						nows += s[i];
			
					if (starts(nows, spec)) {
						exit = 1;
						s = nows;
					}
					else if (nows.size() > 0) {
						desc[name].back() += nows;
						desc[name].back() += " ";
					}
					
				
				desc[name].back().resize(int(desc[name].back().size()) - 1);
			}
				

			
		}
	}
	if (cor)
		cout << "Correct";
	else {
		cout << "Incorrect" << endl;
		cout << spec << "begin{thebibliography}{99}" << endl;
		for (int i = 0; i < int(namelist.size()); i++) {
			cout << spec << "bibitem{" << namelist[i] << "} "; 
			for (int j = 0; j < desc[namelist[i]].size(); j++)
				cout << desc[namelist[i]][j] << endl;
		}
		cout << spec << "end{thebibliography}";
	}
}