#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

#define int ll

const ll MOD = (1ll << 32);
const ll INF = 6e18;

ll min_ans(vector<ll> &a)
{
    int n = a.size();

    ll ans = INF;
    ll mn = INF;
    for(int i = 0; i < n; i++)
    {

        if(mn < INF && mn < a[i])
            ans = min(ans, a[i] * mn);
        mn = min(a[i], mn);
    }

    return ans;
}

ll max_ans(vector<ll> &a)
{

    int n = a.size();

    ll ans = INF;
    ll mn = -INF;
    for(int i = 0; i < n; i++)
    {

        if(mn > -INF && mn < a[i])
            ans = min(ans, a[i] * mn);
        mn = max(a[i], mn);
    }

    return ans;
}


ll solve(vector<ll> &a) {
    // for (auto i : a) {
    //     cout << i << ' ' ;
    // }
    // cout << endl;
    int n = a.size();
    bool mn = 1, pl = 1;
    for(auto i : a)
     {
         mn &= (i < 0);
         pl &= (i > 0);

     }
    if(pl)
        return min_ans(a);
    else if(mn)
    {
        return max_ans(a);
    }

    ll ans = INF;
    ll mn1 = INF;
    for(auto i : a)
    {
        if(mn1 < INF && mn1 != i)
            ans = min(ans, i * mn1);
        mn1 = min(i, mn1);
    }

    return ans;
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    // cout << solve({-3, -2, -1, -12}) << '\n';
    // return 0;

    int t;
    cin >> t;

    for (int test = 0; test < t; ++test) {
        int n, l, r, x, y, z;
        cin >> n >> l >> r >> x >> y >> z;

        vector<int> b(n);
        cin >> b[0] >> b[1];

        for (int i = 2; i < n; ++i) {
            b[i] = (1ll * b[i - 2] * x + 1ll * b[i - 1] * y + z) % MOD;
        }

        vector<int> a(n);
        for (int i = 0; i < n; ++i) {
            a[i] = b[i] % (r - l + 1) + l;
        }

        // for (auto i : a) {
        //     cout << ' ' << i;
        // }
        // cout << '\n';

        ll ans = solve(a);

        if (ans == INF) {
            cout << "IMPOSSIBLE\n";
        } else {
            cout << ans << '\n';
        }
    }

    return 0;
}
