#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

#define int ll

const ll MOD = (1ll << 32);
const ll INF = 6e18;

ll solve(const vector<int> &a) {
    int n = a.size();

    vector<ll> realmin(n), suffmin(n);
    vector<ll> realmax(n), suffmax(n);

    realmin[n - 1] = realmax[n - 1] = a[n - 1];
    suffmin[n - 1] = INF;
    suffmax[n - 1] = -INF;

    for (int i = n - 2; i >= 0; --i) {
        realmin[i] = min(1ll * a[i], realmin[i + 1]);
        if (realmin[i + 1] == a[i]) {
            suffmin[i] = suffmin[i + 1];
        } else {
            suffmin[i] = min(realmin[i + 1], 1ll * a[i]);
        }

        realmax[i] = max(1ll * a[i], realmax[i + 1]);
        if (realmax[i + 1] == a[i]) {
            suffmax[i] = suffmax[i + 1];
        } else {
            suffmax[i] = max(realmax[i + 1], 1ll * a[i]);
        }
    }

    // cout << suffmax[0] << '\n';

    ll ans = INF;

    for (int i = 0; i < n - 1; ++i) {
        if (suffmin[i + 1] == INF && suffmax[i + 1] == -INF) {
            continue;
        } else if (suffmin[i + 1] == INF) {
            ans = min(ans, 1ll * a[i] * suffmax[i + 1]);
        } else if (suffmax[i + 1] == -INF) {
            ans = min(ans, 1ll * a[i] * suffmin[i + 1]);
        } else {
            ans = min(ans, min(1ll * a[i] * suffmax[i + 1], 1ll * a[i] * suffmin[i + 1]));
        }
    }

    return ans;
}

bool used[200000];

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    int l, r;
    cin >> n >> m;
    if(n < 2)
        return cout << "NO", 0;
    vector<int> a(n), b(n, n);
    for(int i = 0; i < m; i++)
    {
        cin >> l >> r;
        l--, r--;
        used[l] = 1;
    }
    bool ok = 0;
    for(int i = 0; i < n; i++)
    {
        if(!used[i] && !ok)
        {
            ok = 1;
            a[i] = n;
        }
    }
    if(!ok)
        return cout << "NO", 0;
    int h = 1;
    for(int i = 0; i < n; i++)
        if(a[i] == 0)
            a[i] = h++;
    cout << "YES" << endl;
    for(auto i : a)
        cout << i << ' ' ;
    cout << endl;

    for(auto i : b)
        cout << i << ' ';
	return 0;
}
