#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

#define int ll

const int MOD = (1 << 32);
const ll INF = 6e18;

ll maksym(const vector<int> &a) {
    int n = a.size();

    int mn1, mn2;

    if (a[n - 1] == a[n - 2]) {
        mn1 = a[n - 1];
        mn2 = INF;
    } else {
        mn1 = min(a[n - 1], a[n - 2]);
        mn2 = max(a[n - 1], a[n - 2]);
    }

    for (int i = n - 3; i >= 0; --i) {
        if (a[i] < mn1) {
            mn2 = mn1;
            mn1 = a[i];
        } else if (mn1 < a[i] && a[i] < mn2) {
            mn2 = a[i];
        }

        if (mn2 == INF) {
            continue;
        }

        //ans = min(ans, mn1 * mn2);
    }

    //return ans;
}

ll solve(const vector<int> &a) {
    int n = a.size();

    vector<int> minsuff(n), maxsuff(n);
    vector<int> minsuff2(n), maxsuff2(n);

    minsuff[n - 1] = maxsuff[n - 1] = a[n - 1];
    minsuff2[n - 1] = INF;
    maxsuff2[n - 1] = -INF;

    for (int i = n - 2; i >= 0; --i) {
        if (a[i] < minsuff[i + 1]) {
            minsuff2[i] = minsuff[i + 1];
            minsuff[i] = a[i];
        } else if (a[i] < minsuff2[i + 1]) {
            minsuff2[i] = a[i];
        }

        if (a[i] > maxsuff[i + 1]) {
            maxsuff2[i] = maxsuff[i + 1];
            maxsuff[i] = a[i];
        } else if (a[i] > maxsuff2[i + 1]) {
            maxsuff2[i] = a[i];
        }
    }

    ll ans = INF;


    for (int i = n - 2; i >= 0; --i) {
        ll x = a[i] == minsuff[i + 1] ? minsuff2[i + 1] : minsuff[i + 1];
        ll y = a[i] == maxsuff[i + 1] ? maxsuff2[i + 1] : maxsuff[i + 1];

        if (x == INF && y == INF) {
            continue;
        } else if (x == INF) {
            ans = min(ans, a[i] * y);
        } else if (y == INF) {
            ans = min(ans, a[i] * x);
        } else {
            ans = min(ans, min(a[i] * x, a[i] * y));
        }
    }

    return ans;
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

	ll t, n, a, b, k;
	cin >> t >> n >> a >> b >> k;
	if(n < k)
        return cout << 0, 0;
	ll s = (a * (n - n / 2) + b * (n / 2)) / k;
	cout << min(s, t);
	return 0;
}

