#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    ll n, m;
    cin >> n >> m;

    if (m == n * (n - 1ll) / 2ll)
        return cout << "NO" << endl, 0;

    vector<vector<ll>> g(n);
    for (int i = 0; i < m; i++)
    {
        ll a, b;
        cin >> a >> b;
        a--;
        b--;

        g[a].push_back(b);
        g[b].push_back(a);
    }

    int a = -1;
    int b = -1;
    for (int i = 0; i < n; i++)
    {
        if (g[i].size() == n - 1)
            continue;

        vector<bool> taken(n, false);
        for (int x : g[i])
            taken[x] = true;

        for (int j = 0; j < n; j++) {
            if (!taken[j] && j != i)
            {
                a = i;
                b = j;
                break;
            }
        }

        break;
    }

    vector<int> ans1(n);
    vector<int> ans2(n);
    ans1[a] = ans2[a] = 1;
    ans1[b] = 2;
    ans2[b] = 1;

    int cur = 3;
    for (int i = 0; i < n; i++)
    {
        if (i == a || i == b)
            continue;

        ans1[i] = ans2[i] = cur++;
    }

    cout << "YES" << endl;
    for (int x : ans1)
        cout << x << " ";
    cout << endl;

    for (int x : ans2)
        cout << x << " ";
    cout << endl;

    return 0;
}