#include <bits/stdc++.h>

using namespace std;

#define all(x) x.begin(), x.end()
#define len(x) int(x.size())
#define fori(n) for (int i = 0; i < (n); i++)
#define forj(n) for (int j = 0; j < (n); j++)

typedef long long ll;

const int N = 1e5 + 10;

vector <int> g[N];
vector <int> used;
vector <int> ans;

int col = 1;
int cur_comp = 1;
vector <vector<int>> comp;

void set_colors(int v){
    used[v] = cur_comp;
    comp[cur_comp - 1].push_back(v);
    ans[v] = col++;
    for (int i : g[v]){
        if (used[i] == 0)
            set_colors(i);
    }
}

int main(){
    #ifdef HOME
    freopen("input.txt", "rt", stdin);
    #endif // HOME
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    if (n == 1){
        cout << "NO";
        return 0;
    }
    if (m == 0){
        cout << "YES\n";
        for (int i = 0; i < n; i++)
            cout << i + 1 << ' ';
        cout << "\n";
        for (int i = 0; i < n; i++)
            cout << 1 << ' ';
        return 0;
    }
    set <pair<int, int>> was;
    for (int i = 0; i < m; i++){
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        if (a > b) swap(a, b);
        if (was.find({a, b}) != was.end()) continue;
        g[a].push_back(b);
        g[b].push_back(a);
        was.insert({a, b});
    }
    used.resize(n, 0);
    ans.resize(n, -1);
    for (int i = 0; i < n; i++)
        if (used[i] == 0){
            comp.push_back(vector<int>(0));
            set_colors(i);
            cur_comp++;
        }
    if (comp.size() > 1){
        cout << "YES\n";
        for (int i : ans)
            cout << i << ' ';
        cout << "\n";
        int idx = comp[0][0];
        int idy = comp[1][0];
        ans[idx] = ans[idy];
        for (int i : ans)
            cout << i << ' ';
    }
    else{
        if (1ll * was.size() == (1ll * n * (n - 1ll)) / 2ll){
            cout << "NO\n";
            return 0;
        }
        cout << "YES\n";
        for (int i : ans)
            cout << i << ' ';
        cout << "\n";
        bool f = false;
        for (int i = 0; i < n; i++){
            for (int j = i + 1; j < n; j++){
                if (was.find({i, j}) == was.end()){
                    ans[i] = ans[j];
                    f = true;
                    break;
                }
            }
            if (f) break;
        }
        for (int i : ans)
            cout << i << ' ';
    }
    return 0;
}
