#include <bits/stdc++.h>

using namespace std;

#define int long long
#define double long double

const int INF = 3e9;
const int BINF = 5e18;

int dx[8] = {1, 2, 2, 1, -1, -2, -2, -1};
int dy[8] = {2, 1, -1, -2, -2, -1, 1, 2};

pair<int, int> tonum(string s) {
    return make_pair(s[0] - 'a', s[1] - '1');
}

int a[10][10], was[10][10];
pair<int, int> pref[10][10];
int n;

bool on_board(int x, int y) {
    if (x < 0 || y < 0) return false;
    if (x >= 8 || y >= 8) return false;
    return true;
}

string tostr(pair<pair<int, int>, pair<int, int> > p) {
    string ans;
    ans += char(p.first.second + 'a');
    ans += char(p.first.first + '1');
    ans += '-';
    ans += char(p.second.second + 'a');
    ans += char(p.second.first + '1');
    return ans;
}

int32_t main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    cin.tie(0);
    cout.tie(0);
    cin.sync_with_stdio(0);
    srand(time(0));
    cin >> n;
    for (int i = 0; i < n; i++) {
        string tmp;
        cin >> tmp;
        a[tonum(tmp).second][tonum(tmp).first] = 1;
    }
    vector<pair<pair<int, int>, pair<int, int> > > ans;
    for (int tr = 64; tr > -1; tr--) {
        for (int i = 0; i < 8; i++) {
            for (int j = 0; j < 8; j++) {
                was[i][j] = 0;
                pref[i][j] = make_pair(i, j);
            }
        }
        for (int i = 0; i < 64; i++) {
            if (n < 56) {
                was[i / 8][i % 8] = 1;
            }
            if (a[i / 8][i % 8] == 0) {
                vector<pair<int, int> > que;
                que.push_back(make_pair(i / 8, i % 8));
                int l = 0;
                was[i / 8][i % 8] = 1;
                while (l < que.size()) {
                    if (a[que[l].first][que[l].second] == 1) {
                        break;
                    }
                    for (int tp = 0; tp < 8; tp++) {
                        int nx = que[l].first + dx[tp];
                        int ny = que[l].second + dy[tp];
                        if (on_board(nx, ny) && was[nx][ny] == 0) {
                            was[nx][ny] = 1;
                            pref[nx][ny] = que[l];
                            que.push_back(make_pair(nx, ny));
                        }
                    }
                    l++;
                }
                if (l >= que.size()) {
                    break;
                }
                int nowx = que[l].first, nowy = que[l].second;
                while (pref[nowx][nowy] != make_pair(nowx, nowy)) {
                    ans.push_back(make_pair(make_pair(nowx, nowy),
                                            make_pair(pref[nowx][nowy].first, pref[nowx][nowy].second)));
                    pair<int, int> tmp = pref[nowx][nowy];
                    swap(a[nowx][nowy], a[pref[nowx][nowy].first][pref[nowx][nowy].second]);
                    nowx = tmp.first;
                    nowy = tmp.second;
                }
                break;
            }
        }
    }
    if (ans.size() > 1500) return -1;
    cout << ans.size() << "\n";
    for (int i = 0; i < ans.size(); i++) {
        cout << tostr(ans[i]) << "\n";
    }
    return 0;
}