#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define f first
#define s second
#define mp(a, b) make_pair(a, b)
#define size(x) (ll)x.size()

void fast_io() {
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // LOCAL

    ios::sync_with_stdio(false);
}

vector<vector<int> > g, gr;
vector<int> us;
vector<int> order;

void dfs(int v) {
    us[v] = 1;
    for(int to : g[v]) {
        if(us[to] == 1) {
            cout << "NO";
            exit(0);
        }else if(us[to] == 0) {
            dfs(to);
        }
    }
    us[v] = 2;
    order.push_back(v);
}

int main()
{
    fast_io();

    int n, m;
    cin >> n >> m;
    g.resize(n);
    gr.resize(n);
    us.assign(n, 0);
    for(int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        g[a - 1].push_back(b - 1);
        gr[b - 1].push_back(a - 1);
    }
    for(int i = 0; i < n; i++) {
        if(us[i] == 0) {
            dfs(i);
        }
    }
    vector<int> st;
    for(int i = 0; i < n; i++) {
        if(size(gr[i]) == 0) {
            st.push_back(i);
        }
    }
    vector<int> ans(n, -1);
    reverse(order.begin(), order.end());
    for(int i = 0; i < n; i++) {
        ans[order[i]] = i + 1;
    }
    if(size(st) == 1) {
        queue<int> q;
        us.assign(n, 0);
        for(int i = 0; i < n; i++) {
            if(size(gr[i]) == 0) {
                q.push(i);
                us[i] = 1;
            }
        }
        while(!q.empty()) {
            int x = q.front();
            q.pop();
            for(int to : g[x]) {
                if(us[to] < us[x] + 1) {
                    q.push(to);
                    us[to] = us[x] + 1;
                }
            }
        }

        set<int> st;
        for(int i = 0; i < n; i++) {
            st.insert(us[i]);
            if(size(st) == n) {
                cout << "NO";
                return 0;
            }
        }
        if(size(st) == n) {
            cout << "NO";
            return 0;
        }

    }else {
        us = ans;
        int x = min(ans[st[0]], ans[st[1]]);
        us[st[0]] = x;
        us[st[1]] = x;
    }
    cout << "YES\n";
    for(int i = 0; i < n; i++)
        cout << ans[i] << " ";
    cout << "\n";
    for(int i = 0; i < n; i++) {
        cout << us[i] << " ";
    }
}
