#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define f first
#define s second
#define mp(a, b) make_pair(a, b)
#define size(x) (ll)x.size()

void fast_io() {
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // LOCAL

    ios::sync_with_stdio(false);
}

int main()
{
    fast_io();
    int dist[8][8][8][8];
    int x[8] = {1, -1, 1, -1, 2, 2, -2, -2};
    int y[8] = {2, 2, -2, -2, 1, -1, 1, -1};
    for (int i = 0; i < 8; i++)
    {
        for (int j = 0; j < 8; j++)
        {
            for (int i1 = 0; i1 < 8; i1++)
            {
                for (int j1 = 0; j1 < 8; j1++)
                {
                    dist[i][j][i1][j1] = 1e9;
                }
            }
            dist[i][j][i][j] = 0;
            queue<pair<ll, ll>> q;
            q.push({i, j});
            while (!q.empty())
            {
                pair <ll, ll> id = q.front();
                q.pop();
                ll ds = dist[i][j][id.f][id.s];
                for (int ii = 0; ii < 8; ii++)
                {
                    id.f += x[ii];
                    id.s += y[ii];
                    if (id.f >= 0 && id.f < 8 && id.s >= 0 && id.s < 8 && dist[i][j][id.f][id.s] > ds + 1)
                    {
                        dist[i][j][id.f][id.s] = ds + 1;
                        q.push({id.f, id.s});
                    }
                    id.f -= x[ii];
                    id.s -= y[ii];
                }
            }
            /*for (int i1 = 0; i1 < 8; i1++)
            {
                for (int j1 = 0; j1 < 8; j1++)
                {
                    cout << dist[i][j][i1][j1] << " ";
                }
                cout << "\n";
            }
            cout << "\n";*/
        }
    }
    ll n;
    cin >> n;
    char ch;
    vector <pair <int, int>> a(n);
    for (int i = 0; i < n; i++)
    {
        cin >> ch >> a[i].s;
        a[i].f = ch - 'a';
        a[i].s--;
    }
    vector <bool> used(n, 0);
    ll fx = 0, fy = 0;
        string ans = "";
        ll anss = 0;
    for (int t = 0; t < n; t++)
    {

        ll mn = 1e9, im = -1;
        for (int i = 0; i < n; i++)
        {
            if (used[i]) continue;
            if (dist[a[i].f][a[i].s][fx][fy] < mn)
            {
                mn = dist[a[i].f][a[i].s][fx][fy];
                im = i;
            }
        }
        ll curx = a[im].f, cury = a[im].s;
        used[im] = 1;
        while (curx != fx || cury != fy)
        {
            ll ds = dist[curx][cury][fx][fy];
            for (int i = 0; i < 8; i++)
            {
                curx += x[i];
                cury += y[i];
                if (curx >= 0 && curx < 8 && cury >= 0 && cury < 8 && ds == dist[curx][cury][fx][fy] + 1)
                {
                    ans = ans + char(curx - x[i] + 'a') + char('0' + cury - y[i] + 1) + "-" + char(curx + 'a') + char('0' + cury + 1) + "\n";
                    anss++;
                    break;
                }
                curx -= x[i];
                cury -= y[i];
            }
        }
        fx++;
        if (fx == 9)
        {
            fx = 0;
            fy++;
        }
    }
    cout << anss << "\n" << ans;
}
