#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cmath>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int,int> pi;
typedef vector<int> vi;
#define fs first
#define sc second
const int inf = 2e9;
const ll linf = 1e18;
const int maxn = 10000100;


//#define LOCAL

#ifndef LOCAL
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("fast-math")
#pragma GCC target("sse,sse2,sse3,ssse3,popcnt,abm,mmx,tune=native")
#endif

ll a[maxn], b[maxn];

int main() {
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	int n, m;
	cin >> n >> m;
	set<pair<int, int> > s;
	for (int i = 0; i < m; ++i) {
		int a, b;
		cin >> a >> b;
		if (a > b) swap(a, b);
		s.insert({ a-1,b-1 });
	}
	for (int i = 0; i < n; ++i) {
		for (int j = i + 1; j < n; ++j) {
			if (s.find({ i,j }) == s.end()) {
				vector<int> av(n), bv(n);
				int cnt = 3;
				for (int h = 0; h < n; ++h) {
					if (h != i && h != j) av[h] = cnt++;
				}
				av[i] = 1;
				av[j] = 2;
				bv[i] = 1;
				bv[j] = 1;
				cnt = 3;
				for (int h = 0; h < n; ++h) {
					if (h != i && h != j) bv[h] = cnt++;
				}
				cout << "YES" << endl;
				for (int h = 0; h < n; ++h)cout << av[h] << " "; 
				cout << endl;
				for (int h = 0; h < n; ++h) cout << bv[h] << " ";
				return 0;
			}
		}
	}
	cout << "NO";
	return 0;
}

/*
ios_base::sync_with_stdio(false);
int t;
cin >> t;
for (int it = 0; it < t; ++it) {
int n;
ll l, r, x, y, z, b1, b2;
cin >> n >> l>>r >> x >> y >>z>>b1>>b2;
b[0] = b1;
b[1] = b2;
for (int i = 2; i < n; ++i) b[i] = (b[i - 2] * x + b[i - 1] * y + z) % (1ll << 32);
for (int i = 0; i < n; ++i) a[i] = b[i] % (r - l + 1) + l;
int mn = a[n - 1];
ll ans = 0;
for (int i = n - 2; i >= 0; --i) {

}


}
*/