#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cmath>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <queue>
using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int,int> pi;
typedef vector<int> vi;
#define fs first
#define sc second
const int inf = 2e9;
const ll linf = 1e18;
const int maxn = 10000100;


//#define LOCAL

#ifndef LOCAL
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("fast-math")
#pragma GCC target("sse,sse2,sse3,ssse3,popcnt,abm,mmx,tune=native")
#endif

ll b[maxn];
int a[maxn], mn[maxn], mx[maxn];

int main() {
	ios_base::sync_with_stdio(false);
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	int t;
	cin >> t;
	for (int it = 0; it < t; ++it) {
		int n;
		ll l, r, x, y, z, b1, b2;
		cin >> n >> l >> r >> x >> y >> z >> b1 >> b2;
		b[0] = b1;
		b[1] = b2;
		for (int i = 2; i < n; ++i) b[i] = (b[i - 2] * x + b[i - 1] * y + z) % (1ll << 32);
		for (int i = 0; i < n; ++i) a[i] = b[i] % (r - l + 1) + l;
		
		ll ans = linf;
		mn[n - 1] = mx[n - 1] = a[n - 1];
		bool flg = 1;
		for (int i = 0; i < n - 1; ++i) {
			if (a[i] < a[i + 1]) {
				flg = 0; break;
			}
		}
		if (flg) {
			cout << "IMPOSSIBLE" << endl;
			continue;
		}
		for (int i = n - 2; i >= 0; --i) {
			mn[i] = min(mn[i + 1], a[i]);
			mx[i] = max(mx[i + 1], a[i]);
		}
		for (int i = 0; i < n - 1; ++i) {
			if (mn[i + 1] > a[i]) ans = min(ans, 1ll * a[i] * mn[i + 1]);
			if (mx[i + 1] > a[i]) ans = min(ans, 1ll * a[i] * mx[i + 1]);
		}
		cout << ans << endl;
	}
	return 0;
}

/*


*/