#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cmath>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <queue>
using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pi;
typedef vector<int> vi;
#define fs first
#define sc second
const int inf = 2e9;
const ll linf = 4e18+10;
const int maxn = 1e7 + 100;


//#define LOCAL

#ifndef LOCAL
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("fast-math")
#pragma GCC target("sse,sse2,sse3,ssse3,popcnt,abm,mmx,tune=native")
#endif

unsigned int b[maxn];
int a[maxn], mn[maxn], mx[maxn], kmn[maxn], kmx[maxn];

int main() {
	ios_base::sync_with_stdio(false);
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	int t;
	cin >> t;
	for (int it = 0; it < t; ++it) {
		int n;
		int l, r;
		unsigned int x, y, z, b1, b2;
		cin >> n >> l >> r >> x >> y >> z >> b1 >> b2;
		b[0] = b1;
		b[1] = b2;
		for (int i = 2; i < n; ++i) b[i] = (b[i - 2] * x + b[i - 1] * y + z);
		for (int i = 0; i < n; ++i) a[i] = ((ll)b[i]) % (r - l + 1) + l;
	/*int n;
	cin >> n;
	for (int i = 0; i < n; ++i) cin >> a[i];
	*/
		ll ans = linf;
		kmx[n - 1] = -2e9 - 20;
		kmn[n - 1] = 2e9 + 20;
		if (a[n - 1] >= 0) kmn[n - 1] = a[n-1];
		else kmx[n - 1] = a[n-1];
		mx[n - 1] = mn[n - 1] = a[n - 1];
		for (int i = n - 2; i >= 0; --i) {
			mx[i] = max(mx[i + 1], a[i]);
			mn[i] = min(mn[i + 1], a[i]);
			if (a[i] >= 0) {
				kmn[i] = min(kmn[i + 1], a[i]);
				kmx[i] = kmx[i + 1];
			}
			else {
				kmn[i] = kmn[i + 1];
				kmx[i] = max(kmx[i + 1], a[i]);
			}
		}
		int curmn = a[0], curmx = a[0], curkmx = -2e9-20, curkmn = 2e9+20;
		for (int i = 0; i < n - 1; ++i) {
			curmn = min(curmn, a[i]);
			curmx = max(curmx, a[i]);
			if (a[i] >= 0) curkmn = min(curkmn, a[i]);
			else curkmx = max(curkmx, a[i]);
			if (curmn < mn[i + 1]) ans = min(ans, 1ll * curmn*mn[i + 1]);
			if (curmn < mx[i + 1]) ans = min(ans, 1ll * curmn*mx[i + 1]);
			if (curmn < kmn[i + 1] && kmn[i + 1] != 2e9 + 20) ans = min(ans, 1ll * curmn*kmn[i + 1]);
			if (curmn < kmx[i + 1] && kmx[i + 1] != -2e9 - 20) ans = min(ans, 1ll * curmn*kmx[i + 1]);
			if (curmx < mn[i + 1]) ans = min(ans, 1ll * curmx*mn[i + 1]);
			if (curmx < mx[i + 1]) ans = min(ans, 1ll * curmx*mx[i + 1]);
			if (curmx < kmn[i + 1] && kmn[i + 1] != 2e9 + 20) ans = min(ans, 1ll * curmx*kmn[i + 1]);
			if (curmx < kmx[i + 1] && kmx[i + 1] != -2e9 - 20) ans = min(ans, 1ll * curmx*kmx[i + 1]);
			if (curkmn != 2e9 + 20) {
				if (curkmn < mn[i + 1]) ans = min(ans, 1ll * curkmn*mn[i + 1]);
				if (curkmn < mx[i + 1]) ans = min(ans, 1ll * curkmn*mx[i + 1]);
				if (curkmn < kmn[i + 1] && kmn[i + 1] != 2e9 + 20) ans = min(ans, 1ll * curkmn*kmn[i + 1]);
				if (curkmn < kmx[i + 1] && kmx[i + 1] != -2e9 - 20) ans = min(ans, 1ll * curkmn*kmx[i + 1]);
			}
			if (curkmx != -2e9 - 20) {
				if (curkmx < mn[i + 1]) ans = min(ans, 1ll * curkmx*mn[i + 1]);
				if (curkmx < mx[i + 1]) ans = min(ans, 1ll * curkmx*mx[i + 1]);
				if (curkmx < kmn[i + 1] && kmn[i + 1] != 2e9 + 20) ans = min(ans, 1ll * curkmx*kmn[i + 1]);
				if (curkmx < kmx[i + 1] && kmx[i + 1] != -2e9 - 20) ans = min(ans, 1ll * curkmx*kmx[i + 1]);
			}
		}
		if (ans == linf) cout << "IMPOSSIBLE" << endl;
		else cout << ans << endl;
	}
	return 0;
}