#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cmath>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <queue>
using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pi;
typedef vector<int> vi;
#define fs first
#define sc second
const int inf = 2e9;
const ll linf = 4e18+10;
const int maxn = 1e7 + 100;


//#define LOCAL

#ifndef LOCAL
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("fast-math")
#pragma GCC target("sse,sse2,sse3,ssse3,popcnt,abm,mmx,tune=native")
#endif

unsigned int b[maxn];
int a[maxn], mn[maxn], mx[maxn];

int main() {
	ios_base::sync_with_stdio(false);
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	int t;
	cin >> t;
	for (int it = 0; it < t; ++it) {
		int n;
		int l, r;
		unsigned int x, y, z, b1, b2;
		cin >> n >> l >> r >> x >> y >> z >> b1 >> b2;
		b[0] = b1;
		b[1] = b2;
		for (int i = 2; i < n; ++i) b[i] = (b[i - 2] * x + b[i - 1] * y + z);
		for (int i = 0; i < n; ++i) a[i] = ((ll)b[i]) % (r - l + 1) + l;

		ll ans = linf;
		mx[n - 1] = mn[n - 1] = a[n - 1];
		bool flg = 1;
		for (int i = 0; i < n - 1; ++i) {
			if (a[i] < a[i + 1]) {
				flg = 0; break;
			}
		}
		if (flg) {
			cout << "IMPOSSIBLE" << endl;
			continue;
		}
		for (int i = n - 2; i >= 0; --i) {
			mx[i] = max(mx[i + 1], a[i]);
			mn[i] = min(mn[i + 1], a[i]);
		}
		int curmn = a[0], curmx = a[0];
		for (int i = 0; i < n - 1; ++i) {
			curmn = min(curmn, a[i]);
			curmx = max(curmx, a[i]);
			if (curmn < mn[i + 1]) ans = min(ans, 1ll * curmn*mn[i + 1]);
			if (curmx < mn[i + 1]) ans = min(ans, 1ll * curmx*mn[i + 1]);
			if (curmn < mx[i + 1]) ans = min(ans, 1ll * curmn*mx[i + 1]);
			if (curmx < mx[i + 1]) ans = min(ans, 1ll * curmx*mx[i + 1]);
		}
		if (ans == linf) cout << "IMPOSSIBLE" << endl;
		else cout << ans << endl;
	}
	return 0;
}