#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cmath>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <queue>
#include <ctime>
#include <random>
using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pi;
typedef vector<int> vi;
#define fs first
#define sc second
const int inf = 2e9;
const ll linf = 4e18+10;
const int maxn = 1e7 + 100;


//#define LOCAL

#ifndef LOCAL
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("fast-math")
#pragma GCC target("sse,sse2,sse3,ssse3,popcnt,abm,mmx,tune=native")
#endif



int main() {
	ios_base::sync_with_stdio(false);
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	int n;
	cin >> n;
	map<pair<string, vector<bool> >, vector<int> > m;
	for (int i = 0; i < n; ++i) {
		string s, t;
		cin >> s >> t;
		vector<bool> u(26, 0);
		for (int j = 0; j < t.length(); ++j)
			u[t[j] - 'a'] = 1;
		int r = s.length() - 1;
		while (r >= 0) {
			if (!u[s[r] - 'a'])
				break;
			--r;
		}
		string str = s.substr(0, r + 1);
		//cout << str << '\n';
		m[{str, u}].push_back(i + 1);
	}
	cout << m.size() << '\n';
	for (auto i : m) {
		cout << i.sc.size() << ' ';
		for (auto j : i.sc)
			cout << j << ' ';
		cout << '\n';
	}
	return 0;
}

