#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cmath>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <queue>
#include <unordered_set>
#include <unordered_map>
using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pi;
typedef vector<int> vi;
#define fs first
#define sc second
const int inf = 2e9;
const ll linf = 1e18;
const int maxn = 10000100;
const ld eps = 1e-3;


//#define LOCAL

#ifndef LOCAL
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("fast-math")
#pragma GCC target("sse,sse2,sse3,ssse3,popcnt,abm,mmx,tune=native")
#endif

int t, n, a, b, k;
ll na, nb;

bool f(int t) {
	return (min((ld)na*a/ t, (ld)na) + min((ld)nb*b / t, (ld)nb))  + eps >= k;
}

int main() {
	ios_base::sync_with_stdio(false);
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	cin >> t >> n >> a >> b >> k;
	nb = n / 2, na = n - nb;
	int l = 0, r = t + 1;
	while (l + 1 < r) {
		int c = (l + r) / 2;
		if (f(c)) l = c;
		else r = c;
	}
	cout << l << endl;
}