#include <iostream>
#include <vector>
#include <deque>
#include <queue>
#include <stack>
#include <set>
#include <map>
#include <iomanip>
#include <string>
#include <algorithm>
#include <cmath>
#include <bitset>


using namespace std;

/*#pragma optimize("no-stack-protector")
#pragma optimize("Ofast")
#pragma optimize("unroll-loops")
#pragma optimize("fast-math")
#pragma target("sse,sse2,sse3,ssse3,popcnt,abm,mmx,tune=native")*/

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

const ll INF = 1e18 + 7;
const int inf = 1e9 + 7;
const ld eps = 1e-9;

int main() {
#ifdef LOCAL
	freopen("input.txt", "rt", stdin);
	freopen("output.txt", "wt", stdout);
#endif
	ios_base::sync_with_stdio(false);

	ll n, mxgl = 0, a;
	ull ans = 0;
	cin >> n;

	vector<pair<ll, ll>> arr(n);
	for (int i = 0; i < n; i++)
	{
		cin >> arr[i].second >> arr[i].first;
		for (int j = 1; j < arr[i].second; j++)
		{
			cin >> a;
			arr[i].first = max(arr[i].first, a);
		}
	}
	for (int i = 0; i < n; i++)
	{
		mxgl = max(arr[i].first, mxgl);
	}
	for (int i = 0; i < n; i++)
	{
		ans += arr[i].second * (mxgl - arr[i].first);
	}
	cout << ans;
}