#include <bits/stdc++.h>

using namespace std;

typedef long long lint;
vector<lint> eq, noteq;
vector<vector<lint>> g;
int counter = 3;

void dfs(int v)
{
    if(eq[v] != -1) return;
    eq[v] = noteq[v] = counter++;
    for(lint u: g[v]) dfs(u);
}

int main()
{
    ios_base::sync_with_stdio(false);
    lint n, m;
    cin >> n >> m;
    g.resize(n);
    eq.resize(n, -1);
    noteq.resize(n, -1);
    for(int i = 0; i < m ; i++){
        lint a, b;
        cin >> a >> b;
        a--, b--;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    if(m == n*(n-1)/2){
        cout << "NO"<< endl;
        return 0;
    }

    lint v;
    for(int i = 0; i < n; i++){
        if(g[i].size() != n-1){
            v = i;
            vector<bool> is(n, false);
            for(lint u: g[i]) is[u] = true;
            lint u;
            for(int j = 0; j < n; j++){
                if(!is[j] && j != i) u = j;
            }
            eq[v] = eq[u] = 1;
            noteq[v] = 1;
            noteq[u] = 2;
            break;
        }
    }
    for(lint x: g[v]) dfs(x);
    for(int i = 0; i < n; i++) dfs(i);
    cout << "YES" << endl;
    for(lint x: noteq) cout << x << " ";
    cout << endl;
    for(lint x: eq) cout << x << " ";
    cout << endl;
    return 0;
}
