#include <iostream>
#include <algorithm>
#include <vector>
#include <set>

using namespace std;

int main(){
    int n, m, a, b;
    cin >> n >> m;
    vector<vector<int>> arr(n);
    set<pair<int, int>> s;
    for (int i = 0; i < m; ++i){
        cin >> a >> b;
        --a; --b;
        if (a > b)
            swap(a, b);

        if (s.find(make_pair(a, b)) == s.end()){
            arr[b].push_back(a);
            s.insert(make_pair(a, b));
        }
    }
    vector<int> ans1(n), ans2(n);
    for (int i = 0; i < n; ++i){
        ans1[i] = i + 1;
        ans2[i] = i + 1;
    }

    for (int i = 0; i < n; ++i)
        sort(arr[i].begin(), arr[i].end());

    if (s.size() >= (long long)n * (n - 1) / 2){
        cout << "NO" << endl;
        return 0;
    }

    cout << "YES" << endl;

    for (int i = 0; i < n; ++i){
        if (arr[i].size() != i){
            int j = 0;
            while (j < arr[i].size() && arr[i][j] == j)
                ++j;
            for (int k = j; k < i; ++k){
                ++ans1[k];
                ++ans2[k];
            }
            ans1[i] = j + 1;
            ans2[i] = j + 2;
            break;
        }
    }

    for (int i = 0; i < n; ++i)
        cout << ans1[i] << " ";
    cout << endl;

    for (int i = 0; i < n; ++i)
        cout << ans2[i] << " ";
    cout << endl;

    return 0;
}
