#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;

int const INF = 1e9;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int n;
    cin >> n;
    vector<pair<vector<int>, pair<string, int>>> a(n);
    string s1, s2;
    for(int i = 0; i < n; i++){
        cin >> s1 >> s2;
        a[i].first.resize(26);
        for(char c : s1){
            a[i].first[c - 'a']++;
        }
        for(char c : s2){
            a[i].first[c - 'a'] = INF;
        }
        a[i].second.first = s1;
        a[i].second.second = i + 1;
    }
    sort(a.begin(), a.end());
    vector<vector<int>> ans(n);
    int cur = 0;
    ans[0].push_back(a[0].second.second);
   // cout << a[0].second.second << endl;
    for(int i = 1; i < n; i++){
        //cout << a[i].second.second << endl;
        if(a[i].first != a[i - 1].first){
            cur++;
            ans[cur].push_back(a[i].second.second);
        } else {
            string st1 = a[i - 1].second.first;
            string st2 = a[i].second.first;
            if(st1.size() > st2.size()){
                swap(st1, st2);
            }
            bool fl = true;
            bool roflan = false;
            for(int j = 0; j < st1.size(); j++){
                if(st1[j] != st2[j] && a[i - 1].first[st1[j] - 'a'] != INF){
                    fl = false;
                    break;
                } else if(st1[j] == st2[j] && a[i - 1].first[st1[j] - 'a'] != INF && roflan){
                    fl =false;
                    break;
                } else if(st1[j] != st2[j] && a[i - 1].first[st1[j] - 'a'] == INF){
                    roflan = true;
                }
            }
            //cout << "denis sosat" << " " << fl << endl;
            if(!fl)
                cur++;
            ans[cur].push_back(a[i].second.second);
        }
    }
    cout << cur + 1 << endl;
    for(int i = 0; i <= cur; i++){
        cout << ans[i].size() << " ";
        for(int j : ans[i]) cout << j << " " ;
        cout << endl;

    }
    return 0;
}
/*3
a kb
ak bk
ab kb*/
