#include<iostream>
#include<vector>
#include<algorithm>
#include<cmath>
#include<map>

using namespace std;

typedef long long ll;

ll cnta, cntb, a, b;

ll check(ll t, ll k) {
	if (t <= a) {
		if (k <= cnta + cntb) {
			return 1;
		}
		return 0;
	}
	if (t > a && t <= b) {
		k -= cntb;
		if (k*t <= cnta*a) {
			return 1;
		}
		return 0;
	}

	if (k*t <= cnta*a + cntb*b) {
		return 1;
	}
	return 0;
}

signed main() {
	cin.tie(0);
	ios_base::sync_with_stdio(0);
	ll t, n, k;
	cin >> t >> n >> a >> b >> k;
	cnta = (n + 1) / 2;
	cntb = n / 2;

	if (a > b) {
		swap(a, b);
		swap(cnta, cntb);
	}

	ll l = 0, r = t + 1;

	while (r - l > 1) {
		ll m = (r + l) / 2;
		if (check(m, k)) {
			l = m;
		}
		else {
			r = m;
		}
	}

	cout << l;

	return 0;
}