#include <bits/stdc++.h>
#define F first
#define S second
#define pb push_back
using namespace std;

bool can[20][20], was[20][20];

int used[20][20];

pair < int, int > p[20][20];

pair < int, int > all[100];

vector < pair < pair < int, int >, pair < int, int > > > ot;

const int rx[8] = {1, 1, -1, -1, 2, 2, -2, -2};
const int ry[8] = {2, -2, 2, -2, 1, -1, 1, -1};

void solve(int x, int y, int ost) {
    if (can[x][y]) {
        can[x][y] = 0;
        was[x][y] = 1;
        return;
    }
    queue < pair < int, int > > q;
    int z;
    q.push({x, y});
    used[x][y] = ost;
    int nowx, nowy;
    while (!q.empty()) {
        int i = q.front().F, j = q.front().S;
        q.pop();
        for (int now = 0; now < 8; ++now) {
            nowx = i + rx[now];
            nowy = j + ry[now];
            if (nowx < 0) {
                continue;
            }
            if (nowy < 0) {
                continue;
            }
            if (nowx >= 8) {
                continue;
            }
            if (nowy >= 8) {
                continue;
            }
            if (used[nowx][nowy] == ost) {
                continue;
            }
            if (was[nowx][nowy]) {
                continue;
            }
            if (can[nowx][nowy]) {
                can[nowx][nowy] = 0;
                was[x][y] = 1;
                vector < pair < int, int > > mem;
                mem.pb({nowx, nowy});
                nowx = i;
                nowy = j;
                while (1) {
                    mem.pb({nowx, nowy});
                    if (nowx == x && nowy == y) {
                        break;
                    }
                    z = nowx;
                    nowx = p[nowx][nowy].F;
                    nowy = p[z][nowy].S;
                }
                for (int haha = 1; haha < int(mem.size()); ++haha) {
                    ot.pb({{mem[haha].F, mem[haha].S}, {mem[haha - 1].F, mem[haha - 1].S}});
                }
                return;
            }
            used[nowx][nowy] = ost;
            q.push({nowx, nowy});
            p[nowx][nowy] = {i, j};
        }
    }
}

int main() {
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    string t;
    for (int i = 0; i < n; ++i) {
        cin >> t;
        all[i].F = t[0] - 'a';
        all[i].S = t[1] - '1';
        can[all[i].F][all[i].S] = 1;
    }
    int ost = n, i = 0, j = 0;
    while (ost > 0) {
        solve(i, j, ost);
        ++i;
        if (i == 8) {
            ++j;
            i = 0;
        }
        --ost;
    }
    while (int(ot.size()) > 1500) {
        continue;
    }
    cout << int(ot.size()) << endl;
    for (auto i : ot) {
        cout << char('a' + i.S.F) << char('1' + i.S.S) << '-' << char('a' + i.F.F) << char('1' + i.F.S) << endl;
    }
}
