#include <iostream>
#include <set>
using namespace std;

const int maxn = 1e5 + 5;
set<int> graph[maxn];

int res[maxn];

int main() {
    ios_base :: sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;

    for (int i = 0; i < m; i++) {
        int v, u;
        cin >> v >> u;
        v--;
        u--;
        graph[v].insert(u);
        graph[u].insert(v);
    }

    int goodv = -1, goodu = -1;

    for (int i = 0; i < n; i++) {
        if (graph[i].size() < n - 1) {
            goodv = i;
            for (int j = 0; j < n; j++) {
                if (i == j) continue;
                if (graph[i].find(j) == graph[i].end()) {
                    goodu = j;
                    break;
                }
            }
            break;
        }
    }

    if (goodu == -1) {
        cout << "NO";
        return 0;
    }
    res[goodv] = 1;
    res[goodu] = 2;
    int ind = 3;
    for (int i = 0; i < n; i++) {
        if (i == goodu || i == goodv) continue;
        res[i] = ind;
        ind++;
    }
    cout << "YES" << endl;
    for (int i = 0; i < n; i++) {
        cout << res[i] << " ";
    }
    cout << endl;
    res[goodu] = 1;
    for (int i = 0; i < n; i++) {
        cout << res[i] << " ";
    }
    return 0;
}