import java.io.*;
import java.util.*;

public class Main {
	static PrintWriter out;
	static boolean[][] place = new boolean[8][8]; 
	static boolean[][] used;
	static boolean[][] usedx;
	static int anss = 0;
	static boolean check(int i, int j, int ix, int jx) {
		if(dfs(ix, jx)) {
			place[ix][jx] = false;
			anss++; 
			out.print((char)(ix+'a') +"" +(char)(jx+'1')+"-");
			out.println((char)(i+'a')+""  +(char)(j+'1'));
			return true;
		}
		return false;
	}
	static boolean dfs(int i, int j) {
		if(i < 0 || i > 7 || j < 0 || j > 7) return false;
		if(used[i][j]) return false;
		if(usedx[i][j]) return false;
		used[i][j] = true;
		if(place[i][j]) {
			return true;
		}
		if(check(i, j, i+1, j+2)) return true;
		if(check(i, j, i-1, j+2)) return true;
		if(check(i, j, i+1, j-2)) return true;
		if(check(i, j, i-1, j-2)) return true;
		if(check(i, j, i+2, j+1)) return true;
		if(check(i, j, i+2, j-1)) return true;
		if(check(i, j, i-2, j+1)) return true;
		if(check(i, j, i-2, j-1)) return true;
		return false;
	}
	public static void main(String[] args) {
		Scanner in = new Scanner(System.in);		
		out = new PrintWriter(System.out);
		int n = in.nextInt();
		Pair[] p = new Pair[n];
		for(int i =0;i<n;i++) {
			String s = in.next();
			p[i] = new Pair( ((int) s.charAt(0) - 'a'), ((int) s.charAt(1) - '1'));
			place[p[i].a][p[i].b] = true; 
		}
		int ans = 0;
		usedx = new boolean[8][8];
		boolean flag = true;
		for(int j = 0;j<8;j++) {
			for(int i =0;i<8;i++) {
				
				if(place[i][j]) {
					place[i][j] = false;
					continue;
				}
				used = new boolean[8][8];
				
				if(!dfs(i, j))flag = false;
				usedx[i][j] = true;
				if(!flag) break;
			}
			if(!flag) break;
		}
		System.out.println(anss);
		out.close();
	}
}
class Pair{
	int a;
	int b;
	public Pair(int a, int b) {
		this.a = a;
		this.b = b;
	}
}