#include <iostream>
#include <set>
#include <vector>
#include <algorithm>

using namespace std;

struct stroka{
    int i;
    string s;
};

const int maxn = 1e5 + 5;
set <char> a1[maxn];
set <char> a2[maxn];

vector<stroka> b;

vector<int> groups[maxn];
int kgroups = 0;
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n;
    cin >> n;

    for (int i = 0; i < n; i++) {
        string s1, s2;
        cin >> s1 >> s2;
        for (auto x: s1) {
            a1[i].insert(x);
        }
        for (auto x: s2) {
            a2[i].insert(x);
        }
        bool flag = true;
        for (auto x:a1[i]) {
            if (a2[i].find(x) == a2[i].end()) {
                groups[kgroups].push_back(i);
                kgroups++;
                flag = false;
                break;
            }
        }
        if (flag) {
            b.push_back({i, ""});
            for (auto x: a2[i]) {
                b.back().s += x;
            }
        }
    }
    sort(b.begin(), b.end(), [](const stroka& s1, const stroka& s2) {
        return s1.s < s2.s;
    });
    if (b.size() > 0) {
        groups[kgroups].push_back(b[0].i);
        kgroups++;
    }
    for (int i = 0; i < b.size() - 1; i++) {
        int j = i + 1;
        if (b[i].s.size() == b[j].s.size() && b[i].s == b[j].s) {
            groups[kgroups - 1].push_back(b[j].i);
        } else {
            groups[kgroups].push_back(b[j].i);
            kgroups++;
        }
    }
    cout << kgroups << endl;
    for (int i = 0; i < kgroups; i++) {
        cout << groups[i].size() << " ";
        for (auto x: groups[i]) {
            cout << x + 1 << " ";
        }
        cout << endl;
    }
    return 0;
    /*for (auto s: b) {
        cout << s.i << " " << s.s << endl;
    }*/
}

