#include <iostream>
#include <algorithm>
#include <vector>
#include <string>

using namespace std;

int t1[1 << 19], t2[1 << 19];

void del1(int v) {
    t1[v] = 0;
    if (2 * v >= (1 << 19))
        return;
    if (t1[2 * v] != 0)
        del1(2 * v);
    if (t1[2 * v + 1] != 0)
        del1(2 * v + 1);
}

void del2(int v) {
    t2[v] = 0;
    if (2 * v >= (1 << 19))
        return;
    if (t2[2 * v] != 0)
        del2(2 * v);
    if (t2[2 * v + 1] != 0)
        del2(2 * v + 1);
}

void upd1(int v, int x) {
    v += (1 << 18);
    t1[v] += x;
    v /= 2;
    while (v != 0) {
        t1[v] += x;
        v /= 2;
    }
}

void upd2(int v, int x) {
    v += (1 << 18);
    t2[v] += x;
    v /= 2;
    while (v != 0) {
        t2[v] += x;
        v /= 2;
    }
}

int get(int v) {
    if (2 * v >= (1 << 19))
        return (v - (1 << 18));
    if (t1[2 * v] > t2[2 * v])
        return get(2 * v);
    return get(2 * v + 1);
}

int main()
{
    ios::sync_with_stdio(0), cin.tie(0);
    int k, n, m, c, s = 0, l = 0, r, v;
    cin >> n >> m;
    vector <vector <int> > a(n);
    vector <pair <int, int> > b(n);
    for (int i = 0; i < n; i++) {
        cin >> k;
        s += k;
        for (int j = 0; j < k; j++) {
            cin >> c;
            a[i].push_back(c - 1);
        }
        b[i] = {k, i};
    }
    sort(b.begin(), b.end());
    k = s / n;
    c = s % n;
    r = n - 1;
    for (int i = 0; i < b[r].first; i++) {
        upd1(a[b[r].second][i], 1);
    }
    for (int i = 0; i < b[l].first; i++) {
        upd2(a[b[l].second][i], 1);
        //cout << a[b[l].second][i] << endl;
    }
    vector <vector <int> > ans;
    while (true) {
        //cout << l << " " << r << " " << b[l].first << " " << b[l].second << " " << b[r].first << " " << b[r].second << endl;
        if (n - r <= c && b[r].first == k + 1) {
            del1(1);
            r--;
            if (r == l)
                break;
            for (int i = 0; i < b[r].first; i++) {
                upd1(a[b[r].second][i], 1);
            }
            continue;
        }
        if (n - r > c && b[r].first == k) {
            del1(1);
            r--;
            if (r == l)
                break;
            for (int i = 0; i < b[r].first; i++) {
                upd1(a[b[r].second][i], 1);
            }
            continue;
        }
        if (n - l <= c && b[l].first == k + 1) {
            del2(1);
            l++;
            if (r == l)
                break;
            for (int i = 0; i < b[l].first; i++) {
                upd2(a[b[l].second][i], 1);
            }
            continue;
        }
        if (n - l > c && b[l].first == k) {
            del2(1);
            l++;
            if (r == l)
                break;
            for (int i = 0; i < b[l].first; i++) {
                upd2(a[b[l].second][i], 1);
            }
            continue;
        }
        v = get(1);
        //cout << v << endl;
        ans.push_back({b[r].second + 1, b[l].second + 1, v + 1});
        upd1(v, -1);
        upd2(v, 1);
        b[r].first--;
        b[l].first++;
    }
    cout << ans.size() << endl;
    for (int i = 0; i < ans.size(); i++)
        cout << ans[i][0] << " " << ans[i][1] << " " << ans[i][2] << '\n';
}
