#include <iostream>
#include <algorithm>
#include <vector>
#include <string>

using namespace std;

long long p = 67, mod = 10e13 + 31;

long long f(string& s)
{
    long long now = 0;
    for (int i = 0; i < s.size(); i++)
    {
        now = (now * p + s[i]) % mod;
    }
    return now;
}

int main()
{
    int n, d;
    cin >> n;
    string s1, s2;
    vector<pair<pair<int, long long>, int> > a;
    for (int i = 0; i < n; i++)
    {
        cin >> s1 >> s2;
        d = 0;
        for (int j = 0; j < s2.size(); j++)
        {
            d |= (1 << (s2[j] - 'a'));
        }
        while (s1.size() && (d & (1 << (s1.back() - 'a'))))
        {
            s1.pop_back();
        }
        a.push_back({{d, f(s1)}, i});
    }
    sort(a.begin(), a.end());
    vector<vector<int> > ans;
    ans.push_back({a[0].second});
    for (int i = 1; i < a.size(); i++)
    {
        if (a[i].first == a[i - 1].first)
        {
            ans.back().push_back(a[i].second);
        }
        else
        {
            ans.push_back({a[i].second});
        }
    }
    cout << ans.size() << '\n';
    for (int i = 0; i < ans.size(); i++)
    {
        cout << ans[i].size() << ' ';
        for (int j = 0; j < ans[i].size(); j++)
        {
            cout << ans[i][j] + 1 << ' ';
        }
        cout << '\n';
    }
    return 0;

}
