#pragma GCC optimize("O3")
#include <bits/stdc++.h>
#define pb push_back
#define all(a) (a).begin(), (a).end()
#define popb pop_back
#define pf push_front
#define popf pop_front
#define sz(a) (ll)((a).size())
#define fast ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0)
#define die(cond) if(cond) for() {}
#define maxeq(a, b) if (a < b) a = b;
#define mineq(a, b) if (a > b) a = b;
#define heap priority_queue
#define hash_map unordered_map
#define hash_set unordered_set
#define endl "\n"
using namespace std;
typedef long long ll;
typedef long double ld;
typedef vector<ll> vll;
typedef pair<ll, ll> pll;
typedef set<ll> sll;
typedef map<ll, ll> mll;
const ll inf = numeric_limits<ll>::max()/2;
const ld pi = acos(-1);
const ld eps = 1e-6;

inline void read(), solve();

int main() {
    fast;
    read();
    solve();
    return 0;
}

const ll MAXS = 26;

ll n;
vector<string> a;
vector<vll> cnt;
vll ind;

bool comp(ll i, ll j) {
    if (cnt[i] != cnt[j]) {
        return cnt[i] < cnt[j];
    }
    return a[i] < a[j];
}

inline void solve() {
    for (ll i = 0; i < n; i++) {
        while (!a[i].empty() && cnt[i][a[i].back()-'a']) {
            a[i].popb();
        }
    }
    ind.resize(n);
    iota(all(ind), 0);
    sort(all(ind), comp);
    vector<vll> ans;
    for (ll z = 0; z < n; z++){
        ll i = ind[z];
        if (z == 0) {
            ans.pb({i});
            continue;
        }
        if (cnt[i] == cnt[ans.back().back()] && a[i] == a[ans.back().back()]) {
            ans.back().pb(i);
        } else {
            ans.pb({i});
        }
    }
    cout << sz(ans) << endl;
    for (vll& v : ans) {
        cout << sz(v) << " ";
        for (ll x : v) {
            cout << x + 1 << " ";
        }
        cout << endl;
    }
}

inline void read() {
    cin >> n;
    a.resize(n);
    cnt.assign(n, vll(MAXS, 0));
    for (ll i = 0; i < n; i++) {
        string s, t;
        cin >> s >> t;
        a[i] = s;
        for (char c : t) {
            cnt[i][c-'a'] = 1;
        }
    }
}
