
#include <bits/stdc++.h>

using namespace std;

#define int long long

typedef long long ll;
typedef long double ld;

int n;

int get_num(int i, int j) {
    return i * n + j;
}

pair<int, int> get_cell(int num) {
    return {num / n, num % n};
}

bool ok(int i, int j) {
    return i >= 0 && j >= 0 && i < n && j < n;
}

vector<vector<int>> d;

vector<int> di = {1, 1, -1, -1, 2, 2, -2, -2};
vector<int> dj = {2, -2, 2, -2, 1, -1, 1, -1};

void bfs(int scell) {
    vector<int> dd(n * n, 1e9);
    queue <int> q;
    dd[scell] = 0;
    q.push(scell);
    //cout << "pituh" << endl;
    while (!q.empty()) {
        int ind = q.front();
        q.pop();
        pair<int, int> uu = get_cell(ind);
        int i = uu.first;
        int j = uu.second;
        assert(ok(i, j));
        //cout << i << ' ' << j << endl;
        for (int c = 0; c < 8; c++) {
            int ni = i + di[c];
            int nj = j + dj[c];
            int nind = get_num(ni, nj);
            if (ok(ni, nj) && dd[nind] > dd[ind] + 1) {
                dd[nind] = dd[ind] + 1;
                q.push(nind);
            }
        }
    }
    d[scell] = dd;
    //exit(0);
}

void go() {
    d.resize(n * n);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            int ind = get_num(i, j);
            bfs(ind);
        }
    }
}

vector<pair<int, int>> pos;
vector<bool> okk;
vector<pair<int, int>> ans;

vector<int> toall;


void movee(int who, int to) {
    //cout << "mnoving " << who << ' ' << to << endl;
    while (get_num(pos[who].first, pos[who].second) != to) {
        int mn = 1e9;
        int i = pos[who].first;
        int j = pos[who].second;
        int ind = get_num(i, j);
        for (int c = 0; c < 8; c++) {
            int ni = i + di[c];
            int nj = j + dj[c];
            int nind = get_num(ni, nj);
            if (ok(ni, nj) && d[nind][to] < mn) {
                mn = d[nind][to];
            }
        }
        for (int c = 0; c < 8; c++) {
            int ni = i + di[c];
            int nj = j + dj[c];
            //cout << "trying " << ni << ' ' << nj << endl;
            int nind = get_num(ni, nj);
            if (ok(ni, nj) && d[nind][to] == mn) {
                int ps = find(pos.begin(), pos.end(), make_pair(ni, nj)) - pos.begin();
                if (ps < pos.size()) {
                   // bool was_ok = okk[ps];
                    //cout << " wok " << was_ok << endl;
                    //cout << "swap " << pos[ps].first << ' ' << pos[ps].second << endl;

                    movee(ps, to);

                    ans.push_back({ind, nind});
                    pos[who].first = ni;
                    pos[who].second = nj;
                    return;
                } else {
                    //cout << "our " << i << ' ' << j << endl;
                   // cout << "go to " << ni << ' ' << nj << endl;
                    ans.push_back({ind, nind});
                    pos[who].first = ni;
                    pos[who].second = nj;
                    break;
                }
            }
        }
    }
    for (int i = 0; i < (int)pos.size(); i++) {
        int ind = get_num(pos[i].first, pos[i].second);
        if (find(toall.begin(), toall.end(), ind) != toall.end()) {
            okk[i] = 1;
        }
        else {
            okk[i] = 0;
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.setf(ios::fixed); cout.precision(20);
    #ifdef LOCAL
    freopen("input.txt", "r", stdin);
    #endif // LOCAL

    n = 8;
    go();
    int k;
    cin >> k;
    okk.resize(k, false);
    for (int i = 0; i < k; i++) {
        char a;
        int b;
        cin >> a >> b;
        int f = a - 'a';
        int s = b - 1;
        pos.push_back({(n - 1) - s, f});
    }
    /*cout << "pos " << endl;
    for (auto t : pos) {
        cout << t.first << ' ' << t.second << '\n';
    }*/
    //cout << endl;
    for (int i = n - 1; i >= 0; i--) {
        for (int j = 0; j < n; j++) {
            if ((int)toall.size() >= k) {
                continue;
            }
            toall.push_back(get_num(i, j));
        }
    }
    for (int i = 0; i < (int)pos.size(); i++) {
        int ind = get_num(pos[i].first, pos[i].second);
        if (find(toall.begin(), toall.end(), ind) != toall.end()) {
            okk[i] = 1;
        }
        else {
            okk[i] = 0;
        }
    }
    //cout << "precalc ans read" << endl;
    for (auto t : toall) {
            bool fl = 1;
        for (int i = 0; i < (int)pos.size(); i++) {
            int ind = get_num(pos[i].first, pos[i].second);
            if (ind == t) {
                fl = false;
            }
        }
        if (!fl) continue;
        for (int i = 0; i < k; i++) {
            if (!okk[i]) {
                //cout << "from " << i << endl;
                movee(i, t);
                break;
            }
        }
        //exit(0);
    }
    /*cout << "printing ans" << endl;
    for (auto [f, s] : ans) {
        pair<int, int> ff = get_cell(f);
        pair<int, int> ss = get_cell(s);
        int f1 = ff.first;
        int s1 = ff.second;
        int f2 = ss.first;
        int s2 = ss.second;
        cout << f1 << ' ' << s1 << ' ' << f2 << ' ' << s2 << endl;
    }*/
    assert(ans.size() <= 1500);
    cout << ans.size() << endl;
    for (auto [f, s] : ans) {
        pair<int, int> ff = get_cell(f);
        pair<int, int> ss = get_cell(s);
         int f1 = ff.first;
        int s1 = ff.second;
        int f2 = ss.first;
        int s2 = ss.second;
        cout << (char)(s1 + 'a') << 8 - f1 << '-' << (char)(s2 + 'a') << 8 - f2 << '\n';
    }
}
