#include <bits/stdc++.h>

using namespace std;

#define int long long

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

map < pair<int, pair<int, int> >, int > q;

int cnt = 0;

vector <int> kek;

int n;

int mxx(int a, int b, int c) {
    --a, --b, --c;
    return max(kek[a], max(kek[b], kek[c]));
}

int mnn(int a, int b, int c) {
    --a, --b, --c;
    return min(kek[a], min(kek[b], kek[c]));
}

int query(int a, int b, int c){
    if (b > c)
        swap(b, c);
    if (a > b)
        swap(a, b);
    if (b > c)
        swap(b, c);
    if (q.find({a, {b, c}}) == q.end()){
        ++cnt;
        assert(cnt <= 4 * n);
        int t;

        cout << "? " << a << ' ' << b << ' ' << c << endl;
        cin >> t;
        //t = mxx(a, b, c) + mnn(a, b, c);
        q[{a, {b, c}}] = t;
    }
    return q[{a, {b, c}}];
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.setf(ios::fixed); cout.precision(20);
    #ifdef LOCAL
    freopen("input.txt", "r", stdin);
    #endif // LOCAL


    cin >> n;
    srand(time(0));
    //n = 5;
    kek.resize(n);
    /*for (int i = 0; i < n; ++i) {
        kek[i] = rand() % n;
        cout << kek[i] << ' ';
    }
    cout << endl; */
    /*kek[0] = 4;
    kek[1] = 4;
    kek[2] = 1;
    kek[3] = 4;
    kek[4] = 1; */

    int mn = 1;

    for (int i = 4; i <= n; i++){
        if (query(mn, 2, 3) > query(i, 2, 3))
            mn = i;
    }

    {
        int a = -1, b = -1;
        for (int i = 1; i <= n ; i++){
            if (i != mn && i != 2 && i != 3){
                if (a== -1)
                    a = i;
                else if (b == -1){
                    b = i;
                    break;
                }
            }
        }
        if (query(mn, a, b) > query(2, a, b))
            mn = 2;
        if (query(mn, a, b) > query(3, a, b))
            mn = 3;
    }
    int mn2 = 1;
    if (mn == 1)
        mn2 = 2;

   {
    int a = -1, b = -1;
    for (int i = 1; i <=n ; i++){
            if (i != mn && i != mn2){
                if (a== -1)
                    a = i;
                else if (b == -1){
                    b = i;
                    break;
                }
            }
        }
    for (int i = 1; i <= n; i++){
        if (i != mn && i != mn2){
            if (query(mn2, a, b) > query(i, a, b))
                mn2 = i;
        }
    }
    int na = -1, nb = -1;
    for (int i = 1; i <= n; i++){
        if (i != mn && i != mn2 && i != a && i != b){
            if (na == -1)
                na = i;
            else if (nb == -1){
                nb = i;
                break;
            }
        }
        ////
    }

    if (n != 5){
        if (query(mn2, na, nb) > query(a, na, nb))
            mn2 = a;
        if (query(mn2, na, nb) > query(b, na, nb))
            mn2 = b;
    }
    else{
        if (query(mn2, na, a) > query(mn2, na, b)){
            // b < a
            if (query(a, na, mn2) > query(a, na, b))
                mn2 = b;
        }
        else{
            // a < b
            if (query(b, na, mn2) > query(b, na, a))
                mn2 = a;
        }
    }

   }

   vector <pair <int, int> > other;
   for (int i = 1; i <=n ;i++){
        if (i != mn && i != mn2){
            other.push_back({query(i, mn, mn2), i});
        }
   }

   sort(other.begin(), other.end());

   vector <int> pos;

   pos.push_back(mn);
   pos.push_back(mn2);
   for (int i = 0; i < other.size(); i++)
        pos.push_back(other[i].second);

   vector <int> res(n);

   {
       int sum = query(pos[0], pos[1], pos[2]);
       int div = query(pos[4], pos[3], pos[2]) - query(pos[4], pos[3], pos[0]);

       res[0] = (sum - div) / 2;
       res[2] = sum - res[0];

   }

   {

       int sum = query(pos[0], pos[1], pos[3]);
       res[3] = sum - res[0];
       sum = query(pos[1], pos[2], pos[3]);
       res[1] = sum - res[3];
   }

   for (int i = 4; i < n; i++){
    res[i] = query(pos[i], pos[0], pos[1]) - res[0];
   }

   vector <int> ans(n);

   for (int i = 0; i < n; i++){
    ans[pos[i] - 1] = res[i];
   }

    cout << "! ";
    for (int i = 0; i < n; i++)
        cout << ans[i] << ' ';
    cout << endl;

}
