
#include <bits/stdc++.h>

using namespace std;

#define int long long

typedef long long ll;
typedef long double ld;

const int P = 239;
const int md = 1e9 + 9;

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.setf(ios::fixed); cout.precision(20);
    #ifdef LOCAL
    freopen("input.txt", "r", stdin);
    #endif // LOCAL
    int n;
    cin >> n;
    map <pair <int, vector <int>>, vector <int>> cmp;

    for (int i = 0; i < n; ++i) {
        string s, t;
        cin >> s >> t;
        vector <int> have(26);
        for (auto c : t) have[c - 'a'] = 1;
        while (!s.empty() && have[s.back() - 'a']) s.pop_back();
        int h = 0;
        for (auto c : s) {
            h = ((h * P) % md + c) % md;
        }
        cmp[make_pair(h, have)].push_back(i);
    }
    cout << cmp.size() << '\n';
    for (auto &p : cmp) {
        cout << p.second.size() << ' ';
        for (auto x : p.second) {
            cout << x + 1 << ' ';
        }
        cout << '\n';
    }
}
