#include <iostream>
#include <set>
#include <algorithm>

using namespace std;

typedef long long ll;

ll a[10000000], b[10000000];

const ll MOD = 1ll << 32ll;

const ll INF = 9223372036854775807;

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int t;
	cin >> t;
	while (t--) {
		long long n, l, r, x, y, z;
		cin >> n >> l >> r >> x >> y >> z >> b[0] >> b[1];
		for (int i = 2; i < n; ++i) {
			b[i] = (b[i - 2] * x + b[i - 1] * y + z) % MOD;
		}
		for (int i = 0; i < n; ++i) {
			a[i] = (b[i] % (r - l + 1)) + l;
		}
		ll minNeg = INF, maxNeg = -INF, minP = INF, maxP = -INF;
		ll ans = INF;
		for (int i = 0; i < n; ++i) {
			if (a[i] < 0) {
				minNeg = min(minNeg, a[i]);
				maxNeg = max(maxNeg, a[i]);
			}
			else {
				minP = min(minP, a[i]);
				maxP = max(maxP, a[i]);
			}
			if (i) {
				if (a[i] < 0) {
					if (maxP > -INF)
						if (maxP < a[i])
							ans = min(ans, maxP * a[i]);
					else
						if (maxNeg < a[i])
							ans = min(ans, maxNeg * a[i]);
				}
				else {
					if (minNeg < INF)
						if (minNeg < a[i])
							ans = min(ans, minNeg * a[i]);
					else
						if (minP < a[i])
							ans = min(ans, minP * a[i]);
				}
			}
		}
		if (ans != INF)
			cout << ans << '\n';
		else
			cout << "IMPOSSIBLE" << '\n';
	}
}
