#include <iostream>
#include <set>
#include <algorithm>

using namespace std;

typedef long long ll;

ll a[10000000];
__int128 b[10000000];
ll Min[10000000], Max[10000000];

const ll MOD = 1ll << 32ll;

const ll INF = 9223372036854775807;

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int t;
	cin >> t;
	while (t--) {
		long long n, l, r, x, y, z, w, v;
		cin >> n >> l >> r >> x >> y >> z >> w >> v;
		b[0] = w;
		b[1] = v;
		for (int i = 2; i < n; ++i) {
			b[i] = (b[i - 2] * x + b[i - 1] * y + z) % MOD;
		}
		for (int i = 0; i < n; ++i) {
			a[i] = (b[i] % (r - l + 1)) + l;
		}
//		for (int i = 0; i < n; ++i)
//			cin >> a[i];
		Max[n - 1] = -INF;
		Min[0] = INF;
		for (int i = 1; i < n; ++i)
			Min[i] = min(Min[i - 1], a[i - 1]);
		for (int i = n - 2; i >= 0; --i)
			Max[i] = max(Max[i + 1], a[i + 1]);
		ll ans = INF;
		if (a[0] < Max[0])
			ans = min(ans, a[0] * Max[0]);
		if (a[n - 1] > Min[n - 1])
			ans = min(ans, a[n - 1] * Min[n - 1]);
		for (int i = 1; i < (n - 1); ++i) {
			if (a[i] > Min[i])
				ans = min(ans, a[i] * Min[i]);
			if (a[i] < Max[i])
				ans = min(ans, a[i] * Max[i]);
		}
		if (ans != INF)
			cout << ans << endl;
		else
			cout << "IMPOSSIBLE" << endl;
	}
}
