#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

//typedef unsigned int uint;
#define int ll

typedef pair<int, int> pii;

#define F first
#define S second
#define all(x) (x).begin(), (x).end()
#define len(x) (int)(x).size()
#define pb push_back

template<class t1, class t2>
bool cmax(t1 &a, const t2 &b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

template<class t1, class t2>
bool cmin(t1 &a, const t2 &b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

void run();

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    assert(freopen("../f.in", "r", stdin));
#endif
    run();
    return 0;
}

string text;
vector<string> cites;

string get_ref(int &i) {
    string s;
    while (text[i] != '}') {
        s += text[i++];
    }
    return s;
}

void solve(int i) {
    i += 6;
    vector<string> new_cites;
    map<string, string> cur;
    while (i < len(text)) {
        if (text.substr(i, 9) == "\\bibitem{") {
            i += 9;
            string bib = get_ref(i);
            new_cites.pb(bib);
            i++;
            cur[bib] = "";
            //cout << bib << "\n";
            while (text[i] != '\\') cur[bib] += text[i++];
        } else {
            break;
        }
    }
    if (new_cites == cites) {
        cout << "Correct" << "\n";
        return;
    }
    cout << "Incorrect\n";
    cout << "\\begin{thebibliography}{99}\n";
    for (auto &x : cites) {
        cout << "\\bibitem{" << x << "}";
        cout << cur[x];
        //cout << '\n';
    }
    cout << "\\end{thebibliography}\n";

}

void run() {
    getline(cin, text, '\0');
    //cout << text << "\n";

    int i = 0;
    while (i < len(text)) {
        if (text.substr(i, 6) == "\\cite{") {
            i += 6;
            cites.pb(get_ref(i));
        } else if (text.substr(i, 7) == "\\begin{") {
            i += 7;
            get_ref(i);
            solve(i);
            return;
        } else {
            i++;
        }
    }
    //for (auto x: cites) cout << x << "\n";

}
