#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;

//typedef unsigned int uint;
#define int ll

template<class t>
using oset = tree<t, null_type, less<t>, rb_tree_tag, tree_order_statistics_node_update>;

typedef pair<int, int> pii;

#define F first
#define S second
#define all(x) (x).begin(), (x).end()
#define len(x) (int)(x).size()
#define pb push_back

template<class t1, class t2>
bool cmax(t1 &a, const t2 &b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

template<class t1, class t2>
bool cmin(t1 &a, const t2 &b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

void run();

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    assert(freopen("../f.in", "r", stdin));
#endif
    run();
    return 0;
}

int mex(const oset<int> &s, const oset<int> &d, int l, int r) {
    ++r;
    while (r - l > 1) {
        int c = (r + l) >> 1;
        if (s.order_of_key(c) + d.order_of_key(c) != c)
            r = c;
        else
            l = c;
    }
    return l;
}

void run() {
    int n, m;
    cin >> n >> m;
    vector<vector<int>> gifts(n);
    int sm = 0;
    for (auto &x : gifts) {
        int s;
        cin >> s;
        sm += s;
        x.resize(s);
        for (auto &y : x) {
            cin >> y;
            --y;
        }
    }
    vector<vector<int>> light;
    vector<int> sz, or_pos;
    int ubound = (sm + n - 1) / n, lbound = sm / n;
    vector<oset<int>> pos(m);
    oset<int> del;
    int lcnt = n - sm % n;
    int hcnt = sm % n;
    if (!hcnt)
        hcnt = n;
    for (int i = 0; i < n; ++i) {
        if (len(gifts[i]) > lbound)
            continue;
        --lcnt;
        if (len(gifts[i]) == lbound) {
            if (lcnt >= 0)
                continue;
        }
        light.pb(gifts[i]);
        or_pos.pb(i);
        sz.pb(lbound);
        if (lcnt < 0)
            ++sz.back();
    }
    int nn = len(light);
    for (int i = 0; i < nn; ++i) {
        for (auto &x : light[i]) {
            pos[x].insert(i);
        }
    }
    vector<vector<int>> ans;
    for (int i = 0; i < n; ++i) {
        int cur = len(gifts[i]);
        int bound = ubound;
        if (len(gifts[i]) <= lbound)
            continue;
        --hcnt;
        if (len(gifts[i]) == ubound) {
            if (hcnt >= 0)
                continue;
        }
        if (hcnt < 0)
            --bound;
        for (auto &x : gifts[i]) {
            if (cur <= bound)
                break;
            int m = mex(pos[x], del,  -1, nn);
            if (m == nn)
                continue;
            light[m].pb(x);
            pos[x].insert(m);
            ans.pb({i, or_pos[m], x});
            --cur;
            if (len(light[m]) >= sz[m]) {
                for (auto &x : light[m])
                    pos[x].erase(m);
                del.insert(m);
            }
        }
    }
    cout << len(ans) << endl;
    for (auto &x : ans) {
        for (auto &y : x) {
            cout << y + 1 << " ";
        }
        cout << endl;
    }
}
