#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

typedef unsigned int uint;
#define int ll

typedef pair<int, int> pii;

#define F first
#define S second
#define all(x) (x).begin(), (x).end()
#define len(x) (int)(x).size()
#define pb push_back

template<class t1, class t2>
bool cmax(t1 &a, const t2 &b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

template<class t1, class t2>
bool cmin(t1 &a, const t2 &b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

void run();

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    run();
    return 0;
}

const int INF = 5e18;

void run() {
    int n, m;
    cin >> n >> m;
    if (n < 2) {
        cout << "NO\n";
        return;
    }
    set<pii> cur;
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        a--; b--;
        int l = min(a, b);
        int r = max(a, b);
        cur.insert({l, r});
    }
    vector<int> cnt(n, 0);
    for (auto x: cur) {
        cnt[x.F]++;
        cnt[x.S]++;
    }
    int best = -1;
    for (int i = 0; i < n; i++) {
        if (cnt[i] < n - 1) {
            best = i;
            break;
        }
    }
    if (best == -1) {
        cout << "NO\n";
        return;
    }
    int best2 = -1;
    for (int i = 0; i < n; i++) {
        if (i == best) continue;
        if (!cur.count({best, i}) && !cur.count({i, best})) {
            best2 = i;
            break;
        }
    }
    if (best2 == -1) {
        cout << "NO\n";
        return;
    }
    vector<int> ans(n, -1);
    ans[best] = 1;
    ans[best2] = 2;
    int last = 3;
    cout << "YES\n";
    for (int i = 0; i < n; i++) {
        if (ans[i] == -1) ans[i] = last++;
    }
    for (auto x: ans) cout << x << " ";
    cout << "\n";
    ans[best2] = 1;
    for (auto x: ans) cout << x << " ";
    return;
}