#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>

using namespace std;

typedef long long ll;
typedef pair < ll, ll > pii;

ll b[30000000];
ll a[30000000];
ll MOD = (1LL << 32);

void solve()
{
    ll n, l, r, x, y, z, b1, b2;
    cin >> n >> l >> r >> x >> y >> z >> b1 >> b2;
    b[1] = b1;
    b[2] = b2;
    for (int i = 3; i <= n; i++)
    {
        b[i] = (b[i - 2] * x % MOD + b[i - 1] * y % MOD + z) % MOD;
    }
    for (int i = 1; i <= n; i++)
    {
        a[i] = (b[i] % (r - l + 1)) + l;
    }
    /*cin >> n;
    for (int i = 1; i <= n; i++)
    {
        cin >> a[i];
    }*/
    ll inf = 5e18;
    ll ans = inf;
    ll min_ = a[1];
    for (int i = 2; i <= n; ++i) {
        if (min_ < a[i]) {
            ans = min(ans, min_ * a[i]);
        } else {
            min_ = a[i];
        }
    }
    ll max_ = a[n];
    for (int i = n - 1; i >= 1; --i) {
        if (max_ > a[i]) {
            ans = min(ans, max_ * a[i]);
        } else {
            max_ = a[i];
        }
    }
    if (ans == inf) {
        cout << "IMPOSSIBLE" << endl;
    } else {
        cout << ans << endl;
    }
}

int main()
{
   ll t;
   cin >> t;
   while (t--)
   {
       solve();
   }
}
