#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef pair < ll, ll > pii;

const int N = 30000000;
ll b[N];
ull a[N];
int lst[N];
ll MOD = (1LL << 32);

bool check(ull a, int x, ull b, int y) {
    if (x == -1 && y == -1) {
        return a > b;
    }
    if (x == 1 && y == 1) {
        return a < b;
    }
    if (x == 1 && y == -1) {
        return false;
    }
    if (x == -1 && y == 1) {
        return true;
    }
}

void solve()
{
    ull n, x, y, z, b1, b2;
    ll l, r;
    cin >> n >> l >> r >> x >> y >> z >> b1 >> b2;
    b[1] = b1;
    b[2] = b2;
    for (int i = 3; i <= n; i++)
    {
        b[i] = (b[i - 2] * x  + b[i - 1] * y + z) % MOD;
    }
    for (int i = 1; i <= n; i++)
    {
        if (l >= 0) {
            ull p = (b[i] % (r - l + 1)) + l;
            a[i] = p;
            lst[i] = 1;
        } else {
            ll p = (b[i] % (r - l + 1));
            if (abs(l) > p) {
                p = -1LL * (l + p);
                a[i] = abs(p);
                lst[i] = -1;
            } else {
                a[i] = p + l;
                lst[i] = 1;
            }
        }
    }
//    cin >> n;
//    for (int i = 1; i <= n; i++)
//    {
//        cin >> a[i];
//        cin >> lst[i];
//    }
    ull inf = ((1LL << 64) - 1);
    ull ans = inf;
    int as = 1;
    ull min_ = a[1];
    //cout << min_ << endl;
    int s = lst[1];
    for (int i = 2; i <= n; ++i) {
        if (check(min_, s, a[i], lst[i])) {
            if (check(min_ * a[i], lst[i] * s, ans, as)) {
                ans = min_ * a[i];
                //cout << min_ << ' ' << a[i] << ' ' << ans<< endl;
                as = lst[i] * s;
            }
        } else {
            min_ = a[i];
            s = lst[i];
        }
    }
    ull max_ = a[n];
    s = lst[n];
    for (int i = n - 1; i >= 1; --i) {
        if (check(a[i], lst[i], max_, s)) {
            if (check(max_ * a[i], lst[i] * s, ans, as)) {
                ans = max_ * a[i];
                as = lst[i] * s;
            }
        } else {
            max_ = a[i];
            s = lst[i];
        }

    }
    if (ans == inf && as == 1) {
        cout << "IMPOSSIBLE" << endl;
    } else {
        if (as == -1)
            cout << '-';
        cout << ans << endl;
    }
}

int main()
{
//    ull inf = ((1LL << 64 ) - 1);
//    cout << inf << endl;
//    cout << ull(MOD - 1) * ull(MOD) << endl;
//    cout << ull(4294967294) * ull(4294967295) << endl;
//    //cout << ull(4294967294) << ' ' ull(4294967295) << endl;
//    //4294967294 4294967295
//    cout << MOD - 1 << ' ' << MOD << endl;
   ll t;
   cin >> t;
   while (t--)
   {
       solve();
   }
}
