#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>

using namespace std;

typedef long long ll;
typedef pair < ll, ll > pii;

ll b[30000000];
ll a[30000000];
ll MOD = (1LL << 32);

void solve()
{
    ll n, l, r, x, y, z, b1, b2;
    cin >> n >> l >> r >> x >> y >> z >> b1 >> b2;
    b[1] = b1;
    b[2] = b2;
    for (int i = 3; i <= n; i++)
    {
        b[i] = (b[i - 2] * x + b[i - 1] * y + z) % MOD;
    }
    for (int i = 1; i <= n; i++)
    {
        a[i] = (b[i] % (r - l + 1)) + l;
    }
    /*cin >> n;
    for (int i = 1; i <= n; i++)
    {
        cin >> a[i];
    }*/
    ll ans = 5e18;
    ll min_ = a[1];
    for (int i = 2; i <= n; i++)
    {
        if (a[i] > min_)
            ans = min(ans, min_ * a[i]);
        else
            min_ = a[i];
    }

    for (int i = 1; i <= n; i++)
    {
        a[i] *= -1;
    }
    min_ = 3e9;
    for (int i = n; i >= 1; i--)
    {
        /*if (a[i] == -1)
            continue;
        if (min_ > 2e9)
        {
            min_ = a[i];
            continue;
        }*/
        if (a[i] > min_)
            ans = min(ans, min_ * a[i]);
        else
            min_ = a[i];
    }

    if (ans > 4e18)
    {
        cout << "IMPOSSIBLE\n";
        return;
    }
    else
    {
        cout << ans << "\n";
    }
}

int main()
{
   ll t;
   cin >> t;
   while (t--)
   {
       solve();
   }
}
