#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>

using namespace std;

typedef long long ll;
typedef pair < ll, ll > pii;

ll b[30000000];
ll a[30000000];
ll MOD = (1LL << 32);

void solve()
{
    ll n, l, r, x, y, z, b1, b2;
    cin >> n >> l >> r >> x >> y >> z >> b1 >> b2;
    b[1] = b1;
    b[2] = b2;
    for (int i = 3; i <= n; i++)
    {
        b[i] = (b[i - 2] % MOD * x % MOD + b[i - 1] % MOD * y % MOD + z) % MOD;
    }
    for (int i = 1; i <= n; i++)
    {
        a[i] = (b[i] % (r - l + 1)) + l;
    }
    /*cin >> n;
    for (int i = 1; i <= n; i++)
    {
        cin >> a[i];
    }*/
    ll ans = 5e18;
    ll min_ = a[1];
    for (int i = 2; i <= n; ++i) {
        if (min_ < a[i]) {
            ans = min(ans, min_ * a[i]);
        } else {
            min_ = a[i];
        }
    }
    ll max_ = -5e18;
    int idx = -1;
    for (int i = n; i >= 1; --i) {
        if (a[i] <= 0) {
            max_ = a[i];
            idx = i - 1;
            break;
        }
    }
    if (idx == -1) {
        if (ans > 4e18 + 100) {
            cout << "IMPOSSIBLE" << endl;
            return;
        } else {
            cout << ans << endl;
        }
    }
    for (int i = idx; i >= 1; --i) {
        if (a[i] > 0) continue;
        if (a[i] < max_) {
            ans = min(ans, a[i] * max_);
        } else {
            max_ = a[i];
        }
    }
    if (ans > 4e18 + 100) {
        cout << "IMPOSSIBLE" << endl;
    } else {
        cout << ans << endl;
    }
}

int main()
{
   ll t;
   cin >> t;
   while (t--)
   {
       solve();
   }
}
