#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <string>
#include <map>

using namespace std;

typedef long long ll;
typedef pair < ll, ll > pii;
string s[500000];
string t[500000];
map<pair<vector<int>, vector<int>>, vector<int>> mm;

ll cnt[500];
ll INF = 1e9;

void go(int x)
{
    for (int i = 0; i < s[x].size(); i++)
    {
        cnt[s[x][i]]++;
    }
    for (int i = 0; i < t[x].size(); i++)
    {
        cnt[t[x][i]] = INF;
    }
    vector<int> a, b;
    for (int i = 0; i < s[x].size(); i++)
    {
        if (cnt[s[x][i]] != INF)
        {
            a.push_back(s[x][i]);
        }
    }
    for (int i = 'a'; i <= 'z'; i++)
    {
        if (cnt[i] == INF)
        {
            b.push_back(i);
        }
        cnt[i] = 0;
    }
    mm[{a, b}].push_back(x);
}

int main()
{
   ll n;
   cin >> n;
   for (int i = 1; i <= n; i++)
   {
       cin >> s[i] >> t[i];
       go(i);
   }
   cout << mm.size() << endl;
   for (auto it : mm)
   {
       cout << it.second.size() << " ";
       for (int j = 0; j < it.second.size(); j++)
       {
           cout << it.second[j] << " ";
       }
       cout << "\n";
   }
}
