#include <bits/stdc++.h>

#define sz(s) signed(s.size())
#define all(s) s.begin(),s.end()


using namespace std;

const int MAXN = 1e5 + 179;
set<int> g[MAXN];
vector< tuple<int, int, int> > ans;

int buf[MAXN], bufsz;

int insert(int i1, int i2, int kk) {
    bufsz = 0;
    if (g[i2].size()) {
        auto it = g[i2].begin();
        for (int col : g[i1]) {
            if (kk == 0) { break; }
            while (it != g[i2].end() && (*it <= col)) {
                it++;
            }
            it--;
            if (col != (*it)) {
                ans.push_back({i1 + 1, i2 + 1, col});
                buf[bufsz++] = col;
                --kk;
            }
            ++it;
        }
    } else {
        for (int col : g[i1]) {
            if (kk == 0) { break; }
            ans.push_back({i1 + 1, i2 + 1, col});
            buf[bufsz++] = col;
            --kk;
        }
    }
    for (int i = 0; i < bufsz; ++i) {
        g[i1].erase(g[i1].find(buf[i]));
        g[i2].insert(buf[i]);
    }
}

signed main(){
    ios_base::sync_with_stdio(false);
    int n, m;
    cin >> n >> m;
    int cnt = 0;
    for (int i = 0; i < n; ++i) {
        int sz, x;
        cin >> sz;
        cnt += sz;
        for (int j = 0; j < sz; ++j) {
            cin >> x;
            g[i].insert(x);
        }
    }
    int k = cnt / n;
    int x = cnt % k;
    vector<int> indexes(n);
    iota(all(indexes), 0);
    sort(all(indexes), [](const auto& x, const auto& y) {
        return g[x].size() > g[y].size();
    });
    vector<int> sizes(n, k);
    for (int i = 0; i < x; ++i) { sizes[i] = k + 1; }
    int ptr = 0;
    for (int i = 0; i < n; ++i) {
        while (g[indexes[i]].size() > sizes[i]) {
            for (; ptr < n && g[indexes[ptr]].size() >= sizes[ptr]; ++ptr);
            if (ptr == n) { break; }
            int c1 = signed(g[indexes[i]].size()) - sizes[i];
            int c2 = sizes[ptr] - signed(g[indexes[ptr]].size());
            insert(indexes[i], indexes[ptr], min(c1, c2));
        }
    }
    cout << ans.size() << endl;
    for (const auto& x : ans) {
        cout << (get<0>(x)) << " " << (get<1>(x)) << " " << (get<2>(x)) << '\n';
    }
    return 0;
}