#include <bits/stdc++.h>

using namespace std;

#define all(s) s.begin(),s.end()
#define int long long

const int MAXN = 1e7 + 179;
const int INF = 4e18 + 179;
const int R = 1ll << 32;
int a[MAXN];

void solve() {
    int n, l, r, x, y, z, b1, b2;
    cin >> n >> l >> r >> x >> y >> z >> b1 >> b2;
    a[0] = b1; a[1] = b2;
    for (int i = 2; i < n; ++i) {
        a[i] = (a[i - 2] * x + a[i - 1] * y + z) % R;
    }
    for (int i = 0; i < n; ++i) {
        a[i] = (a[i] % (r - l + 1)) + l;
    }
    int ans = INF;
    int mn = a[0];
    for (int i = 1; i < n; ++i) {
        if (mn < a[i]) { ans = min(ans, mn * a[i]); }
        mn = min(mn, a[i]);
    }
    int max_neg = a[n - 1];
    for (int i = n - 2; i >= 0; --i) {
        if (max_neg > a[i]) { ans = min(ans, max_neg * a[i]); }
        if (max_neg > 0 || (a[i] <= 0 && a[i] > max_neg)) {
            max_neg = a[i];
        }
    }
    if (ans == INF) {
        cout << "IMPOSSIBLE\n";
    } else {
        cout << ans << '\n';
    }

}
 signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}