#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

const int MAX_N = 100005;

int n, m;
vector<int> g[MAX_N];
bool used[MAX_N];
vector<int> gg[MAX_N];
int cntOut[MAX_N];
int res[MAX_N];
set<pair<int, int>> usedEdges;

void dfs(int u)
{
    used[u] = true;
    for (int v : g[u])
    {
        cntOut[u]++;
        if (!used[v])
        {
            dfs(v);
        }
    }
}

int main()
{
    ios::sync_with_stdio(false);
    cin >> n >> m;
    for (int i = 0; i < m; i++)
    {
        int a, b;
        cin >> a >> b;
        a--; b--;
        g[a].push_back(b);
        g[b].push_back(a);
    }

    if (n == 1)
    {
        cout << "NO" << endl;
        return 0;
    }
    dfs(0);

    set<pair<int, int>> pq;
    for (int i = 0; i < n; i++)
        pq.emplace(cntOut[i], i);

    int num = n;
    while (!pq.empty())
    {
        auto p = *pq.begin();
        pq.erase(pq.begin());
        res[p.second] = num;
        num--;
        //cout << "! " << p.second << endl;
        for (int v : gg[p.second])
        {
            pq.erase(pair<int, int>(cntOut[v], v));
            cntOut[v]--;
            pq.emplace(cntOut[v], v);
        }
    }

    vector<int> pos;
    for (int i = 0; i < n; i++)
    {
        bool check = true;
        //cout << i << " " << res[i] << endl;
        for (int j : g[i])
        {
            check &= res[i] > res[j];
            //cout << res[j] << endl;
        }
        if (check)
            pos.push_back(i);
    }

    if (pos.size() < 2)
    {
        cout << "NO" << endl;
        return 0;
    }

    cout << "YES" << endl;
    for (int i = 0; i < n; i++)
        cout << res[i] << " ";
    cout << endl;

    int maxVal = 0;
    for (int i : pos)
        maxVal = max(maxVal, res[i]);
    for (int i : pos)
        res[i] = maxVal;

    for (int i = 0; i < n; i++)
        cout << res[i] << " ";
    cout << endl;
}
