//
// Created by orspc on 09.12.2018.
//
#include <iostream>
#include <set>
#include <vector>
#include <algorithm>
using namespace std;
const int MAXN = 1e5 + 7;
using ll = long long;

int main() {
    std::ios::sync_with_stdio(0);
    std::cin.tie(0);
    ll n, m;
    cin >> n >> m;
    if (2 * m == n * (n - 1)) {
        std::cout << "NO";
        return 0;
    }
    std::vector<std::pair<int, int>> pr(m);
    std::vector<int> deg(n);
    for (auto &i : pr) {
        std::cin >> i.first >> i.second;
        --i.first;
        --i.second;
        ++deg[i.first];
        ++deg[i.second];
    }
    int st = 0, fin = 0;
    for (int i = 0; i < n; ++i) {
        if (deg[i] < n - 1) {
            st = i;
            break;
        }
    }
    std::vector<int> used(n);
    for (auto p : pr) {
        if (p.first == st) {
            used[p.second] = 1;
        }
        if (p.second == st) {
            used[p.first] = 1;
        }
    }
    for (int i = 0; i < n; ++i) {
        if (i != st && (used[i] == 0)) {
            fin = i;
            break;
        }
    }
    std::vector<int> ans(n);
    ans[st] = 1;
    ans[fin] = 2;
    int k = 3;
    for (int i = 0; i < n; ++i) {
        if (ans[i] == 0) {
            ans[i] = k++;
        }
    }
    for (auto i : ans) {
        std::cout << i << ' ';
    }
    std::cout << '\n';
    ans[fin] = 1;
    for (auto i : ans) {
        std::cout << i << ' ';
    }
    return 0;
}
