#pragma GCC target "sse,sse2,sse3"
#include <iostream>
#include <algorithm>
#include <vector>
#include <set>

#define INF 1234567890
#define sz(x) ((int)(x).size())

using namespace std;

typedef long long ll;

bool mysort(set<int> &a, set<int> &b) {
    return (a.size() > b.size());
}

struct step {
    int from, to, x;
};

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m, sum = 0;
    cin >> n >> m;
    vector<int> names(n);
    vector< set<int> > a(n);
    for(int i = 0; i < n; ++i) {
        a[i].insert(-INF + i);
        int t1;
        cin >> t1;
        sum += t1;
        for(int j = 0; j < t1; ++j) {
            int t2;
            cin >> t2;
            a[i].insert(t2);
        }
    }
    sort(a.begin(), a.end(), mysort);
    for(int i = 0; i < n; ++i) {
        auto p = a[i].begin();
        names[i] = (*p) + INF;
        a[i].erase(p);
    }


    int p_count = sum / n;
    int plus_one = sum % n;
    int pref = 0, suff = n - 1;
    vector<step> ans;
    while(pref < suff) {
        //cout << pref << " " << suff << endl;
        step t;
        t.from = pref; t.to = suff;
        int need = p_count - sz(a[suff]);
        int can = sz(a[pref]) - p_count;
        if(suff < plus_one)
            need++;
        if(pref < plus_one)
            can--;

        for(auto p = a[pref].begin(); p != a[pref].end();) {
            if(need == 0 || can == 0)
                break;
            //cout << "elem: " << (*p) << endl;
            if(a[suff].find(*p) == a[suff].end()) {
                a[suff].insert(*p);
                t.x = (*p);
                ans.push_back(t);
                a[pref].erase(p++);
                need--;
                can--;
            }
            else
                p++;
        }
        //cout << need << " " << can << endl;
        if(need == 0)
            suff--;
        if(can == 0)
            pref++;
        //cin >> t.from;
    }
    cout << sz(ans) << endl;
    for(int i = 0; i < sz(ans); ++i)
        cout << ans[i].from + 1 << " " << ans[i].to + 1 << " " << ans[i].x << endl;
    return 0;
}
