import java.io.*;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.StringTokenizer;

public class B {
    static class Parser {
        BufferedReader bf;
        StringTokenizer st;

        Parser(InputStream in) throws IOException {
            bf = new BufferedReader(new InputStreamReader(in));
            st = new StringTokenizer(bf.readLine());
        }

        String next() throws IOException {
            while (st == null || !st.hasMoreTokens()) st = new StringTokenizer(bf.readLine());
            return st.nextToken();
        }
    }

    public static void main(String[] args) throws IOException {
        Parser in = new Parser(System.in);
        PrintWriter out = new PrintWriter(System.out);
        ArrayList<String> refs = new ArrayList<>();
        HashMap<String, ArrayList<String>> opis = new HashMap<>();
        String a = in.next();
        int iter = 0;
        boolean checkCor = true;
        while (a != null) {
            if (a.charAt(0) == '\\') {
                if (a.charAt(1) == 'c') {
                    refs.add(getName(a));
                } else {
                    while (!a.equals("\\end{thebibliography}")) {
                        if (a.charAt(1) == 'b') {
                            if (a.charAt(2) == 'i') {
                                ArrayList<String> asdf = new ArrayList<>();
                                String w = getName(a);
                                if (!w.equals(refs.get(iter++))) checkCor = false;
                                a = in.next();
                                while (a.charAt(0) != '\\') {
                                    asdf.add(a);
                                    a = in.next();
                                }
                                opis.put(w, asdf);
                            } else {
                                a = in.next();
                            }
                        }
                    }
                    break;

                }
            }
            a = in.next();
        }
        if (checkCor) {
            out.println("Correct");
        } else {
            out.println("Incorrect");
            out.println("\\begin{thebibliography}{99}");
            for (int i = 0; i < refs.size(); i++) {
                out.print("\\bibitem{" + refs.get(i) + "}");
                ArrayList<String> cout = opis.get(refs.get(i));
                if(cout.size() > 0) out.print(" ");
                for (int j = 0; j < cout.size() - 1; j++) out.print(cout.get(j) + " ");
                if (cout.size() > 0) out.println(cout.get(cout.size() - 1));
                else out.println();
            }
            out.print("\\end{thebibliography}");
        }
        out.close();
    }

    public static String getName(String ss) {
        int n = ss.length();
        int s = 0;
        for (; s < n; s++) {
            if (ss.charAt(s) == '{') {
                ++s;
                break;
            }
        }
        for (int e = s; e < n; e++) {
            if (ss.charAt(e) == '}') return ss.substring(s, e);
        }
        return null;
    }
}
