#include <bits/stdc++.h>
#define int ll

using namespace std;

typedef long long ll;

const int MAXN = 100;

int x[MAXN];
int y[MAXN];
int x_[MAXN];
int y_[MAXN];
bool f[8][8];
int sum = 0;
int cnt = 0;
string path;
vector<int> kok = {0, 10, 20, 50, 200, 200, 70, 25, 10};

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

bool check(int a, int b, int x, int y) {
    if (x < 0 || y < 0 || x >= 7 || y >= 7) {
        return false;
    }
    cnt += (!f[x][y]);
    if (!f[x][y]) {
        path += char('a' + a);
        path += char('1' + b);
        path += "-";
        path += char('a' + x);
        path += char('1' + y);
        path += "\n";
    }
    return !f[x][y];
}

void change(int& x, int& y) {
    int rnd = uniform_int_distribution<int>(0, sum - 1)(rng);//rand() % sum;
    int dir = lower_bound(kok.begin(), kok.end(), rnd) - kok.begin();
    f[x][y] = false;
           if (dir == 0 && check(x, y, x + 1, y + 2)) {
        x += 1;
        y += 2;
    } else if (dir == 1 && check(x, y, x + 2, y + 1)) {
        x += 2;
        y += 1;
    } else if (dir == 2 && check(x, y, x + 2, y - 1)) {
        x += 2;
        y += -1;
    } else if (dir == 3 && check(x, y, x + 1, y - 2)) {
        x += 1;
        y += -2;
    } else if (dir == 4 && check(x, y, x - 1, y - 2)) {
        x += -1;
        y += -2;
    } else if (dir == 5 && check(x, y, x - 2, y - 1)) {
        x += -2;
        y += -1;
    } else if (dir == 6 && check(x, y, x - 2, y + 1)) {
        x += -2;
        y += 1;
    } else if (dir == 7 && check(x, y, x - 1, y + 2)) {
        x += -1;
        y += 2;
    }
    f[x][y] = true;
}

int n;

bool res() {
    for (int i = 0; i < n; ++i) {
        if (!f[i % 8][i / 8]) {
            return false;
        }
    }
    return true;
}

void print() {
    for (int i = 7; i >= 0; --i) {
        for (int j = 0; j < 8; ++j) {
            cout << f[j][i] << " ";
        }
        cout << endl;
    }
}

bool solve() {
    path = "";
    cnt = 0;
    for (int i = 0; i < 8; ++i) {
        for (int j = 0; j < 8; ++j) {
            f[i][j] = false;
        }
    }
    for (int i = 0; i < n; ++i) {
        char a, b;
        x[i] = x_[i];
        y[i] = y_[i];
        f[x[i]][y[i]] = true;
    }
    while (cnt < 1500) {
        //int k = rand() % n;
        int k = uniform_int_distribution<int>(0, n - 1)(rng);
        change(x[k], y[k]);
        if (res()) {
            cout << cnt << endl << path;
            return true;
        }
    }
    return false;
}

signed main() {
    srand(time(NULL));
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    for (int i = 1; i <= 8; ++i) {
        kok[i] = (sum += kok[i]);
    }
    for (int i = 0; i < n; ++i) {
        char a, b;
        cin >> a >> b;
        x_[i] = a - 'a';
        y_[i] = b - '1';
    }
    while (!solve());
    return 0;
}
