#include <bits/stdc++.h>

using namespace std;

const int side = 8, TURNS = 8;
const int dx[] = {-2, -1, 1, 2, 2, 1, -1, -2};
const int dy[] = {1, 2, 2, 1, -1, -2, -2, -1};

pair<int, int> rev(string s) {
    return make_pair(s[0] - 'a', s[1] - '1');
}

string re(pair<int, int> p) {
    string s = "";
    s += (char)(p.first + 'a');
    return s + (char)(p.second + '1');
}

pair<int, int> nex(pair<int, int> p) {
    p.first++;
    if (p.first == side) {
        p.first = 0;
        p.second++;
    }
    return p;
}

pair<int, int> ko;

bool check(pair<int, int> p) {
    if (p.first < 0 || p.second < 0 || p.first >= side || p.second >= side) {
        return false;
    }
    return true;
    //return p.second > ko.second || (p.second == ko.second && p.first >= ko.first);
}

bool check1(pair<int, int> p) {
    if (p.first < 0 || p.second < 0 || p.first >= side || p.second >= side) {
        return false;
    }
    return p.second > ko.second || (p.second == ko.second && p.first >= ko.first);
}

int fie[side][side] = {};
int fie1[side][side] = {};
pair<int, int> pre[side][side];
vector<pair<pair<int, int>, pair<int, int> > > ans;

void move(pair<int, int> p) {
    pair<int, int> p1 = pre[p.first][p.second];
    bool flag = true;
    if (fie1[p1.first][p1.second] == 1) {
        move(p1);
        flag = false;
    }
    ans.push_back(make_pair(p, p1));
    fie1[p.first][p.second] = 0;
    fie1[p1.first][p1.second] = 1;
    if (flag && p1 != ko) {
        move(p1);
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int k;
    cin >> k;
    for (int i = 0; i < k; i++) {
        string s;
        cin >> s;
        pair<int, int> p = rev(s);
        fie1[p.first][p.second] = 1;
    }
    int color = 2;
    ko = make_pair(0, 0);
    for (int _ = 0; _ < k; _++) {
        if (fie1[ko.first][ko.second] == 1) {
            ko = nex(ko);
            continue;
        }
        fie[ko.first][ko.second] = color;
        queue<pair<int, int> > q;
        q.push(ko);
        pair<int, int> an = ko;
        while (!q.empty()) {
            pair<int, int> p = q.front();
            q.pop();
            if (fie1[p.first][p.second] == 1 && check1(p)) {
                an = p;
                break;
            }
            for (int j = 0; j < TURNS; j++) {
                pair<int, int> p1 = make_pair(p.first + dx[j], p.second + dy[j]);
                if (check(p1) && fie[p1.first][p1.second] != color) {
                    fie[p1.first][p1.second] = color;
                    pre[p1.first][p1.second] = p;
                    q.push(p1);
                }
            }
        }
        if (an == ko) {
            return 1;
        }
        move(an);
        ko = nex(ko);
        color++;
    }
    cout << ans.size() << endl;
    for (int i = 0; i < ans.size(); i++) {
        cout << re(ans[i].first) << '-' << re(ans[i].second) << endl;
    }
    return 0;
}
