#include <iostream>
#include <vector>

using namespace std;

int real_main()
{
    int n, l, r;
    unsigned int x, y, z, b1, b2;
    cin >> n >> l >> r >> x >> y >> z >> b1 >> b2;
    vector<unsigned int> barr(n);
    barr[0] = b1;
    barr[1] = b2;
    for(int i = 2; i < n; i++)
        barr[i] = barr[i - 2] * x + barr[i - 1] * y + z;
    vector<int> data(n);
    for(int i = 0; i < n; i++)
        data[i] = ((long long)(barr[i])) % (r - l + 1) + l;
    long long ans;
    bool have_ans = false;
    for(int i = 0; i < n; i++)
        for(int j = i + 1; j < n; j++)
            if(data[j] > data[i])
            {
                if(!have_ans)
                    ans = data[i] * (long long)data[j];
                have_ans = true;
                ans = min(ans, data[i] * (long long)data[j]);
            }
    if(!have_ans)
        cout << "IMPOSSIBLE\n";
    else
        cout << ans << endl;
    return 0;
}

int main()
{
    int t;
    cin >> t;
    for(int i = 0; i < t; i++)
        real_main();
    return 0;
}
