#include<bits/stdc++.h>

using namespace std;

void FAST_IO() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
    #ifdef _offline
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // _offline
}

typedef long long ll;
typedef unsigned int uint;
typedef pair<int, int> pii;
const int MAXN = 1e7 + 100;
ll arr[MAXN];

void solve() {
    int n;
    ll l, r;
    uint x, y, z, b1, b2;
    cin >> n >> l >> r >> x >> y >> z >> b1 >> b2;
    ll mod = r - l + 1;
    arr[1] = (b1 % mod) + l;
    arr[2] = (b2 % mod) + l;
    for (int i = 3; i <= n; ++i) {
        swap(b1, b2);
        b2 = b2 * x + b1 * y + z;
        arr[i] = (b2 % mod) + l;
    }
    ll ans = LLONG_MAX;
    ll mn = arr[1];
    for (int i = 2; i <= n; ++i) {
        if (mn < arr[i]) {
            ans = min(ans, mn * arr[i]);
        }
        if (mn >= 0) {
            mn = min(mn, arr[i]);
        }
        else if (arr[i] < 0) {
            mn = max(mn, arr[i]);
        }
    }
    ll mx = arr[n];
    for (int i = n - 1; i >= 1; --i) {
        if (mx > arr[i]) {
            ans = min(ans, arr[i] * mx);
        }
        mx = max(mx, arr[i]);
    }
    if (ans == LLONG_MAX) {
        cout << "IMPOSSIBLE\n";
    }
    else {
        cout << ans << '\n';
    }
}

signed main() {
    FAST_IO();
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}

