#include<bits/stdc++.h>

using namespace std;

void FAST_IO() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
    #ifdef _offline
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // _offline
}

typedef long long ll;
typedef pair<int, int> pii;

ll t, n, a, b, k, ca, cb;

bool check(ll x)
{
    if (x == 0)
    {
        return true;
    }
    ll nowa = min(a, x);
    ll nowb = min(b, x);
    ll base = (ca * nowa) / x + (cb * nowb) / x;
    ll ost = (ca * nowa) % x + (cb * nowb) % x;
    ost /= x;
    ll tt = ost + base;
    return tt >= k;
}

signed main() {
    FAST_IO();
    cin >> t >> n >> a >> b >> k;
    ca = (n + 1) / 2;
    cb = n / 2;
    ll l = 0, r = t;
    while (l + 1 < r)
    {
        ll m = (l + r) >> 1;
        if (check(m))
        {
            l = m;
        }
        else
        {
            r = m;
        }
    }
    if (check(r))
    {
        cout << r;
    }
    else if (check(l))
    {
        cout << l;
    }
    else
    {
        assert(false);
    }
    return 0;
}

