#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int cnt = 0, global_num;
bool ans = true;
vector<bool> vis, vis1;
vector<vector<int>> g;
vector<int> fans, sans;

void dfs(int v, int par)
{
	vis[v] = true;
	fans[v] = global_num, sans[v] = global_num;
	global_num--;
	for (int to : g[v])
	{
		if (to == par) continue;
		if (vis[to]) continue;
		dfs(to, v);
	}
}

void lst(int v, int par)
{
	vis1[v] = true;
	bool if_lst = true;
	for (int to : g[v])
	{
		if (par == to) continue;
		if (vis1[to]) continue;
		lst(to, v);
		if_lst = false;
	}
	if (if_lst)
	{
		cnt++;
		sans[v] = 1;
	}
}

bool lll(int v)
{
	int cnt = 0;
	for (int to : g[v])
	{
		if (vis1[to]) continue;
		cnt++;
	}
	if (cnt == 1)
		return false;
	return true;
}

signed main()
{
	int n, m;
	cin >> n >> m;
	g.resize(n);
	vis.resize(n, false);
	vis1.resize(n, false);
	fans.resize(n, -1);
	sans.resize(n, -1);
	for (int i = 0; i < m; i++)
	{
		int u, v;
		cin >> u >> v;
		--u, --v;
		g[u].push_back(v);
		g[v].push_back(u);
	}
	if ((n <= 1) && (m == 0))
	{
		cout << "NO";
		return 0;
	}
	global_num = n;
	for (int i = 0; i < n; i++)
	{
		if ((!vis[i]) && (lll(i)))
		{
			dfs(i, -1);
			lst(i, -1);
		}
	}
	for (int i = 0; i < n; i++)
	{
		if (!vis[i])
		{
			dfs(i, -1);
			lst(i, -1);
		}
	}
	cout << "YES\n";
	for (int i : fans)
		cout << i << " ";
	cout << "\n";
	for (int i : sans)
		cout << i << " ";
	return 0;
}