#include <vector>
#include <iostream>
#include <algorithm>
#define int long long


using namespace std;


const int MOD = ((int)1 << 32);


int solve()
{
	int n, l, r, x, y, z, b1, b2;
	cin >> n >> l >> r >> x >> y >> z >> b1 >> b2;
	vector<int> a(n);
	a[0] = b1;
	//cout << MOD << endl;
	a[1] = b2;
	for (int i = 2; i < n; i++)
	{
		a[i] = z + y * a[i - 1] + x * a[i - 2];
		a[i] = a[i] % MOD;
	}
	for (int i = 0; i < n; i++)
	{
		a[i] = (a[i] % (r - l + 1)) + l;
	}
	int cur = n - 1;
	while (cur >= 0 && a[cur] < 0)
	{
		cur--;
	}
	bool flag = false;
	int ans = 0;
	int best = cur;
	cur--;
	while (cur > -1)
	{
		if (a[cur] >= a[best])
		{
			best = cur;
		}
		if (a[cur] < 0)
		{
			if (!flag)
			{
				ans = a[cur] * a[best];
				flag = true;
			}
			else
			{
				ans = min(ans, a[cur] * a[best]);
			}
		}
		cur--;
	}
	if (flag)
	{
		cout << ans << endl;
		return 0;
	}

	vector<int> flags;
	int last = 0;
	while (last < n && a[last] < 0)
	{
		last++;
	}
	if (last != n)
	{
		flags.push_back(last);
		for (int i = last + 1; i < n; i++)
		{
			if (a[i] >= 0 && a[i] <= a[last])
			{
				last = i;
				flags.push_back(last);
			}
		}
		for (int i = n - 1; i > last; i--)
		{
			if (a[i] >= 0)
			{
				if (!flag)
				{
					ans = a[i] * a[last];
					flag = true;
				}
				else
				{
					ans = min(ans, a[i] * a[last]);
				}
			}
		}
		for (int i = flags.size() - 2; i > -1; i--)
		{
			for (int j = flags[i] + 1; j < flags[i + 1]; j++)
			{
				if (a[j] >= 0)
				{
					if (!flag)
					{
						ans = a[flags[i]] * a[j];
						flag = true;
					}
					else
					{
						ans = min(ans, a[flags[i]] * a[j]);
					}
				}
			}
		}
	}
	best = n - 1;
	for (int i = n - 2; i > -1; i--)
	{
		if (a[i] < 0 && a[best] > a[i])
		{
			if (!flag)
			{
				ans = a[i] * a[best];
				flag = true;
			}
			else
			{
				ans = min(ans, a[i] * a[best]);
			}
		}
		if (a[i] > a[best])
		{
			best = i;
		}
	}
	if (!flag)
	{
		cout << "IMPOSSIBLE" << endl;
		return 0;
	}
	cout << ans << endl;
}


signed main()
{
	int t;
	cin >> t;
	//cout << t << endl;
	for (int i = 0; i < t; i++)
	{
		solve();
	}
	return 0;
}

/*
2
4 -5 5 11 13 17 0 3
5 0 100 0 1 0 42 42
*/