#include <vector>
#include <iostream>
#include <algorithm>
#include <string>
#define int long long

using namespace std;

bool in_(pair<string, string> &f, pair<string, string> &s)
{
	int i = 0, j = 0;
	while ((i < f.second.size()) && (j < s.second.size()))
	{
		if (f.second == s.second)
		{
			i++, j++;
		}
		else
			i++;
	}
	vector<bool> have(35, false);
	for (char k : f.first)
		have[k - 'a'] = true;
	for (int k = j; k < s.second.size(); k++)
	{
		if (!have[s.second[k] - 'a'])
			return false;
	}
	return true;
}

signed main()
{
	int n;
	cin >> n;
	vector<pair<string, pair<string, int>>> a(n);
	for (int i = 0; i < n; i++)
	{
		string f, s;
		cin >> f >> s;
		a[i].second = { f, i };
		sort(s.begin(), s.end());
		string pb;
		pb += s[0];
		for (int j = 1; j < s.size(); j++)
		{
			if (s[j] != s[j - 1])
				pb += s[j];
		}
		a[i].first = pb;
	}

	sort(a.begin(), a.end());

	vector<pair<string, string>> group;
	vector<vector<int>> ans;
	vector<int> group_num;

	group.push_back({ a[0].first, a[0].second.first });
	group_num.push_back({ 0 });
	ans.push_back({ a[0].second.second });

	for (int i = 1; i < n; i++)
	{
		bool can_we = false;
		pair<string, string> pb = { a[i].first, a[i].second.first };
		for (int j = group.size() - 1; j >= 0; j--)
		{
			pair<string, string> now = group[j];
			if (now.first != a[i].first)
			{
				group.push_back(pb);
				ans.push_back({ a[i].second.second });
				group_num.push_back(ans.size() - 1);
				can_we = true;
				break;
			}
			if ((in_(now, pb)) && (in_(pb, now)))
			{
				//if (pb.second.size() < now.second.size()) group[j] = pb;
				ans[group_num[j]].push_back(a[i].second.second);
				can_we = true;
				break;
			}
		}
		if (!can_we)
		{
			group.push_back(pb);
			group_num.push_back(ans.size());
			ans.push_back({ a[i].second.second });
		}
	}
	cout << ans.size() << "\n";
	for (int i = 0; i < ans.size(); i++)
	{
		cout << ans[i].size() << " ";
		for (int j : ans[i])
			cout << j + 1 << " ";
		cout << "\n";
	}
	return 0;
}