#include <bits/stdc++.h>

using namespace std;

bool streq(string &a, int st, string b)
{
    if (a.size() < b.size())
        return false;
    for (int i = 0; i < min(a.size() -st, b.size()); i++)
        if (a[i + st] != b[i])
            return false;
    return true;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    string s;
    map<string, int> order;
    int cur = 0;
    vector<pair<int, string> > strs;
    string frst_s;
    while (getline(cin, s))
    {
        for (int i = 0; i < s.size(); i++)
        {
            if (streq(s, i, "\\cite{"))
            {
                string t = "";
                i += 6;
                while (true)
                {
                    if (s[i] == '}')
                    {
                         break;
                    }
                    t.push_back(s[i]);
                    i++;
                }

                order[t] = cur;
                cur++;
            }
        }

        if (streq(s, 0, "\\begin{thebibliography}{"))
        {
            frst_s = s;
            break;
        }
    }

    //return 0;
    while (getline(cin, s))
    {
        if (streq(s, 0, "\\bibitem{"))
        {
            string t = "";
            int j = 9;
            while (true)
            {
                if (s[j] == '}')
                    break;
                else
                    t.push_back(s[j]);
                j++;
            }
            strs.push_back({order[t], s});
        }
    }

    bool f = true;
    for (int i = 0; i < strs.size() - 1; i++)
        if (strs[i + 1].first < strs[i].first)
            f = false;
    if (f)
        cout << "Correct";
    else
    {
        cout << "Incorrect" << '\n' << frst_s << '\n';
        sort(strs.begin(), strs.end());
        for (auto &i : strs)
            cout << i.second << '\n';
        cout << "\\end{thebibliography}";
    }


    return 0;
}
