#include <bits/stdc++.h>

using namespace std;
#define int long long
#define x first
#define y second

pair<int, int> getc(string s) {
    return {8 - (s[1] - '0'), s[0] - 'a'};
}

string retc(pair<int, int> c) {
    string s = "";
    s += (c.y + 'a');
    s += (8 - c.x + '0');
    return s;
}

const int inf = 1e10;
bool kn[10][10];
bool placed[10][10];
int n = 8;
int dist[10][10];
pair<int, int> par[10][10];

void cleard() {
    for (int i = 0; i < n; i ++) {
        for (int j = 0; j < n; j ++) {
            dist[i][j] = inf;
            par[i][j] = {-1, -1};
        }
    }
}

vector<pair<string, string> > answ;

void addway(pair<int, int> s, pair<int, int> f) {
    //cout << retc(s) << ' ' << retc(f) << endl;
    kn[s.x][s.y] = 0;
    while (s != f) {
        answ.push_back({retc(s), retc(par[s.x][s.y])});
        s = par[s.x][s.y];
    }

    kn[f.x][f.y] = 1;
    placed[f.x][f.y] = 1;
}

void movek(pair<int, int> s, pair<int, int> f) {
    auto ss = s;
    vector<pair<int, int> > placedway;
    placedway.push_back(ss);
    while (par[s.x][s.y].x != -1) {
        //cout << "\t" << retc(s) << endl;
        if (placed[s.x][s.y]) {
            placedway.push_back(s);
        }

        s = par[s.x][s.y];
    }

    placedway.push_back(f);
    reverse(placedway.begin(), placedway.end());

    for (int i = 1; i < placedway.size(); i ++) {
        //cout << retc(placedway[i]) << endl;
        addway(placedway[i], placedway[i - 1]);
    }
}

void out_ret() {
    if (answ.size() > 1500) {
        cout << 1/0;
        exit(0);
    }

    cout << answ.size() << "\n";
    for (auto u : answ) {
        cout << u.x << '-' << u.y << "\n";
    }

    exit(0);
}

signed main() {
    ios :: sync_with_stdio(0);
    cin.tie(0);

    int m;
    cin >> m;

    vector<int> dx = {-2, -2, -1, -1, 1, 1, 2, 2};
    vector<int> dy = {-1, 1, -2, 2, -2, 2, -1, 1};

    for (int i = 0; i < m; i ++) {
        string s;
        cin >> s;
        auto p = getc(s);
        kn[p.x][p.y] = 1;
    }

    int cnt = 0;
    for (int i = n - 1; i > -1; i --) {
        for (int j = 0; j < n; j ++) {
            if (cnt == m) {
                out_ret();
            }

            pair<int, int> near;
            queue<pair<int, int> > q;
            cleard();
            q.push({i, j});
            dist[i][j] = 0;
            bool notbreak = 1;

            while (!q.empty() && notbreak) {
                auto v = q.front();
                q.pop();

                if (kn[v.x][v.y] == 1 && !placed[v.x][v.y]) {
                    near = v;
                    notbreak = 0;
                    break;
                }

                for (int di = 0; di < 8; di ++) {
                    pair<int, int> u = {v.x + dx[di], v.y + dy[di]};
                    if (u.x >= 0 && u.x < n && u.y >= 0 && u.y < n && dist[u.x][u.y] == inf) {
                        dist[u.x][u.y] = dist[v.x][v.y] + 1;
                        par[u.x][u.y] = v;
                        q.push(u);


                    }
                }
            }

            movek(near, {i, j});
            cnt++;
        }
    }

    return 0;
}
