#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
using namespace std;

struct item
{
    int m[26];
    long long h;
    int k;
};

bool cmp(item x, item y)
{
    for (int i = 0; i < 26; i++)
        if (x.m[i] != y.m[i]) return x.m[i] < y.m[i];

    return x.h < y.h;
}

int  main(){

    ios_base::sync_with_stdio(false);

    int n;
    cin >> n;

    item a[n];
    long long bs = 533, md = 1e9 + 7;

    for (int i = 0; i < n; i++)
    {
        string s, t;
        cin >> s >> t;
        a[i].k = i;
        for (int j = 0; j < 26; j++) a[i].m[j] = 0;
        for (int j = 0; j < (int)t.size(); j++) a[i].m[t[j]-'a'] = 1;
        int p = s.size()-1;
        while (p >= 0 && a[i].m[s[p]-'a']) p--;
        a[i].h = 0;
        for (int j = 0; j <= p; j++) a[i].h = (a[i].h*bs + s[j])%md;
    }

    sort(a, a+n, cmp);

    int res = 1;
    vector <vector <int> > v(200000);
    v[0].push_back(a[0].k);

    for (int i = 1; i < n; i++)
    {
        int fl = 1;
        for (int j = 0; j < 26; j++)
            if (a[i].m[j] != a[i-1].m[j]) fl = 0;

        if (a[i].h != a[i-1].h || fl == 0) res++;
        v[res-1].push_back(a[i].k);
    }

    cout << res << "\n";

    for (int i = 0; i < res; i++)
    {
        cout << v[i].size() << " ";
        for (int xx: v[i]) cout << xx+1 << " ";
        cout << "\n";
    }
}

