#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
long long const INF = 4294967296;
long long t, n, l, r, x, y, z, b1, b2, ans, f;
vector<long long> a;
vector<long long> b;


void merge(ll l, ll m, ll r) {
    vector <ll> result;
    ll p1 = l;
    ll p2 = m;

    if (f == 0) {
        if (a[l] > a[r - 1]) {
            ans = a[l] * a[r - 1];
            f = 1;
        }
        if (a[m - 1] > a[m]) {
            ans = min(ans, a[m - 1] * a[m]);
            f = 1;
        }
    }
    else {
        if (a[m - 1] > a[m])
            ans = min(ans, a[m - 1] * a[m]);
        if (a[l] > a[r - 1])
            ans = min(ans, a[l] * a[r - 1]);
    }

    while (p1 < m && p2 < r) {
        if (a[p1] <= a[p2]) {
            result.push_back(a[p1]);
            p1++;
        }
        else {
            result.push_back(a[p2]);
            p2++;
        }
    }
    for (ll i = p1; i < m; ++i)
        result.push_back(a[i]);
    for (ll i = p2; i < r; ++i)
        result.push_back(a[i]);
    for (ll i = l; i < r; ++i)
        a[i] = result[i - l];
}

void merge_sort(ll l, ll r) {
    if (r - l == 1)
        return;
    ll m = (r + l) / 2;
    merge_sort(l, m);
    merge_sort(m, r);
    merge(l, m, r);
}

int main() {

    cin >> t;
    for (ll cnt = 0; cnt < t; ++cnt) {
        cin >> n >> l >> r >> x >> y >> z >> b1 >> b2;
        a.assign(n, 0);
        b.assign(n, 0);
        b[0] = b1;
        b[1] = b2;

        for (ll i = 2; i < n; ++i) {
            b[i] = (x * b[i - 2] + y * b[i - 1] + z) % INF;
        }
        for (ll i =0 ; i < n; ++i) {
            a[i] = (b[i] % (r - l + 1)) + l;
            ///cout << a[i] << ' ';
        }
        ///cout << '\n';
        reverse(a.begin(), a.end());
        ans = 0;
        f = 0;
        ///cout << '\n';
        merge_sort(0, n);
        if (f == 1)
            cout << ans << '\n';
        else
            cout << "IMPOSSIBLE";
    }
}

