#include <iostream>
#include <vector>

using namespace std;

struct ll{
    vector<short int> n;
    int len=0;
};

ll operator + (const ll& a, const ll& b){
    ll ans;
    int s=0;
    if(a.len>b.len){
        for(int i=0;i<b.len;i++){
            s += a.n[i]+b.n[i];
            ans.len++;
            ans.n.push_back(s%10);
            s = s/10;
        }
        for(int i=b.len; i<a.len;i++){
            s += a.n[i];
            ans.len++;
            ans.n.push_back(s%10);
            s = s/10;
        }
        while(s!=0){
            ans.len++;
            ans.n.push_back(s%10);
            s = s/10;
        }
    }else{
        for(int i=0;i<a.len;i++){
            s += a.n[i]+b.n[i];
            ans.len++;
            ans.n.push_back(s%10);
            s = s/10;
        }
        for(int i=a.len; i<b.len;i++){
            s += b.n[i];
            ans.len++;
            ans.n.push_back(s%10);
            s = s/10;
        }
        while(s!=0){
            ans.len++;
            ans.n.push_back(s%10);
            s = s/10;
        }
    }
    return ans;
}

bool operator < (const ll& a, const ll& b){
    if(a.len < b.len){
        return true;
    }else if(a.len > b.len){
        return false;
    }else{
        int i=0;
        while(a.n[i]==b.n[i] && i<a.len) i++;
        if(i == a.len) return false;
        else{
            return a.n[i]<b.n[i];
        }
    }
}

bool operator == (const ll& a, const ll& b){
    if(a.len < b.len){
        return false;
    }else if(a.len > b.len){
        return false;
    }else{
        int i=0;
        while(a.n[i]==b.n[i] && i<a.len) i++;
        if(i == a.len) return true;
        else false;
    }
}

ll operator - (const ll& a, const ll& b){
    ll ans;
    int s=0;
    int ost = 0;
    if(a.len>=b.len){
        for(int i=0;i<b.len;i++){
            s = a.n[i]-ost-b.n[i];
            if(s<0)
                s = 10+s, ost = 1;
            else
                ost = 0;
            ans.len++;
            ans.n.push_back(s);
        }
        for(int i=b.len; i<a.len;i++){
            s = a.n[i]-ost;
            if(s<0)
                s = 10+s, ost = 1;
            else
                ost = 0;
            ans.len++;
            ans.n.push_back(s);
        }
        while(ans.n[ans.len-1]==0){
            ans.len--;
            ans.n.pop_back();
        }
    }
    return ans;
}

ll Ult(const ll& a){
    ll ans;
    int s=0;
    for(int i=0;i<a.len;i++){
        s += a.n[i]*2;
        ans.len++;
        ans.n.push_back(s%10);
        s/=10;
    }
    while(s!=0){
        ans.len++;
        ans.n.push_back(s%10);
        s/=10;
    }
    return ans;
}

struct monst
{
    ll a;
    ll h;
};
monst cur[250005];
int dead[250005];
int main()
{
    int n;
    cin >> n;
    int k=0;
    for (int i=1; i<=250000; i++)
        dead[i]=-1;
    for (int t=1; t<=n; t++)
    {
        int mode;
        cin >> mode;
        if (mode==1)
        {
            k++;
            cur[k].a.n.push_back(1);
            cur[k].a.len++;
            cur[k].h.n.push_back(1);
            cur[k].h.len++;
        }
        if (mode==2)
        {
            int i;
            cin >> i;
            if (dead[i]!=-1)
                continue;
            cur[i].a=Ult(cur[i].a);
        }
        if (mode==3)
        {
            int i;
            cin >> i;
            if (dead[i]!=-1)
                continue;
            cur[i].h = Ult(cur[i].h);
        }
        if (mode==4)
        {
            int i;
            cin >> i;
            k++;
            cur[k].a=cur[i].a;
            cur[k].h=cur[i].h;
            if (dead[i]!=-1)
            {
                dead[k]=t;
            }
        }
        if (mode==5)
        {
            int i, j;
            cin >> i >> j;
            if (dead[i]!=-1 || dead[j]!=-1)
                continue;
            if(cur[i].h<cur[j].a || cur[i].h==cur[j].a){
                dead[i]=t;
                cur[i].h.len = 0;
                cur[i].h.n.clear();
            }
            else
                cur[i].h=cur[i].h-cur[j].a;


            if(cur[j].h<cur[i].a || cur[j].h==cur[i].a){
                dead[j]=t;
                cur[j].h.len = 0;
                cur[j].h.n.clear();
            }
            else
                cur[j].h = cur[j].h - cur[i].a;
        }
    }
    cout << k << "\n";
    for (int i=1; i<=k; i++)
        cout << dead[i] << " ";
    return 0;
}
