import java.io.*;
import java.util.*;

public class D {
    String fileName = "B";

    public void solve() throws IOException {
        int n = nextInt();
        int m = nextInt();
        int[] cnt = new int[n + 1];
        List<List<Integer>> g = new ArrayList<>(n + 1);
        for (int i = 0; i < n + 1; i++) {
            g.add(new ArrayList<>());
        }
        for (int i = 0; i < m; i++) {
            int a = nextInt();
            int b = nextInt();
            cnt[a]++;
            cnt[b]++;
            g.get(a).add(b);
            g.get(b).add(a);
        }
        int minV = 1;
        for (int i = 1; i <= n; i++) {
            if (cnt[i] < cnt[minV]) {
                minV = i;
            }
        }
        if (cnt[minV] == n - 1) {
            out.print("NO");
        } else {
            out.println("YES");
            int[] a = new int[n + 1];
            a[minV] = 1;
            for (int i = 0; i < g.get(minV).size(); i++) {
                int u = g.get(minV).get(i);
                a[u] = n - i;
            }
            int cur = 2;
            for (int i = 1; i <= n; i++) {
                if (a[i] == 0)
                    a[i] = cur++;
            }
            for (int i = 1; i <= n; i++) {
                out.print(a[i]);
                out.print(' ');
            }
            out.println(' ');
            a[minV]++;
            for (int i = 1; i <= n; i++) {
                out.print(a[i]);
                out.print(' ');
            }
        }
    }

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new D().run();
    }

}