#include <iostream>
#include <vector>
#include <map>
#include <cstdio>
#include <fstream>
using namespace std;

int main() {
    freopen("in.txt", "r", stdin);
    vector <char> text;
    char c;
    vector <int> fig;
    int middle = 0;
    while (scanf("%c", &c) != -1){
        if (c == '\n')
            continue;
        //cout << (int) c << endl;
        text.push_back(c);
        if (c == '{'){
            fig.push_back(text.size() - 1);
        }
        else if (c == '}'){
            fig.push_back(text.size() - 1);
            if (fig.size() > 2 && fig[fig.size() - 2] - 1 == fig[fig.size() - 3]){
                middle = fig.size() - 1;
            }
        }
    }
    vector <string> names, post_names;
    for (int i = 0; i < fig.size() - 2; i+=2){
        string temp;
        int index = fig[i] + 1;
        while (text[index] != '}'){
            temp += text[index];
            index++;
        }
        if (i < middle - 3){
            names.push_back(temp);
        }
        else if (i > middle){
            post_names.push_back(temp);
        }
    }
    if (names == post_names){
        cout << "Correct";
        return 0;
    }
    map <string, string> post;
    string line;
    for (int i = fig[middle] + 1; i < text.size(); i++){
        if (text[i] == char(92)){
            if (line.empty()){
                line.push_back(text[i]);
            }
            else{
                post.insert({post_names[post.size()], line});
                line = "";
                line += char(92);
            }
        }
        else{
            line += text[i];
        }
    }
    cout << "Incorrect" << endl;
    cout << char(92) << "begin{thebibliography}{" << 99 << "}" << endl;
    for (auto &i: names){
        cout << post.at(i) << endl;
    }
    cout << char(92) << "end{thebibliography}";
    return 0;
}
