#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>

using namespace std;

int main() {
    int n, m;
    cin >> n >> m;
    vector <vector <int> > graph(n + 1);
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        graph[a].push_back(b);
        graph[b].push_back(a);
    }
    int v = -1, u = -1;
    for (int i = 1; i <= n; i++) {
        int sz = graph[i].size();
        if (sz < n - 1) {
            v = i;
            vector <bool> was(n + 1);
            for (int k : graph[i]) {
                was[k] = true;
            }
            for (int j = 1; j <= n; j++) {
                if (!was[j] && j != v) {
                    u = j;
                    break;
                }
            }
            break;
        }
    }
    if (v == -1 || u == -1) {
        cout << "NO";
        return 0;
    }
    cout << "YES\n";
    vector <int> ans(n + 1);
    for (int i = 1; i <= n; i++)
        ans[i] = i;
    ans[v] = 1;
    ans[u] = 2;
    ans[1] = v;
    ans[2] = u;
    for (int i = 1; i <= n; i++) {
        cout << ans[i] << ' ';
    }
    cout << endl;
    ans[u] = 1;
    for (int i = 1; i <= n; i++) {
        cout << ans[i] << ' ';
    }
}
