#include <iostream>
#include <vector>
#include <map>
#include <cmath>

using namespace std;

const long long INF = 5e18;

int main() {
    ios::sync_with_stdio(false);
    int t;
    cin >> t;
    for (int test = 0; test < t; test++) {
        int n, l, r, x, y, z;
        long long b1, b2;
        cin >> n >> l >> r >> x >> y >> z >> b1 >> b2;
        int a1 = (b1 % (r - l + 1)) + l;
        int a2 = (b2 % (r - l + 1)) + l;
        int neg_min = 0, neg_max = 0;
        bool zero = false;
        int pos_min = 0;
        if (a1 < 0) {
            neg_min = a1;
            neg_max = a1;
        } else if (a1 == 0) {
            zero = true;
        } else {
            pos_min = a1;
        }
        long long ans = INF;
        for (int i = 1; i < n; i++) {
            if (a2 > neg_min && neg_min != 0) {
                ans = min(ans, (long long) neg_min * a2);
            }
            if (a2 > neg_max && neg_max != 0) {
                ans = min(ans, (long long) a2 * neg_max);
            }
            if (a2 > pos_min && pos_min != 0) {
                ans = min(ans, (long long) a2 * pos_min);
            }
            if (zero && a2 > 0) {
                ans = min(ans, 0ll);
            }

            if (a2 < 0) {
                neg_min = min(neg_min, a2);
                neg_max = max(neg_max, a2);
            } else if (a2 == 0) {
                zero = true;
            } else {
                pos_min = max(pos_min, a2);
            }

            b1 = (b1 * x + b2 * y + z) % ((long long) 1 << 32);
            a1 = (b1 % (r - l + 1)) + l;
            swap(b1, b2);
            swap(a1, a2);
        }
        if (ans == INF) {
            cout << "IMPOSSIBLE\n";
        } else {
            cout << ans << "\n";
        }
    }
}
