#include <iostream>
#include <vector>
#include <cmath>

using namespace std;

int main() {

    int n, m;
    cin >> n >> m;
    vector < vector < int > > have(n);
    int sum = 0;
    for (int i = 0; i < n; i++) {
        int sz;
        cin >> sz;
        for (int j = 0; j < sz; j++) {
            int a;
            cin >> a;
            have[i].push_back(a);
        }
        sum += sz;
    }

    if(sum % n == 0) {
        int mid = sum / 3;
        vector < int > men;
        vector < int > bol;
        vector < vector < int > > ans;
        for (int i = 0; i < n; i++) {
            if(have[i].size() < mid) men.push_back(i);
            if(have[i].size() > mid) bol.push_back(i);
        }
        int sz = men.size();
        int k = max(1.0, sqrt(sz));
        int kol = men.size() / k + 1;
        vector < int > bloks[kol][m + 1];
        vector < vector < int > > dif(kol, vector < int > (m + 1, 0));
        vector < bool > used(n, 0);
        vector < int > blsz(men.size() / k + 1, 0);
        for (int i = 0; i < men.size(); i++) {
            blsz[i / k]++;
            for (auto x : have[men[i]]) {
                bloks[i / k][x].push_back(i);
            }
        }
        for (int i = 0; i < bol.size(); i++) {
            int cnt = 0;
            int nuzh = have[bol[i]].size() - mid;
            for (auto x: have[bol[i]]) {
                for (int j = 0; j < kol; j++) {
                    if(bloks[j][x].size() - dif[j][x] == blsz[j]) continue;
                    int cnt1 = j * k;
                    for (auto z : bloks[j][x]) {
                        if(!used[z] && z != cnt1) break;
                        cnt1++;
                    }
                    bloks[j][x].push_back(men[cnt1]);
                    ans.push_back({bol[i], men[cnt1], x});
                    have[men[cnt1]].push_back(x);
                    if(have[men[cnt1]].size() == mid) {
                        blsz[j]--;
                        used[men[cnt1]] = true;
                        for(auto y : have[men[cnt1]]) {
                            dif[j][y]++;
                        }
                    }
                    cnt++;
                    break;
                }
                if(cnt == nuzh) break;
            }
        }
        for (auto x: ans) {
            cout << x[0] + 1 << " " << x[1] + 1 << " " << x[2] << endl;
        }
        return 0;
    }
    int mid = sum / 3;
    vector < int > men;
    vector < int > bol;
    vector < vector < int > > ans;
    for (int i = 0; i < n; i++) {
        if(have[i].size() < mid) men.push_back(i);
        if(have[i].size() > mid) bol.push_back(i);
    }
    int sz = men.size();
    int k = max(1.0, sqrt(sz));
    int kol = men.size() / k + 1;
    vector < int > bloks[kol][m + 1];
    vector < vector < int > > dif(kol, vector < int > (m + 1, 0));
    vector < bool > used(n, 0);
    vector < int > blsz(men.size() / k + 1, 0);
    for (int i = 0; i < men.size(); i++) {
        blsz[i / k]++;
        for (auto x : have[men[i]]) {
            bloks[i / k][x].push_back(i);
        }
    }
    int koll = men.size();
    for (int i = 0; i < bol.size(); i++) {
        int cnt = 0;
        int nuzh = have[bol[i]].size() - (mid + 1);
        if(nuzh == 0) continue;
        for (auto x: have[bol[i]]) {
            for (int j = 0; j < kol; j++) {
                if(bloks[j][x].size() - dif[j][x] == blsz[j]) continue;
                int cnt1 = j * k;
                for (auto z : bloks[j][x]) {
                    if(!used[z] && z != cnt1) break;
                    cnt1++;
                }
                bloks[j][x].push_back(men[cnt1]);
                ans.push_back({bol[i], men[cnt1], x});
                have[men[cnt1]].push_back(x);
                if(have[men[cnt1]].size() == mid) {
                    blsz[j]--;
                    used[men[cnt1]] = true;
                    for(auto y : have[men[cnt1]]) {
                        dif[j][y]++;
                    }
                    koll--;
                }
                cnt++;
                break;
            }
            if(cnt == nuzh) break;
        }
    }
    if(koll != 0) {
        for (int i = 0; i < bol.size(); i++) {
            int cnt = 0;
            int nuzh = 1;
            for (auto x: have[bol[i]]) {
                for (int j = 0; j < kol; j++) {
                    if(bloks[j][x].size() - dif[j][x] == blsz[j]) continue;
                    int cnt1 = j * k;
                    for (auto z : bloks[j][x]) {
                        if(!used[z] && z != cnt1) break;
                        cnt1++;
                    }
                    bloks[j][x].push_back(men[cnt1]);
                    ans.push_back({bol[i], men[cnt1], x});
                    have[men[cnt1]].push_back(x);
                    if(have[men[cnt1]].size() == mid) {
                        blsz[j]--;
                        used[men[cnt1]] = true;
                        for(auto y : have[men[cnt1]]) {
                            dif[j][y]++;
                        }
                        koll--;
                    }
                    cnt++;
                    break;
                }
                if(cnt == nuzh) break;
            }
        }
    }
    for (auto x: ans) {
        cout << x[0] + 1 << " " << x[1] + 1 << " " << x[2] << endl;
    }
    return 0;
}
