//#include <bits/stdc++.h>

#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <queue>
#include <string>

using namespace std;

const int SZ = 1e5 + 10;

void fast() {
	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);
}

bool used[8][8];
bool tused[8][8];
pair<int, int> p[8][8];
int dx[8] = { 2, 2, 1, 1, -1, -1, -2, -2 };
int dy[8] = { -1, 1, 2, -2, 2, -2, 1, -1 };

bool check(int x, int y) {
	return x >= 0 && x < 8 && y >= 0 && y < 8;
}

string tooo(int x, int y) {
	char ch = y + 'a';
	string a = ""; a += ch;
	return a + to_string(x + 1);
}

signed main() {
	fast();
	int n;
	cin >> n;
	vector<pair<int, int>> a(n);
	for (int i = 0; i < n; i++) {
		char ch;
		cin >> ch >> a[i].first;
		a[i].first--;
		a[i].second = ch - 'a';
		used[a[i].first][a[i].second] = true;
	}
	int cnt = 0;
	vector <string> answ;
	for (int i = 0; i < 8; i++) {
		for (int j = 0; j < 8 && cnt < n; j++, cnt++) {
			if (used[i][j]) continue;
			for (int x = 0; x < 8; x++)
				for (int y = 0; y < 8; y++)
					tused[x][y] = false;
			queue<pair<int, int>> q;
			q.push({ i, j });
			tused[i][j] = true;
			while (true) {
				int vi = q.front().first;
				int vj = q.front().second;
				if (used[vi][vj]) break;
				q.pop();
				for (int t = 0; t < 8; t++) {
					int ti = vi + dx[t];
					int tj = vj + dy[t];
					if (check(ti, tj) && (make_pair(ti, tj) > make_pair(i, j))
						&& !tused[ti][tj]) {
						tused[ti][tj] = true;
						p[ti][tj] = { vi, vj };
						q.push({ ti, tj });
					}
				}
			}
			int vi = q.front().first;
			int vj = q.front().second;
			used[vi][vj] = false;
			used[i][j] = true;
			while (vi != i || vj != j) {
				int pi = p[vi][vj].first;
				int pj = p[vi][vj].second;
				answ.push_back(tooo(vi, vj) + "-" + tooo(pi, pj));
				vi = pi;
				vj = pj;
			}
		}
	}
	cout << answ.size() << '\n';
	for (auto a : answ) {
		cout << a << '\n';
	}
	return 0;
}