//#include <bits/stdc++.h>
#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#define int long long
using namespace std;

typedef long long ll;

const ll SZ = 1e7 + 10;
const ll MOD = 1LL << 32;
const ll INF = 5e18;

void fast() {
	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);
}

template<class T, class U> inline void checkmin(T &x, U y) { if (y < x) x = y; }
#define sz(a) int(a.size())

void solve() {
	int n, l, r;
	unsigned int x, y, z, b1, b2;
	cin >> n >> l >> r >> x >> y >> z >> b1 >> b2;
	vector<unsigned int> b(n);
	b[0] = b1;
	b[1] = b2;
	for (int i = 2; i < n; ++i)
		b[i] = b[i - 2] * x + b[i - 1] * y + z;
	vector<int> a(n);
	int mx = r - l + 1;
	for (int i = 0; i < n; ++i)
		a[i] = (ll)b[i] % mx + l;
	ll ans = 5e18;
	set<int> st;
	for (auto i : a) {
		st.insert(i);
		if (i > 0) {
			auto it = st.begin();
			if (*it < i)
				if (sz(st) > 0)
					checkmin(ans, (ll)i * (ll)(*it));
		} else {
			if (sz(st) > 0) {
				auto it = st.find(i);
				if (it == st.begin()) continue;
				--it;
				if (*it < i)
					checkmin(ans, (ll)i * (ll)(*it));
			}
		}
	}
	if (ans == 5e18) cout << "IMPOSSIBLE\n";
	else cout << ans << '\n';
}

signed main() {
	fast();
	ll t;
	cin >> t;
	while (t--) solve();
	/*ll n, m;
	cin >> n >> m;
	vector<ll> arr(n), brr(n);
	vector<bool> used(n);
	for (int i = 0; i < m; ++i) {
		int a, b;
		cin >> a >> b;
		--a, --b;
		used[a] = used[b] = true;
	}
	int cnt = 1;
	for (int i = 0; i < n; ++i)
		if (used[i]) arr[i] = brr[i] = cnt++;
	for (int i = 0; i < n; ++i)
		if (!used[i]) arr[i] = cnt++, brr[i] = 1;
	set<int> st;
	for (auto i : brr) st.insert(i);
	if (st.size() == n || n == 1) cout << "NO";
	else {
		cout << "YES\n";
		for (auto i : arr) cout << i << ' ';
		cout << '\n';
		for (auto &i : brr) cout << i << ' ';
	}*/
	cout << endl;
	return 0;
}
