//#include <bits/stdc++.h>
#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
using namespace std;
typedef long long ll;
void fast() {
	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);
}

template<class T, class U> inline void checkmin(T &x, U y) { if (y < x) x = y; }
#define sz(a) int(a.size())

const int N = 1e7 + 10;
int ffmin[N], ffmax[N];

void insertmin(int i, int x) {
	for (; i < N; i |= i + 1) {
		ffmin[i] = min(ffmin[i], x);
	}
}

void insertmax(int i, int x) {
	for (; i < N; i |= i + 1) {
		ffmax[i] = max(ffmax[i], x);
	}
}

int getmin(int i) {
	int res = INT_MAX;
	for (; i >= 0; i = (i & (i + 1)) - 1)
		res = min(res, ffmin[i]);
	return res;
}

int getmax(int i) {
	int res = INT_MIN;
	for (; i >= 0; i = (i & (i + 1)) - 1)
		res = max(res, ffmax[i]);
	return res;
}

void solve() {
	int n, l, r;
	int x, y, z, b1, b2;
	cin >> n >> l >> r >> x >> y >> z >> b1 >> b2;
	for (int i = 0; i < n; i++) {
		ffmax[i] = INT_MIN;
		ffmin[i] = INT_MAX;
	}
	vector<unsigned int> b(n);
	b[0] = b1;
	b[1] = b2;
	for (int i = 2; i < n; ++i)
		b[i] = b[i - 2] * x + b[i - 1] * y + z;
	vector<pair<int, int>> a(n);
	int mx = r - l + 1;
	vector<int> bmin(n);
	for (int i = 0; i < n; ++i) {
		a[i].first = (int)b[i] % mx + l;
		a[i].second = i;
		if (i == 0)
		{
			bmin[i] = a[i].first;
		}
		else {
			bmin[i] = min(bmin[i - 1], a[i].first);
		}
	}
	ll res = LLONG_MAX;
	sort(a.begin(), a.end());
	for (int i = 0; i < n; i++) {
	
		if (!(i > 0 && a[i].first == a[i - 1].first) &&
			a[i].second >= 1 && i > 0 && bmin[a[i].second] < a[i].first) {
			if (a[i].first >= 0) {
				res = min(res, a[i].first * (ll)getmin(a[i].second - 1));
			}
			else {
				res = min(res, a[i].first * (ll)getmax(a[i].second - 1));
			}
		}
		insertmin(a[i].second, a[i].first);
		insertmax(a[i].second, a[i].first);
	}
	if (res == LLONG_MAX) {
		cout << "IMPOSSIBLE" << '\n';
	}
	else {
		cout << res << '\n';
	}
}

signed main() {
	fast();
	ll t;
	cin >> t;
	while (t--) solve();
	/*ll n, m;
	cin >> n >> m;
	vector<ll> arr(n), brr(n);
	vector<bool> used(n);
	for (int i = 0; i < m; ++i) {
	int a, b;
	cin >> a >> b;
	--a, --b;
	used[a] = used[b] = true;
	}
	int cnt = 1;
	for (int i = 0; i < n; ++i)
	if (used[i]) arr[i] = brr[i] = cnt++;
	for (int i = 0; i < n; ++i)
	if (!used[i]) arr[i] = cnt++, brr[i] = 1;
	set<int> st;
	for (auto i : brr) st.insert(i);
	if (st.size() == n || n == 1) cout << "NO";
	else {
	cout << "YES\n";
	for (auto i : arr) cout << i << ' ';
	cout << '\n';
	for (auto &i : brr) cout << i << ' ';
	}*/
	cout << endl;
	return 0;
}