//#include <bits/stdc++.h>
#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
using namespace std;

void fast() {
	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);
}

template<class T, class U> inline void checkmin(T &x, U y) { if (y < x) x = y; }
template<class T, class U> inline void checkmax(T &x, U y) { if (y > x) x = y; }
#define sz(a) int(a.size())
#define ll long long

const ll SZ = 1e7 + 10;
const ll MOD = 1LL << 32;
const ll INF = 5e18;
const int INTINF = 2e9 + 100;

const int N = 10000005;
int fenv[N];

void change(int r, ll x) {
	for (; r < N; r |= r + 1) checkmax(fenv[r], x);
}

int get(int r) {
	int ans = -INTINF;
	for (; r >= 0; r = (r & (r + 1)) - 1) checkmax(ans, fenv[r]);
	return ans;
}

void solve() {
	int n, l, r;
	unsigned int x, y, z, b1, b2;
	cin >> n >> l >> r >> x >> y >> z >> b1 >> b2;
	vector<unsigned int> b(n);
	b[0] = b1;
	b[1] = b2;
	for (int i = 2; i < n; ++i)
		b[i] = b[i - 2] * x + b[i - 1] * y + z;
	vector<ll> a(n);
	int mx = r - l + 1;
	for (int i = 0; i < n; ++i)
		a[i] = (ll)b[i] % mx + l;
	ll ans = INF;
	ll mn = a[0];
	for (auto i : a) {
		if (mn < i) checkmin(ans, i * mn);
		if (i == 0) checkmin(ans, 0);
		checkmin(mn, i);
	}
	for (int i = 0; i < n; ++i) fenv[i] = -INTINF;
	vector<pair<int, int>> v(n);
	for (int i = 0; i < n; ++i)
		v[i] = { a[i], i };
	sort(v.begin(), v.end());
	vector<pair<int, int>> toadd;
	int past = v[0].first - 1;
	for (int i = 0; i < n; ++i) {
		if (v[i].first != past) {
			for (auto i : toadd)
				change(i.second, i.first);
			toadd.clear();
		}
		ll got = get(v[i].second);
		if (got != -INTINF) checkmin(ans, got * v[i].first);
		past = v[i].first;
		toadd.push_back(v[i]);
	}
	if (ans == INF) cout << "IMPOSSIBLE\n";
	else cout << ans << '\n';
}

signed main() {
	fast();
	ll t;
	cin >> t;
	while (t--) solve();
	return 0;
}