#include <bits/stdc++.h>

using namespace std;

string get(string s) {
	string ans;
	bool ch = 0;
    for (int i = 0; i < s.size(); ++i) {
    	ch ^= (s[i] == '}' || s[i] == '{');
		if (ch && s[i] != '}' && s[i] != '{') {
		    ans += s[i];
		}	
    }	
    return ans;
}	

vector <string> get1(string s) {
    vector <string> ans;
    int i = 0;
    int n = s.size();
    while (i < n) {
		int u = i;
		while (u < n && s[u] != '}') {
		    ++u;
		}	
		if (u == n) {
			break;
		}
		ans.push_back(get(s.substr(i, u - i + 1)));
		i = u + 1;
    }	
    return ans;
}	

map <string, int> num;

bool comp(string a, string b) {
    return num[get(a)] < num[get(b)];
}	

string beg = "\\begin{thebibliography}{99}";
string en = "\\end{thebibliography}";

signed main() {
	//freopen("input.txt", "r", stdin);

	ios_base::sync_with_stdio(0);
	cin.tie(0);

	string line;
	string t;
	vector <string> v;
	bool ch = 0;
	while (getline(cin, line)) {
	    if (line == beg) {
			ch = 1;
	    }	
	    if (!ch) {
	        t += line;
	    }	
	    else {
	    	if (line != beg) {
	        	v.push_back(line);
	        }
	    }	
	}	

	v.pop_back();

	vector <string> a = get1(t);	
	for (int i = 0; i < a.size(); ++i) {
	    num[a[i]] = i;
	}	
	
	vector <string> v1 = v;
	sort(v1.begin(), v1.end(), comp);

	ch = 1;
	for (int i = 0; i < v.size(); ++i) {
		ch &= (v[i] == v1[i]);
	}	
	
	if (ch) {
	    cout << "Correct\n";
	}	
	else {
		cout << "Incorrect\n";
		cout << beg << '\n';
		for (int i = 0; i < v1.size(); ++i) {
			cout << v1[i] << '\n';
		}	
		cout << en << '\n';
	}

  	return 0;
}	