#include <bits/stdc++.h>

using namespace std;

#define int long long
              
const int BASE = 129;
const int MAXN = 1e6 + 7;
const int MOD1 = 1000 * 1000 * 1000 + 7;
const int MOD2 = 1000 * 1000 * 1000 + 9;

int mod1(int n) {
    return (n % MOD1 + MOD1) % MOD1;
}	

int mod2(int n) {
    return (n % MOD2 + MOD2) % MOD2;
}	

int n;
string a[MAXN], b[MAXN];
int mask[MAXN];
int h1[MAXN], h2[MAXN];
int per[MAXN];

bool check(int mask, char c) {
 	int i = c - 'a';
 	return ((mask >> i) & 1);
}

bool comp(int i, int j) {
	return (h1[i] < h1[j]) || (h1[i] == h1[j] && h2[i] < h2[j]) || (h1[i] == h1[j] && h2[i] == h2[j] && mask[i] < mask[j]);
}	

signed main() {
	#ifdef HOME
		freopen("input.txt", "r", stdin);
	#endif

	ios_base::sync_with_stdio(0);
	cin.tie(0);

	cin >> n;
	for (int i = 0; i < n; ++i) {
	    cin >> a[i] >> b[i];
	}	

	for (int i = 0; i < n; ++i) {
		for (char c : b[i]) {
			mask[i] |= 1 << (c - 'a');
        }	
        while (a[i].size() && check(mask[i], a[i].back())) {
            a[i].pop_back();
        }	
	}	
	
	for (int i = 0; i < n; ++i) {
		h1[i] = 0;
		for (char c : a[i]) {
		    h1[i] = mod1(h1[i] * BASE + c);
		}	
		h2[i] = 0;
		for (char c : a[i]) {
		    h2[i] = mod2(h2[i] * BASE + c);
		}	
	}	
	
	for (int i = 0; i < n; ++i) {
	    per[i] = i;
	}	

	sort(per, per + n, comp);

	vector <vector <int> > ans;
	for (int i = 0; i < n; ++i) {
	    if (i == 0 || comp(per[i - 1], per[i])) {
	    	ans.push_back({});
	    }	
	    ans.back().push_back(per[i]);
	}	
	
	cout << ans.size() << '\n';
	for (auto e : ans) {
		cout << e.size() << ' ';
	    for (int ne : e) {
	        cout << ne + 1 << ' ';
	    }	
	    cout << '\n';
	}	

    return 0;
}	