#include <bits/stdc++.h>

using namespace std;

using ll = long long int;
using ull = unsigned long long int;
using dd = double;
using ldd = long double;

#ifdef HOME
    #define debug(x) cout << #x << " " << x << endl;
    #define debug_v(x) cout << #x << " " << for(auto ii : x) cout << ii << " "; cout << endl;
    #define PO cout << "PO" << endl;
    #define OL cout << "OL" << endl;
#else
    #define debug(x) 0;
    #define debug_v(x) 0;
    #define PO 0;
    #define OL 0;
#endif // HOME

int block = 800;
vector<int> arr(1e5 + 1);

bool cmp(int a, int b)
{
    return arr[a] < arr[b];
}

int main()
{
    ios_base::sync_with_stdio(0);
    cout.tie(0);
    cin.tie(0);

    int n, m;
    cin >> n >> m;

    vector<pair<int, int>> tos(n);
    vector<vector<int>> have(m);
    for (int i = 0; i < n; ++i)
    {
        int x;
        cin >> x;
        arr[i] = x;
        for (int ii = 0; ii < x; ++ii)
        {
            int in;
            cin >> in;
            have[in - 1].push_back(i);
        }
    }
    for (int i = 0; i < m; ++i)
    {
        sort(all(have[i], cmp));
        for (int j = 0, jj = have[i].size() - 1; j < have[i].size() / 2; ++j, --jj)
        {
            if (arr[have[i][jj]] - 1 <= arr[have[i][j]])
                break;
            arr[have[i][jj]]--;
            arr[have[i][j]++;
            cout << have[i][jj] + 1 << " " << have[i][j] << " " << i + 1 << '\n';
        }
    }

}

