#include <bits/stdc++.h>

using namespace std;

using ll = long long int;
using ull = unsigned long long int;
using dd = double;
using ldd = long double;

#ifdef HOME
    #define debug(x) cout << #x << " " << x << endl;
    #define debug_v(x) cout << #x << " " << for(auto ii : x) cout << ii << " "; cout << endl;
    #define PO cout << "PO" << endl;
    #define OL cout << "OL" << endl;
#else
    #define debug(x) 0;
    #define debug_v(x) 0;
    #define PO 0;
    #define OL 0;
#endif // HOME

ll mod = 1e9 + 7;
ll p = 37;

ll _hash(string a)
{
    ll ans = 0;
    for (int i = 0; i < a.size(); ++i)
        ans = (ans * p + a[i] - 'a' + 1) % mod;
    return ans;
}

ll mod2 = 1e9 + 11;
ll p2 = 39;

ll _2(string a)
{
    ll ans = 0;
    for (int i = 0; i < a.size(); ++i)
    {
        ans = (ans * p2 + a[i] - 'a' + 1) % mod2;
    }
    return ans;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cout.tie(0);
    cin.tie(0);
    int n;
    cin >> n;
    vector<vector<int>> arr(n + 1000);
    map<pair<pair<pair<ll, ll>, ll>, ll>, int> have;
    int sz = 0;
    string a, b;
    for (int i = 0; i < n; ++i)
    {
        cin >> a >> b;
        ll j = 0;
        for (int k = 0; k < b.size(); ++k)
        {
            j |= (1 << (b[k] - 'a'));
        }
        while (a.size() && (j & (1 << (a.back() - 'a'))))
        {
            a.pop_back();
        }
        ll h = _hash(a);
        ll h2 = _2(a);
        if (have.find({{{h, h2}, a.size()}, j}) == have.end())
            {
                have[{{{h, h2}, a.size()}, j}] = sz;
                ++sz;
            }
        arr[have[{{{h, h2}, a.size()}, j}]].push_back(i);
    }
    cout << sz << '\n';
    for (int i = 0; i < sz; ++i)
    {
        cout << arr[i].size() << " ";
        for (int l : arr[i])
            cout << l + 1 << " ";
        cout << '\n';
    }
}


