#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

#define x first
#define y second

#define pb push_back
#define mp make_pair
#define sz(s) (int)s.size()
#define all(s) s.begin(),s.end()

int n, m, cur;
vector<vector<int> > A;
vector<char> Vis1, Vis2;
vector<int> T, B, K;

void DFS(int i, int prev){
    T[i]= 1;
    K[i]= cur;
    if (A[B[cur]].size() < 2 && A[i].size() > 1){
        B[cur]= i;
    }

    for (int j= 0; j < A[i].size(); ++j){
        if (T[A[i][j]] == 0){
            DFS(A[i][j], i);
        }
    }
    T[i]= 2;
}

 void f(){
    cur= 0;
    B.push_back(0);
    K.resize(n + 1);

    for (int i= 1; i <= n; ++i){
        K[i]= i;
    }

    for (int i= 1; i <= n; ++i){
        if (T[i] == 0){
            cur++;
            B.push_back(i);
            DFS(i, 0);
        }
    }
}

vector<int> Ans1, Ans2;

void dfs(int i, int &cut){
    Ans1[i]= cut;
    Vis1[i]= true;
    cut++;
    for (int j= 0; j < A[i].size(); ++j){
        if (!Vis1[A[i][j]]){
            dfs(A[i][j], cut);
        }
    }
}

signed main() {
    ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    cin >> n >> m;
    A.resize(n + 1);
    T.resize(n + 1);
    Vis1.resize(n + 1, false);
    Vis2.resize(n + 1, false);
    Ans1.resize(n + 1);
    Ans2.resize(n + 1);

    for (int i= 0; i < m; ++i){
        int x, y;
        cin >> x >> y;
        A[x].push_back(y);
        A[y].push_back(x);
    }

    if (n == 1 || (n == 2 && m == 1)){
        cout << "NO";
        return 0;
    }

    f();

    /*for (int i= 1; i < K.size(); ++i){
        cout << K[i] << " ";
    }
    cout << endl;
    for (int i= 1; i < B.size(); ++i){
        cout << B[i] << " ";
    }
    cout << endl;*/

        int cut= 1;

        for (int i= 1; i <= n; ++i){
            if (!Vis1[B[K[i]]]){
                {queue<pii> Q;
                Q.push(pii(B[K[i]], cut));
                Vis1[B[K[i]]]= true;
                Ans1[B[K[i]]]= cut;

                while (!Q.empty()){
                    pii v= Q.front();
                    Ans1[v.x]= cut;
                    cut++;
                    Q.pop();
                    for (int j= 0; j < A[v.x].size(); ++j){
                        if (!Vis1[A[v.x][j]]){
                            Vis1[A[v.x][j]]= true;
                            Q.push(pii(A[v.x][j], cut));
                        }
                    }
                }
                }

                queue<pii> Q;
                Q.push(pii(B[K[i]], 1));
                Vis2[B[K[i]]]= true;

                while (!Q.empty()){
                    pii v= Q.front();
                    Ans2[v.x]= v.y;
                    Q.pop();
                    for (int j= 0; j < A[v.x].size(); ++j){
                        if (!Vis2[A[v.x][j]]){
                            Vis2[A[v.x][j]]= true;
                            Q.push(pii(A[v.x][j], v.y + 1));
                        }
                    }
                }
            }
        }


        cout << "YES\n";
        for (int i= 1; i <= n; ++i){
            cout << Ans1[i] << " ";
        }
        cout << endl;
        for (int i= 1; i <= n; ++i){
            cout << Ans2[i] << " ";
        }

}
