#include <bits/stdc++.h>
#define all(a) a.begin(),a.end()
//#pragma GCC optimize("O3")
//#pragma GCC target("sse4")

using namespace std;

typedef long long ll;

const int MAXN = 8;
const vector <int> dx = {1, 2, 2, 1, -1, -2, -2, -1};
const vector <int> dy = {-2, -1, 1, 2, 2, 1, -1, -2};

bool horse[MAXN][MAXN], used[MAXN][MAXN];
vector <pair <int, int>> path;

bool ok(int x, int y) {
    if (used[x][y])
        return 0;
    return x >= 0 && x < MAXN && y >= 0 && y < MAXN;
}

void get(int x, int y) {
    queue <pair <int, int>> crd;
    pair <int, int> p[MAXN][MAXN];
    for (int i = 0; i < MAXN; ++i)
        for (int j = 0; j < MAXN; ++j)
            p[i][j] = {-1, -1};
    crd.push({x, y});
    pair <int, int> res = {-1, -1};
    while (crd.size()) {
        auto cur = crd.front();
        used[cur.first][cur.second] = 1;
        if (horse[cur.first][cur.second]) {
            res = cur;
            break;
        }
        crd.pop();
        for (int i = 0; i < 8; ++i) {
            int nx = cur.first + dx[i];
            int ny = cur.second + dy[i];
            if (ok(nx, ny)) {
                p[nx][ny] = cur;
                crd.push({nx, ny});
            }
        }
    }
    horse[res.first][res.second] = 0;
    horse[x][y] = 1;
    pair <int, int> foo = {-1, -1};
    while (p[res.first][res.second] != foo) {
        path.push_back(res);
        res = p[res.first][res.second];
    }
    path.push_back(res);
}

main() {
    //ifstream cin("in.txt");
    ios_base::sync_with_stdio(0);
    cin.tie(0);cout.tie(0);
    int k;
    cin >> k;
    for (int i = 0; i < k; ++i) {
        char r, s;
        cin >> r >> s;
        int x = r - 'a';
        int y = s - '1';
        horse[x][y] = 1;
    }
    for (int i = 0; i < k; ++i) {
        int x = i % MAXN;
        int y = i / MAXN;
        if (used[x][y])
            continue;
        get(x, y);
    }
    cout << path.size() - k << "\n";
    int cnt = 0;
    for (int i = 0; i + 1 < path.size(); ++i) {
        int x = cnt % MAXN;
        int y = cnt / MAXN;
        if (path[i].first == x && path[i].second == y) {
            ++cnt;
            continue;
        }
        char c11 = path[i].first + 'a';
        char c12 = path[i].second + '1';
        char c21 = path[i + 1].first + 'a';
        char c22 = path[i + 1].second + '1';
        cout << c11 << c12 << "-" << c21 << c22 << "\n";
    }
    return 0;
}
