import java.io.*;
import java.lang.reflect.Array;
import java.util.*;
import java.math.*;

public class Tst2 {

    public void solve() throws IOException {

        BigInteger two = BigInteger.valueOf(2), one = BigInteger.ONE, zr = BigInteger.ZERO;
        int a = ni(), k=0;
        boolean[] l = new boolean[a];
        int[] d = new int[a]; Arrays.fill(d,-1);
        BigInteger[] pow = new BigInteger[a], h = new BigInteger[a];
        for(int q=0; q<a; q++){
            int c = ni();
            if(c==1){
                l[k] = true;
                pow[k] = one;
                h[k] = one;
                k++;
            }
            if(c==2){
                int x = ni()-1;
                if(!l[x]) continue;
                pow[x] = pow[x].multiply(two);
            }
            if(c==3){
                int x = ni()-1;
                if(!l[x]) continue;
                h[x]=h[x].multiply(two);
            }
            if(c==4){
                int x  =ni()-1;
                if(!l[x]){
                    d[k] = q+1;
                    k++;
                }
                else{
                    l[k] = true;
                    pow[k] = pow[x];
                    h[k] = h[x];
                    k++;
                }
            }
            if(c==5){
                int x  =ni()-1, y = ni()-1;
                if(!l[x] || !l[y]) continue;
                h[x] = h[x].subtract(pow[y]);
                h[y] = h[y].subtract(pow[x]);
                if(h[x].compareTo(zr)<=0){
                    l[x] = false;
                    d[x] = q+1;
                }
                if(h[y].compareTo(zr)<=0){
                    d[y] = q+1;
                    l[y] = false;
                }
            }
        }
        pw.println(k);
        for(int q=0; q<k; q++) pw.print(d[q]+" ");
    }

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            pw = new PrintWriter(System.out);

            solve();

            pw.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter pw;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public String ns() throws IOException {
        return nextToken();
    }

    public int ni() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nd() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nl() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new Tst2().run();
    }

}