#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define all(x) x.begin(), x.end()

vector <long long> tma;

void buildma(int v, int vl, int vr, vector <long long> &a) {
    if (vl == vr - 1) {
        tma[v] = a[vl];
        return;
    }
    int vm = (vl + vr) / 2;
    buildma(2 * v + 1, vl, vm, a);
    buildma(2 * v + 2, vm, vr, a);
    tma[v] = max(tma[2 * v + 1], tma[2 * v + 2]);
}

long long getma(int v, int vl, int vr, int l, int r) {
    if (vl == l && vr == r) {
        return tma[v];
    }
    int vm = (vl + vr) / 2;
    if (r <= vm) {
        return getma(2 * v + 1, vl, vm, l, r);
    }
    if (l >= vm) {
        return getma(2 * v + 2, vm, vr, l, r);
    }
    return max(getma(2 * v + 1, vl, vm, l, vm), getma(2 * v + 2, vm, vr, vm, r));
}

vector <long long> tmi;

void buildmi(int v, int vl, int vr, vector <long long> &a) {
    if (vl == vr - 1) {
        tmi[v] = a[vl];
        return;
    }
    int vm = (vl + vr) / 2;
    buildmi(2 * v + 1, vl, vm, a);
    buildmi(2 * v + 2, vm, vr, a);
    tmi[v] = min(tmi[2 * v + 1], tmi[2 * v + 2]);
}

long long getmi(int v, int vl, int vr, int l, int r) {
    if (vl == l && vr == r) {
        return tmi[v];
    }
    int vm = (vl + vr) / 2;
    if (r <= vm) {
        return getmi(2 * v + 1, vl, vm, l, r);
    }
    if (l >= vm) {
        return getmi(2 * v + 2, vm, vr, l, r);
    }
    return min(getmi(2 * v + 1, vl, vm, l, vm), getmi(2 * v + 2, vm, vr, vm, r));
}

int main()
{
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
    int t;
    cin >> t;
    while(t--){
        long long ans = 1e18 + 1;
        bool flag = false;
        long long n,l,r,x,y,z,b1,b2;
        cin >> n >> l >> r >> x >> y >> z >> b1 >> b2;
        vector<long long> b(n);
        vector<long long > a(n);
        b[0]=b1;
        b[1]=b2;
        for(int i=2;i<n;i++){
            long long one = 1;
            b[i] = (b[i-2]*x+b[i-1]*y+z)%(one << 32);
        }
        for (int i = 0; i < n; i++) {
            a[i]=(b[i]%(r-l+1))+l;
        }
        tma.assign(a.size() * 4, 0);
        tmi.assign(a.size() * 4, 0);
        buildma(0, 0, n, a);
        buildmi(0, 0, n, a);
        for (int i = 0; i < n - 1; i++) {
            if (a[i] < 0) {
                long long nowma = getma(0, 0, n, i + 1, n);
                if (nowma > a[i]) {
                    flag = true;
                    ans = min(ans, nowma * a[i]);
                }
            }
            if (a[i] >= 0) {
                long long nowmi = getmi(0, 0, n, i + 1, n);
                if (nowmi > a[i]) {
                    flag = true;
                    ans = min(ans, nowmi * a[i]);
                }
            }
        }
        if (!flag) {
            cout << "IMPOSSIBLE" << "\n";
            continue;
        }
        cout << ans << "\n";
    }
    return 0;
}
