import java.util.*;
import java.io.*;

public class Main {

    FastScanner in;
    PrintWriter out;

    private void solve() throws IOException {
        int t = in.nextInt();
        long mod = 4294967296L;
        /*for(int i = 0; i < 32; i++){
            mod *= 2;
        }*/
        for(int i = 0; i < t; i++){
            int n = in.nextInt();
            long l = in.nextLong(), r = in.nextLong(), x = in.nextLong(), y = in.nextLong(), z = in.nextLong(), b1 = in.nextLong(), b2 = in.nextLong();
            long[] ar = new long[n];
            ar[0] = b1;
            ar[1] = b2;
            for(int j = 2; j < n; j++){
                ar[j] = ((ar[j - 2]*x) + (ar[j - 1]*y) + z)%mod;
            }
            for(int j = 0; j < n; j++){
                ar[j] = (ar[j]%(r - l + 1)) + l;
            }
            TreeSet<Long> st = new TreeSet<>();
            long min = Long.MAX_VALUE;
            long minans = Long.MAX_VALUE;
            boolean flag = false;
            ar = new long[]{1, -1, 1, 0, -1};
            for (int j = 0; j < ar.length; j++){
                if(ar[j] >= 0){
                    if(min < ar[j] && minans >= ar[j] * min){
                        minans = ar[j] * min;
                        flag = true;
                    }
                } else {
                    Object cur = st.lower(ar[j]);
                    if(cur != null && minans >= ar[j] * (long)cur){
                        minans = ar[j] *(long) cur;
                        flag = true;
                    }
                }
                if(ar[j] < min){
                    min = ar[j];
                }
                st.add(ar[j]);
            }
            if(flag) {
                out.println(minans);
            } else {
                out.println("IMPOSSIBLE");
            }
        }

    }


    class FastScanner {
        BufferedReader br;
        StringTokenizer st;

        FastScanner(InputStream s){
            br = new BufferedReader(new InputStreamReader(s));
        }

        String next() throws IOException {
            while(st == null || !st.hasMoreTokens())
                st = new StringTokenizer(br.readLine());
            return st.nextToken();
        }

        boolean hasNext() throws IOException{
            return br.ready() || (st != null && st.hasMoreTokens());
        }

        int nextInt() throws IOException {
            return Integer.parseInt(in.next());
        }
        long nextLong() throws IOException {
            return Long.parseLong(in.next());
        }

        double nextDouble() throws IOException {
            return Double.parseDouble(in.next().replace(',', '.'));
        }

        String nextLine() throws IOException {
            return br.readLine();
        }

        boolean hasNextLine() throws IOException {
            return br.ready();
        }
    }

    private void run() throws  IOException {
        in = new FastScanner(System.in);
        out = new PrintWriter(System.out);
        solve();

        out.flush();
        out.close();
    }

    public static void main(String[] args) throws IOException {
        new Main().run();


    }

}
