﻿#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES

#include <bits/stdc++.h>

using namespace std;

#define sp(x) setprecision(x) << fixed
#define sort(x) sort(x.begin(), x.end())
#define rsort(x) sort(x.rbegin(), x.rend())

typedef long long ll;
typedef long double ld;
typedef pair<ll, ll> pll;

bool can(vector<ll>&a, set<pair<ll, ll>>m) {
	for (auto i : m) {
		if (a[i.first - 1] >= a[i.second - 1])
			return false;
	}
	return true;
}

ll gcd(ll a, ll b) {
	if (b == 0)
		return a;

	return gcd(b, a%b);
}
ll lcm(ll a, ll b) {
	return a / gcd(a, b)*b;
}
ll bin_pow(ll a, ll n) {
	if (n == 0)
		return 1;

	if (n % 2 == 0) {
		ll b = bin_pow(a, n / 2);
		return b * b;
	}
	else
		return bin_pow(a, n - 1)*a;
}

bool operator==(const string& s, const size_t n) {
	return s.size() == n;
}
string operator*(const string& s, const ll n) {
	string ans = "";

	for (ll i = 0; i < n; i++) {
		ans += s;
	}

	return ans;
}

int main() {
	ll n, m;
	cin >> n >> m;
	if (n == 1) {
		cout << "NO";
		return 0;
	}
	set<pair<ll, ll>>equal;
	map<ll, ll>down, up;
	for (int i = 0; i < m; i++) {
		ll f, s;
		cin >> f >> s;
		down[min(f, s)]++;
		up[max(f, s)]++;
		equal.insert({ min(f, s), max(f, s) });
	}

	map<ll, ll>temp;
	for (auto i : equal) {
		temp[i.first]++;
		temp[i.second]++;
	}
	vector<ll>nums, nums1;
	for (int i = 1; i <= n; i++) {
		nums.push_back(i);
		nums1.push_back(i);
		temp[i] += 0;
	}
	pair<ll, ll>ppair;
	ppair = { 1e9, 1e9 };
	for (auto i : temp) {
		if (i.second < ppair.second && down[i.first] != 1 && up[i.first] != n - 1) {
			ppair.second = i.second;
			ppair.first = i.first;
		}
	}
	if (ppair.second == 2) {
		cout << "NO";
		//return main();
	}
	set<pair<ll, ll>>s;
	for (auto i : equal) {
		if (i.first == ppair.first || i.second == ppair.first)
			s.insert(i);
	}
	bool b = 0;
	for (auto i : nums) {
		if (i == ppair.first) {
			continue;
		}
		nums1[ppair.first - 1] = i;
		if (can(nums1, s)) {
			b = 1;
			break;
		}
	}
	if (b == 0) {
		cout << "NO\n";
		return 0;
	}
	cout << "YES\n";
	for (auto i : nums)
		cout << i << ' ';
	cout << '\n';
	for (auto i : nums1)
		cout << i << ' ';
	//main();
	return 0;
}