#pragma GCC optimize("O3")
#pragma GCC targer("sse4")

#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES
#include <bits/stdc++.h>

using namespace std;

#define sp(x) setprecision(x) << fixed
#define sort(x) sort(x.begin(), x.end())
#define rsort(x) sort(x.rbegin(), x.rend())

typedef long long ll;
typedef long double ld;
typedef pair<ll, ll> pll;

ll gcd(ll a, ll b) {
	if (b == 0)
		return a;

	return gcd(b, a%b);
}
ll lcm(ll a, ll b) {
	return a / gcd(a, b)*b;
}
ll bin_pow(ll a, ll n) {
	if (n == 0)
		return 1;

	if (n % 2 == 0) {
		ll b = bin_pow(a, n / 2);
		return b * b;
	}
	else
		return bin_pow(a, n - 1)*a;
}

bool operator==(const string& s, const size_t n) {
	return s.size() == n;
}
string operator*(const string& s, const ll n) {
	string ans = "";

	for (ll i = 0; i < n; i++) {
		ans += s;
	}

	return ans;
}

int main() {
	ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);
	int n, k;
	cin >> n >> k;
	vector<int> a(n);
	for (int i = 0; i < n; i++)
	{
		cin >> a[i];
	}
	int ans = 1;
	int maxAns = 0;
	for (int i = 1; i < n; i++)
	{
		if (a[i] != a[i - 1])
		{
			ans++;
		}
		else
		{
			maxAns = max(ans, maxAns);
			ans = 1;
		}
	}
	cout << maxAns;
	return 0;
}