//#pragma GCC optimize("Ofast")
//#pragma GCC optimitze("unroll-loops")

#include <iostream>
#include <vector>
using namespace std;

typedef long long ll;

#define int long long

#define u unsigned

ll gcd(ll a, ll b) {
    while (a) {
        b %= a;
        swap(a, b);
    }

    return b;
}



signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    int n, k;
    cin >> n >> k;
    vector <int> a((u)n);
    for (int i = 0; i < n; ++i)
        cin >> a[i];

    a.push_back(a.back());

    int l = 0, r = 1, Max = 0;
    while (l < n && r <= n) {
        if (a[r - 1] == a[r]) {
            Max = max(Max, r - l);
            l = r;
            r = l + 1;
        } else {
            r++;
        }
    }
    cout << max(Max, r - l) << "\n";
}