#include <iostream>
#include <algorithm>
#include <set>
#include <climits>

using namespace std;

const int N = 10000007;
const long long mod = 1LL << 32LL;

int n;
long long l, r;
long long x, y, z;

long long a[N], b[N];

void solve()
{
    scanf("%d %lld %lld %lld %lld %lld %lld %lld", &n, &l, &r, &x, &y, &z, b+1, b+2);

    if (n == 1) {
        cout << "IMPOSSIBLE" << endl;
        return;
    }

    bool flag = false;
    a[1] = (b[1] % (r - l + 1)) + l;
    a[2] = (b[2] % (r - l + 1)) + l;

    for (int i = 3; i <= n; i++) {
        b[i] = (b[i - 2]*x + b[i - 1]*y + z) % mod;
        a[i] = (b[i] % (r - l + 1)) + l;
        //cout<<a[i]<<" "<<b[i]<<endl;
        if (a[i] > 0)
            flag = true;
    }
    //cout<<"hi"<<endl;

    long long ans = LLONG_MAX;
    if (flag) {
        long long mn = a[1];
        for (int i = 2; i <= n; i++) {
            //cout<<a[i]<<endl;
            if (a[i] <= mn) {
                mn = a[i];
                continue;
            }
            ans = min(ans, mn * a[i]);
        }
    }

    else {
        set<long long> s;
        s.insert(a[1]);
        set<long long>::iterator it;
        for (int i=2;i<=n;i++){
            it=s.lower_bound(a[i]);
            if (it==s.begin())continue;
            --it;
            ans = min(ans, *it * a[i]);
        }
    }
    if (ans==LLONG_MAX){
        cout<<"IMPOSSIBLE"<<endl;
    }
    else{
        cout<<ans<<endl;
    }
}

int main()
{
    ios_base::sync_with_stdio(false);

    int t;
    cin >> t;

    while (t--)
        solve();

    return 0;
}
