#include <iostream>
#include <algorithm>
#include <set>
#include <climits>
#include <vector>

using namespace std;

const int N = 10000007;
const long long mod = 1LL << 32LL;

int n;
long long l, r;
long long x, y, z;

long long a[N], b[N];

void solve()
{
    cin >> n >> l >> r >> x >> y >> z >> b[1] >> b[2];
    //scanf("%d %I64d %I64d %I64d %I64d %I64d %I64d %I64d", &n, &l, &r, &x, &y, &z, b+1, b+2);

    if (n == 1) {
        cout << "IMPOSSIBLE" << endl;
        return;
    }

    vector<int> v;

    a[1] = (b[1] % (r - l + 1)) + l;
    a[2] = (b[2] % (r - l + 1)) + l;
    for (int i = 3; i <= n; i++) {
        b[i] = (b[i - 2]*x + b[i - 1]*y + z) % mod;
        a[i] = (b[i] % (r - l + 1)) + l;
        if (a[i] < 0)
            v.push_back(a[i]);
    }
    //cout<<"hi"<<endl;

    long long ans = LLONG_MAX;
    {
        long long mn = a[1];
        for (int i = 2; i <= n; i++) {
            //cout<<a[i]<<endl;
            if (a[i] <= mn) {
                mn = a[i];
                continue;
            }
            ans = min(ans, mn * a[i]);
            //cout<<mn*a[i]<<" "<<ans<<endl;
        }
    }

    if (!v.empty())
    {
        set<long long> s;
        s.insert(v[0]);
        set<long long>::iterator it;
        for (int i=1;i<v.size();i++){
            it=s.lower_bound(v[i]);
            if (it==s.begin())continue;
            --it;
            ans = min(ans, *it * v[i]);
        }
    }
    if (ans==LLONG_MAX){
        cout<<"IMPOSSIBLE"<<endl;
    }
    else{
        cout<<ans<<endl;
    }
}

int main()
{
    ios_base::sync_with_stdio(false);

    int t;
    cin >> t;

    while (t--)
        solve();

    return 0;
}
