#include <iostream>
#include <cmath>
#include <algorithm>
#include <stdio.h>
#include <set>
using namespace std;
const long long mod=(1LL<<32LL);
const int MAXN=10000007;
typedef long long LL;

long long ans=0LL, max_neg, min_neg, min_pos, max_pos;
bool is_neg, is_pos;
bool fnd=false;
long long b[MAXN];
long long t, n, l, r, x, y, z, a;

void upd(long long x)
{
	if (!fnd || x<ans)
	{
		ans=x;
		fnd=true;
	}
}


LL binmodUtil(LL a,LL b)
{
	if (b<=1)
		return a*b;
	if(b%2LL)
		return (a+binmodUtil(a, b-1LL))%mod;
	return (2LL*binmodUtil(a, b/2LL))%mod;
}
LL binmod(LL a,LL b)
{
	return binmodUtil(max(a, b), min(a, b));
}

int main()
{
	cin>>t;
	while (t--)
	{
		set<long long> neg;
		ans=max_neg=min_neg=min_pos=max_pos=0LL;
		is_neg=is_pos=fnd=false;
		scanf("%lld%lld%lld%lld%lld%lld%lld%lld", &n, &l, &r, &x, &y, &z, b+1, b+2);
		for (int i=3; i<=n; i++)
		{
			b[i]=(binmod(b[i-2], x) + binmod(b[i-1], y) + z) % mod;
		}
		for (int i=1; i<=n; i++)
		{
			a=b[i]%(r-l+1) + l;
			if (a<=0)
				neg.insert(-a);
			if (i==1)
			{
				if (a>=0)
				{
					is_pos=true;
					max_pos=min_pos=a;
				}
				if (a<=0)
				{
					is_neg=true;
					max_neg=min_neg=a;
				}
				continue;
			}
			if (a>=0)
			{
				if (is_neg && min_neg<a)
				{
					upd(min_neg*a);
				}
				if(is_pos && min_pos<a)
				{
					upd(min_pos*a);
				}
			}
			else
			{
				if(is_neg)
				{
					long long cur_neg=-(*neg.upper_bound(-a));
					upd(cur_neg*a);
				}
			}
			if (a>=0)
			{
				if (!is_pos || a < min_pos)
					min_pos=a;
				if (!is_pos || a > max_pos)
					max_pos=a;
				is_pos=true;
			}
			if (a<=0)
			{
				if (!is_neg || a < min_neg)
					min_neg=a;
				if (!is_neg || a > max_neg)
					max_neg=a;
				is_neg=true;
			}
		}
		if (!fnd)
		{
			printf("IMPOSSIBLE\n");
		}
		else
		{
			printf("%lld\n", ans);
		}
	}
	
	return 0;
}
